/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 19 "parser.y"

#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "sip.h"


#define MAX_NESTED_IF       10
#define MAX_NESTED_SCOPE    10

#define inMainModule()      (currentSpec->module == currentModule || currentModule->container != NULL)


static sipSpec *currentSpec;            /* The current spec being parsed. */
static int strictParse;                 /* Set if the platform is enforced. */
static stringList *backstops;           /* The list of backstops. */
static stringList *neededQualifiers;    /* The list of required qualifiers. */
static stringList *excludedQualifiers;  /* The list of excluded qualifiers. */
static moduleDef *currentModule;        /* The current module being parsed. */
static mappedTypeDef *currentMappedType;    /* The current mapped type. */
static enumDef *currentEnum;            /* The current enum being parsed. */
static int sectionFlags;                /* The current section flags. */
static int currentIsVirt;               /* Set if the callable is virtual. */
static int currentCtorIsExplicit;       /* Set if the ctor is explicit. */
static int currentIsStatic;             /* Set if the current is static. */
static int currentIsSignal;             /* Set if the current is Q_SIGNAL. */
static int currentIsSlot;               /* Set if the current is Q_SLOT. */
static int currentIsTemplate;           /* Set if the current is a template. */
static char *previousFile;              /* The file just parsed. */
static parserContext currentContext;    /* The current context. */
static int stackPtr;                    /* The stack pointer. */
static int skipStack[MAX_NESTED_IF];    /* Stack of skip flags. */
static classDef *scopeStack[MAX_NESTED_SCOPE];  /* The scope stack. */
static int sectFlagsStack[MAX_NESTED_SCOPE];    /* The section flags stack. */
static int currentScopeIdx;             /* The scope stack index. */
static int currentTimelineOrder;        /* The current timeline order. */
static classList *currentSupers;        /* The current super-class list. */
static platformDef *currentPlatforms;   /* The current platforms list. */
static platformDef *platformStack[MAX_NESTED_IF];   /* Stack of platforms. */
static KwArgs defaultKwArgs;            /* The default keyword arguments support. */
static int makeProtPublic;              /* Treat protected items as public. */
static int parsingCSignature;           /* An explicit C/C++ signature is being parsed. */


static const char *getPythonName(moduleDef *mod, optFlags *optflgs,
        const char *cname);
static classDef *findClass(sipSpec *pt, ifaceFileType iftype,
        apiVersionRangeDef *api_range, scopedNameDef *fqname, int tmpl_arg);
static classDef *findClassWithInterface(sipSpec *pt, ifaceFileDef *iff,
        int tmpl_arg);
static classDef *newClass(sipSpec *pt, ifaceFileType iftype,
        apiVersionRangeDef *api_range, scopedNameDef *snd,
        const char *virt_error_handler, typeHintDef *typehint_in,
        typeHintDef *typehint_out, const char *typehint_value);
static void finishClass(sipSpec *, moduleDef *, classDef *, optFlags *);
static exceptionDef *findException(sipSpec *pt, scopedNameDef *fqname, int new);
static mappedTypeDef *newMappedType(sipSpec *,argDef *, optFlags *);
static enumDef *newEnum(sipSpec *pt, moduleDef *mod, mappedTypeDef *mt_scope,
        char *name, optFlags *of, int flags, int isscoped);
static void instantiateClassTemplate(sipSpec *pt, moduleDef *mod,
        classDef *scope, scopedNameDef *fqname, classTmplDef *tcd,
        templateDef *td, const char *pyname, int use_template_name,
        docstringDef *docstring);
static void newTypedef(sipSpec *, moduleDef *, char *, argDef *, optFlags *,
        docstringDef *);
static void newVar(sipSpec *pt, moduleDef *mod, char *name, int isstatic,
        argDef *type, optFlags *of, codeBlock *acode, codeBlock *gcode,
        codeBlock *scode, int section);
static void newCtor(moduleDef *, char *, int, signatureDef *, optFlags *,
                    codeBlock *, throwArgs *, signatureDef *, int,
                    docstringDef *, codeBlock *);
static void newFunction(sipSpec *, moduleDef *, classDef *, ifaceFileDef *,
        mappedTypeDef *, int, int, int, int, int, char *, signatureDef *, int,
        int, optFlags *, codeBlock *, codeBlock *, codeBlock *, throwArgs *,
        signatureDef *, docstringDef *, int, codeBlock *);
static optFlag *findOptFlag(optFlags *flgs, const char *name);
static optFlag *getOptFlag(optFlags *flgs, const char *name, flagType ft);
static memberDef *findFunction(sipSpec *, moduleDef *, classDef *,
        ifaceFileDef *, mappedTypeDef *, const char *, int, int, int);
static void checkAttributes(sipSpec *, moduleDef *, classDef *,
        mappedTypeDef *, const char *, int);
static void newModule(FILE *fp, const char *filename);
static moduleDef *allocModule();
static void parseFile(FILE *fp, const char *name, moduleDef *prevmod,
        int optional);
static void handleEOF(void);
static void handleEOM(void);
static qualDef *findQualifier(const char *name);
static const char *getInt(const char *cp, int *ip);
static scopedNameDef *text2scopedName(ifaceFileDef *scope, char *text);
static scopedNameDef *scopeScopedName(ifaceFileDef *scope,
        scopedNameDef *name);
static void pushScope(classDef *);
static void popScope(void);
static classDef *currentScope(void);
static void newQualifier(moduleDef *, int, int, int, const char *, qualType);
static qualDef *allocQualifier(moduleDef *, int, int, int, const char *,
        qualType);
static void newImport(const char *filename);
static int timePeriod(const char *lname, const char *uname);
static int platOrFeature(char *name, int optnot);
static void addPlatform(qualDef *qd);
static int notSkipping(void);
static void getHooks(optFlags *,char **,char **);
static int getTransfer(optFlags *optflgs);
static int getReleaseGIL(optFlags *optflgs);
static int getHoldGIL(optFlags *optflgs);
static int getDeprecated(optFlags *optflgs);
static int getAllowNone(optFlags *optflgs);
static int getDisallowNone(optFlags *optflgs);
static const char *getVirtErrorHandler(optFlags *optflgs);
static const char *getDocType(optFlags *optflgs);
static const char *getTypeHintValue(optFlags *optflgs);
static void getTypeHints(optFlags *optflgs, typeHintDef **in,
        typeHintDef **out);
static int getNoTypeHint(optFlags *optflgs);
static void templateSignature(signatureDef *sd, KwArgs kwargs, int result,
        classTmplDef *tcd, templateDef *td, classDef *ncd,
        scopedNameDef *type_names, scopedNameDef *type_values);
static void templateType(argDef *ad, classTmplDef *tcd, templateDef *td,
        classDef *ncd, scopedNameDef *type_names, scopedNameDef *type_values);
static int search_back(const char *end, const char *start, const char *target);
static char *type2string(argDef *ad);
static char *scopedNameToString(scopedNameDef *name);
static void addUsedFromCode(sipSpec *pt, ifaceFileList **used, const char *sname);
static int sameName(scopedNameDef *snd, const char *sname);
static int stringFind(stringList *sl, const char *s);
static void setModuleName(sipSpec *pt, moduleDef *mod, const char *fullname);
static int foundInScope(scopedNameDef *fq_name, scopedNameDef *rel_name);
static void defineClass(scopedNameDef *snd, classList *supers, optFlags *of);
static classDef *completeClass(scopedNameDef *snd, optFlags *of, int has_def);
static memberDef *instantiateTemplateMethods(memberDef *tmd, moduleDef *mod);
static void instantiateTemplateEnums(sipSpec *pt, classTmplDef *tcd,
        templateDef *td, classDef *cd, ifaceFileList **used,
        scopedNameDef *type_names, scopedNameDef *type_values);
static void instantiateTemplateVars(sipSpec *pt, classTmplDef *tcd,
        templateDef *td, classDef *cd, ifaceFileList **used,
        scopedNameDef *type_names, scopedNameDef *type_values);
static void instantiateTemplateTypedefs(sipSpec *pt, classTmplDef *tcd,
        templateDef *td, classDef *cd, scopedNameDef *type_names,
        scopedNameDef *type_values);
static overDef *instantiateTemplateOverloads(sipSpec *pt, overDef *tod,
        memberDef *tmethods, memberDef *methods, classTmplDef *tcd,
        templateDef *td, classDef *cd, ifaceFileList **used,
        scopedNameDef *type_names, scopedNameDef *type_values);
static void resolveAnyTypedef(sipSpec *pt, argDef *ad);
static void addTypedef(sipSpec *pt, typedefDef *tdd);
static void addVariable(sipSpec *pt, varDef *vd);
static void applyTypeFlags(moduleDef *mod, argDef *ad, optFlags *flags);
static Format convertFormat(const char *format);
static Signature convertSignature(const char *signature);
static argType convertEncoding(const char *encoding);
static apiVersionRangeDef *getAPIRange(optFlags *optflgs);
static apiVersionRangeDef *convertAPIRange(moduleDef *mod, nameDef *name,
        int from, int to);
static char *convertFeaturedString(char *fs);
static KwArgs keywordArgs(moduleDef *mod, optFlags *optflgs, signatureDef *sd,
        int need_name);
static char *strip(char *s);
static int isEnabledFeature(const char *name);
static void addProperty(sipSpec *pt, moduleDef *mod, classDef *cd,
        const char *name, const char *get, const char *set,
        docstringDef *docstring);
static moduleDef *configureModule(sipSpec *pt, moduleDef *module,
        const char *filename, const char *name, int c_module, KwArgs kwargs,
        int use_arg_names, int py_ssize_t_clean, int use_limited_api,
        int call_super_init, int all_raise_py_exc,
        const char *def_error_handler, docstringDef *docstring);
static void addAutoPyName(moduleDef *mod, const char *remove_leading);
static KwArgs convertKwArgs(const char *kwargs);
static void checkAnnos(optFlags *annos, const char *valid[]);
static void checkNoAnnos(optFlags *annos, const char *msg);
static void appendCodeBlock(codeBlockList **headp, codeBlock *cb);
static void handleKeepReference(optFlags *optflgs, argDef *ad, moduleDef *mod);
static void mappedTypeAnnos(mappedTypeDef *mtd, optFlags *optflgs);
static void add_new_deref(argDef *new, argDef *orig, int isconst);
static void add_derefs(argDef *dst, argDef *src);
static int isBackstop(qualDef *qd);
static void checkEllipsis(signatureDef *sd);
static scopedNameDef *fullyQualifiedName(scopedNameDef *snd);

#line 254 "../parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TK_API = 3,                     /* TK_API  */
  YYSYMBOL_TK_AUTOPYNAME = 4,              /* TK_AUTOPYNAME  */
  YYSYMBOL_TK_DEFDOCSTRFMT = 5,            /* TK_DEFDOCSTRFMT  */
  YYSYMBOL_TK_DEFDOCSTRSIG = 6,            /* TK_DEFDOCSTRSIG  */
  YYSYMBOL_TK_DEFENCODING = 7,             /* TK_DEFENCODING  */
  YYSYMBOL_TK_PLUGIN = 8,                  /* TK_PLUGIN  */
  YYSYMBOL_TK_VIRTERRORHANDLER = 9,        /* TK_VIRTERRORHANDLER  */
  YYSYMBOL_TK_EXPTYPEHINTCODE = 10,        /* TK_EXPTYPEHINTCODE  */
  YYSYMBOL_TK_TYPEHINTCODE = 11,           /* TK_TYPEHINTCODE  */
  YYSYMBOL_TK_DOCSTRING = 12,              /* TK_DOCSTRING  */
  YYSYMBOL_TK_DOC = 13,                    /* TK_DOC  */
  YYSYMBOL_TK_EXPORTEDDOC = 14,            /* TK_EXPORTEDDOC  */
  YYSYMBOL_TK_EXTRACT = 15,                /* TK_EXTRACT  */
  YYSYMBOL_TK_MAKEFILE = 16,               /* TK_MAKEFILE  */
  YYSYMBOL_TK_ACCESSCODE = 17,             /* TK_ACCESSCODE  */
  YYSYMBOL_TK_GETCODE = 18,                /* TK_GETCODE  */
  YYSYMBOL_TK_SETCODE = 19,                /* TK_SETCODE  */
  YYSYMBOL_TK_PREINITCODE = 20,            /* TK_PREINITCODE  */
  YYSYMBOL_TK_INITCODE = 21,               /* TK_INITCODE  */
  YYSYMBOL_TK_POSTINITCODE = 22,           /* TK_POSTINITCODE  */
  YYSYMBOL_TK_FINALCODE = 23,              /* TK_FINALCODE  */
  YYSYMBOL_TK_UNITCODE = 24,               /* TK_UNITCODE  */
  YYSYMBOL_TK_UNITPOSTINCLUDECODE = 25,    /* TK_UNITPOSTINCLUDECODE  */
  YYSYMBOL_TK_MODCODE = 26,                /* TK_MODCODE  */
  YYSYMBOL_TK_TYPECODE = 27,               /* TK_TYPECODE  */
  YYSYMBOL_TK_PREPYCODE = 28,              /* TK_PREPYCODE  */
  YYSYMBOL_TK_COPYING = 29,                /* TK_COPYING  */
  YYSYMBOL_TK_MAPPEDTYPE = 30,             /* TK_MAPPEDTYPE  */
  YYSYMBOL_TK_CODELINE = 31,               /* TK_CODELINE  */
  YYSYMBOL_TK_IF = 32,                     /* TK_IF  */
  YYSYMBOL_TK_END = 33,                    /* TK_END  */
  YYSYMBOL_TK_NAME_VALUE = 34,             /* TK_NAME_VALUE  */
  YYSYMBOL_TK_PATH_VALUE = 35,             /* TK_PATH_VALUE  */
  YYSYMBOL_TK_STRING_VALUE = 36,           /* TK_STRING_VALUE  */
  YYSYMBOL_TK_VIRTUALCATCHERCODE = 37,     /* TK_VIRTUALCATCHERCODE  */
  YYSYMBOL_TK_TRAVERSECODE = 38,           /* TK_TRAVERSECODE  */
  YYSYMBOL_TK_CLEARCODE = 39,              /* TK_CLEARCODE  */
  YYSYMBOL_TK_GETBUFFERCODE = 40,          /* TK_GETBUFFERCODE  */
  YYSYMBOL_TK_RELEASEBUFFERCODE = 41,      /* TK_RELEASEBUFFERCODE  */
  YYSYMBOL_TK_READBUFFERCODE = 42,         /* TK_READBUFFERCODE  */
  YYSYMBOL_TK_WRITEBUFFERCODE = 43,        /* TK_WRITEBUFFERCODE  */
  YYSYMBOL_TK_SEGCOUNTCODE = 44,           /* TK_SEGCOUNTCODE  */
  YYSYMBOL_TK_CHARBUFFERCODE = 45,         /* TK_CHARBUFFERCODE  */
  YYSYMBOL_TK_PICKLECODE = 46,             /* TK_PICKLECODE  */
  YYSYMBOL_TK_VIRTUALCALLCODE = 47,        /* TK_VIRTUALCALLCODE  */
  YYSYMBOL_TK_METHODCODE = 48,             /* TK_METHODCODE  */
  YYSYMBOL_TK_PREMETHODCODE = 49,          /* TK_PREMETHODCODE  */
  YYSYMBOL_TK_INSTANCECODE = 50,           /* TK_INSTANCECODE  */
  YYSYMBOL_TK_FROMTYPE = 51,               /* TK_FROMTYPE  */
  YYSYMBOL_TK_TOTYPE = 52,                 /* TK_TOTYPE  */
  YYSYMBOL_TK_TOSUBCLASS = 53,             /* TK_TOSUBCLASS  */
  YYSYMBOL_TK_INCLUDE = 54,                /* TK_INCLUDE  */
  YYSYMBOL_TK_OPTINCLUDE = 55,             /* TK_OPTINCLUDE  */
  YYSYMBOL_TK_IMPORT = 56,                 /* TK_IMPORT  */
  YYSYMBOL_TK_EXPHEADERCODE = 57,          /* TK_EXPHEADERCODE  */
  YYSYMBOL_TK_MODHEADERCODE = 58,          /* TK_MODHEADERCODE  */
  YYSYMBOL_TK_TYPEHEADERCODE = 59,         /* TK_TYPEHEADERCODE  */
  YYSYMBOL_TK_MODULE = 60,                 /* TK_MODULE  */
  YYSYMBOL_TK_CMODULE = 61,                /* TK_CMODULE  */
  YYSYMBOL_TK_CONSMODULE = 62,             /* TK_CONSMODULE  */
  YYSYMBOL_TK_COMPOMODULE = 63,            /* TK_COMPOMODULE  */
  YYSYMBOL_TK_CLASS = 64,                  /* TK_CLASS  */
  YYSYMBOL_TK_STRUCT = 65,                 /* TK_STRUCT  */
  YYSYMBOL_TK_PUBLIC = 66,                 /* TK_PUBLIC  */
  YYSYMBOL_TK_PROTECTED = 67,              /* TK_PROTECTED  */
  YYSYMBOL_TK_PRIVATE = 68,                /* TK_PRIVATE  */
  YYSYMBOL_TK_SIGNALS = 69,                /* TK_SIGNALS  */
  YYSYMBOL_TK_SIGNAL_METHOD = 70,          /* TK_SIGNAL_METHOD  */
  YYSYMBOL_TK_SLOTS = 71,                  /* TK_SLOTS  */
  YYSYMBOL_TK_SLOT_METHOD = 72,            /* TK_SLOT_METHOD  */
  YYSYMBOL_TK_BOOL = 73,                   /* TK_BOOL  */
  YYSYMBOL_TK_SHORT = 74,                  /* TK_SHORT  */
  YYSYMBOL_TK_INT = 75,                    /* TK_INT  */
  YYSYMBOL_TK_LONG = 76,                   /* TK_LONG  */
  YYSYMBOL_TK_FLOAT = 77,                  /* TK_FLOAT  */
  YYSYMBOL_TK_DOUBLE = 78,                 /* TK_DOUBLE  */
  YYSYMBOL_TK_CHAR = 79,                   /* TK_CHAR  */
  YYSYMBOL_TK_WCHAR_T = 80,                /* TK_WCHAR_T  */
  YYSYMBOL_TK_VOID = 81,                   /* TK_VOID  */
  YYSYMBOL_TK_PYOBJECT = 82,               /* TK_PYOBJECT  */
  YYSYMBOL_TK_PYTUPLE = 83,                /* TK_PYTUPLE  */
  YYSYMBOL_TK_PYLIST = 84,                 /* TK_PYLIST  */
  YYSYMBOL_TK_PYDICT = 85,                 /* TK_PYDICT  */
  YYSYMBOL_TK_PYCALLABLE = 86,             /* TK_PYCALLABLE  */
  YYSYMBOL_TK_PYSLICE = 87,                /* TK_PYSLICE  */
  YYSYMBOL_TK_PYTYPE = 88,                 /* TK_PYTYPE  */
  YYSYMBOL_TK_PYBUFFER = 89,               /* TK_PYBUFFER  */
  YYSYMBOL_TK_VIRTUAL = 90,                /* TK_VIRTUAL  */
  YYSYMBOL_TK_ENUM = 91,                   /* TK_ENUM  */
  YYSYMBOL_TK_SIGNED = 92,                 /* TK_SIGNED  */
  YYSYMBOL_TK_UNSIGNED = 93,               /* TK_UNSIGNED  */
  YYSYMBOL_TK_SCOPE = 94,                  /* TK_SCOPE  */
  YYSYMBOL_TK_LOGICAL_OR = 95,             /* TK_LOGICAL_OR  */
  YYSYMBOL_TK_CONST = 96,                  /* TK_CONST  */
  YYSYMBOL_TK_STATIC = 97,                 /* TK_STATIC  */
  YYSYMBOL_TK_SIPSIGNAL = 98,              /* TK_SIPSIGNAL  */
  YYSYMBOL_TK_SIPSLOT = 99,                /* TK_SIPSLOT  */
  YYSYMBOL_TK_SIPANYSLOT = 100,            /* TK_SIPANYSLOT  */
  YYSYMBOL_TK_SIPRXCON = 101,              /* TK_SIPRXCON  */
  YYSYMBOL_TK_SIPRXDIS = 102,              /* TK_SIPRXDIS  */
  YYSYMBOL_TK_SIPSLOTCON = 103,            /* TK_SIPSLOTCON  */
  YYSYMBOL_TK_SIPSLOTDIS = 104,            /* TK_SIPSLOTDIS  */
  YYSYMBOL_TK_SIPSSIZET = 105,             /* TK_SIPSSIZET  */
  YYSYMBOL_TK_SIZET = 106,                 /* TK_SIZET  */
  YYSYMBOL_TK_NUMBER_VALUE = 107,          /* TK_NUMBER_VALUE  */
  YYSYMBOL_TK_REAL_VALUE = 108,            /* TK_REAL_VALUE  */
  YYSYMBOL_TK_TYPEDEF = 109,               /* TK_TYPEDEF  */
  YYSYMBOL_TK_NAMESPACE = 110,             /* TK_NAMESPACE  */
  YYSYMBOL_TK_TIMELINE = 111,              /* TK_TIMELINE  */
  YYSYMBOL_TK_PLATFORMS = 112,             /* TK_PLATFORMS  */
  YYSYMBOL_TK_FEATURE = 113,               /* TK_FEATURE  */
  YYSYMBOL_TK_LICENSE = 114,               /* TK_LICENSE  */
  YYSYMBOL_TK_QCHAR_VALUE = 115,           /* TK_QCHAR_VALUE  */
  YYSYMBOL_TK_TRUE_VALUE = 116,            /* TK_TRUE_VALUE  */
  YYSYMBOL_TK_FALSE_VALUE = 117,           /* TK_FALSE_VALUE  */
  YYSYMBOL_TK_NULL_VALUE = 118,            /* TK_NULL_VALUE  */
  YYSYMBOL_TK_OPERATOR = 119,              /* TK_OPERATOR  */
  YYSYMBOL_TK_THROW = 120,                 /* TK_THROW  */
  YYSYMBOL_TK_QOBJECT = 121,               /* TK_QOBJECT  */
  YYSYMBOL_TK_EXCEPTION = 122,             /* TK_EXCEPTION  */
  YYSYMBOL_TK_RAISECODE = 123,             /* TK_RAISECODE  */
  YYSYMBOL_TK_EXPLICIT = 124,              /* TK_EXPLICIT  */
  YYSYMBOL_TK_TEMPLATE = 125,              /* TK_TEMPLATE  */
  YYSYMBOL_TK_FINAL = 126,                 /* TK_FINAL  */
  YYSYMBOL_TK_ELLIPSIS = 127,              /* TK_ELLIPSIS  */
  YYSYMBOL_TK_DEFMETATYPE = 128,           /* TK_DEFMETATYPE  */
  YYSYMBOL_TK_DEFSUPERTYPE = 129,          /* TK_DEFSUPERTYPE  */
  YYSYMBOL_TK_PROPERTY = 130,              /* TK_PROPERTY  */
  YYSYMBOL_TK_HIDE_NS = 131,               /* TK_HIDE_NS  */
  YYSYMBOL_TK_FORMAT = 132,                /* TK_FORMAT  */
  YYSYMBOL_TK_GET = 133,                   /* TK_GET  */
  YYSYMBOL_TK_ID = 134,                    /* TK_ID  */
  YYSYMBOL_TK_KWARGS = 135,                /* TK_KWARGS  */
  YYSYMBOL_TK_LANGUAGE = 136,              /* TK_LANGUAGE  */
  YYSYMBOL_TK_LICENSEE = 137,              /* TK_LICENSEE  */
  YYSYMBOL_TK_NAME = 138,                  /* TK_NAME  */
  YYSYMBOL_TK_OPTIONAL = 139,              /* TK_OPTIONAL  */
  YYSYMBOL_TK_ORDER = 140,                 /* TK_ORDER  */
  YYSYMBOL_TK_REMOVELEADING = 141,         /* TK_REMOVELEADING  */
  YYSYMBOL_TK_SET = 142,                   /* TK_SET  */
  YYSYMBOL_TK_SIGNATURE = 143,             /* TK_SIGNATURE  */
  YYSYMBOL_TK_TIMESTAMP = 144,             /* TK_TIMESTAMP  */
  YYSYMBOL_TK_TYPE = 145,                  /* TK_TYPE  */
  YYSYMBOL_TK_USEARGNAMES = 146,           /* TK_USEARGNAMES  */
  YYSYMBOL_TK_PYSSIZETCLEAN = 147,         /* TK_PYSSIZETCLEAN  */
  YYSYMBOL_TK_USELIMITEDAPI = 148,         /* TK_USELIMITEDAPI  */
  YYSYMBOL_TK_ALLRAISEPYEXC = 149,         /* TK_ALLRAISEPYEXC  */
  YYSYMBOL_TK_CALLSUPERINIT = 150,         /* TK_CALLSUPERINIT  */
  YYSYMBOL_TK_DEFERRORHANDLER = 151,       /* TK_DEFERRORHANDLER  */
  YYSYMBOL_TK_VERSION = 152,               /* TK_VERSION  */
  YYSYMBOL_153_ = 153,                     /* '('  */
  YYSYMBOL_154_ = 154,                     /* ')'  */
  YYSYMBOL_155_ = 155,                     /* ','  */
  YYSYMBOL_156_ = 156,                     /* '='  */
  YYSYMBOL_157_ = 157,                     /* '{'  */
  YYSYMBOL_158_ = 158,                     /* '}'  */
  YYSYMBOL_159_ = 159,                     /* ';'  */
  YYSYMBOL_160_ = 160,                     /* '!'  */
  YYSYMBOL_161_ = 161,                     /* '-'  */
  YYSYMBOL_162_ = 162,                     /* '+'  */
  YYSYMBOL_163_ = 163,                     /* '*'  */
  YYSYMBOL_164_ = 164,                     /* '/'  */
  YYSYMBOL_165_ = 165,                     /* '&'  */
  YYSYMBOL_166_ = 166,                     /* '|'  */
  YYSYMBOL_167_ = 167,                     /* '~'  */
  YYSYMBOL_168_ = 168,                     /* '<'  */
  YYSYMBOL_169_ = 169,                     /* '>'  */
  YYSYMBOL_170_ = 170,                     /* ':'  */
  YYSYMBOL_171_ = 171,                     /* '['  */
  YYSYMBOL_172_ = 172,                     /* ']'  */
  YYSYMBOL_173_ = 173,                     /* '%'  */
  YYSYMBOL_174_ = 174,                     /* '^'  */
  YYSYMBOL_YYACCEPT = 175,                 /* $accept  */
  YYSYMBOL_specification = 176,            /* specification  */
  YYSYMBOL_statement = 177,                /* statement  */
  YYSYMBOL_178_1 = 178,                    /* $@1  */
  YYSYMBOL_modstatement = 179,             /* modstatement  */
  YYSYMBOL_nsstatement = 180,              /* nsstatement  */
  YYSYMBOL_defdocstringfmt = 181,          /* defdocstringfmt  */
  YYSYMBOL_defdocstringfmt_args = 182,     /* defdocstringfmt_args  */
  YYSYMBOL_defdocstringfmt_arg_list = 183, /* defdocstringfmt_arg_list  */
  YYSYMBOL_defdocstringfmt_arg = 184,      /* defdocstringfmt_arg  */
  YYSYMBOL_defdocstringsig = 185,          /* defdocstringsig  */
  YYSYMBOL_defdocstringsig_args = 186,     /* defdocstringsig_args  */
  YYSYMBOL_defdocstringsig_arg_list = 187, /* defdocstringsig_arg_list  */
  YYSYMBOL_defdocstringsig_arg = 188,      /* defdocstringsig_arg  */
  YYSYMBOL_defencoding = 189,              /* defencoding  */
  YYSYMBOL_defencoding_args = 190,         /* defencoding_args  */
  YYSYMBOL_defencoding_arg_list = 191,     /* defencoding_arg_list  */
  YYSYMBOL_defencoding_arg = 192,          /* defencoding_arg  */
  YYSYMBOL_plugin = 193,                   /* plugin  */
  YYSYMBOL_plugin_args = 194,              /* plugin_args  */
  YYSYMBOL_plugin_arg_list = 195,          /* plugin_arg_list  */
  YYSYMBOL_plugin_arg = 196,               /* plugin_arg  */
  YYSYMBOL_virterrorhandler = 197,         /* virterrorhandler  */
  YYSYMBOL_veh_args = 198,                 /* veh_args  */
  YYSYMBOL_veh_arg_list = 199,             /* veh_arg_list  */
  YYSYMBOL_veh_arg = 200,                  /* veh_arg  */
  YYSYMBOL_api = 201,                      /* api  */
  YYSYMBOL_api_args = 202,                 /* api_args  */
  YYSYMBOL_api_arg_list = 203,             /* api_arg_list  */
  YYSYMBOL_api_arg = 204,                  /* api_arg  */
  YYSYMBOL_exception = 205,                /* exception  */
  YYSYMBOL_baseexception = 206,            /* baseexception  */
  YYSYMBOL_exception_body = 207,           /* exception_body  */
  YYSYMBOL_exception_body_directives = 208, /* exception_body_directives  */
  YYSYMBOL_exception_body_directive = 209, /* exception_body_directive  */
  YYSYMBOL_raisecode = 210,                /* raisecode  */
  YYSYMBOL_mappedtype = 211,               /* mappedtype  */
  YYSYMBOL_212_2 = 212,                    /* $@2  */
  YYSYMBOL_mappedtypetmpl = 213,           /* mappedtypetmpl  */
  YYSYMBOL_214_3 = 214,                    /* $@3  */
  YYSYMBOL_mtdefinition = 215,             /* mtdefinition  */
  YYSYMBOL_mtbody = 216,                   /* mtbody  */
  YYSYMBOL_mtline = 217,                   /* mtline  */
  YYSYMBOL_mtfunction = 218,               /* mtfunction  */
  YYSYMBOL_namespace = 219,                /* namespace  */
  YYSYMBOL_220_4 = 220,                    /* $@4  */
  YYSYMBOL_optnsbody = 221,                /* optnsbody  */
  YYSYMBOL_nsbody = 222,                   /* nsbody  */
  YYSYMBOL_platforms = 223,                /* platforms  */
  YYSYMBOL_224_5 = 224,                    /* $@5  */
  YYSYMBOL_platformlist = 225,             /* platformlist  */
  YYSYMBOL_platform = 226,                 /* platform  */
  YYSYMBOL_feature = 227,                  /* feature  */
  YYSYMBOL_feature_args = 228,             /* feature_args  */
  YYSYMBOL_feature_arg_list = 229,         /* feature_arg_list  */
  YYSYMBOL_feature_arg = 230,              /* feature_arg  */
  YYSYMBOL_timeline = 231,                 /* timeline  */
  YYSYMBOL_232_6 = 232,                    /* $@6  */
  YYSYMBOL_qualifierlist = 233,            /* qualifierlist  */
  YYSYMBOL_qualifiername = 234,            /* qualifiername  */
  YYSYMBOL_ifstart = 235,                  /* ifstart  */
  YYSYMBOL_236_7 = 236,                    /* $@7  */
  YYSYMBOL_oredqualifiers = 237,           /* oredqualifiers  */
  YYSYMBOL_qualifiers = 238,               /* qualifiers  */
  YYSYMBOL_ifend = 239,                    /* ifend  */
  YYSYMBOL_license = 240,                  /* license  */
  YYSYMBOL_license_args = 241,             /* license_args  */
  YYSYMBOL_license_arg_list = 242,         /* license_arg_list  */
  YYSYMBOL_license_arg = 243,              /* license_arg  */
  YYSYMBOL_defmetatype = 244,              /* defmetatype  */
  YYSYMBOL_defmetatype_args = 245,         /* defmetatype_args  */
  YYSYMBOL_defmetatype_arg_list = 246,     /* defmetatype_arg_list  */
  YYSYMBOL_defmetatype_arg = 247,          /* defmetatype_arg  */
  YYSYMBOL_defsupertype = 248,             /* defsupertype  */
  YYSYMBOL_defsupertype_args = 249,        /* defsupertype_args  */
  YYSYMBOL_defsupertype_arg_list = 250,    /* defsupertype_arg_list  */
  YYSYMBOL_defsupertype_arg = 251,         /* defsupertype_arg  */
  YYSYMBOL_hiddenns = 252,                 /* hiddenns  */
  YYSYMBOL_hiddenns_args = 253,            /* hiddenns_args  */
  YYSYMBOL_hiddenns_arg_list = 254,        /* hiddenns_arg_list  */
  YYSYMBOL_hiddenns_arg = 255,             /* hiddenns_arg  */
  YYSYMBOL_consmodule = 256,               /* consmodule  */
  YYSYMBOL_consmodule_args = 257,          /* consmodule_args  */
  YYSYMBOL_consmodule_arg_list = 258,      /* consmodule_arg_list  */
  YYSYMBOL_consmodule_arg = 259,           /* consmodule_arg  */
  YYSYMBOL_consmodule_body = 260,          /* consmodule_body  */
  YYSYMBOL_consmodule_body_directives = 261, /* consmodule_body_directives  */
  YYSYMBOL_consmodule_body_directive = 262, /* consmodule_body_directive  */
  YYSYMBOL_compmodule = 263,               /* compmodule  */
  YYSYMBOL_compmodule_args = 264,          /* compmodule_args  */
  YYSYMBOL_compmodule_arg_list = 265,      /* compmodule_arg_list  */
  YYSYMBOL_compmodule_arg = 266,           /* compmodule_arg  */
  YYSYMBOL_compmodule_body = 267,          /* compmodule_body  */
  YYSYMBOL_compmodule_body_directives = 268, /* compmodule_body_directives  */
  YYSYMBOL_compmodule_body_directive = 269, /* compmodule_body_directive  */
  YYSYMBOL_module = 270,                   /* module  */
  YYSYMBOL_module_args = 271,              /* module_args  */
  YYSYMBOL_272_8 = 272,                    /* $@8  */
  YYSYMBOL_module_arg_list = 273,          /* module_arg_list  */
  YYSYMBOL_module_arg = 274,               /* module_arg  */
  YYSYMBOL_module_body = 275,              /* module_body  */
  YYSYMBOL_module_body_directives = 276,   /* module_body_directives  */
  YYSYMBOL_module_body_directive = 277,    /* module_body_directive  */
  YYSYMBOL_dottedname = 278,               /* dottedname  */
  YYSYMBOL_optnumber = 279,                /* optnumber  */
  YYSYMBOL_include = 280,                  /* include  */
  YYSYMBOL_include_args = 281,             /* include_args  */
  YYSYMBOL_include_arg_list = 282,         /* include_arg_list  */
  YYSYMBOL_include_arg = 283,              /* include_arg  */
  YYSYMBOL_optinclude = 284,               /* optinclude  */
  YYSYMBOL_import = 285,                   /* import  */
  YYSYMBOL_import_args = 286,              /* import_args  */
  YYSYMBOL_import_arg_list = 287,          /* import_arg_list  */
  YYSYMBOL_import_arg = 288,               /* import_arg  */
  YYSYMBOL_optaccesscode = 289,            /* optaccesscode  */
  YYSYMBOL_optgetcode = 290,               /* optgetcode  */
  YYSYMBOL_optsetcode = 291,               /* optsetcode  */
  YYSYMBOL_copying = 292,                  /* copying  */
  YYSYMBOL_exphdrcode = 293,               /* exphdrcode  */
  YYSYMBOL_modhdrcode = 294,               /* modhdrcode  */
  YYSYMBOL_typehdrcode = 295,              /* typehdrcode  */
  YYSYMBOL_travcode = 296,                 /* travcode  */
  YYSYMBOL_clearcode = 297,                /* clearcode  */
  YYSYMBOL_getbufcode = 298,               /* getbufcode  */
  YYSYMBOL_releasebufcode = 299,           /* releasebufcode  */
  YYSYMBOL_readbufcode = 300,              /* readbufcode  */
  YYSYMBOL_writebufcode = 301,             /* writebufcode  */
  YYSYMBOL_segcountcode = 302,             /* segcountcode  */
  YYSYMBOL_charbufcode = 303,              /* charbufcode  */
  YYSYMBOL_instancecode = 304,             /* instancecode  */
  YYSYMBOL_picklecode = 305,               /* picklecode  */
  YYSYMBOL_finalcode = 306,                /* finalcode  */
  YYSYMBOL_modcode = 307,                  /* modcode  */
  YYSYMBOL_typecode = 308,                 /* typecode  */
  YYSYMBOL_preinitcode = 309,              /* preinitcode  */
  YYSYMBOL_initcode = 310,                 /* initcode  */
  YYSYMBOL_postinitcode = 311,             /* postinitcode  */
  YYSYMBOL_unitcode = 312,                 /* unitcode  */
  YYSYMBOL_unitpostinccode = 313,          /* unitpostinccode  */
  YYSYMBOL_prepycode = 314,                /* prepycode  */
  YYSYMBOL_exptypehintcode = 315,          /* exptypehintcode  */
  YYSYMBOL_modtypehintcode = 316,          /* modtypehintcode  */
  YYSYMBOL_classtypehintcode = 317,        /* classtypehintcode  */
  YYSYMBOL_doc = 318,                      /* doc  */
  YYSYMBOL_exporteddoc = 319,              /* exporteddoc  */
  YYSYMBOL_autopyname = 320,               /* autopyname  */
  YYSYMBOL_autopyname_args = 321,          /* autopyname_args  */
  YYSYMBOL_autopyname_arg_list = 322,      /* autopyname_arg_list  */
  YYSYMBOL_autopyname_arg = 323,           /* autopyname_arg  */
  YYSYMBOL_docstring = 324,                /* docstring  */
  YYSYMBOL_docstring_args = 325,           /* docstring_args  */
  YYSYMBOL_docstring_arg_list = 326,       /* docstring_arg_list  */
  YYSYMBOL_docstring_arg = 327,            /* docstring_arg  */
  YYSYMBOL_optdocstring = 328,             /* optdocstring  */
  YYSYMBOL_extract = 329,                  /* extract  */
  YYSYMBOL_extract_args = 330,             /* extract_args  */
  YYSYMBOL_extract_arg_list = 331,         /* extract_arg_list  */
  YYSYMBOL_extract_arg = 332,              /* extract_arg  */
  YYSYMBOL_makefile = 333,                 /* makefile  */
  YYSYMBOL_codeblock = 334,                /* codeblock  */
  YYSYMBOL_codelines = 335,                /* codelines  */
  YYSYMBOL_enum = 336,                     /* enum  */
  YYSYMBOL_337_9 = 337,                    /* $@9  */
  YYSYMBOL_optenumkey = 338,               /* optenumkey  */
  YYSYMBOL_optfilename = 339,              /* optfilename  */
  YYSYMBOL_optname = 340,                  /* optname  */
  YYSYMBOL_optenumbody = 341,              /* optenumbody  */
  YYSYMBOL_enumbody = 342,                 /* enumbody  */
  YYSYMBOL_enumline = 343,                 /* enumline  */
  YYSYMBOL_optcomma = 344,                 /* optcomma  */
  YYSYMBOL_optenumassign = 345,            /* optenumassign  */
  YYSYMBOL_optassign = 346,                /* optassign  */
  YYSYMBOL_expr = 347,                     /* expr  */
  YYSYMBOL_binop = 348,                    /* binop  */
  YYSYMBOL_optunop = 349,                  /* optunop  */
  YYSYMBOL_value = 350,                    /* value  */
  YYSYMBOL_optcast = 351,                  /* optcast  */
  YYSYMBOL_scopedname = 352,               /* scopedname  */
  YYSYMBOL_scopednamehead = 353,           /* scopednamehead  */
  YYSYMBOL_scopepart = 354,                /* scopepart  */
  YYSYMBOL_bool_value = 355,               /* bool_value  */
  YYSYMBOL_simplevalue = 356,              /* simplevalue  */
  YYSYMBOL_exprlist = 357,                 /* exprlist  */
  YYSYMBOL_typedef = 358,                  /* typedef  */
  YYSYMBOL_struct = 359,                   /* struct  */
  YYSYMBOL_360_10 = 360,                   /* $@10  */
  YYSYMBOL_361_11 = 361,                   /* $@11  */
  YYSYMBOL_classtmpl = 362,                /* classtmpl  */
  YYSYMBOL_363_12 = 363,                   /* $@12  */
  YYSYMBOL_template = 364,                 /* template  */
  YYSYMBOL_class = 365,                    /* class  */
  YYSYMBOL_366_13 = 366,                   /* $@13  */
  YYSYMBOL_367_14 = 367,                   /* $@14  */
  YYSYMBOL_superclasses = 368,             /* superclasses  */
  YYSYMBOL_superlist = 369,                /* superlist  */
  YYSYMBOL_superclass = 370,               /* superclass  */
  YYSYMBOL_class_access = 371,             /* class_access  */
  YYSYMBOL_optclassbody = 372,             /* optclassbody  */
  YYSYMBOL_classbody = 373,                /* classbody  */
  YYSYMBOL_classline = 374,                /* classline  */
  YYSYMBOL_property = 375,                 /* property  */
  YYSYMBOL_property_args = 376,            /* property_args  */
  YYSYMBOL_property_arg_list = 377,        /* property_arg_list  */
  YYSYMBOL_property_arg = 378,             /* property_arg  */
  YYSYMBOL_property_body = 379,            /* property_body  */
  YYSYMBOL_property_body_directives = 380, /* property_body_directives  */
  YYSYMBOL_property_body_directive = 381,  /* property_body_directive  */
  YYSYMBOL_name_or_string = 382,           /* name_or_string  */
  YYSYMBOL_optslot = 383,                  /* optslot  */
  YYSYMBOL_dtor = 384,                     /* dtor  */
  YYSYMBOL_385_15 = 385,                   /* $@15  */
  YYSYMBOL_dtor_decl = 386,                /* dtor_decl  */
  YYSYMBOL_ctor = 387,                     /* ctor  */
  YYSYMBOL_388_16 = 388,                   /* $@16  */
  YYSYMBOL_simplector = 389,               /* simplector  */
  YYSYMBOL_optctorsig = 390,               /* optctorsig  */
  YYSYMBOL_391_17 = 391,                   /* $@17  */
  YYSYMBOL_optsig = 392,                   /* optsig  */
  YYSYMBOL_393_18 = 393,                   /* $@18  */
  YYSYMBOL_function = 394,                 /* function  */
  YYSYMBOL_operatorname = 395,             /* operatorname  */
  YYSYMBOL_optconst = 396,                 /* optconst  */
  YYSYMBOL_optfinal = 397,                 /* optfinal  */
  YYSYMBOL_optabstract = 398,              /* optabstract  */
  YYSYMBOL_optflags = 399,                 /* optflags  */
  YYSYMBOL_flaglist = 400,                 /* flaglist  */
  YYSYMBOL_flag = 401,                     /* flag  */
  YYSYMBOL_flagvalue = 402,                /* flagvalue  */
  YYSYMBOL_virtualcallcode = 403,          /* virtualcallcode  */
  YYSYMBOL_methodcode = 404,               /* methodcode  */
  YYSYMBOL_premethodcode = 405,            /* premethodcode  */
  YYSYMBOL_virtualcatchercode = 406,       /* virtualcatchercode  */
  YYSYMBOL_arglist = 407,                  /* arglist  */
  YYSYMBOL_rawarglist = 408,               /* rawarglist  */
  YYSYMBOL_argvalue = 409,                 /* argvalue  */
  YYSYMBOL_varmember = 410,                /* varmember  */
  YYSYMBOL_411_19 = 411,                   /* $@19  */
  YYSYMBOL_412_20 = 412,                   /* $@20  */
  YYSYMBOL_simple_varmem = 413,            /* simple_varmem  */
  YYSYMBOL_414_21 = 414,                   /* $@21  */
  YYSYMBOL_varmem = 415,                   /* varmem  */
  YYSYMBOL_member = 416,                   /* member  */
  YYSYMBOL_417_22 = 417,                   /* $@22  */
  YYSYMBOL_variable = 418,                 /* variable  */
  YYSYMBOL_variable_body = 419,            /* variable_body  */
  YYSYMBOL_variable_body_directives = 420, /* variable_body_directives  */
  YYSYMBOL_variable_body_directive = 421,  /* variable_body_directive  */
  YYSYMBOL_cpptype = 422,                  /* cpptype  */
  YYSYMBOL_argtype = 423,                  /* argtype  */
  YYSYMBOL_optref = 424,                   /* optref  */
  YYSYMBOL_deref = 425,                    /* deref  */
  YYSYMBOL_basetype = 426,                 /* basetype  */
  YYSYMBOL_cpptypelist = 427,              /* cpptypelist  */
  YYSYMBOL_optexceptions = 428,            /* optexceptions  */
  YYSYMBOL_exceptionlist = 429             /* exceptionlist  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  4
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1669

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  175
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  255
/* YYNRULES -- Number of rules.  */
#define YYNRULES  598
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1050

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   407


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   160,     2,     2,     2,   173,   165,     2,
     153,   154,   163,   162,   155,   161,     2,   164,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   170,   159,
     168,   156,   169,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   171,     2,   172,   174,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   157,   166,   158,   167,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   575,   575,   576,   579,   579,   598,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,   617,   618,   619,   620,   621,
     622,   623,   624,   625,   626,   627,   628,   629,   630,   631,
     632,   633,   634,   635,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   662,   668,   673,   678,
     679,   689,   696,   702,   707,   712,   713,   723,   730,   739,
     744,   749,   750,   760,   767,   778,   783,   788,   789,   799,
     806,   835,   840,   845,   846,   856,   863,   889,   897,   902,
     903,   914,   920,   928,   975,   979,  1086,  1091,  1092,  1103,
    1106,  1109,  1123,  1139,  1144,  1144,  1167,  1167,  1234,  1248,
    1249,  1252,  1253,  1254,  1258,  1262,  1271,  1280,  1289,  1290,
    1293,  1308,  1308,  1345,  1346,  1349,  1350,  1353,  1353,  1382,
    1383,  1386,  1392,  1398,  1403,  1408,  1409,  1419,  1426,  1426,
    1452,  1453,  1456,  1462,  1462,  1481,  1484,  1487,  1490,  1495,
    1496,  1501,  1509,  1546,  1554,  1560,  1565,  1566,  1579,  1587,
    1595,  1603,  1613,  1624,  1629,  1634,  1635,  1645,  1652,  1663,
    1668,  1673,  1674,  1684,  1691,  1703,  1708,  1713,  1714,  1724,
    1731,  1751,  1756,  1761,  1762,  1772,  1779,  1783,  1788,  1789,
    1799,  1802,  1805,  1819,  1837,  1842,  1847,  1848,  1858,  1865,
    1869,  1874,  1875,  1885,  1888,  1891,  1905,  1917,  1927,  1927,
    1941,  1946,  1947,  1965,  1978,  1997,  2010,  2023,  2036,  2049,
    2062,  2075,  2088,  2108,  2112,  2117,  2118,  2128,  2131,  2134,
    2137,  2151,  2152,  2168,  2171,  2174,  2183,  2189,  2194,  2195,
    2206,  2212,  2220,  2228,  2234,  2239,  2244,  2245,  2255,  2262,
    2265,  2270,  2273,  2278,  2281,  2286,  2292,  2298,  2304,  2309,
    2314,  2319,  2324,  2329,  2334,  2339,  2344,  2349,  2354,  2359,
    2364,  2370,  2375,  2381,  2387,  2393,  2399,  2405,  2410,  2416,
    2422,  2427,  2433,  2439,  2445,  2450,  2451,  2461,  2468,  2552,
    2556,  2562,  2567,  2568,  2579,  2585,  2593,  2596,  2599,  2608,
    2614,  2619,  2620,  2631,  2637,  2648,  2653,  2656,  2657,  2667,
    2667,  2691,  2694,  2697,  2702,  2705,  2710,  2713,  2718,  2719,
    2722,  2723,  2726,  2727,  2728,  2772,  2773,  2776,  2777,  2780,
    2783,  2788,  2789,  2807,  2810,  2813,  2816,  2819,  2822,  2827,
    2830,  2833,  2836,  2839,  2842,  2845,  2850,  2865,  2868,  2873,
    2879,  2882,  2883,  2891,  2896,  2899,  2904,  2913,  2923,  2926,
    2930,  2934,  2938,  2942,  2946,  2952,  2957,  2963,  2981,  3003,
    3042,  3048,  3042,  3092,  3092,  3118,  3123,  3129,  3123,  3169,
    3170,  3173,  3174,  3177,  3229,  3232,  3235,  3238,  3243,  3246,
    3251,  3252,  3253,  3256,  3257,  3258,  3259,  3260,  3261,  3262,
    3263,  3264,  3265,  3266,  3277,  3281,  3285,  3296,  3307,  3318,
    3329,  3340,  3351,  3362,  3373,  3384,  3395,  3406,  3417,  3418,
    3419,  3420,  3431,  3442,  3453,  3460,  3467,  3474,  3483,  3496,
    3501,  3502,  3514,  3521,  3528,  3537,  3541,  3546,  3547,  3557,
    3560,  3563,  3577,  3578,  3581,  3584,  3590,  3590,  3591,  3594,
    3660,  3660,  3661,  3664,  3710,  3713,  3713,  3724,  3727,  3727,
    3739,  3757,  3777,  3821,  3902,  3903,  3904,  3905,  3906,  3907,
    3908,  3909,  3910,  3911,  3912,  3913,  3914,  3915,  3916,  3917,
    3918,  3919,  3920,  3921,  3922,  3923,  3924,  3925,  3926,  3927,
    3928,  3929,  3930,  3933,  3936,  3941,  3944,  3949,  3952,  3960,
    3963,  3969,  3973,  3985,  3989,  3995,  3999,  4022,  4026,  4032,
    4035,  4040,  4043,  4048,  4051,  4056,  4059,  4064,  4116,  4121,
    4127,  4150,  4162,  4174,  4186,  4205,  4216,  4233,  4250,  4259,
    4266,  4266,  4267,  4267,  4268,  4272,  4272,  4273,  4277,  4278,
    4282,  4282,  4283,  4286,  4341,  4347,  4352,  4353,  4365,  4368,
    4371,  4386,  4401,  4418,  4423,  4437,  4547,  4550,  4558,  4561,
    4564,  4569,  4577,  4588,  4603,  4607,  4611,  4615,  4619,  4623,
    4627,  4631,  4635,  4639,  4643,  4647,  4651,  4655,  4659,  4663,
    4667,  4671,  4675,  4679,  4683,  4687,  4691,  4695,  4699,  4703,
    4707,  4711,  4717,  4723,  4739,  4742,  4750,  4756,  4763
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TK_API",
  "TK_AUTOPYNAME", "TK_DEFDOCSTRFMT", "TK_DEFDOCSTRSIG", "TK_DEFENCODING",
  "TK_PLUGIN", "TK_VIRTERRORHANDLER", "TK_EXPTYPEHINTCODE",
  "TK_TYPEHINTCODE", "TK_DOCSTRING", "TK_DOC", "TK_EXPORTEDDOC",
  "TK_EXTRACT", "TK_MAKEFILE", "TK_ACCESSCODE", "TK_GETCODE", "TK_SETCODE",
  "TK_PREINITCODE", "TK_INITCODE", "TK_POSTINITCODE", "TK_FINALCODE",
  "TK_UNITCODE", "TK_UNITPOSTINCLUDECODE", "TK_MODCODE", "TK_TYPECODE",
  "TK_PREPYCODE", "TK_COPYING", "TK_MAPPEDTYPE", "TK_CODELINE", "TK_IF",
  "TK_END", "TK_NAME_VALUE", "TK_PATH_VALUE", "TK_STRING_VALUE",
  "TK_VIRTUALCATCHERCODE", "TK_TRAVERSECODE", "TK_CLEARCODE",
  "TK_GETBUFFERCODE", "TK_RELEASEBUFFERCODE", "TK_READBUFFERCODE",
  "TK_WRITEBUFFERCODE", "TK_SEGCOUNTCODE", "TK_CHARBUFFERCODE",
  "TK_PICKLECODE", "TK_VIRTUALCALLCODE", "TK_METHODCODE",
  "TK_PREMETHODCODE", "TK_INSTANCECODE", "TK_FROMTYPE", "TK_TOTYPE",
  "TK_TOSUBCLASS", "TK_INCLUDE", "TK_OPTINCLUDE", "TK_IMPORT",
  "TK_EXPHEADERCODE", "TK_MODHEADERCODE", "TK_TYPEHEADERCODE", "TK_MODULE",
  "TK_CMODULE", "TK_CONSMODULE", "TK_COMPOMODULE", "TK_CLASS", "TK_STRUCT",
  "TK_PUBLIC", "TK_PROTECTED", "TK_PRIVATE", "TK_SIGNALS",
  "TK_SIGNAL_METHOD", "TK_SLOTS", "TK_SLOT_METHOD", "TK_BOOL", "TK_SHORT",
  "TK_INT", "TK_LONG", "TK_FLOAT", "TK_DOUBLE", "TK_CHAR", "TK_WCHAR_T",
  "TK_VOID", "TK_PYOBJECT", "TK_PYTUPLE", "TK_PYLIST", "TK_PYDICT",
  "TK_PYCALLABLE", "TK_PYSLICE", "TK_PYTYPE", "TK_PYBUFFER", "TK_VIRTUAL",
  "TK_ENUM", "TK_SIGNED", "TK_UNSIGNED", "TK_SCOPE", "TK_LOGICAL_OR",
  "TK_CONST", "TK_STATIC", "TK_SIPSIGNAL", "TK_SIPSLOT", "TK_SIPANYSLOT",
  "TK_SIPRXCON", "TK_SIPRXDIS", "TK_SIPSLOTCON", "TK_SIPSLOTDIS",
  "TK_SIPSSIZET", "TK_SIZET", "TK_NUMBER_VALUE", "TK_REAL_VALUE",
  "TK_TYPEDEF", "TK_NAMESPACE", "TK_TIMELINE", "TK_PLATFORMS",
  "TK_FEATURE", "TK_LICENSE", "TK_QCHAR_VALUE", "TK_TRUE_VALUE",
  "TK_FALSE_VALUE", "TK_NULL_VALUE", "TK_OPERATOR", "TK_THROW",
  "TK_QOBJECT", "TK_EXCEPTION", "TK_RAISECODE", "TK_EXPLICIT",
  "TK_TEMPLATE", "TK_FINAL", "TK_ELLIPSIS", "TK_DEFMETATYPE",
  "TK_DEFSUPERTYPE", "TK_PROPERTY", "TK_HIDE_NS", "TK_FORMAT", "TK_GET",
  "TK_ID", "TK_KWARGS", "TK_LANGUAGE", "TK_LICENSEE", "TK_NAME",
  "TK_OPTIONAL", "TK_ORDER", "TK_REMOVELEADING", "TK_SET", "TK_SIGNATURE",
  "TK_TIMESTAMP", "TK_TYPE", "TK_USEARGNAMES", "TK_PYSSIZETCLEAN",
  "TK_USELIMITEDAPI", "TK_ALLRAISEPYEXC", "TK_CALLSUPERINIT",
  "TK_DEFERRORHANDLER", "TK_VERSION", "'('", "')'", "','", "'='", "'{'",
  "'}'", "';'", "'!'", "'-'", "'+'", "'*'", "'/'", "'&'", "'|'", "'~'",
  "'<'", "'>'", "':'", "'['", "']'", "'%'", "'^'", "$accept",
  "specification", "statement", "$@1", "modstatement", "nsstatement",
  "defdocstringfmt", "defdocstringfmt_args", "defdocstringfmt_arg_list",
  "defdocstringfmt_arg", "defdocstringsig", "defdocstringsig_args",
  "defdocstringsig_arg_list", "defdocstringsig_arg", "defencoding",
  "defencoding_args", "defencoding_arg_list", "defencoding_arg", "plugin",
  "plugin_args", "plugin_arg_list", "plugin_arg", "virterrorhandler",
  "veh_args", "veh_arg_list", "veh_arg", "api", "api_args", "api_arg_list",
  "api_arg", "exception", "baseexception", "exception_body",
  "exception_body_directives", "exception_body_directive", "raisecode",
  "mappedtype", "$@2", "mappedtypetmpl", "$@3", "mtdefinition", "mtbody",
  "mtline", "mtfunction", "namespace", "$@4", "optnsbody", "nsbody",
  "platforms", "$@5", "platformlist", "platform", "feature",
  "feature_args", "feature_arg_list", "feature_arg", "timeline", "$@6",
  "qualifierlist", "qualifiername", "ifstart", "$@7", "oredqualifiers",
  "qualifiers", "ifend", "license", "license_args", "license_arg_list",
  "license_arg", "defmetatype", "defmetatype_args", "defmetatype_arg_list",
  "defmetatype_arg", "defsupertype", "defsupertype_args",
  "defsupertype_arg_list", "defsupertype_arg", "hiddenns", "hiddenns_args",
  "hiddenns_arg_list", "hiddenns_arg", "consmodule", "consmodule_args",
  "consmodule_arg_list", "consmodule_arg", "consmodule_body",
  "consmodule_body_directives", "consmodule_body_directive", "compmodule",
  "compmodule_args", "compmodule_arg_list", "compmodule_arg",
  "compmodule_body", "compmodule_body_directives",
  "compmodule_body_directive", "module", "module_args", "$@8",
  "module_arg_list", "module_arg", "module_body", "module_body_directives",
  "module_body_directive", "dottedname", "optnumber", "include",
  "include_args", "include_arg_list", "include_arg", "optinclude",
  "import", "import_args", "import_arg_list", "import_arg",
  "optaccesscode", "optgetcode", "optsetcode", "copying", "exphdrcode",
  "modhdrcode", "typehdrcode", "travcode", "clearcode", "getbufcode",
  "releasebufcode", "readbufcode", "writebufcode", "segcountcode",
  "charbufcode", "instancecode", "picklecode", "finalcode", "modcode",
  "typecode", "preinitcode", "initcode", "postinitcode", "unitcode",
  "unitpostinccode", "prepycode", "exptypehintcode", "modtypehintcode",
  "classtypehintcode", "doc", "exporteddoc", "autopyname",
  "autopyname_args", "autopyname_arg_list", "autopyname_arg", "docstring",
  "docstring_args", "docstring_arg_list", "docstring_arg", "optdocstring",
  "extract", "extract_args", "extract_arg_list", "extract_arg", "makefile",
  "codeblock", "codelines", "enum", "$@9", "optenumkey", "optfilename",
  "optname", "optenumbody", "enumbody", "enumline", "optcomma",
  "optenumassign", "optassign", "expr", "binop", "optunop", "value",
  "optcast", "scopedname", "scopednamehead", "scopepart", "bool_value",
  "simplevalue", "exprlist", "typedef", "struct", "$@10", "$@11",
  "classtmpl", "$@12", "template", "class", "$@13", "$@14", "superclasses",
  "superlist", "superclass", "class_access", "optclassbody", "classbody",
  "classline", "property", "property_args", "property_arg_list",
  "property_arg", "property_body", "property_body_directives",
  "property_body_directive", "name_or_string", "optslot", "dtor", "$@15",
  "dtor_decl", "ctor", "$@16", "simplector", "optctorsig", "$@17",
  "optsig", "$@18", "function", "operatorname", "optconst", "optfinal",
  "optabstract", "optflags", "flaglist", "flag", "flagvalue",
  "virtualcallcode", "methodcode", "premethodcode", "virtualcatchercode",
  "arglist", "rawarglist", "argvalue", "varmember", "$@19", "$@20",
  "simple_varmem", "$@21", "varmem", "member", "$@22", "variable",
  "variable_body", "variable_body_directives", "variable_body_directive",
  "cpptype", "argtype", "optref", "deref", "basetype", "cpptypelist",
  "optexceptions", "exceptionlist", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-840)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-564)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -840,   125,  -840,  1218,  -840,  -840,    42,    -2,    54,    55,
      58,    74,   100,   100,   100,   100,    75,   181,   100,   100,
     100,   100,   100,   100,   100,   100,  1542,    51,  -840,  -840,
      23,   228,    46,   100,   100,   100,    48,   238,    62,    64,
      84,    84,  -840,  -840,  -840,   190,  -840,  -840,  -840,  -840,
    -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,   218,
     224,   277,   279,  1542,  -840,  -840,  1506,   309,  -840,  -840,
      76,    59,  1506,    84,   203,  -840,    66,    68,    53,  -840,
    -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,
    -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,
    -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,
    -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,
    -840,  -840,  -840,  -840,   206,   285,  -840,  -840,  -840,  -840,
     359,  -840,  -840,  -840,    79,  -840,   297,   -26,  -840,  -840,
     254,  -840,  -840,   268,  -840,  -840,   271,  -840,  -840,   281,
    -840,  -840,   286,   100,  -840,  -840,   257,  -840,  -840,  -840,
    -840,   101,   100,   395,  -840,  -840,  -840,  -840,  -840,  -840,
    -840,  -840,    84,   276,  -840,  -840,   158,  -840,  -840,  -840,
     298,  -840,  -840,  -840,  -840,  -840,  -840,   338,   287,  -840,
     335,   324,   342,  -840,   331,   344,  -840,  -840,    18,  -840,
    -840,  -840,   418,  -840,  -840,  -840,   447,  -840,   285,  -840,
      77,  -840,   378,   380,  -840,   400,  -840,  -840,   171,   276,
     388,   390,  1506,   404,  -840,  -840,   406,  -840,  -840,   407,
    -840,  -840,  1506,   279,  1542,   482,   -49,   234,   146,  -840,
     391,   392,   169,  -840,   393,   210,  -840,   396,   214,  -840,
     399,   222,  -840,   401,   295,  -840,   402,   306,  -840,  -840,
    -840,  -840,   403,   405,   312,  -840,  -840,  -840,   100,  -840,
     516,  -840,     4,   408,   409,   316,  -840,   410,   323,  -840,
     412,   413,   414,   416,   417,   419,   420,   421,   422,   423,
     326,  -840,   244,  -840,   335,  -840,  -840,   424,   337,  -840,
     267,  -840,   425,   339,  -840,   267,  -840,   381,   381,  -840,
     276,  -840,   146,   276,   397,   426,   528,   529,   428,   341,
    -840,   429,   430,   431,   432,   343,  -840,  -840,  1279,    84,
     276,  -840,   -21,   433,   349,  -840,   435,   352,  -840,   436,
     354,  -840,    -9,  -840,   276,  -840,  1279,   437,   439,   105,
     440,   441,   442,   443,   444,   449,   450,  -840,    34,   -34,
     438,   451,   452,   456,   486,  -840,  -840,   314,   488,  -840,
     -26,   567,  -840,   254,   575,  -840,   268,   576,  -840,   271,
     579,  -840,   281,   580,  -840,   286,   581,   513,  -840,   101,
    -840,   465,   -11,  -840,   466,   461,   590,   530,   472,   467,
     592,   394,  -840,   158,   594,  -840,   298,   595,   596,   238,
     394,   394,   394,   394,   394,   599,   523,  -840,   338,   485,
      81,  -840,  -840,    36,  -840,  -840,  -840,  -840,   238,  -840,
     324,  -840,  -840,    38,  -840,  -840,   238,  -840,   331,  -840,
    -840,    45,  -840,  -840,   315,   276,   276,  -840,  -840,   480,
     606,   253,   483,  -840,    -1,  -840,  -840,    33,  -840,   314,
    -840,   400,   605,   607,   608,   609,  -840,   171,   418,   418,
     418,   418,   418,   493,   494,   418,   495,   497,  -840,   418,
     492,   496,   498,  1506,  -840,   238,  -840,   404,   238,  -840,
     406,    84,  -840,   407,  -840,  -840,   499,   288,   500,  -840,
    1506,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,
     502,  -840,   504,  -840,  -840,  -840,  1279,  -840,  -840,  -840,
    -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,
    -840,  -840,  -840,  -840,  -840,  -840,    93,   516,  -840,   334,
    -840,  -840,    11,  -840,   418,  -840,  -840,  -840,  -840,  -840,
    -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,
    -840,  -840,  -840,   515,  -840,  -840,   128,   100,   505,  -840,
    -840,  -840,   506,  -840,  -840,  -840,   507,  -840,  -840,  -840,
    -840,   508,  -840,    84,  -840,  -840,   510,   642,   517,  -840,
     735,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,
    -840,  -840,  -840,  -840,   276,   276,   276,   276,   276,  1279,
    1279,   276,   573,  1279,   276,   519,  -840,  -840,   232,  -840,
    -840,  -840,  -840,  -840,  -840,  -840,  -840,   466,   573,   100,
     100,   100,  -840,  -840,    56,  -840,   656,   520,  -840,  -840,
     521,   509,  -840,  -840,  -840,  -840,  -840,   100,   100,   100,
     100,  1506,   134,  -840,  -840,  -840,  -840,  -840,  -840,  -840,
    -840,  -840,   643,  -840,   522,   358,  -840,   525,   526,   360,
    -840,  -840,  -840,  -840,  -840,   315,  -840,   527,   527,   389,
    -840,  -840,   533,  -840,  -840,   492,   492,   492,  -840,  -840,
     535,   536,  -840,  -840,   561,  -840,  -840,    84,   293,  -840,
     272,   100,    47,  -840,  -840,  -840,  -840,  -840,  -840,   561,
    -840,  -840,  -840,  -840,  -840,   100,   673,   534,   573,   335,
    -840,  -840,  -840,  -840,   658,   537,  -840,  -840,   659,  -840,
     515,   661,   662,  -840,   128,  -840,  1092,   540,   541,   538,
    -840,  -840,   545,   389,  -840,  1506,  -840,  -840,  -840,   418,
     418,  -840,   584,   552,  -840,  -840,  -840,  -840,  -840,  -840,
     519,  -840,  -840,  -840,  -840,  -840,  -840,   843,  -840,   548,
    -840,   584,  -840,   100,   690,  -840,   561,   549,   558,  -840,
    -840,  -840,  -840,  -840,  -840,   100,   100,   559,   100,   100,
     100,   100,   100,   100,   100,   100,   100,   100,   100,   100,
     644,   644,   644,   543,  -840,  -840,   547,  -840,  -840,   563,
     683,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,
    -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,
    -840,  -840,  -840,  -840,  -840,   983,  -840,  -840,  -840,  -840,
    -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,
     519,   276,   562,  -840,   362,   276,   276,   565,   564,  -840,
    -840,  -840,  -840,  -840,  -840,  -840,   568,   -30,  -840,  -840,
     569,  -840,   564,  -840,   100,  -840,   584,   335,  1279,  -840,
    -840,  1279,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,
    -840,  -840,  -840,  -840,  -840,   553,   555,   560,  -840,  1336,
    1336,   566,  1450,  1393,   694,   156,   572,   578,  -840,  -840,
    -840,   577,  -840,   276,  -840,  -840,    84,   627,   276,  -840,
     274,   276,  -840,   564,  -840,   583,   585,  -840,  -840,  -840,
    -840,  -840,  -840,  -840,  -840,    90,  -840,   559,  -840,   582,
     586,   587,   364,  -840,   267,  -840,   593,  -840,  -840,   589,
    -840,   367,  -840,   570,   293,   373,   570,   276,   573,   584,
     591,   701,   314,   712,  -840,   156,  -840,  -840,  -840,    52,
    -840,   584,   642,  -840,    84,  -840,   597,  -840,   519,   600,
     570,   584,   276,  -840,  -840,  -840,  -840,   602,  -840,   564,
    -840,  -840,  1506,   700,   293,   642,   603,   276,   616,  -840,
     276,   598,   100,   702,   700,   700,   570,  -840,   611,   612,
    1279,  -840,   100,   715,   702,   702,   615,   601,   642,   700,
     604,  -840,   100,   706,   715,   715,   642,  1279,   700,   702,
     617,  -840,   100,  -840,   706,   706,   700,   610,   702,   715,
    -840,  -840,  -840,  -840,   702,   618,  -840,  -840,  -840,  -840
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       4,     4,     2,     0,     1,     3,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   151,   353,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   575,   565,   568,   569,   573,   574,   578,   579,
     580,   581,   582,   583,   584,   585,   586,   587,   588,   311,
       0,   566,     0,     0,   589,   590,     0,     0,   138,   127,
       0,   153,     0,     0,     0,   591,     0,     0,     0,     5,
      43,    19,    20,    21,     9,    42,    14,    50,    40,    41,
      46,    16,    17,    15,    44,    45,    18,    22,    23,    24,
       7,     8,     6,    11,    12,    13,    10,    25,    26,    55,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    52,   561,   350,   351,    51,    47,    49,
     373,    48,    53,    54,     0,   558,     0,     0,    86,    57,
       0,    56,    63,     0,    62,    69,     0,    68,    75,     0,
      74,    81,     0,     0,   307,   278,     0,   279,   281,   282,
     299,     0,     0,   314,   272,   273,   274,   275,   276,   270,
     277,   255,     0,   499,   143,   236,     0,   235,   242,   244,
       0,   243,   256,   257,   258,   231,   232,     0,   223,   208,
     233,     0,   186,   181,     0,   199,   194,   376,   370,   571,
     312,   313,   316,   576,   564,   567,   570,   577,   349,   558,
       0,   121,     0,     0,   133,     0,   132,   154,     0,   499,
       0,    94,     0,     0,   162,   163,     0,   168,   169,     0,
     174,   175,     0,     0,     0,     0,   499,     0,   556,    87,
       0,     0,     0,    89,     0,     0,    59,     0,     0,    65,
       0,     0,    71,     0,     0,    77,     0,     0,    83,    80,
     308,   306,     0,     0,     0,   301,   298,   315,     0,   563,
       0,   104,   316,     0,     0,     0,   238,     0,     0,   246,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   211,     0,   206,   233,   234,   207,     0,     0,   183,
       0,   180,     0,     0,   196,     0,   193,   379,   379,   317,
     499,   572,   556,   499,     0,   123,     0,     0,     0,     0,
     135,     0,     0,     0,     0,     0,   156,   152,   518,     0,
     499,   592,     0,     0,     0,   165,     0,     0,   171,     0,
       0,   177,     0,   352,   499,   374,   518,   544,     0,     0,
       0,   465,   464,   466,   467,   469,   470,   484,   487,   491,
       0,   468,   471,     0,   560,   557,   554,     0,     0,    88,
       0,     0,    58,     0,     0,    64,     0,     0,    70,     0,
       0,    76,     0,     0,    82,     0,     0,     0,   300,     0,
     305,   503,     0,   501,     0,   145,     0,   149,     0,     0,
       0,     0,   237,     0,     0,   245,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   210,     0,     0,
     289,   227,   228,     0,   225,   229,   230,   209,     0,   182,
       0,   190,   191,     0,   188,   192,     0,   195,     0,   203,
     204,     0,   201,   205,   384,   499,   499,   309,   553,     0,
       0,     0,     0,   142,     0,   140,   131,     0,   129,     0,
     134,     0,     0,     0,     0,     0,   155,     0,   316,   316,
     316,   316,   316,     0,     0,   316,     0,   517,   519,   316,
     329,     0,     0,     0,   375,     0,   164,     0,     0,   170,
       0,     0,   176,     0,   562,   106,     0,     0,     0,   485,
       0,   489,   490,   475,   474,   476,   477,   479,   480,   488,
     472,   492,   473,   486,   478,   481,   518,   559,   442,   443,
      91,    92,    90,    61,    60,    67,    66,    73,    72,    79,
      78,    85,    84,   303,   304,   302,     0,     0,   500,     0,
     105,   146,     0,   144,   316,   240,   354,   355,   241,   239,
     248,   247,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   212,     0,   283,   290,     0,     0,     0,   226,
     185,   184,     0,   189,   198,   197,     0,   202,   385,   386,
     387,   380,   381,     0,   377,   371,     0,   296,     0,   125,
       0,   373,   122,   139,   141,   128,   130,   137,   136,   159,
     160,   161,   158,   157,   499,   499,   499,   499,   499,   518,
     518,   499,   493,     0,   499,   347,   529,    95,     0,    93,
     593,   167,   166,   173,   172,   179,   178,     0,   493,     0,
       0,     0,   548,   549,     0,   546,   249,     0,   482,   483,
       0,   231,   507,   508,   505,   504,   502,     0,     0,     0,
       0,     0,     0,   109,   119,   111,   112,   113,   117,   114,
     118,   147,     0,   150,     0,     0,   285,     0,     0,     0,
     292,   288,   224,   187,   200,   384,   383,   388,   388,   318,
     297,   368,     0,   124,   126,   329,   329,   329,   524,   525,
       0,     0,   528,   494,   495,   520,   555,     0,   330,   331,
     339,     0,     0,    97,   101,    99,   100,   102,   107,   495,
     550,   551,   552,   545,   547,     0,   251,     0,   493,   233,
     271,   267,   115,   116,     0,     0,   110,   148,     0,   284,
       0,     0,     0,   291,     0,   382,   390,     0,     0,   327,
     322,   323,     0,   319,   320,     0,   521,   522,   523,   316,
     316,   496,   594,     0,   333,   334,   335,   336,   337,   338,
     347,   340,   342,   343,   344,   345,   341,     0,   103,     0,
      98,   594,   250,     0,   253,   461,   495,     0,     0,   108,
     287,   286,   294,   295,   293,     0,     0,   353,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     444,   444,   444,     0,   530,   532,   540,   535,   450,     0,
       0,   399,   395,   393,   394,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   415,   416,   404,   417,   403,
     401,   400,   396,   398,   397,     0,   391,   402,   419,   448,
     418,   452,   542,   420,   534,   537,   538,   539,   378,   372,
     347,   499,     0,   321,     0,   499,   499,     0,   497,   348,
     332,   363,   360,   359,   364,   362,     0,   356,   361,   346,
       0,    96,   497,   252,     0,   543,   594,   233,   518,   280,
     269,   518,   259,   260,   261,   262,   263,   264,   265,   266,
     268,   423,   422,   421,   445,     0,     0,     0,   427,     0,
       0,     0,     0,     0,     0,     0,   435,     0,   389,   392,
     328,   325,   310,   499,   526,   527,   596,     0,   499,   358,
     347,   499,   254,   497,   506,     0,     0,   424,   425,   426,
     540,   531,   533,   447,   541,     0,   536,     0,   451,     0,
       0,     0,     0,   430,     0,   428,     0,   326,   324,     0,
     597,     0,   498,   457,   366,     0,   457,   499,   493,   594,
       0,     0,     0,     0,   429,     0,   439,   440,   441,     0,
     437,   594,   296,   595,     0,   458,     0,   357,   347,     0,
     457,   594,   499,   432,   433,   434,   431,     0,   438,   497,
     369,   598,     0,   513,   367,   296,     0,   499,   454,   436,
     499,     0,     0,   511,   513,   513,   457,   455,     0,     0,
     518,   514,     0,   515,   511,   511,     0,     0,   296,   513,
       0,   512,     0,   509,   515,   515,   296,   518,   513,   511,
       0,   516,     0,   463,   509,   509,   513,     0,   511,   515,
     459,   510,   460,   462,   511,     0,   453,   449,   120,   456
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -840,  -840,   754,  -840,  -840,  -408,  -840,  -840,  -840,   434,
    -840,  -840,  -840,   415,  -840,  -840,  -840,   386,  -840,  -840,
    -840,   384,  -840,  -840,  -840,   411,  -840,  -840,  -840,   427,
    -622,  -840,  -840,  -840,    91,  -840,  -840,  -840,  -840,  -840,
     165,  -840,   143,  -840,  -615,  -840,  -840,  -840,  -840,  -840,
    -840,   345,  -840,  -840,  -840,   340,  -840,  -840,  -840,   350,
    -264,  -840,  -840,  -840,  -261,  -840,  -840,  -840,   363,  -840,
    -840,  -840,   311,  -840,  -840,  -840,   346,  -840,  -840,  -840,
     332,  -840,  -840,  -840,   375,  -840,  -840,   445,  -840,  -840,
    -840,   446,  -840,  -840,   398,  -840,  -840,  -840,  -840,   448,
    -840,  -840,   453,    17,  -276,  -840,  -840,  -840,   455,  -840,
    -840,  -840,  -840,   457,  -840,  -840,  -840,  -840,  -840,  -840,
    -513,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,  -595,
    -840,  -840,  -840,  -593,  -840,  -840,  -840,  -840,  -840,  -840,
    -840,  -840,  -840,  -840,  -840,  -840,  -840,  -840,   102,  -268,
    -840,  -840,    99,  -839,  -840,  -840,  -840,   454,  -840,   -13,
    -840,  -510,  -840,  -840,  -840,  -225,  -840,  -840,    94,  -840,
    -840,  -239,  -790,  -840,  -840,  -653,  -840,   -27,   772,   613,
    -351,  -840,  -840,  -578,  -573,  -840,  -840,  -561,  -840,   835,
    -216,  -840,  -840,   539,  -840,   167,  -840,   170,  -840,    15,
    -840,  -840,  -840,  -116,  -840,  -840,  -118,  -436,  -272,  -840,
    -840,   -48,  -840,  -840,   -52,  -840,  -840,  -788,  -840,    12,
    -840,  -598,  -644,  -837,  -194,  -840,   318,  -840,  -503,  -734,
    -735,  -786,  -342,  -840,   243,  -840,  -840,  -840,  -366,  -840,
     -44,  -840,  -840,    14,  -840,  -840,   230,     0,  -840,   556,
     660,   -10,  -205,  -722,  -840
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     2,     3,    79,    80,    81,   141,   245,   246,
      82,   144,   248,   249,    83,   147,   251,   252,    84,   150,
     254,   255,    85,   153,   257,   258,    86,   138,   242,   243,
      87,   330,   619,   702,   703,   704,    88,   394,    89,   627,
     540,   652,   653,   654,    90,   315,   452,   590,    91,   213,
     457,   458,    92,   216,   319,   320,    93,   212,   454,   455,
      94,   272,   397,   398,    95,    96,   219,   325,   326,    97,
     224,   334,   335,    98,   227,   337,   338,    99,   230,   340,
     341,   100,   192,   298,   299,   301,   433,   434,   101,   195,
     303,   304,   306,   441,   442,   102,   188,   294,   290,   291,
     293,   423,   424,   189,   296,   103,   177,   275,   276,   104,
     105,   181,   278,   279,   716,   774,   875,   106,   107,   108,
     109,   816,   817,   818,   819,   820,   821,   822,   823,   658,
     825,   826,   110,   659,   111,   112,   113,   114,   115,   116,
     117,   118,   828,   119,   120,   425,   564,   665,   666,   680,
     567,   669,   670,   681,   121,   162,   264,   265,   122,   155,
     156,   123,   586,   202,   268,   310,   742,   743,   744,   948,
     851,   616,   698,   760,   767,   699,   700,   124,   125,   126,
     548,   869,   955,   127,   128,   308,   678,   129,   235,   591,
     131,   307,   677,   445,   581,   582,   583,   737,   835,   836,
     837,   906,   942,   943,   945,   969,   970,   520,   895,   838,
     901,   839,   840,   904,   841,  1008,  1017,   976,   992,   842,
     363,   694,   752,   918,   271,   392,   393,   645,  1033,  1013,
    1003,  1023,   476,   477,   478,   843,   899,   900,   844,   903,
     845,   846,   902,   847,   498,   634,   635,   479,   480,   366,
     238,   135,   332,   858,   951
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     157,   158,   159,   134,   496,   164,   165,   166,   167,   168,
     169,   170,   171,   197,   198,   132,   173,   133,   427,   345,
     182,   183,   184,   597,   426,   327,   657,   342,   421,   660,
     709,   422,   435,   453,   139,   921,   431,   443,   395,   432,
     419,   439,   347,   589,   440,   661,   221,   399,   420,   872,
     420,   231,  -563,   209,   190,   193,   196,   420,   175,   555,
     556,   557,   558,   559,   420,   771,   210,   456,    27,    28,
      27,    28,   220,   629,   630,   631,   136,    27,    28,    27,
      28,   179,   185,   186,    27,    28,   957,    29,    27,    28,
     142,   145,   148,   225,   228,   217,   185,   186,   185,   186,
     185,   186,   185,   186,   346,   707,    35,   860,   151,   160,
     214,   313,   240,   236,   811,   270,   447,   565,    29,   449,
     776,   812,   511,  -561,   960,     4,   241,   641,   186,   642,
     954,   154,   876,   990,   483,   512,   482,  -563,   232,   657,
     259,   824,   660,   827,   537,   269,   483,    62,   484,   266,
     495,   140,  1000,   538,   923,   426,  1004,   593,   831,   421,
     494,   647,   422,   832,   396,   435,    27,    28,   979,   431,
     701,   662,   432,   443,   640,   833,   176,   439,    62,  1028,
     440,  -563,   684,  -563,   648,   649,   650,  1036,   994,   707,
     509,   595,   996,    35,   568,   137,   572,   910,   237,   180,
     643,   187,   510,   576,   174,   769,   229,   143,   146,   237,
     987,   149,   218,   811,   713,   191,   163,   194,  1016,   223,
     812,   226,   331,   815,   344,    59,   830,   152,   161,   215,
     314,   651,   331,   632,   566,   262,   633,   982,  1034,  1035,
     824,   263,   827,   604,   605,   606,   607,   608,   419,   989,
     611,   584,   585,  1047,   614,   390,   420,   831,   500,   997,
     667,   501,   832,   178,    27,    28,   199,   690,   691,  1014,
    1015,   668,   185,   186,   833,   655,    27,    28,   656,   420,
    1024,  1025,   200,   201,  1029,    27,    28,    29,   260,   939,
     261,    35,   725,  1038,   940,  1039,   273,   274,   941,    27,
      28,  1044,   481,   203,  1046,   629,   630,   631,   321,   364,
    1048,   365,    35,    29,   322,   323,   324,    40,    41,   663,
      27,    28,   815,   369,   370,   830,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,   211,    59,    60,    61,    62,   518,    63,
     519,   204,   205,   206,   705,   701,   207,   706,    64,    65,
     981,   647,    66,    67,   372,   373,    27,    28,   375,   376,
     632,   222,    72,   633,   232,    73,   378,   379,    74,   233,
      75,   578,   579,   580,   648,   649,   650,   348,   655,   234,
     349,   656,   244,    35,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   239,   360,   247,   361,   362,   250,
     685,   686,   687,   688,   689,   740,   868,   692,   741,   253,
     696,    27,    28,   739,   256,    59,   554,   697,  -365,  -365,
     267,   651,   761,   762,   763,   764,   277,   765,   705,   766,
     270,   706,   295,   777,   292,   570,   746,   747,   748,   381,
     382,   134,   309,   574,   754,   755,   756,   757,   758,   759,
     384,   385,   297,   132,   625,   133,   388,   389,   829,   302,
     402,   403,   813,   280,   281,   814,   282,   405,   406,   740,
     417,   418,   741,   620,   283,   284,   285,   286,   287,   288,
     289,   429,   430,   437,   438,   460,   461,   466,   467,   300,
     637,   305,   621,   486,   487,   623,   489,   490,   492,   493,
     546,   547,   729,   730,   733,   734,   913,   483,   964,   965,
     834,   973,   974,   311,   855,   856,   984,   977,   978,   896,
     897,  1042,  1043,   931,   932,   316,   925,   317,   318,   926,
     854,   328,   333,   329,   336,   339,    40,   367,   368,   371,
     391,   444,   374,   644,   671,   377,   676,   380,   383,   386,
     450,   387,   453,   456,   400,   401,   404,   829,   407,   408,
     409,   813,   410,   411,   814,   412,   413,   414,   415,   416,
     428,   436,   517,   451,   459,   462,   463,   464,   465,   485,
     134,   488,   491,   499,   497,   521,   502,   503,   504,   505,
     506,   924,   132,   523,   133,   507,   508,   514,   515,   516,
     513,   525,   527,   529,   531,   533,   710,   711,   712,   834,
     534,   536,  -317,   539,   541,   542,   543,   545,   544,   550,
     561,   552,   553,   560,   720,   721,   722,   723,   563,   587,
     588,   599,   592,   600,   601,   602,   609,   610,   615,   612,
     617,   724,   613,   628,   420,   618,   664,   911,   638,   636,
     639,   914,   915,   675,   672,   673,   674,   679,  1020,   693,
     753,   682,   697,   715,   717,   718,   968,   727,   728,   719,
     966,   731,   732,   967,   736,  1037,   745,   751,   768,   749,
     750,   773,   778,   775,   850,   780,   779,   782,   783,   848,
     849,   968,   772,   852,   857,   966,   859,   871,   967,   874,
     877,   878,   881,   898,  -446,   894,   905,   907,   916,   949,
     917,   912,   920,   927,   953,   928,   919,   956,   937,   944,
     929,   946,   947,   810,   952,   983,   134,   958,   961,   959,
     867,   975,   962,   963,   346,   331,   985,   971,   972,  1002,
    1012,  1010,  1022,  1032,  1027,     5,   993,   870,  1030,   995,
     873,   999,  1005,   980,  1045,   528,   530,    27,    28,    29,
    1018,  1019,   879,   880,  1026,   882,   883,   884,   885,   886,
     887,   888,   889,   890,   891,   892,   893,  1007,   998,  1040,
    1049,   526,   708,   770,    35,   726,   532,   522,   622,    40,
      41,   598,   596,  1006,   594,   571,  1009,   524,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,   626,    59,    60,    61,    62,
     603,    63,   781,   784,   208,   134,   624,   853,   130,   577,
      64,    65,   735,   535,    66,    67,   343,   446,   738,   986,
     909,   988,   938,   933,    72,   646,   695,    73,   549,   936,
      74,   922,    75,   551,   714,     0,   562,     0,   448,   312,
       0,     0,     0,     0,     0,     0,   569,    29,   573,   861,
       0,     0,     0,     0,   575,     0,     0,     0,     0,   950,
       0,     0,     0,   683,     0,     0,     0,     0,     0,   134,
     134,     0,   935,   134,     0,     0,     0,     0,   172,     0,
       0,     0,     0,     0,   934,     0,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,     0,     0,    60,    61,    62,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   991,    64,    65,
     862,   863,     0,     0,     0,     0,     0,     0,   864,   546,
     547,   865,     0,     0,     0,     0,     0,     0,     0,     0,
      75,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1011,
       0,     0,  1001,     0,   785,   420,     0,     0,     0,  1021,
     866,     0,     0,     0,     0,     0,   786,     0,     0,  1031,
     647,     0,     0,     0,     0,    27,    28,   787,     0,  1041,
       0,   788,   789,   790,   791,   792,   793,   794,   795,   796,
       0,     0,     0,   648,   797,   798,   799,     0,     0,     0,
       0,     0,    35,     0,     0,     0,     0,    40,    41,   800,
     801,   802,   803,   804,     0,   805,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,   806,    59,    60,    61,    62,     0,    63,
     807,     0,     0,     0,     0,     0,     0,     0,    64,    65,
       0,     0,    66,    67,     0,     0,     0,     0,     0,     0,
       0,     0,    72,   785,   420,    73,     0,   808,    74,     0,
      75,     0,     0,   809,     0,   786,     0,     0,     0,   647,
       0,     0,     0,     0,    27,    28,   787,     0,     0,     0,
     788,   789,   790,   791,   792,   793,   794,   795,   796,     0,
       0,   908,   648,   797,   798,   799,     0,     0,     0,     0,
     810,    35,     0,     0,     0,     0,    40,    41,   800,   801,
     802,   803,   804,     0,   805,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,   806,    59,    60,    61,    62,     0,    63,   807,
       0,     0,     0,     0,     0,     0,     0,    64,    65,     0,
       0,    66,    67,     0,     0,     0,     0,     0,     0,     0,
       0,    72,     0,     0,    73,     0,   808,    74,     0,    75,
       0,     6,   809,     7,     8,     9,    10,    11,    12,    13,
       0,    14,    15,    16,    17,     0,     0,     0,    18,    19,
      20,     0,    21,    22,    23,     0,    24,    25,    26,     0,
      27,    28,    29,     0,     0,     0,     0,     0,     0,   810,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,     0,     0,     0,     0,     0,     0,
       0,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,     0,    59,
      60,    61,    62,    29,    63,     0,     0,     0,     0,     0,
       0,     0,     0,    64,    65,     0,     0,    66,    67,    68,
      69,    70,    71,     0,     0,     0,     0,    72,     0,     0,
      73,     0,     0,    74,   172,    75,    76,    77,     0,    78,
       0,     0,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,     0,
      29,    60,    61,    62,     0,    63,     0,   468,   469,   470,
     471,   472,   473,   474,    64,    65,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     475,   172,     0,     0,     0,     0,    75,     0,     0,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,   930,    29,    60,    61,
      62,     0,    63,   807,     0,     0,     0,     0,     0,     0,
       0,    64,    65,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    72,     0,     0,   172,     0,
       0,     0,     0,    75,     0,     0,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,   930,    29,    60,    61,    62,     0,    63,
       0,     0,     0,     0,     0,     0,     0,     0,    64,    65,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    72,     0,     0,   172,     0,     0,     0,     0,
      75,     0,     0,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      29,     0,    60,    61,    62,     0,    63,     0,     0,     0,
       0,     0,     0,     0,     0,    64,    65,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    72,
       0,   172,     0,     0,     0,     0,    29,    75,     0,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,     0,     0,    60,    61,
      62,     0,    63,     0,     0,     0,     0,   172,     0,     0,
       0,    64,    65,     0,     0,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,     0,    75,    60,    61,    62,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    64,    65,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    75
};

static const yytype_int16 yycheck[] =
{
      13,    14,    15,     3,   346,    18,    19,    20,    21,    22,
      23,    24,    25,    40,    41,     3,    26,     3,   294,   235,
      33,    34,    35,   459,   292,   219,   539,   232,   292,   539,
     628,   292,   300,    34,    36,   872,   300,   305,    34,   300,
       4,   305,   236,   451,   305,    34,    73,   272,    12,   771,
      12,    78,    34,    63,    37,    38,    39,    12,    35,   410,
     411,   412,   413,   414,    12,   709,    66,    34,    32,    33,
      32,    33,    72,    17,    18,    19,    34,    32,    33,    32,
      33,    35,    34,    35,    32,    33,   923,    34,    32,    33,
      36,    36,    34,    76,    77,    36,    34,    35,    34,    35,
      34,    35,    34,    35,   153,   618,    59,   760,    34,    34,
      34,    34,   138,    34,   736,   164,   310,    36,    34,   313,
     718,   736,   156,   153,    34,     0,   152,    34,    35,    36,
     920,    31,   776,   972,   155,   169,   330,   119,   168,   652,
     153,   736,   652,   736,   155,   172,   155,    94,   169,   162,
     344,   153,   989,   164,   876,   423,   995,   158,   736,   423,
     169,    27,   423,   736,   160,   433,    32,    33,   956,   433,
     123,   160,   433,   441,   516,   736,   153,   441,    94,  1018,
     441,   163,   590,   165,    50,    51,    52,  1026,   978,   702,
     156,   158,   980,    59,   158,   153,   158,   850,   119,   153,
     107,   153,   168,   158,   153,   158,   153,   153,   153,   119,
     158,   153,   153,   835,   158,   153,    35,   153,  1006,   153,
     835,   153,   222,   736,   234,    91,   736,   153,   153,   153,
     153,    97,   232,   497,   153,   134,   497,   959,  1024,  1025,
     835,   140,   835,   468,   469,   470,   471,   472,     4,   971,
     475,   445,   446,  1039,   479,   268,    12,   835,   153,   981,
     132,   156,   835,    35,    32,    33,    76,   609,   610,  1004,
    1005,   143,    34,    35,   835,   539,    32,    33,   539,    12,
    1014,  1015,    64,    65,  1019,    32,    33,    34,    31,   133,
      33,    59,   158,  1028,   138,  1029,   138,   139,   142,    32,
      33,  1036,   329,    79,  1038,    17,    18,    19,   137,   163,
    1044,   165,    59,    34,   143,   144,   145,    64,    65,   544,
      32,    33,   835,   154,   155,   835,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    34,    91,    92,    93,    94,    34,    96,
      36,    74,    75,    76,   618,   123,    79,   618,   105,   106,
     958,    27,   109,   110,   154,   155,    32,    33,   154,   155,
     634,   168,   119,   634,   168,   122,   154,   155,   125,    94,
     127,    66,    67,    68,    50,    51,    52,   153,   652,    30,
     156,   652,   138,    59,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   107,   171,   138,   173,   174,   138,
     604,   605,   606,   607,   608,   679,   767,   611,   679,   138,
     614,    32,    33,    34,   138,    91,   409,   153,   154,   155,
      35,    97,   160,   161,   162,   163,   138,   165,   702,   167,
     164,   702,   107,   719,   157,   428,   685,   686,   687,   154,
     155,   451,    34,   436,   161,   162,   163,   164,   165,   166,
     154,   155,   138,   451,   491,   451,   154,   155,   736,   138,
     154,   155,   736,   135,   136,   736,   138,   154,   155,   743,
     154,   155,   743,   483,   146,   147,   148,   149,   150,   151,
     152,   154,   155,   154,   155,   154,   155,   154,   155,   157,
     500,   157,   485,   154,   155,   488,   154,   155,   154,   155,
     116,   117,   154,   155,   154,   155,   154,   155,   154,   155,
     736,   154,   155,    76,   749,   750,   962,   154,   155,   801,
     802,  1034,  1035,   899,   900,   157,   878,   157,   138,   881,
     745,   153,   138,   153,   138,   138,    64,   156,   156,   156,
      34,   170,   156,   536,   567,   156,   583,   156,   156,   156,
     163,   156,    34,    34,   156,   156,   156,   835,   156,   156,
     156,   835,   156,   156,   835,   156,   156,   156,   156,   156,
     156,   156,    96,   157,   156,   156,   156,   156,   156,   156,
     590,   156,   156,   154,   157,   107,   156,   156,   156,   156,
     156,   877,   590,    36,   590,   156,   156,   156,   156,   153,
     172,    36,    36,    34,    34,    34,   629,   630,   631,   835,
     107,   156,   161,   157,    34,    95,   154,    35,   161,    35,
     107,    36,    36,    34,   647,   648,   649,   650,   153,   159,
      34,    36,   159,    36,    36,    36,   153,   153,   156,   154,
     154,   651,   155,   154,    12,   157,   141,   851,   156,   159,
     156,   855,   856,   155,   159,   159,   159,   157,  1010,    96,
     697,   154,   153,    17,   154,   154,   944,    34,   156,   170,
     944,   156,   156,   944,   157,  1027,   153,   126,   701,   154,
     154,    18,    34,   159,   156,    36,   159,    36,    36,   159,
     159,   969,   715,   158,   120,   969,   154,   159,   969,    19,
     161,   153,   153,   170,   167,    71,   153,    34,   153,   913,
     156,   159,   153,   170,   918,   170,   158,   921,    34,   157,
     170,   153,   155,   167,   107,    34,   736,   154,   156,   154,
     767,   171,   156,   156,   153,   745,    34,   154,   159,    49,
      48,   153,    37,    47,   153,     1,   159,   767,   154,   159,
     773,   159,   159,   957,   154,   379,   382,    32,    33,    34,
     159,   159,   785,   786,   159,   788,   789,   790,   791,   792,
     793,   794,   795,   796,   797,   798,   799,   171,   982,   172,
     172,   376,   627,   702,    59,   652,   385,   370,   487,    64,
      65,   461,   457,   997,   454,   430,  1000,   373,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,   493,    91,    92,    93,    94,
     467,    96,   730,   734,    62,   835,   490,   743,     3,   441,
     105,   106,   675,   389,   109,   110,   233,   308,   678,   965,
     835,   969,   904,   901,   119,   537,   613,   122,   403,   903,
     125,   874,   127,   406,   634,    -1,   418,    -1,   312,   209,
      -1,    -1,    -1,    -1,    -1,    -1,   423,    34,   433,    36,
      -1,    -1,    -1,    -1,   438,    -1,    -1,    -1,    -1,   916,
      -1,    -1,    -1,   158,    -1,    -1,    -1,    -1,    -1,   899,
     900,    -1,   902,   903,    -1,    -1,    -1,    -1,    65,    -1,
      -1,    -1,    -1,    -1,   902,    -1,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    -1,    92,    93,    94,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   974,   105,   106,
     107,   108,    -1,    -1,    -1,    -1,    -1,    -1,   115,   116,
     117,   118,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     127,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1002,
      -1,    -1,   992,    -1,    11,    12,    -1,    -1,    -1,  1012,
     157,    -1,    -1,    -1,    -1,    -1,    23,    -1,    -1,  1022,
      27,    -1,    -1,    -1,    -1,    32,    33,    34,    -1,  1032,
      -1,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    -1,    -1,    50,    51,    52,    53,    -1,    -1,    -1,
      -1,    -1,    59,    -1,    -1,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    -1,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    -1,    96,
      97,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
      -1,    -1,   109,   110,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   119,    11,    12,   122,    -1,   124,   125,    -1,
     127,    -1,    -1,   130,    -1,    23,    -1,    -1,    -1,    27,
      -1,    -1,    -1,    -1,    32,    33,    34,    -1,    -1,    -1,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    -1,
      -1,   158,    50,    51,    52,    53,    -1,    -1,    -1,    -1,
     167,    59,    -1,    -1,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    -1,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,    -1,
      -1,   109,   110,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   119,    -1,    -1,   122,    -1,   124,   125,    -1,   127,
      -1,     3,   130,     5,     6,     7,     8,     9,    10,    11,
      -1,    13,    14,    15,    16,    -1,    -1,    -1,    20,    21,
      22,    -1,    24,    25,    26,    -1,    28,    29,    30,    -1,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,   167,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    91,
      92,    93,    94,    34,    96,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,   106,    -1,    -1,   109,   110,   111,
     112,   113,   114,    -1,    -1,    -1,    -1,   119,    -1,    -1,
     122,    -1,    -1,   125,    65,   127,   128,   129,    -1,   131,
      -1,    -1,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      34,    92,    93,    94,    -1,    96,    -1,    98,    99,   100,
     101,   102,   103,   104,   105,   106,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     121,    65,    -1,    -1,    -1,    -1,   127,    -1,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    34,    92,    93,
      94,    -1,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   105,   106,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,    65,    -1,
      -1,    -1,    -1,   127,    -1,    -1,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    34,    92,    93,    94,    -1,    96,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   119,    -1,    -1,    65,    -1,    -1,    -1,    -1,
     127,    -1,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      34,    -1,    92,    93,    94,    -1,    96,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,
      -1,    65,    -1,    -1,    -1,    -1,    34,   127,    -1,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    -1,    92,    93,
      94,    -1,    96,    -1,    -1,    -1,    -1,    65,    -1,    -1,
      -1,   105,   106,    -1,    -1,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,   127,    92,    93,    94,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   105,   106,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   127
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   176,   177,   178,     0,   177,     3,     5,     6,     7,
       8,     9,    10,    11,    13,    14,    15,    16,    20,    21,
      22,    24,    25,    26,    28,    29,    30,    32,    33,    34,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    91,
      92,    93,    94,    96,   105,   106,   109,   110,   111,   112,
     113,   114,   119,   122,   125,   127,   128,   129,   131,   179,
     180,   181,   185,   189,   193,   197,   201,   205,   211,   213,
     219,   223,   227,   231,   235,   239,   240,   244,   248,   252,
     256,   263,   270,   280,   284,   285,   292,   293,   294,   295,
     307,   309,   310,   311,   312,   313,   314,   315,   316,   318,
     319,   329,   333,   336,   352,   353,   354,   358,   359,   362,
     364,   365,   394,   418,   422,   426,    34,   153,   202,    36,
     153,   182,    36,   153,   186,    36,   153,   190,    34,   153,
     194,    34,   153,   198,    31,   334,   335,   334,   334,   334,
      34,   153,   330,    35,   334,   334,   334,   334,   334,   334,
     334,   334,    65,   426,   153,    35,   153,   281,    35,    35,
     153,   286,   334,   334,   334,    34,    35,   153,   271,   278,
     278,   153,   257,   278,   153,   264,   278,   352,   352,    76,
      64,    65,   338,    79,    74,    75,    76,    79,   353,   426,
     422,    34,   232,   224,    34,   153,   228,    36,   153,   241,
     422,   352,   168,   153,   245,   278,   153,   249,   278,   153,
     253,   352,   168,    94,    30,   363,    34,   119,   425,   107,
     138,   152,   203,   204,   138,   183,   184,   138,   187,   188,
     138,   191,   192,   138,   195,   196,   138,   199,   200,   334,
      31,    33,   134,   140,   331,   332,   334,    35,   339,   352,
     164,   399,   236,   138,   139,   282,   283,   138,   287,   288,
     135,   136,   138,   146,   147,   148,   149,   150,   151,   152,
     273,   274,   157,   275,   272,   107,   279,   138,   258,   259,
     157,   260,   138,   265,   266,   157,   267,   366,   360,    34,
     340,    76,   425,    34,   153,   220,   157,   157,   138,   229,
     230,   137,   143,   144,   145,   242,   243,   399,   153,   153,
     206,   422,   427,   138,   246,   247,   138,   250,   251,   138,
     254,   255,   427,   354,   426,   365,   153,   399,   153,   156,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     171,   173,   174,   395,   163,   165,   424,   156,   156,   154,
     155,   156,   154,   155,   156,   154,   155,   156,   154,   155,
     156,   154,   155,   156,   154,   155,   156,   156,   154,   155,
     334,    34,   400,   401,   212,    34,   160,   237,   238,   340,
     156,   156,   154,   155,   156,   154,   155,   156,   156,   156,
     156,   156,   156,   156,   156,   156,   156,   154,   155,     4,
      12,   235,   239,   276,   277,   320,   324,   279,   156,   154,
     155,   235,   239,   261,   262,   324,   156,   154,   155,   235,
     239,   268,   269,   324,   170,   368,   368,   399,   424,   399,
     163,   157,   221,    34,   233,   234,    34,   225,   226,   156,
     154,   155,   156,   156,   156,   156,   154,   155,    98,    99,
     100,   101,   102,   103,   104,   121,   407,   408,   409,   422,
     423,   352,   399,   155,   169,   156,   154,   155,   156,   154,
     155,   156,   154,   155,   169,   399,   407,   157,   419,   154,
     153,   156,   156,   156,   156,   156,   156,   156,   156,   156,
     168,   156,   169,   172,   156,   156,   153,    96,    34,    36,
     382,   107,   204,    36,   184,    36,   188,    36,   192,    34,
     196,    34,   200,    34,   107,   332,   156,   155,   164,   157,
     215,    34,    95,   154,   161,    35,   116,   117,   355,   283,
      35,   288,    36,    36,   278,   355,   355,   355,   355,   355,
      34,   107,   274,   153,   321,    36,   153,   325,   158,   277,
     278,   259,   158,   262,   278,   266,   158,   269,    66,    67,
      68,   369,   370,   371,   399,   399,   337,   159,    34,   180,
     222,   364,   159,   158,   234,   158,   226,   382,   230,    36,
      36,    36,    36,   243,   340,   340,   340,   340,   340,   153,
     153,   340,   154,   155,   340,   156,   346,   154,   157,   207,
     422,   278,   247,   278,   251,   352,   255,   214,   154,    17,
      18,    19,   235,   239,   420,   421,   159,   422,   156,   156,
     407,    34,    36,   107,   278,   402,   401,    27,    50,    51,
      52,    97,   216,   217,   218,   235,   239,   295,   304,   308,
     336,    34,   160,   340,   141,   322,   323,   132,   143,   326,
     327,   334,   159,   159,   159,   155,   352,   367,   361,   157,
     324,   328,   154,   158,   180,   399,   399,   399,   399,   399,
     407,   407,   399,    96,   396,   409,   399,   153,   347,   350,
     351,   123,   208,   209,   210,   235,   239,   295,   215,   396,
     334,   334,   334,   158,   421,    17,   289,   154,   154,   170,
     334,   334,   334,   334,   422,   158,   217,    34,   156,   154,
     155,   156,   156,   154,   155,   370,   157,   372,   372,    34,
     235,   239,   341,   342,   343,   153,   346,   346,   346,   154,
     154,   126,   397,   352,   161,   162,   163,   164,   165,   166,
     348,   160,   161,   162,   163,   165,   167,   349,   334,   158,
     209,   397,   334,    18,   290,   159,   396,   279,    34,   159,
      36,   323,    36,    36,   327,    11,    23,    34,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    51,    52,    53,
      66,    67,    68,    69,    70,    72,    90,    97,   124,   130,
     167,   205,   219,   235,   239,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   308,   317,   324,
     336,   358,   359,   362,   365,   373,   374,   375,   384,   386,
     387,   389,   394,   410,   413,   415,   416,   418,   159,   159,
     156,   345,   158,   343,   427,   340,   340,   120,   428,   154,
     350,    36,   107,   108,   115,   118,   157,   352,   355,   356,
     426,   159,   428,   334,    19,   291,   397,   161,   153,   334,
     334,   153,   334,   334,   334,   334,   334,   334,   334,   334,
     334,   334,   334,   334,    71,   383,   383,   383,   170,   411,
     412,   385,   417,   414,   388,   153,   376,    34,   158,   374,
     350,   399,   159,   154,   399,   399,   153,   156,   398,   158,
     153,   398,   334,   428,   279,   407,   407,   170,   170,   170,
      90,   413,   413,   386,   394,   422,   415,    34,   389,   133,
     138,   142,   377,   378,   157,   379,   153,   155,   344,   399,
     352,   429,   107,   399,   347,   357,   399,   398,   154,   154,
      34,   156,   156,   156,   154,   155,   235,   239,   324,   380,
     381,   154,   159,   154,   155,   171,   392,   154,   155,   392,
     399,   396,   428,    34,   382,    34,   378,   158,   381,   428,
     328,   352,   393,   159,   347,   159,   392,   428,   399,   159,
     398,   422,    49,   405,   328,   159,   399,   171,   390,   399,
     153,   334,    48,   404,   405,   405,   392,   391,   159,   159,
     407,   334,    37,   406,   404,   404,   159,   153,   328,   405,
     154,   334,    47,   403,   406,   406,   328,   407,   405,   404,
     172,   334,   403,   403,   405,   154,   404,   406,   404,   172
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   175,   176,   176,   178,   177,   179,   179,   179,   179,
     179,   179,   179,   179,   179,   179,   179,   179,   179,   179,
     179,   179,   179,   179,   179,   179,   179,   179,   179,   179,
     179,   179,   179,   179,   179,   179,   179,   179,   179,   179,
     179,   179,   179,   179,   180,   180,   180,   180,   180,   180,
     180,   180,   180,   180,   180,   180,   181,   182,   182,   183,
     183,   184,   185,   186,   186,   187,   187,   188,   189,   190,
     190,   191,   191,   192,   193,   194,   194,   195,   195,   196,
     197,   198,   198,   199,   199,   200,   201,   202,   202,   203,
     203,   204,   204,   205,   206,   206,   207,   208,   208,   209,
     209,   209,   209,   210,   212,   211,   214,   213,   215,   216,
     216,   217,   217,   217,   217,   217,   217,   217,   217,   217,
     218,   220,   219,   221,   221,   222,   222,   224,   223,   225,
     225,   226,   227,   228,   228,   229,   229,   230,   232,   231,
     233,   233,   234,   236,   235,   237,   237,   237,   237,   238,
     238,   239,   240,   241,   241,   241,   242,   242,   243,   243,
     243,   243,   244,   245,   245,   246,   246,   247,   248,   249,
     249,   250,   250,   251,   252,   253,   253,   254,   254,   255,
     256,   257,   257,   258,   258,   259,   260,   260,   261,   261,
     262,   262,   262,   263,   264,   264,   265,   265,   266,   267,
     267,   268,   268,   269,   269,   269,   270,   270,   272,   271,
     271,   273,   273,   274,   274,   274,   274,   274,   274,   274,
     274,   274,   274,   275,   275,   276,   276,   277,   277,   277,
     277,   278,   278,   279,   279,   280,   281,   281,   282,   282,
     283,   283,   284,   285,   286,   286,   287,   287,   288,   289,
     289,   290,   290,   291,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   322,   323,   324,   325,
     325,   325,   326,   326,   327,   327,   328,   328,   329,   330,
     330,   331,   331,   332,   332,   333,   334,   335,   335,   337,
     336,   338,   338,   338,   339,   339,   340,   340,   341,   341,
     342,   342,   343,   343,   343,   344,   344,   345,   345,   346,
     346,   347,   347,   348,   348,   348,   348,   348,   348,   349,
     349,   349,   349,   349,   349,   349,   350,   351,   351,   352,
     352,   353,   353,   354,   355,   355,   356,   356,   356,   356,
     356,   356,   356,   356,   356,   357,   357,   357,   358,   358,
     360,   361,   359,   363,   362,   364,   366,   367,   365,   368,
     368,   369,   369,   370,   371,   371,   371,   371,   372,   372,
     373,   373,   373,   374,   374,   374,   374,   374,   374,   374,
     374,   374,   374,   374,   374,   374,   374,   374,   374,   374,
     374,   374,   374,   374,   374,   374,   374,   374,   374,   374,
     374,   374,   374,   374,   374,   374,   374,   374,   375,   376,
     377,   377,   378,   378,   378,   379,   379,   380,   380,   381,
     381,   381,   382,   382,   383,   383,   385,   384,   384,   386,
     388,   387,   387,   389,   390,   391,   390,   392,   393,   392,
     394,   394,   394,   394,   395,   395,   395,   395,   395,   395,
     395,   395,   395,   395,   395,   395,   395,   395,   395,   395,
     395,   395,   395,   395,   395,   395,   395,   395,   395,   395,
     395,   395,   395,   396,   396,   397,   397,   398,   398,   399,
     399,   400,   400,   401,   401,   402,   402,   402,   402,   403,
     403,   404,   404,   405,   405,   406,   406,   407,   408,   408,
     408,   409,   409,   409,   409,   409,   409,   409,   409,   409,
     411,   410,   412,   410,   410,   414,   413,   413,   415,   415,
     417,   416,   416,   418,   419,   419,   420,   420,   421,   421,
     421,   421,   421,   422,   422,   423,   424,   424,   425,   425,
     425,   426,   426,   426,   426,   426,   426,   426,   426,   426,
     426,   426,   426,   426,   426,   426,   426,   426,   426,   426,
     426,   426,   426,   426,   426,   426,   426,   426,   426,   426,
     426,   426,   427,   427,   428,   428,   429,   429,   429
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     1,     3,     1,
       3,     3,     2,     1,     3,     1,     3,     3,     2,     1,
       3,     1,     3,     3,     2,     1,     3,     1,     3,     3,
       3,     1,     3,     1,     3,     3,     2,     2,     3,     1,
       3,     3,     3,     5,     0,     3,     4,     1,     2,     1,
       1,     1,     1,     2,     0,     5,     0,     6,     4,     1,
       2,     1,     1,     1,     1,     2,     2,     1,     1,     1,
      14,     0,     5,     0,     3,     1,     2,     0,     5,     1,
       2,     1,     2,     1,     3,     1,     3,     3,     0,     5,
       1,     2,     1,     0,     5,     1,     2,     3,     4,     1,
       3,     1,     3,     0,     1,     3,     1,     3,     3,     3,
       3,     3,     2,     1,     3,     1,     3,     3,     2,     1,
       3,     1,     3,     3,     2,     1,     3,     1,     3,     3,
       3,     1,     3,     1,     3,     3,     0,     4,     1,     2,
       1,     1,     1,     3,     1,     3,     1,     3,     3,     0,
       4,     1,     2,     1,     1,     1,     3,     3,     0,     3,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     0,     4,     1,     2,     1,     1,     1,
       1,     1,     1,     0,     1,     2,     1,     3,     1,     3,
       3,     3,     2,     2,     1,     3,     1,     3,     3,     0,
       2,     0,     2,     0,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     3,     1,     3,     3,     3,     0,
       1,     3,     1,     3,     3,     3,     0,     1,     3,     1,
       3,     1,     3,     3,     3,     4,     2,     1,     2,     0,
       9,     0,     1,     1,     0,     1,     0,     1,     0,     1,
       1,     2,     1,     1,     4,     0,     1,     0,     2,     0,
       2,     1,     3,     1,     1,     1,     1,     1,     1,     0,
       1,     1,     1,     1,     1,     1,     3,     0,     3,     2,
       1,     1,     3,     1,     1,     1,     1,     4,     2,     1,
       1,     1,     1,     1,     1,     0,     1,     3,     6,    12,
       0,     0,     8,     0,     3,     4,     0,     0,     8,     0,
       2,     1,     3,     2,     0,     1,     1,     1,     0,     3,
       0,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     3,     3,     3,     2,     3,     3,
       1,     3,     3,     3,     3,     0,     4,     1,     2,     1,
       1,     1,     1,     1,     0,     1,     0,     3,     1,    11,
       0,     3,     1,    11,     0,     0,     6,     0,     0,     7,
      17,     7,    17,    16,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     3,     3,     1,     2,     2,     1,     2,     2,
       2,     1,     2,     0,     1,     0,     1,     0,     2,     0,
       3,     1,     3,     1,     3,     1,     5,     1,     1,     0,
       2,     0,     2,     0,     2,     0,     2,     1,     0,     1,
       3,     4,     4,     4,     3,     3,     6,     6,     3,     2,
       0,     3,     0,     3,     1,     0,     3,     1,     1,     1,
       0,     3,     1,     8,     0,     3,     1,     2,     1,     1,
       2,     2,     2,     4,     3,     3,     0,     1,     0,     3,
       2,     1,     4,     2,     2,     1,     1,     2,     1,     1,
       2,     2,     3,     1,     1,     1,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     0,     4,     0,     1,     3
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 4: /* $@1: %empty  */
#line 579 "parser.y"
            {
            /*
             * We don't do these in parserEOF() because the parser is reading
             * ahead and that would be too early.
             */

            if (previousFile != NULL)
            {
                handleEOF();

                if (currentContext.prevmod != NULL)
                    handleEOM();

                free(previousFile);
                previousFile = NULL;
            }
    }
#line 2652 "../parser.c"
    break;

  case 55: /* nsstatement: typehdrcode  */
#line 649 "parser.y"
                    {
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope == NULL)
                    yyerror("%TypeHeaderCode can only be used in a namespace, class or mapped type");

                appendCodeBlock(&scope->iff->hdrcode, (yyvsp[0].codeb));
            }
        }
#line 2668 "../parser.c"
    break;

  case 56: /* defdocstringfmt: TK_DEFDOCSTRFMT defdocstringfmt_args  */
#line 662 "parser.y"
                                                      {
            if (notSkipping())
                currentModule->defdocstringfmt = convertFormat((yyvsp[0].defdocstringfmt).name);
        }
#line 2677 "../parser.c"
    break;

  case 57: /* defdocstringfmt_args: TK_STRING_VALUE  */
#line 668 "parser.y"
                                        {
            resetLexerState();

            (yyval.defdocstringfmt).name = (yyvsp[0].text);
        }
#line 2687 "../parser.c"
    break;

  case 58: /* defdocstringfmt_args: '(' defdocstringfmt_arg_list ')'  */
#line 673 "parser.y"
                                         {
            (yyval.defdocstringfmt) = (yyvsp[-1].defdocstringfmt);
        }
#line 2695 "../parser.c"
    break;

  case 60: /* defdocstringfmt_arg_list: defdocstringfmt_arg_list ',' defdocstringfmt_arg  */
#line 679 "parser.y"
                                                         {
            (yyval.defdocstringfmt) = (yyvsp[-2].defdocstringfmt);

            switch ((yyvsp[0].defdocstringfmt).token)
            {
            case TK_NAME: (yyval.defdocstringfmt).name = (yyvsp[0].defdocstringfmt).name; break;
            }
        }
#line 2708 "../parser.c"
    break;

  case 61: /* defdocstringfmt_arg: TK_NAME '=' TK_STRING_VALUE  */
#line 689 "parser.y"
                                                    {
            (yyval.defdocstringfmt).token = TK_NAME;

            (yyval.defdocstringfmt).name = (yyvsp[0].text);
        }
#line 2718 "../parser.c"
    break;

  case 62: /* defdocstringsig: TK_DEFDOCSTRSIG defdocstringsig_args  */
#line 696 "parser.y"
                                                      {
            if (notSkipping())
                currentModule->defdocstringsig = convertSignature((yyvsp[0].defdocstringsig).name);
        }
#line 2727 "../parser.c"
    break;

  case 63: /* defdocstringsig_args: TK_STRING_VALUE  */
#line 702 "parser.y"
                                        {
            resetLexerState();

            (yyval.defdocstringsig).name = (yyvsp[0].text);
        }
#line 2737 "../parser.c"
    break;

  case 64: /* defdocstringsig_args: '(' defdocstringsig_arg_list ')'  */
#line 707 "parser.y"
                                         {
            (yyval.defdocstringsig) = (yyvsp[-1].defdocstringsig);
        }
#line 2745 "../parser.c"
    break;

  case 66: /* defdocstringsig_arg_list: defdocstringsig_arg_list ',' defdocstringsig_arg  */
#line 713 "parser.y"
                                                         {
            (yyval.defdocstringsig) = (yyvsp[-2].defdocstringsig);

            switch ((yyvsp[0].defdocstringsig).token)
            {
            case TK_NAME: (yyval.defdocstringsig).name = (yyvsp[0].defdocstringsig).name; break;
            }
        }
#line 2758 "../parser.c"
    break;

  case 67: /* defdocstringsig_arg: TK_NAME '=' TK_STRING_VALUE  */
#line 723 "parser.y"
                                                    {
            (yyval.defdocstringsig).token = TK_NAME;

            (yyval.defdocstringsig).name = (yyvsp[0].text);
        }
#line 2768 "../parser.c"
    break;

  case 68: /* defencoding: TK_DEFENCODING defencoding_args  */
#line 730 "parser.y"
                                                {
            if (notSkipping())
            {
                if ((currentModule->encoding = convertEncoding((yyvsp[0].defencoding).name)) == no_type)
                    yyerror("The %DefaultEncoding name must be one of \"ASCII\", \"Latin-1\", \"UTF-8\" or \"None\"");
            }
        }
#line 2780 "../parser.c"
    break;

  case 69: /* defencoding_args: TK_STRING_VALUE  */
#line 739 "parser.y"
                                    {
            resetLexerState();

            (yyval.defencoding).name = (yyvsp[0].text);
        }
#line 2790 "../parser.c"
    break;

  case 70: /* defencoding_args: '(' defencoding_arg_list ')'  */
#line 744 "parser.y"
                                     {
            (yyval.defencoding) = (yyvsp[-1].defencoding);
        }
#line 2798 "../parser.c"
    break;

  case 72: /* defencoding_arg_list: defencoding_arg_list ',' defencoding_arg  */
#line 750 "parser.y"
                                                 {
            (yyval.defencoding) = (yyvsp[-2].defencoding);

            switch ((yyvsp[0].defencoding).token)
            {
            case TK_NAME: (yyval.defencoding).name = (yyvsp[0].defencoding).name; break;
            }
        }
#line 2811 "../parser.c"
    break;

  case 73: /* defencoding_arg: TK_NAME '=' TK_STRING_VALUE  */
#line 760 "parser.y"
                                                {
            (yyval.defencoding).token = TK_NAME;

            (yyval.defencoding).name = (yyvsp[0].text);
        }
#line 2821 "../parser.c"
    break;

  case 74: /* plugin: TK_PLUGIN plugin_args  */
#line 767 "parser.y"
                                  {
            /*
             * Note that %Plugin is internal in SIP v4.  The current thinking
             * is that it won't be needed for SIP v5.
             */

            if (notSkipping())
                appendString(&currentSpec->plugins, (yyvsp[0].plugin).name);
        }
#line 2835 "../parser.c"
    break;

  case 75: /* plugin_args: TK_NAME_VALUE  */
#line 778 "parser.y"
                              {
            resetLexerState();

            (yyval.plugin).name = (yyvsp[0].text);
        }
#line 2845 "../parser.c"
    break;

  case 76: /* plugin_args: '(' plugin_arg_list ')'  */
#line 783 "parser.y"
                                {
            (yyval.plugin) = (yyvsp[-1].plugin);
        }
#line 2853 "../parser.c"
    break;

  case 78: /* plugin_arg_list: plugin_arg_list ',' plugin_arg  */
#line 789 "parser.y"
                                       {
            (yyval.plugin) = (yyvsp[-2].plugin);

            switch ((yyvsp[0].plugin).token)
            {
            case TK_NAME: (yyval.plugin).name = (yyvsp[0].plugin).name; break;
            }
        }
#line 2866 "../parser.c"
    break;

  case 79: /* plugin_arg: TK_NAME '=' TK_NAME_VALUE  */
#line 799 "parser.y"
                                      {
            (yyval.plugin).token = TK_NAME;

            (yyval.plugin).name = (yyvsp[0].text);
        }
#line 2876 "../parser.c"
    break;

  case 80: /* virterrorhandler: TK_VIRTERRORHANDLER veh_args codeblock  */
#line 806 "parser.y"
                                                           {
            if ((yyvsp[-1].veh).name == NULL)
                yyerror("%VirtualErrorHandler must have a 'name' argument");

            if (notSkipping())
            {
                virtErrorHandler *veh, **tailp;

                /* Check there isn't already a handler with the same name. */
                for (tailp = &currentSpec->errorhandlers; (veh = *tailp) != NULL; tailp = &veh->next)
                    if (strcmp(veh->name, (yyvsp[-1].veh).name) == 0)
                        break;

                if (veh != NULL)
                    yyerror("A virtual error handler with that name has already been defined");

                veh = sipMalloc(sizeof (virtErrorHandler));

                veh->name = (yyvsp[-1].veh).name;
                appendCodeBlock(&veh->code, (yyvsp[0].codeb));
                veh->mod = currentModule;
                veh->index = -1;
                veh->next = NULL;

                *tailp = veh;
            }
        }
#line 2908 "../parser.c"
    break;

  case 81: /* veh_args: TK_NAME_VALUE  */
#line 835 "parser.y"
                           {
            resetLexerState();

            (yyval.veh).name = (yyvsp[0].text);
        }
#line 2918 "../parser.c"
    break;

  case 82: /* veh_args: '(' veh_arg_list ')'  */
#line 840 "parser.y"
                             {
            (yyval.veh) = (yyvsp[-1].veh);
        }
#line 2926 "../parser.c"
    break;

  case 84: /* veh_arg_list: veh_arg_list ',' veh_arg  */
#line 846 "parser.y"
                                 {
            (yyval.veh) = (yyvsp[-2].veh);

            switch ((yyvsp[0].veh).token)
            {
            case TK_NAME: (yyval.veh).name = (yyvsp[0].veh).name; break;
            }
        }
#line 2939 "../parser.c"
    break;

  case 85: /* veh_arg: TK_NAME '=' TK_NAME_VALUE  */
#line 856 "parser.y"
                                   {
            (yyval.veh).token = TK_NAME;

            (yyval.veh).name = (yyvsp[0].text);
        }
#line 2949 "../parser.c"
    break;

  case 86: /* api: TK_API api_args  */
#line 863 "parser.y"
                        {
            if (notSkipping())
            {
                apiVersionRangeDef *avd;

                if (findAPI(currentSpec, (yyvsp[0].api).name) != NULL)
                    yyerror("The API name in the %API directive has already been defined");

                if ((yyvsp[0].api).version < 1)
                    yyerror("The version number in the %API directive must be greater than or equal to 1");

                avd = sipMalloc(sizeof (apiVersionRangeDef));

                avd->api_name = cacheName(currentSpec, (yyvsp[0].api).name);
                avd->from = (yyvsp[0].api).version;
                avd->to = -1;

                avd->next = currentModule->api_versions;
                currentModule->api_versions = avd;

                if (inMainModule())
                    setIsUsedName(avd->api_name);
            }
        }
#line 2978 "../parser.c"
    break;

  case 87: /* api_args: TK_NAME_VALUE TK_NUMBER_VALUE  */
#line 889 "parser.y"
                                          {
            resetLexerState();

            deprecated("%API name and version number should be specified using the 'name' and 'version' arguments");

            (yyval.api).name = (yyvsp[-1].text);
            (yyval.api).version = (yyvsp[0].number);
        }
#line 2991 "../parser.c"
    break;

  case 88: /* api_args: '(' api_arg_list ')'  */
#line 897 "parser.y"
                             {
            (yyval.api) = (yyvsp[-1].api);
        }
#line 2999 "../parser.c"
    break;

  case 90: /* api_arg_list: api_arg_list ',' api_arg  */
#line 903 "parser.y"
                                 {
            (yyval.api) = (yyvsp[-2].api);

            switch ((yyvsp[0].api).token)
            {
            case TK_NAME: (yyval.api).name = (yyvsp[0].api).name; break;
            case TK_VERSION: (yyval.api).version = (yyvsp[0].api).version; break;
            }
        }
#line 3013 "../parser.c"
    break;

  case 91: /* api_arg: TK_NAME '=' name_or_string  */
#line 914 "parser.y"
                                       {
            (yyval.api).token = TK_NAME;

            (yyval.api).name = (yyvsp[0].text);
            (yyval.api).version = 0;
        }
#line 3024 "../parser.c"
    break;

  case 92: /* api_arg: TK_VERSION '=' TK_NUMBER_VALUE  */
#line 920 "parser.y"
                                       {
            (yyval.api).token = TK_VERSION;

            (yyval.api).name = NULL;
            (yyval.api).version = (yyvsp[0].number);
        }
#line 3035 "../parser.c"
    break;

  case 93: /* exception: TK_EXCEPTION scopedname baseexception optflags exception_body  */
#line 928 "parser.y"
                                                                          {
            if (notSkipping())
            {
                static const char *annos[] = {
                    "Default",
                    "PyName",
                    NULL
                };

                exceptionDef *xd;
                const char *pyname;

                checkAnnos(&(yyvsp[-1].optflags), annos);

                if (currentSpec->genc)
                    yyerror("%Exception not allowed in a C module");

                if ((yyvsp[0].exception).raise_code == NULL)
                    yyerror("%Exception must have a %RaiseCode sub-directive");

                pyname = getPythonName(currentModule, &(yyvsp[-1].optflags), scopedNameTail((yyvsp[-3].scpvalp)));

                checkAttributes(currentSpec, currentModule, NULL, NULL,
                        pyname, FALSE);

                xd = findException(currentSpec, (yyvsp[-3].scpvalp), TRUE);

                if (xd->cd != NULL)
                    yyerror("%Exception name has already been seen as a class name - it must be defined before being used");

                if (xd->iff->module != NULL)
                    yyerror("The %Exception has already been defined");

                /* Complete the definition. */
                xd->iff->module = currentModule;
                appendCodeBlock(&xd->iff->hdrcode, (yyvsp[0].exception).type_header_code);
                xd->pyname = pyname;
                xd->bibase = (yyvsp[-2].exceptionbase).bibase;
                xd->base = (yyvsp[-2].exceptionbase).base;
                appendCodeBlock(&xd->raisecode, (yyvsp[0].exception).raise_code);

                if (getOptFlag(&(yyvsp[-1].optflags), "Default", bool_flag) != NULL)
                    currentModule->defexception = xd;
            }
        }
#line 3085 "../parser.c"
    break;

  case 94: /* baseexception: %empty  */
#line 975 "parser.y"
                {
            (yyval.exceptionbase).bibase = NULL;
            (yyval.exceptionbase).base = NULL;
        }
#line 3094 "../parser.c"
    break;

  case 95: /* baseexception: '(' scopedname ')'  */
#line 979 "parser.y"
                           {
            exceptionDef *xd;

            (yyval.exceptionbase).bibase = NULL;
            (yyval.exceptionbase).base = NULL;

            /* See if it is a defined exception. */
            for (xd = currentSpec->exceptions; xd != NULL; xd = xd->next)
                if (compareScopedNames(xd->iff->fqcname, (yyvsp[-1].scpvalp)) == 0)
                {
                    (yyval.exceptionbase).base = xd;
                    break;
                }

            if (xd == NULL && (yyvsp[-1].scpvalp)->next == NULL && strncmp((yyvsp[-1].scpvalp)->name, "SIP_", 4) == 0)
            {
                /* See if it is a builtin exception. */

                static char *builtins[] = {
                    "BaseException",
                    "Exception",
                    "StopIteration",
                    "GeneratorExit",
                    "ArithmeticError",
                    "LookupError",
                    "StandardError",                /* Python v2. */

                    "AssertionError",
                    "AttributeError",
                    "BufferError",
                    "EOFError",
                    "FloatingPointError",
                    "OSError",
                    "ImportError",
                    "IndexError",
                    "KeyError",
                    "KeyboardInterrupt",
                    "MemoryError",
                    "NameError",
                    "OverflowError",
                    "RuntimeError",
                    "NotImplementedError",
                    "SyntaxError",
                    "IndentationError",
                    "TabError",
                    "ReferenceError",
                    "SystemError",
                    "SystemExit",
                    "TypeError",
                    "UnboundLocalError",
                    "UnicodeError",
                    "UnicodeEncodeError",
                    "UnicodeDecodeError",
                    "UnicodeTranslateError",
                    "ValueError",
                    "ZeroDivisionError",
                    "EnvironmentError",             /* Python v2. */
                    "IOError",                      /* Python v2. */
                    "WindowsError",                 /* Python v2. */
                    "VMSError",                     /* Python v2. */

                    "BlockingIOError",
                    "BrokenPipeError",
                    "ChildProcessError",
                    "ConnectionError",
                    "ConnectionAbortedError",
                    "ConnectionRefusedError",
                    "ConnectionResetError",
                    "FileExistsError",
                    "FileNotFoundError",
                    "InterruptedError",
                    "IsADirectoryError",
                    "NotADirectoryError",
                    "PermissionError",
                    "ProcessLookupError",
                    "TimeoutError",

                    "Warning",
                    "UserWarning",
                    "DeprecationWarning",
                    "PendingDeprecationWarning",
                    "SyntaxWarning",
                    "RuntimeWarning",
                    "FutureWarning",
                    "ImportWarning",
                    "UnicodeWarning",
                    "BytesWarning",
                    "ResourceWarning",

                    NULL
                };

                char **cp;

                for (cp = builtins; *cp != NULL; ++cp)
                    if (strcmp((yyvsp[-1].scpvalp)->name + 4, *cp) == 0)
                    {
                        (yyval.exceptionbase).bibase = *cp;
                        break;
                    }
            }

            if ((yyval.exceptionbase).bibase == NULL && (yyval.exceptionbase).base == NULL)
                yyerror("Unknown exception base type");
        }
#line 3204 "../parser.c"
    break;

  case 96: /* exception_body: '{' exception_body_directives '}' ';'  */
#line 1086 "parser.y"
                                                      {
            (yyval.exception) = (yyvsp[-2].exception);
        }
#line 3212 "../parser.c"
    break;

  case 98: /* exception_body_directives: exception_body_directives exception_body_directive  */
#line 1092 "parser.y"
                                                           {
            (yyval.exception) = (yyvsp[-1].exception);

            switch ((yyvsp[0].exception).token)
            {
            case TK_RAISECODE: (yyval.exception).raise_code = (yyvsp[0].exception).raise_code; break;
            case TK_TYPEHEADERCODE: (yyval.exception).type_header_code = (yyvsp[0].exception).type_header_code; break;
            }
        }
#line 3226 "../parser.c"
    break;

  case 99: /* exception_body_directive: ifstart  */
#line 1103 "parser.y"
                                   {
            (yyval.exception).token = TK_IF;
        }
#line 3234 "../parser.c"
    break;

  case 100: /* exception_body_directive: ifend  */
#line 1106 "parser.y"
              {
            (yyval.exception).token = TK_END;
        }
#line 3242 "../parser.c"
    break;

  case 101: /* exception_body_directive: raisecode  */
#line 1109 "parser.y"
                  {
            if (notSkipping())
            {
                (yyval.exception).token = TK_RAISECODE;
                (yyval.exception).raise_code = (yyvsp[0].codeb);
            }
            else
            {
                (yyval.exception).token = 0;
                (yyval.exception).raise_code = NULL;
            }

            (yyval.exception).type_header_code = NULL;
        }
#line 3261 "../parser.c"
    break;

  case 102: /* exception_body_directive: typehdrcode  */
#line 1123 "parser.y"
                    {
            if (notSkipping())
            {
                (yyval.exception).token = TK_TYPEHEADERCODE;
                (yyval.exception).type_header_code = (yyvsp[0].codeb);
            }
            else
            {
                (yyval.exception).token = 0;
                (yyval.exception).type_header_code = NULL;
            }

            (yyval.exception).raise_code = NULL;
        }
#line 3280 "../parser.c"
    break;

  case 103: /* raisecode: TK_RAISECODE codeblock  */
#line 1139 "parser.y"
                                   {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 3288 "../parser.c"
    break;

  case 104: /* $@2: %empty  */
#line 1144 "parser.y"
                                            {
            if (notSkipping())
            {
                static const char *annos[] = {
                    "AllowNone",
                    "API",
                    "DocType",
                    "NoRelease",
                    "PyName",
                    "TypeHint",
                    "TypeHintIn",
                    "TypeHintOut",
                    "TypeHintValue",
                    NULL
                };

                checkAnnos(&(yyvsp[0].optflags), annos);

                currentMappedType = newMappedType(currentSpec, &(yyvsp[-1].memArg), &(yyvsp[0].optflags));
            }
        }
#line 3314 "../parser.c"
    break;

  case 106: /* $@3: %empty  */
#line 1167 "parser.y"
                                                         {
            if (notSkipping())
            {
                static const char *annos[] = {
                    "AllowNone",
                    "DocType",
                    "NoRelease",
                    "TypeHint",
                    "TypeHintIn",
                    "TypeHintOut",
                    "TypeHintValue",
                    NULL
                };

                int a;
                mappedTypeTmplDef *mtt;
                ifaceFileDef *iff;

                checkAnnos(&(yyvsp[0].optflags), annos);

                if (currentSpec->genc)
                    yyerror("%MappedType templates not allowed in a C module");

                /*
                 * Check the template arguments are basic types or simple
                 * names.
                 */
                for (a = 0; a < (yyvsp[-3].signature).nrArgs; ++a)
                {
                    argDef *ad = &(yyvsp[-3].signature).args[a];

                    if (ad->atype == defined_type && ad->u.snd->next != NULL)
                        yyerror("%MappedType template arguments must be simple names");
                }

                if ((yyvsp[-1].memArg).atype != template_type)
                    yyerror("%MappedType template must map a template type");

                (yyvsp[-1].memArg).u.td->fqname  = fullyQualifiedName((yyvsp[-1].memArg).u.td->fqname);

                /* Check a template hasn't already been provided. */
                for (mtt = currentSpec->mappedtypetemplates; mtt != NULL; mtt = mtt->next)
                    if (compareScopedNames(mtt->mt->type.u.td->fqname, (yyvsp[-1].memArg).u.td->fqname ) == 0 && sameTemplateSignature(&mtt->mt->type.u.td->types, &(yyvsp[-1].memArg).u.td->types, TRUE))
                        yyerror("%MappedType template for this type has already been defined");

                (yyvsp[-1].memArg).nrderefs = 0;
                (yyvsp[-1].memArg).argflags = 0;

                mtt = sipMalloc(sizeof (mappedTypeTmplDef));

                mtt->sig = (yyvsp[-3].signature);
                mtt->mt = allocMappedType(currentSpec, &(yyvsp[-1].memArg));
                mappedTypeAnnos(mtt->mt, &(yyvsp[0].optflags));
                mtt->next = currentSpec->mappedtypetemplates;

                currentSpec->mappedtypetemplates = mtt;

                currentMappedType = mtt->mt;

                /* Create a dummy interface file. */
                iff = sipMalloc(sizeof (ifaceFileDef));
                iff->hdrcode = NULL;
                mtt->mt->iff = iff;
            }
        }
#line 3384 "../parser.c"
    break;

  case 108: /* mtdefinition: '{' mtbody '}' ';'  */
#line 1234 "parser.y"
                                   {
            if (notSkipping())
            {
                if (currentMappedType->convfromcode == NULL)
                    yyerror("%MappedType must have a %ConvertFromTypeCode directive");

                if (currentMappedType->convtocode == NULL)
                    yyerror("%MappedType must have a %ConvertToTypeCode directive");

                currentMappedType = NULL;
            }
        }
#line 3401 "../parser.c"
    break;

  case 113: /* mtline: typehdrcode  */
#line 1254 "parser.y"
                    {
            if (notSkipping())
                appendCodeBlock(&currentMappedType->iff->hdrcode, (yyvsp[0].codeb));
        }
#line 3410 "../parser.c"
    break;

  case 114: /* mtline: typecode  */
#line 1258 "parser.y"
                 {
            if (notSkipping())
                appendCodeBlock(&currentMappedType->typecode, (yyvsp[0].codeb));
        }
#line 3419 "../parser.c"
    break;

  case 115: /* mtline: TK_FROMTYPE codeblock  */
#line 1262 "parser.y"
                              {
            if (notSkipping())
            {
                if (currentMappedType->convfromcode != NULL)
                    yyerror("%MappedType has more than one %ConvertFromTypeCode directive");

                appendCodeBlock(&currentMappedType->convfromcode, (yyvsp[0].codeb));
            }
        }
#line 3433 "../parser.c"
    break;

  case 116: /* mtline: TK_TOTYPE codeblock  */
#line 1271 "parser.y"
                            {
            if (notSkipping())
            {
                if (currentMappedType->convtocode != NULL)
                    yyerror("%MappedType has more than one %ConvertToTypeCode directive");

                appendCodeBlock(&currentMappedType->convtocode, (yyvsp[0].codeb));
            }
        }
#line 3447 "../parser.c"
    break;

  case 117: /* mtline: instancecode  */
#line 1280 "parser.y"
                     {
            if (notSkipping())
            {
                if (currentMappedType->instancecode != NULL)
                    yyerror("%MappedType has more than one %InstanceCode directive");

                appendCodeBlock(&currentMappedType->instancecode, (yyvsp[0].codeb));
            }
        }
#line 3461 "../parser.c"
    break;

  case 120: /* mtfunction: TK_STATIC cpptype TK_NAME_VALUE '(' arglist ')' optconst optexceptions optflags optsig ';' optdocstring premethodcode methodcode  */
#line 1293 "parser.y"
                                                                                                                                             {
            if (notSkipping())
            {
                applyTypeFlags(currentModule, &(yyvsp[-12].memArg), &(yyvsp[-5].optflags));

                (yyvsp[-9].signature).result = (yyvsp[-12].memArg);

                newFunction(currentSpec, currentModule, NULL, NULL,
                        currentMappedType, 0, TRUE, FALSE, FALSE, FALSE, (yyvsp[-11].text),
                        &(yyvsp[-9].signature), (yyvsp[-7].number), FALSE, &(yyvsp[-5].optflags), (yyvsp[0].codeb), NULL, NULL, (yyvsp[-6].throwlist), (yyvsp[-4].optsignature), (yyvsp[-2].docstr),
                        FALSE, (yyvsp[-1].codeb));
            }
        }
#line 3479 "../parser.c"
    break;

  case 121: /* $@4: %empty  */
#line 1308 "parser.y"
                                       {
            if (currentSpec -> genc)
                yyerror("namespace definition not allowed in a C module");

            if (notSkipping())
            {
                classDef *ns, *c_scope;
                ifaceFileDef *scope;

                if ((c_scope = currentScope()) != NULL)
                    scope = c_scope->iff;
                else
                    scope = NULL;

                ns = newClass(currentSpec, namespace_iface, NULL,
                        text2scopedName(scope, (yyvsp[0].text)), NULL, NULL, NULL, NULL);

                pushScope(ns);

                sectionFlags = 0;
            }
        }
#line 3506 "../parser.c"
    break;

  case 122: /* namespace: TK_NAMESPACE TK_NAME_VALUE $@4 optnsbody ';'  */
#line 1329 "parser.y"
                        {
            if (notSkipping())
            {
                if (inMainModule())
                {
                    classDef *ns = currentScope();

                    setIsUsedName(ns->iff->name);
                    setIsUsedName(ns->pyname);
                }

                popScope();
            }
        }
#line 3525 "../parser.c"
    break;

  case 127: /* $@5: %empty  */
#line 1353 "parser.y"
                         {
            if (notSkipping())
            {
                qualDef *qd;

                for (qd = currentModule->qualifiers; qd != NULL; qd = qd->next)
                    if (qd->qtype == platform_qualifier)
                        yyerror("%Platforms has already been defined for this module");
            }
        }
#line 3540 "../parser.c"
    break;

  case 128: /* platforms: TK_PLATFORMS $@5 '{' platformlist '}'  */
#line 1363 "parser.y"
                             {
            if (notSkipping())
            {
                qualDef *qd;
                int nrneeded;

                /* Check that exactly one platform in the set was requested. */
                nrneeded = 0;

                for (qd = currentModule->qualifiers; qd != NULL; qd = qd->next)
                    if (qd->qtype == platform_qualifier && selectedQualifier(neededQualifiers, qd))
                        ++nrneeded;

                if (nrneeded > 1)
                    yyerror("No more than one of these %Platforms must be specified with the -t flag");
            }
        }
#line 3562 "../parser.c"
    break;

  case 131: /* platform: TK_NAME_VALUE  */
#line 1386 "parser.y"
                          {
            newQualifier(currentModule, -1, -1, notSkipping(), (yyvsp[0].text),
                    platform_qualifier);
        }
#line 3571 "../parser.c"
    break;

  case 132: /* feature: TK_FEATURE feature_args  */
#line 1392 "parser.y"
                                    {
            newQualifier(currentModule, -1, -1, notSkipping(), (yyvsp[0].feature).name,
                    feature_qualifier);
        }
#line 3580 "../parser.c"
    break;

  case 133: /* feature_args: TK_NAME_VALUE  */
#line 1398 "parser.y"
                              {
            resetLexerState();

            (yyval.feature).name = (yyvsp[0].text);
        }
#line 3590 "../parser.c"
    break;

  case 134: /* feature_args: '(' feature_arg_list ')'  */
#line 1403 "parser.y"
                                 {
            (yyval.feature) = (yyvsp[-1].feature);
        }
#line 3598 "../parser.c"
    break;

  case 136: /* feature_arg_list: feature_arg_list ',' feature_arg  */
#line 1409 "parser.y"
                                         {
            (yyval.feature) = (yyvsp[-2].feature);

            switch ((yyvsp[0].feature).token)
            {
            case TK_NAME: (yyval.feature).name = (yyvsp[0].feature).name; break;
            }
        }
#line 3611 "../parser.c"
    break;

  case 137: /* feature_arg: TK_NAME '=' name_or_string  */
#line 1419 "parser.y"
                                           {
            (yyval.feature).token = TK_NAME;

            (yyval.feature).name = (yyvsp[0].text);
        }
#line 3621 "../parser.c"
    break;

  case 138: /* $@6: %empty  */
#line 1426 "parser.y"
                        {
            currentTimelineOrder = 0;
        }
#line 3629 "../parser.c"
    break;

  case 139: /* timeline: TK_TIMELINE $@6 '{' qualifierlist '}'  */
#line 1429 "parser.y"
                              {
            if (notSkipping())
            {
                qualDef *qd;
                int nrneeded;

                /*
                 * Check that exactly one time slot in the set was requested.
                 */
                nrneeded = 0;

                for (qd = currentModule->qualifiers; qd != NULL; qd = qd->next)
                    if (qd->qtype == time_qualifier && selectedQualifier(neededQualifiers, qd))
                        ++nrneeded;

                if (nrneeded > 1)
                    yyerror("At most one of this %Timeline must be specified with the -t flag");

                currentModule->nrtimelines++;
            }
        }
#line 3655 "../parser.c"
    break;

  case 142: /* qualifiername: TK_NAME_VALUE  */
#line 1456 "parser.y"
                              {
            newQualifier(currentModule, currentModule->nrtimelines,
                    currentTimelineOrder++, TRUE, (yyvsp[0].text), time_qualifier);
        }
#line 3664 "../parser.c"
    break;

  case 143: /* $@7: %empty  */
#line 1462 "parser.y"
                      {
            currentPlatforms = NULL;
        }
#line 3672 "../parser.c"
    break;

  case 144: /* ifstart: TK_IF '(' $@7 qualifiers ')'  */
#line 1464 "parser.y"
                         {
            if (stackPtr >= MAX_NESTED_IF)
                yyerror("Internal error: increase the value of MAX_NESTED_IF");

            /* Nested %Ifs are implicit logical ands. */

            if (stackPtr > 0)
                (yyvsp[-1].boolean) = ((yyvsp[-1].boolean) && skipStack[stackPtr - 1]);

            skipStack[stackPtr] = (yyvsp[-1].boolean);

            platformStack[stackPtr] = currentPlatforms;

            ++stackPtr;
        }
#line 3692 "../parser.c"
    break;

  case 145: /* oredqualifiers: TK_NAME_VALUE  */
#line 1481 "parser.y"
                              {
            (yyval.boolean) = platOrFeature((yyvsp[0].text), FALSE);
        }
#line 3700 "../parser.c"
    break;

  case 146: /* oredqualifiers: '!' TK_NAME_VALUE  */
#line 1484 "parser.y"
                          {
            (yyval.boolean) = platOrFeature((yyvsp[0].text), TRUE);
        }
#line 3708 "../parser.c"
    break;

  case 147: /* oredqualifiers: oredqualifiers TK_LOGICAL_OR TK_NAME_VALUE  */
#line 1487 "parser.y"
                                                   {
            (yyval.boolean) = (platOrFeature((yyvsp[0].text), FALSE) || (yyvsp[-2].boolean));
        }
#line 3716 "../parser.c"
    break;

  case 148: /* oredqualifiers: oredqualifiers TK_LOGICAL_OR '!' TK_NAME_VALUE  */
#line 1490 "parser.y"
                                                       {
            (yyval.boolean) = (platOrFeature((yyvsp[0].text), TRUE) || (yyvsp[-3].boolean));
        }
#line 3724 "../parser.c"
    break;

  case 150: /* qualifiers: optname '-' optname  */
#line 1496 "parser.y"
                            {
            (yyval.boolean) = timePeriod((yyvsp[-2].text), (yyvsp[0].text));
        }
#line 3732 "../parser.c"
    break;

  case 151: /* ifend: TK_END  */
#line 1501 "parser.y"
                   {
            if (stackPtr-- <= 0)
                yyerror("Too many %End directives");

            currentPlatforms = (stackPtr == 0 ? NULL : platformStack[stackPtr - 1]);
        }
#line 3743 "../parser.c"
    break;

  case 152: /* license: TK_LICENSE license_args optflags  */
#line 1509 "parser.y"
                                             {
            optFlag *of;

            if ((yyvsp[0].optflags).nrFlags != 0)
                deprecated("%License annotations are deprecated, use arguments instead");

            if ((yyvsp[-1].license).type == NULL)
                if ((of = getOptFlag(&(yyvsp[0].optflags), "Type", string_flag)) != NULL)
                    (yyvsp[-1].license).type = of->fvalue.sval;

            if ((yyvsp[-1].license).licensee == NULL)
                if ((of = getOptFlag(&(yyvsp[0].optflags), "Licensee", string_flag)) != NULL)
                    (yyvsp[-1].license).licensee = of->fvalue.sval;

            if ((yyvsp[-1].license).signature == NULL)
                if ((of = getOptFlag(&(yyvsp[0].optflags), "Signature", string_flag)) != NULL)
                    (yyvsp[-1].license).signature = of->fvalue.sval;

            if ((yyvsp[-1].license).timestamp == NULL)
                if ((of = getOptFlag(&(yyvsp[0].optflags), "Timestamp", string_flag)) != NULL)
                    (yyvsp[-1].license).timestamp = of->fvalue.sval;

            if ((yyvsp[-1].license).type == NULL)
                yyerror("%License must have a 'type' argument");

            if (notSkipping())
            {
                currentModule->license = sipMalloc(sizeof (licenseDef));

                currentModule->license->type = (yyvsp[-1].license).type;
                currentModule->license->licensee = (yyvsp[-1].license).licensee;
                currentModule->license->sig = (yyvsp[-1].license).signature;
                currentModule->license->timestamp = (yyvsp[-1].license).timestamp;
            }
        }
#line 3783 "../parser.c"
    break;

  case 153: /* license_args: %empty  */
#line 1546 "parser.y"
                {
            resetLexerState();

            (yyval.license).type = NULL;
            (yyval.license).licensee = NULL;
            (yyval.license).signature = NULL;
            (yyval.license).timestamp = NULL;
        }
#line 3796 "../parser.c"
    break;

  case 154: /* license_args: TK_STRING_VALUE  */
#line 1554 "parser.y"
                        {
            (yyval.license).type = (yyvsp[0].text);
            (yyval.license).licensee = NULL;
            (yyval.license).signature = NULL;
            (yyval.license).timestamp = NULL;
        }
#line 3807 "../parser.c"
    break;

  case 155: /* license_args: '(' license_arg_list ')'  */
#line 1560 "parser.y"
                                 {
            (yyval.license) = (yyvsp[-1].license);
        }
#line 3815 "../parser.c"
    break;

  case 157: /* license_arg_list: license_arg_list ',' license_arg  */
#line 1566 "parser.y"
                                         {
            (yyval.license) = (yyvsp[-2].license);

            switch ((yyvsp[0].license).token)
            {
            case TK_TYPE: (yyval.license).type = (yyvsp[0].license).type; break;
            case TK_LICENSEE: (yyval.license).licensee = (yyvsp[0].license).licensee; break;
            case TK_SIGNATURE: (yyval.license).signature = (yyvsp[0].license).signature; break;
            case TK_TIMESTAMP: (yyval.license).timestamp = (yyvsp[0].license).timestamp; break;
            }
        }
#line 3831 "../parser.c"
    break;

  case 158: /* license_arg: TK_TYPE '=' TK_STRING_VALUE  */
#line 1579 "parser.y"
                                            {
            (yyval.license).token = TK_NAME;

            (yyval.license).type = (yyvsp[0].text);
            (yyval.license).licensee = NULL;
            (yyval.license).signature = NULL;
            (yyval.license).timestamp = NULL;
        }
#line 3844 "../parser.c"
    break;

  case 159: /* license_arg: TK_LICENSEE '=' TK_STRING_VALUE  */
#line 1587 "parser.y"
                                        {
            (yyval.license).token = TK_LICENSEE;

            (yyval.license).type = NULL;
            (yyval.license).licensee = (yyvsp[0].text);
            (yyval.license).signature = NULL;
            (yyval.license).timestamp = NULL;
        }
#line 3857 "../parser.c"
    break;

  case 160: /* license_arg: TK_SIGNATURE '=' TK_STRING_VALUE  */
#line 1595 "parser.y"
                                         {
            (yyval.license).token = TK_SIGNATURE;

            (yyval.license).type = NULL;
            (yyval.license).licensee = NULL;
            (yyval.license).signature = (yyvsp[0].text);
            (yyval.license).timestamp = NULL;
        }
#line 3870 "../parser.c"
    break;

  case 161: /* license_arg: TK_TIMESTAMP '=' TK_STRING_VALUE  */
#line 1603 "parser.y"
                                         {
            (yyval.license).token = TK_TIMESTAMP;

            (yyval.license).type = NULL;
            (yyval.license).licensee = NULL;
            (yyval.license).signature = NULL;
            (yyval.license).timestamp = (yyvsp[0].text);
        }
#line 3883 "../parser.c"
    break;

  case 162: /* defmetatype: TK_DEFMETATYPE defmetatype_args  */
#line 1613 "parser.y"
                                                {
            if (notSkipping())
            {
                if (currentModule->defmetatype != NULL)
                    yyerror("%DefaultMetatype has already been defined for this module");

                currentModule->defmetatype = cacheName(currentSpec, (yyvsp[0].defmetatype).name);
            }
        }
#line 3897 "../parser.c"
    break;

  case 163: /* defmetatype_args: dottedname  */
#line 1624 "parser.y"
                               {
            resetLexerState();

            (yyval.defmetatype).name = (yyvsp[0].text);
        }
#line 3907 "../parser.c"
    break;

  case 164: /* defmetatype_args: '(' defmetatype_arg_list ')'  */
#line 1629 "parser.y"
                                     {
            (yyval.defmetatype) = (yyvsp[-1].defmetatype);
        }
#line 3915 "../parser.c"
    break;

  case 166: /* defmetatype_arg_list: defmetatype_arg_list ',' defmetatype_arg  */
#line 1635 "parser.y"
                                                 {
            (yyval.defmetatype) = (yyvsp[-2].defmetatype);

            switch ((yyvsp[0].defmetatype).token)
            {
            case TK_NAME: (yyval.defmetatype).name = (yyvsp[0].defmetatype).name; break;
            }
        }
#line 3928 "../parser.c"
    break;

  case 167: /* defmetatype_arg: TK_NAME '=' dottedname  */
#line 1645 "parser.y"
                                           {
            (yyval.defmetatype).token = TK_NAME;

            (yyval.defmetatype).name = (yyvsp[0].text);
        }
#line 3938 "../parser.c"
    break;

  case 168: /* defsupertype: TK_DEFSUPERTYPE defsupertype_args  */
#line 1652 "parser.y"
                                                  {
            if (notSkipping())
            {
                if (currentModule->defsupertype != NULL)
                    yyerror("%DefaultSupertype has already been defined for this module");

                currentModule->defsupertype = cacheName(currentSpec, (yyvsp[0].defsupertype).name);
            }
        }
#line 3952 "../parser.c"
    break;

  case 169: /* defsupertype_args: dottedname  */
#line 1663 "parser.y"
                               {
            resetLexerState();

            (yyval.defsupertype).name = (yyvsp[0].text);
        }
#line 3962 "../parser.c"
    break;

  case 170: /* defsupertype_args: '(' defsupertype_arg_list ')'  */
#line 1668 "parser.y"
                                      {
            (yyval.defsupertype) = (yyvsp[-1].defsupertype);
        }
#line 3970 "../parser.c"
    break;

  case 172: /* defsupertype_arg_list: defsupertype_arg_list ',' defsupertype_arg  */
#line 1674 "parser.y"
                                                   {
            (yyval.defsupertype) = (yyvsp[-2].defsupertype);

            switch ((yyvsp[0].defsupertype).token)
            {
            case TK_NAME: (yyval.defsupertype).name = (yyvsp[0].defsupertype).name; break;
            }
        }
#line 3983 "../parser.c"
    break;

  case 173: /* defsupertype_arg: TK_NAME '=' dottedname  */
#line 1684 "parser.y"
                                           {
            (yyval.defsupertype).token = TK_NAME;

            (yyval.defsupertype).name = (yyvsp[0].text);
        }
#line 3993 "../parser.c"
    break;

  case 174: /* hiddenns: TK_HIDE_NS hiddenns_args  */
#line 1691 "parser.y"
                                     {
            if (notSkipping())
            {
                classDef *ns;

                ns = newClass(currentSpec, namespace_iface, NULL,
                        fullyQualifiedName((yyvsp[0].hiddenns).name), NULL, NULL, NULL, NULL);
                setHiddenNamespace(ns);
            }
        }
#line 4008 "../parser.c"
    break;

  case 175: /* hiddenns_args: scopedname  */
#line 1703 "parser.y"
                           {
            resetLexerState();

            (yyval.hiddenns).name = (yyvsp[0].scpvalp);
        }
#line 4018 "../parser.c"
    break;

  case 176: /* hiddenns_args: '(' hiddenns_arg_list ')'  */
#line 1708 "parser.y"
                                  {
            (yyval.hiddenns) = (yyvsp[-1].hiddenns);
        }
#line 4026 "../parser.c"
    break;

  case 178: /* hiddenns_arg_list: hiddenns_arg_list ',' hiddenns_arg  */
#line 1714 "parser.y"
                                           {
            (yyval.hiddenns) = (yyvsp[-2].hiddenns);

            switch ((yyvsp[0].hiddenns).token)
            {
            case TK_NAME: (yyval.hiddenns).name = (yyvsp[0].hiddenns).name; break;
            }
        }
#line 4039 "../parser.c"
    break;

  case 179: /* hiddenns_arg: TK_NAME '=' scopedname  */
#line 1724 "parser.y"
                                       {
            (yyval.hiddenns).token = TK_NAME;

            (yyval.hiddenns).name = (yyvsp[0].scpvalp);
        }
#line 4049 "../parser.c"
    break;

  case 180: /* consmodule: TK_CONSMODULE consmodule_args consmodule_body  */
#line 1731 "parser.y"
                                                          {
            deprecated("%ConsolidatedModule is deprecated and will not be supported by SIP v5");

            if (notSkipping())
            {
                /* Make sure this is the first mention of a module. */
                if (currentSpec->module != currentModule)
                    yyerror("A %ConsolidatedModule cannot be %Imported");

                if (currentModule->fullname != NULL)
                    yyerror("%ConsolidatedModule must appear before any %Module or %CModule directive");

                setModuleName(currentSpec, currentModule, (yyvsp[-1].consmodule).name);
                currentModule->docstring = (yyvsp[0].consmodule).docstring;

                setIsConsolidated(currentModule);
            }
        }
#line 4072 "../parser.c"
    break;

  case 181: /* consmodule_args: dottedname  */
#line 1751 "parser.y"
                               {
            resetLexerState();

            (yyval.consmodule).name = (yyvsp[0].text);
        }
#line 4082 "../parser.c"
    break;

  case 182: /* consmodule_args: '(' consmodule_arg_list ')'  */
#line 1756 "parser.y"
                                    {
            (yyval.consmodule) = (yyvsp[-1].consmodule);
        }
#line 4090 "../parser.c"
    break;

  case 184: /* consmodule_arg_list: consmodule_arg_list ',' consmodule_arg  */
#line 1762 "parser.y"
                                               {
            (yyval.consmodule) = (yyvsp[-2].consmodule);

            switch ((yyvsp[0].consmodule).token)
            {
            case TK_NAME: (yyval.consmodule).name = (yyvsp[0].consmodule).name; break;
            }
        }
#line 4103 "../parser.c"
    break;

  case 185: /* consmodule_arg: TK_NAME '=' dottedname  */
#line 1772 "parser.y"
                                       {
            (yyval.consmodule).token = TK_NAME;

            (yyval.consmodule).name = (yyvsp[0].text);
        }
#line 4113 "../parser.c"
    break;

  case 186: /* consmodule_body: %empty  */
#line 1779 "parser.y"
                    {
            (yyval.consmodule).token = 0;
            (yyval.consmodule).docstring = NULL;
        }
#line 4122 "../parser.c"
    break;

  case 187: /* consmodule_body: '{' consmodule_body_directives '}' ';'  */
#line 1783 "parser.y"
                                               {
            (yyval.consmodule) = (yyvsp[-2].consmodule);
        }
#line 4130 "../parser.c"
    break;

  case 189: /* consmodule_body_directives: consmodule_body_directives consmodule_body_directive  */
#line 1789 "parser.y"
                                                             {
            (yyval.consmodule) = (yyvsp[-1].consmodule);

            switch ((yyvsp[0].consmodule).token)
            {
            case TK_DOCSTRING: (yyval.consmodule).docstring = (yyvsp[0].consmodule).docstring; break;
            }
        }
#line 4143 "../parser.c"
    break;

  case 190: /* consmodule_body_directive: ifstart  */
#line 1799 "parser.y"
                                    {
            (yyval.consmodule).token = TK_IF;
        }
#line 4151 "../parser.c"
    break;

  case 191: /* consmodule_body_directive: ifend  */
#line 1802 "parser.y"
              {
            (yyval.consmodule).token = TK_END;
        }
#line 4159 "../parser.c"
    break;

  case 192: /* consmodule_body_directive: docstring  */
#line 1805 "parser.y"
                  {
            if (notSkipping())
            {
                (yyval.consmodule).token = TK_DOCSTRING;
                (yyval.consmodule).docstring = (yyvsp[0].docstr);
            }
            else
            {
                (yyval.consmodule).token = 0;
                (yyval.consmodule).docstring = NULL;
            }
        }
#line 4176 "../parser.c"
    break;

  case 193: /* compmodule: TK_COMPOMODULE compmodule_args compmodule_body  */
#line 1819 "parser.y"
                                                           {
            if (notSkipping())
            {
                /* Make sure this is the first mention of a module. */
                if (currentSpec->module != currentModule)
                    yyerror("A %CompositeModule cannot be %Imported");

                if (currentModule->fullname != NULL)
                    yyerror("%CompositeModule must appear before any %Module directive");

                setModuleName(currentSpec, currentModule, (yyvsp[-1].compmodule).name);
                currentModule->docstring = (yyvsp[0].compmodule).docstring;

                setIsComposite(currentModule);
            }
        }
#line 4197 "../parser.c"
    break;

  case 194: /* compmodule_args: dottedname  */
#line 1837 "parser.y"
                               {
            resetLexerState();

            (yyval.compmodule).name = (yyvsp[0].text);
        }
#line 4207 "../parser.c"
    break;

  case 195: /* compmodule_args: '(' compmodule_arg_list ')'  */
#line 1842 "parser.y"
                                    {
            (yyval.compmodule) = (yyvsp[-1].compmodule);
        }
#line 4215 "../parser.c"
    break;

  case 197: /* compmodule_arg_list: compmodule_arg_list ',' compmodule_arg  */
#line 1848 "parser.y"
                                               {
            (yyval.compmodule) = (yyvsp[-2].compmodule);

            switch ((yyvsp[0].compmodule).token)
            {
            case TK_NAME: (yyval.compmodule).name = (yyvsp[0].compmodule).name; break;
            }
        }
#line 4228 "../parser.c"
    break;

  case 198: /* compmodule_arg: TK_NAME '=' dottedname  */
#line 1858 "parser.y"
                                       {
            (yyval.compmodule).token = TK_NAME;

            (yyval.compmodule).name = (yyvsp[0].text);
        }
#line 4238 "../parser.c"
    break;

  case 199: /* compmodule_body: %empty  */
#line 1865 "parser.y"
                    {
            (yyval.compmodule).token = 0;
            (yyval.compmodule).docstring = NULL;
        }
#line 4247 "../parser.c"
    break;

  case 200: /* compmodule_body: '{' compmodule_body_directives '}' ';'  */
#line 1869 "parser.y"
                                               {
            (yyval.compmodule) = (yyvsp[-2].compmodule);
        }
#line 4255 "../parser.c"
    break;

  case 202: /* compmodule_body_directives: compmodule_body_directives compmodule_body_directive  */
#line 1875 "parser.y"
                                                             {
            (yyval.compmodule) = (yyvsp[-1].compmodule);

            switch ((yyvsp[0].compmodule).token)
            {
            case TK_DOCSTRING: (yyval.compmodule).docstring = (yyvsp[0].compmodule).docstring; break;
            }
        }
#line 4268 "../parser.c"
    break;

  case 203: /* compmodule_body_directive: ifstart  */
#line 1885 "parser.y"
                                    {
            (yyval.compmodule).token = TK_IF;
        }
#line 4276 "../parser.c"
    break;

  case 204: /* compmodule_body_directive: ifend  */
#line 1888 "parser.y"
              {
            (yyval.compmodule).token = TK_END;
        }
#line 4284 "../parser.c"
    break;

  case 205: /* compmodule_body_directive: docstring  */
#line 1891 "parser.y"
                  {
            if (notSkipping())
            {
                (yyval.compmodule).token = TK_DOCSTRING;
                (yyval.compmodule).docstring = (yyvsp[0].docstr);
            }
            else
            {
                (yyval.compmodule).token = 0;
                (yyval.compmodule).docstring = NULL;
            }
        }
#line 4301 "../parser.c"
    break;

  case 206: /* module: TK_MODULE module_args module_body  */
#line 1905 "parser.y"
                                          {
            if ((yyvsp[-1].module).name == NULL)
                yyerror("%Module must have a 'name' argument");

            if (notSkipping())
                currentModule = configureModule(currentSpec, currentModule,
                        currentContext.filename, (yyvsp[-1].module).name, (yyvsp[-1].module).c_module,
                        (yyvsp[-1].module).kwargs, (yyvsp[-1].module).use_arg_names, (yyvsp[-1].module).py_ssize_t_clean,
                        (yyvsp[-1].module).use_limited_api, (yyvsp[-1].module).call_super_init,
                        (yyvsp[-1].module).all_raise_py_exc, (yyvsp[-1].module).def_error_handler,
                        (yyvsp[0].module).docstring);
        }
#line 4318 "../parser.c"
    break;

  case 207: /* module: TK_CMODULE dottedname optnumber  */
#line 1917 "parser.y"
                                        {
            deprecated("%CModule is deprecated, use %Module and the 'language' argument instead");

            if (notSkipping())
                currentModule = configureModule(currentSpec, currentModule,
                        currentContext.filename, (yyvsp[-1].text), TRUE, defaultKwArgs,
                        FALSE, FALSE, FALSE, -1, FALSE, NULL, NULL);
        }
#line 4331 "../parser.c"
    break;

  case 208: /* $@8: %empty  */
#line 1927 "parser.y"
                           {resetLexerState();}
#line 4337 "../parser.c"
    break;

  case 209: /* module_args: dottedname $@8 optnumber  */
#line 1927 "parser.y"
                                                          {
            if ((yyvsp[0].number) >= 0)
                deprecated("%Module version number should be specified using the 'version' argument");

            (yyval.module).c_module = FALSE;
            (yyval.module).kwargs = defaultKwArgs;
            (yyval.module).name = (yyvsp[-2].text);
            (yyval.module).use_arg_names = FALSE;
            (yyval.module).py_ssize_t_clean = FALSE;
            (yyval.module).use_limited_api = FALSE;
            (yyval.module).all_raise_py_exc = FALSE;
            (yyval.module).call_super_init = -1;
            (yyval.module).def_error_handler = NULL;
        }
#line 4356 "../parser.c"
    break;

  case 210: /* module_args: '(' module_arg_list ')'  */
#line 1941 "parser.y"
                                {
            (yyval.module) = (yyvsp[-1].module);
        }
#line 4364 "../parser.c"
    break;

  case 212: /* module_arg_list: module_arg_list ',' module_arg  */
#line 1947 "parser.y"
                                       {
            (yyval.module) = (yyvsp[-2].module);

            switch ((yyvsp[0].module).token)
            {
            case TK_KWARGS: (yyval.module).kwargs = (yyvsp[0].module).kwargs; break;
            case TK_LANGUAGE: (yyval.module).c_module = (yyvsp[0].module).c_module; break;
            case TK_NAME: (yyval.module).name = (yyvsp[0].module).name; break;
            case TK_USEARGNAMES: (yyval.module).use_arg_names = (yyvsp[0].module).use_arg_names; break;
            case TK_PYSSIZETCLEAN: (yyval.module).py_ssize_t_clean = (yyvsp[0].module).py_ssize_t_clean; break;
            case TK_USELIMITEDAPI: (yyval.module).use_limited_api = (yyvsp[0].module).use_limited_api; break;
            case TK_ALLRAISEPYEXC: (yyval.module).all_raise_py_exc = (yyvsp[0].module).all_raise_py_exc; break;
            case TK_CALLSUPERINIT: (yyval.module).call_super_init = (yyvsp[0].module).call_super_init; break;
            case TK_DEFERRORHANDLER: (yyval.module).def_error_handler = (yyvsp[0].module).def_error_handler; break;
            }
        }
#line 4385 "../parser.c"
    break;

  case 213: /* module_arg: TK_KWARGS '=' TK_STRING_VALUE  */
#line 1965 "parser.y"
                                          {
            (yyval.module).token = TK_KWARGS;

            (yyval.module).c_module = FALSE;
            (yyval.module).kwargs = convertKwArgs((yyvsp[0].text));
            (yyval.module).name = NULL;
            (yyval.module).use_arg_names = FALSE;
            (yyval.module).py_ssize_t_clean = FALSE;
            (yyval.module).use_limited_api = FALSE;
            (yyval.module).all_raise_py_exc = FALSE;
            (yyval.module).call_super_init = -1;
            (yyval.module).def_error_handler = NULL;
        }
#line 4403 "../parser.c"
    break;

  case 214: /* module_arg: TK_LANGUAGE '=' TK_STRING_VALUE  */
#line 1978 "parser.y"
                                        {
            (yyval.module).token = TK_LANGUAGE;

            if (strcmp((yyvsp[0].text), "C++") == 0)
                (yyval.module).c_module = FALSE;
            else if (strcmp((yyvsp[0].text), "C") == 0)
                (yyval.module).c_module = TRUE;
            else
                yyerror("%Module 'language' argument must be either \"C++\" or \"C\"");

            (yyval.module).kwargs = defaultKwArgs;
            (yyval.module).name = NULL;
            (yyval.module).use_arg_names = FALSE;
            (yyval.module).py_ssize_t_clean = FALSE;
            (yyval.module).use_limited_api = FALSE;
            (yyval.module).all_raise_py_exc = FALSE;
            (yyval.module).call_super_init = -1;
            (yyval.module).def_error_handler = NULL;
        }
#line 4427 "../parser.c"
    break;

  case 215: /* module_arg: TK_NAME '=' dottedname  */
#line 1997 "parser.y"
                               {
            (yyval.module).token = TK_NAME;

            (yyval.module).c_module = FALSE;
            (yyval.module).kwargs = defaultKwArgs;
            (yyval.module).name = (yyvsp[0].text);
            (yyval.module).use_arg_names = FALSE;
            (yyval.module).py_ssize_t_clean = FALSE;
            (yyval.module).use_limited_api = FALSE;
            (yyval.module).all_raise_py_exc = FALSE;
            (yyval.module).call_super_init = -1;
            (yyval.module).def_error_handler = NULL;
        }
#line 4445 "../parser.c"
    break;

  case 216: /* module_arg: TK_USEARGNAMES '=' bool_value  */
#line 2010 "parser.y"
                                      {
            (yyval.module).token = TK_USEARGNAMES;

            (yyval.module).c_module = FALSE;
            (yyval.module).kwargs = defaultKwArgs;
            (yyval.module).name = NULL;
            (yyval.module).use_arg_names = (yyvsp[0].boolean);
            (yyval.module).py_ssize_t_clean = FALSE;
            (yyval.module).use_limited_api = FALSE;
            (yyval.module).all_raise_py_exc = FALSE;
            (yyval.module).call_super_init = -1;
            (yyval.module).def_error_handler = NULL;
        }
#line 4463 "../parser.c"
    break;

  case 217: /* module_arg: TK_PYSSIZETCLEAN '=' bool_value  */
#line 2023 "parser.y"
                                        {
            (yyval.module).token = TK_PYSSIZETCLEAN;

            (yyval.module).c_module = FALSE;
            (yyval.module).kwargs = defaultKwArgs;
            (yyval.module).name = NULL;
            (yyval.module).use_arg_names = FALSE;
            (yyval.module).py_ssize_t_clean = (yyvsp[0].boolean);
            (yyval.module).use_limited_api = FALSE;
            (yyval.module).all_raise_py_exc = FALSE;
            (yyval.module).call_super_init = -1;
            (yyval.module).def_error_handler = NULL;
        }
#line 4481 "../parser.c"
    break;

  case 218: /* module_arg: TK_USELIMITEDAPI '=' bool_value  */
#line 2036 "parser.y"
                                        {
            (yyval.module).token = TK_USELIMITEDAPI;

            (yyval.module).c_module = FALSE;
            (yyval.module).kwargs = defaultKwArgs;
            (yyval.module).name = NULL;
            (yyval.module).use_arg_names = FALSE;
            (yyval.module).py_ssize_t_clean = FALSE;
            (yyval.module).use_limited_api = (yyvsp[0].boolean);
            (yyval.module).all_raise_py_exc = FALSE;
            (yyval.module).call_super_init = -1;
            (yyval.module).def_error_handler = NULL;
        }
#line 4499 "../parser.c"
    break;

  case 219: /* module_arg: TK_ALLRAISEPYEXC '=' bool_value  */
#line 2049 "parser.y"
                                        {
            (yyval.module).token = TK_ALLRAISEPYEXC;

            (yyval.module).c_module = FALSE;
            (yyval.module).kwargs = defaultKwArgs;
            (yyval.module).name = NULL;
            (yyval.module).use_arg_names = FALSE;
            (yyval.module).py_ssize_t_clean = FALSE;
            (yyval.module).use_limited_api = FALSE;
            (yyval.module).all_raise_py_exc = (yyvsp[0].boolean);
            (yyval.module).call_super_init = -1;
            (yyval.module).def_error_handler = NULL;
        }
#line 4517 "../parser.c"
    break;

  case 220: /* module_arg: TK_CALLSUPERINIT '=' bool_value  */
#line 2062 "parser.y"
                                        {
            (yyval.module).token = TK_CALLSUPERINIT;

            (yyval.module).c_module = FALSE;
            (yyval.module).kwargs = defaultKwArgs;
            (yyval.module).name = NULL;
            (yyval.module).use_arg_names = FALSE;
            (yyval.module).py_ssize_t_clean = FALSE;
            (yyval.module).use_limited_api = FALSE;
            (yyval.module).all_raise_py_exc = FALSE;
            (yyval.module).call_super_init = (yyvsp[0].boolean);
            (yyval.module).def_error_handler = NULL;
        }
#line 4535 "../parser.c"
    break;

  case 221: /* module_arg: TK_DEFERRORHANDLER '=' TK_NAME_VALUE  */
#line 2075 "parser.y"
                                             {
            (yyval.module).token = TK_DEFERRORHANDLER;

            (yyval.module).c_module = FALSE;
            (yyval.module).kwargs = defaultKwArgs;
            (yyval.module).name = NULL;
            (yyval.module).use_arg_names = FALSE;
            (yyval.module).py_ssize_t_clean = FALSE;
            (yyval.module).use_limited_api = FALSE;
            (yyval.module).all_raise_py_exc = FALSE;
            (yyval.module).call_super_init = -1;
            (yyval.module).def_error_handler = (yyvsp[0].text);
        }
#line 4553 "../parser.c"
    break;

  case 222: /* module_arg: TK_VERSION '=' TK_NUMBER_VALUE  */
#line 2088 "parser.y"
                                       {
            deprecated("%Module version numbers are deprecated and ignored");

            if ((yyvsp[0].number) < 0)
                yyerror("%Module 'version' argument cannot be negative");

            (yyval.module).token = TK_VERSION;

            (yyval.module).c_module = FALSE;
            (yyval.module).kwargs = defaultKwArgs;
            (yyval.module).name = NULL;
            (yyval.module).use_arg_names = FALSE;
            (yyval.module).py_ssize_t_clean = FALSE;
            (yyval.module).use_limited_api = FALSE;
            (yyval.module).all_raise_py_exc = FALSE;
            (yyval.module).call_super_init = -1;
            (yyval.module).def_error_handler = NULL;
        }
#line 4576 "../parser.c"
    break;

  case 223: /* module_body: %empty  */
#line 2108 "parser.y"
                {
            (yyval.module).token = 0;
            (yyval.module).docstring = NULL;
        }
#line 4585 "../parser.c"
    break;

  case 224: /* module_body: '{' module_body_directives '}' ';'  */
#line 2112 "parser.y"
                                           {
            (yyval.module) = (yyvsp[-2].module);
        }
#line 4593 "../parser.c"
    break;

  case 226: /* module_body_directives: module_body_directives module_body_directive  */
#line 2118 "parser.y"
                                                     {
            (yyval.module) = (yyvsp[-1].module);

            switch ((yyvsp[0].module).token)
            {
            case TK_DOCSTRING: (yyval.module).docstring = (yyvsp[0].module).docstring; break;
            }
        }
#line 4606 "../parser.c"
    break;

  case 227: /* module_body_directive: ifstart  */
#line 2128 "parser.y"
                                {
            (yyval.module).token = TK_IF;
        }
#line 4614 "../parser.c"
    break;

  case 228: /* module_body_directive: ifend  */
#line 2131 "parser.y"
              {
            (yyval.module).token = TK_END;
        }
#line 4622 "../parser.c"
    break;

  case 229: /* module_body_directive: autopyname  */
#line 2134 "parser.y"
                   {
            (yyval.module).token = TK_AUTOPYNAME;
        }
#line 4630 "../parser.c"
    break;

  case 230: /* module_body_directive: docstring  */
#line 2137 "parser.y"
                  {
            if (notSkipping())
            {
                (yyval.module).token = TK_DOCSTRING;
                (yyval.module).docstring = (yyvsp[0].docstr);
            }
            else
            {
                (yyval.module).token = 0;
                (yyval.module).docstring = NULL;
            }
        }
#line 4647 "../parser.c"
    break;

  case 232: /* dottedname: TK_PATH_VALUE  */
#line 2152 "parser.y"
                      {
            /*
             * The grammar design is a bit broken and this is the easiest way
             * to allow periods in names.
             */

            char *cp;

            for (cp = (yyvsp[0].text); *cp != '\0'; ++cp)
                if (*cp != '.' && *cp != '_' && !isalnum(*cp))
                    yyerror("Invalid character in name");

            (yyval.text) = (yyvsp[0].text);
        }
#line 4666 "../parser.c"
    break;

  case 233: /* optnumber: %empty  */
#line 2168 "parser.y"
            {
            (yyval.number) = -1;
        }
#line 4674 "../parser.c"
    break;

  case 235: /* include: TK_INCLUDE include_args  */
#line 2174 "parser.y"
                                    {
            if ((yyvsp[0].include).name == NULL)
                yyerror("%Include must have a 'name' argument");

            if (notSkipping())
                parseFile(NULL, (yyvsp[0].include).name, NULL, (yyvsp[0].include).optional);
        }
#line 4686 "../parser.c"
    break;

  case 236: /* include_args: TK_PATH_VALUE  */
#line 2183 "parser.y"
                              {
            resetLexerState();

            (yyval.include).name = (yyvsp[0].text);
            (yyval.include).optional = FALSE;
        }
#line 4697 "../parser.c"
    break;

  case 237: /* include_args: '(' include_arg_list ')'  */
#line 2189 "parser.y"
                                 {
            (yyval.include) = (yyvsp[-1].include);
        }
#line 4705 "../parser.c"
    break;

  case 239: /* include_arg_list: include_arg_list ',' include_arg  */
#line 2195 "parser.y"
                                         {
            (yyval.include) = (yyvsp[-2].include);

            switch ((yyvsp[0].include).token)
            {
            case TK_NAME: (yyval.include).name = (yyvsp[0].include).name; break;
            case TK_OPTIONAL: (yyval.include).optional = (yyvsp[0].include).optional; break;
            }
        }
#line 4719 "../parser.c"
    break;

  case 240: /* include_arg: TK_NAME '=' TK_PATH_VALUE  */
#line 2206 "parser.y"
                                          {
            (yyval.include).token = TK_NAME;

            (yyval.include).name = (yyvsp[0].text);
            (yyval.include).optional = FALSE;
        }
#line 4730 "../parser.c"
    break;

  case 241: /* include_arg: TK_OPTIONAL '=' bool_value  */
#line 2212 "parser.y"
                                   {
            (yyval.include).token = TK_OPTIONAL;

            (yyval.include).name = NULL;
            (yyval.include).optional = (yyvsp[0].boolean);
        }
#line 4741 "../parser.c"
    break;

  case 242: /* optinclude: TK_OPTINCLUDE TK_PATH_VALUE  */
#line 2220 "parser.y"
                                        {
            deprecated("%OptionalInclude is deprecated, use %Include and the 'optional' argument instead");

            if (notSkipping())
                parseFile(NULL, (yyvsp[0].text), NULL, TRUE);
        }
#line 4752 "../parser.c"
    break;

  case 243: /* import: TK_IMPORT import_args  */
#line 2228 "parser.y"
                                  {
            if (notSkipping())
                newImport((yyvsp[0].import).name);
        }
#line 4761 "../parser.c"
    break;

  case 244: /* import_args: TK_PATH_VALUE  */
#line 2234 "parser.y"
                              {
            resetLexerState();

            (yyval.import).name = (yyvsp[0].text);
        }
#line 4771 "../parser.c"
    break;

  case 245: /* import_args: '(' import_arg_list ')'  */
#line 2239 "parser.y"
                                {
            (yyval.import) = (yyvsp[-1].import);
        }
#line 4779 "../parser.c"
    break;

  case 247: /* import_arg_list: import_arg_list ',' import_arg  */
#line 2245 "parser.y"
                                       {
            (yyval.import) = (yyvsp[-2].import);

            switch ((yyvsp[0].import).token)
            {
            case TK_NAME: (yyval.import).name = (yyvsp[0].import).name; break;
            }
        }
#line 4792 "../parser.c"
    break;

  case 248: /* import_arg: TK_NAME '=' TK_PATH_VALUE  */
#line 2255 "parser.y"
                                      {
            (yyval.import).token = TK_NAME;

            (yyval.import).name = (yyvsp[0].text);
        }
#line 4802 "../parser.c"
    break;

  case 249: /* optaccesscode: %empty  */
#line 2262 "parser.y"
                {
            (yyval.codeb) = NULL;
        }
#line 4810 "../parser.c"
    break;

  case 250: /* optaccesscode: TK_ACCESSCODE codeblock  */
#line 2265 "parser.y"
                                {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 4818 "../parser.c"
    break;

  case 251: /* optgetcode: %empty  */
#line 2270 "parser.y"
            {
            (yyval.codeb) = NULL;
        }
#line 4826 "../parser.c"
    break;

  case 252: /* optgetcode: TK_GETCODE codeblock  */
#line 2273 "parser.y"
                             {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 4834 "../parser.c"
    break;

  case 253: /* optsetcode: %empty  */
#line 2278 "parser.y"
            {
            (yyval.codeb) = NULL;
        }
#line 4842 "../parser.c"
    break;

  case 254: /* optsetcode: TK_SETCODE codeblock  */
#line 2281 "parser.y"
                             {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 4850 "../parser.c"
    break;

  case 255: /* copying: TK_COPYING codeblock  */
#line 2286 "parser.y"
                                 {
            if (notSkipping())
                appendCodeBlock(&currentModule->copying, (yyvsp[0].codeb));
        }
#line 4859 "../parser.c"
    break;

  case 256: /* exphdrcode: TK_EXPHEADERCODE codeblock  */
#line 2292 "parser.y"
                                       {
            if (notSkipping())
                appendCodeBlock(&currentSpec->exphdrcode, (yyvsp[0].codeb));
        }
#line 4868 "../parser.c"
    break;

  case 257: /* modhdrcode: TK_MODHEADERCODE codeblock  */
#line 2298 "parser.y"
                                       {
            if (notSkipping())
                appendCodeBlock(&currentModule->hdrcode, (yyvsp[0].codeb));
        }
#line 4877 "../parser.c"
    break;

  case 258: /* typehdrcode: TK_TYPEHEADERCODE codeblock  */
#line 2304 "parser.y"
                                            {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 4885 "../parser.c"
    break;

  case 259: /* travcode: TK_TRAVERSECODE codeblock  */
#line 2309 "parser.y"
                                      {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 4893 "../parser.c"
    break;

  case 260: /* clearcode: TK_CLEARCODE codeblock  */
#line 2314 "parser.y"
                                   {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 4901 "../parser.c"
    break;

  case 261: /* getbufcode: TK_GETBUFFERCODE codeblock  */
#line 2319 "parser.y"
                                       {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 4909 "../parser.c"
    break;

  case 262: /* releasebufcode: TK_RELEASEBUFFERCODE codeblock  */
#line 2324 "parser.y"
                                               {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 4917 "../parser.c"
    break;

  case 263: /* readbufcode: TK_READBUFFERCODE codeblock  */
#line 2329 "parser.y"
                                            {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 4925 "../parser.c"
    break;

  case 264: /* writebufcode: TK_WRITEBUFFERCODE codeblock  */
#line 2334 "parser.y"
                                             {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 4933 "../parser.c"
    break;

  case 265: /* segcountcode: TK_SEGCOUNTCODE codeblock  */
#line 2339 "parser.y"
                                          {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 4941 "../parser.c"
    break;

  case 266: /* charbufcode: TK_CHARBUFFERCODE codeblock  */
#line 2344 "parser.y"
                                            {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 4949 "../parser.c"
    break;

  case 267: /* instancecode: TK_INSTANCECODE codeblock  */
#line 2349 "parser.y"
                                          {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 4957 "../parser.c"
    break;

  case 268: /* picklecode: TK_PICKLECODE codeblock  */
#line 2354 "parser.y"
                                    {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 4965 "../parser.c"
    break;

  case 269: /* finalcode: TK_FINALCODE codeblock  */
#line 2359 "parser.y"
                                   {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 4973 "../parser.c"
    break;

  case 270: /* modcode: TK_MODCODE codeblock  */
#line 2364 "parser.y"
                                 {
            if (notSkipping())
                appendCodeBlock(&currentModule->cppcode, (yyvsp[0].codeb));
        }
#line 4982 "../parser.c"
    break;

  case 271: /* typecode: TK_TYPECODE codeblock  */
#line 2370 "parser.y"
                                  {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 4990 "../parser.c"
    break;

  case 272: /* preinitcode: TK_PREINITCODE codeblock  */
#line 2375 "parser.y"
                                         {
            if (notSkipping())
                appendCodeBlock(&currentModule->preinitcode, (yyvsp[0].codeb));
        }
#line 4999 "../parser.c"
    break;

  case 273: /* initcode: TK_INITCODE codeblock  */
#line 2381 "parser.y"
                                  {
            if (notSkipping())
                appendCodeBlock(&currentModule->initcode, (yyvsp[0].codeb));
        }
#line 5008 "../parser.c"
    break;

  case 274: /* postinitcode: TK_POSTINITCODE codeblock  */
#line 2387 "parser.y"
                                          {
            if (notSkipping())
                appendCodeBlock(&currentModule->postinitcode, (yyvsp[0].codeb));
        }
#line 5017 "../parser.c"
    break;

  case 275: /* unitcode: TK_UNITCODE codeblock  */
#line 2393 "parser.y"
                                  {
            if (notSkipping())
                appendCodeBlock(&currentModule->unitcode, (yyvsp[0].codeb));
        }
#line 5026 "../parser.c"
    break;

  case 276: /* unitpostinccode: TK_UNITPOSTINCLUDECODE codeblock  */
#line 2399 "parser.y"
                                                     {
            if (notSkipping())
                appendCodeBlock(&currentModule->unitpostinccode, (yyvsp[0].codeb));
        }
#line 5035 "../parser.c"
    break;

  case 277: /* prepycode: TK_PREPYCODE codeblock  */
#line 2405 "parser.y"
                                   {
            /* Deprecated. */
        }
#line 5043 "../parser.c"
    break;

  case 278: /* exptypehintcode: TK_EXPTYPEHINTCODE codeblock  */
#line 2410 "parser.y"
                                              {
            if (notSkipping() && !inMainModule())
                appendCodeBlock(&currentSpec->exptypehintcode, (yyvsp[0].codeb));
        }
#line 5052 "../parser.c"
    break;

  case 279: /* modtypehintcode: TK_TYPEHINTCODE codeblock  */
#line 2416 "parser.y"
                                           {
            if (notSkipping())
                appendCodeBlock(&currentModule->typehintcode, (yyvsp[0].codeb));
        }
#line 5061 "../parser.c"
    break;

  case 280: /* classtypehintcode: TK_TYPEHINTCODE codeblock  */
#line 2422 "parser.y"
                                             {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 5069 "../parser.c"
    break;

  case 281: /* doc: TK_DOC codeblock  */
#line 2427 "parser.y"
                             {
            if (notSkipping() && inMainModule())
                appendCodeBlock(&currentSpec->docs, (yyvsp[0].codeb));
        }
#line 5078 "../parser.c"
    break;

  case 282: /* exporteddoc: TK_EXPORTEDDOC codeblock  */
#line 2433 "parser.y"
                                         {
            if (notSkipping())
                appendCodeBlock(&currentSpec->docs, (yyvsp[0].codeb));
        }
#line 5087 "../parser.c"
    break;

  case 283: /* autopyname: TK_AUTOPYNAME autopyname_args  */
#line 2439 "parser.y"
                                          {
            if (notSkipping())
                addAutoPyName(currentModule, (yyvsp[0].autopyname).remove_leading);
        }
#line 5096 "../parser.c"
    break;

  case 284: /* autopyname_args: '(' autopyname_arg_list ')'  */
#line 2445 "parser.y"
                                                {
            (yyval.autopyname) = (yyvsp[-1].autopyname);
        }
#line 5104 "../parser.c"
    break;

  case 286: /* autopyname_arg_list: autopyname_arg_list ',' autopyname_arg  */
#line 2451 "parser.y"
                                               {
            (yyval.autopyname) = (yyvsp[-2].autopyname);

            switch ((yyvsp[0].autopyname).token)
            {
            case TK_REMOVELEADING: (yyval.autopyname).remove_leading = (yyvsp[0].autopyname).remove_leading; break;
            }
        }
#line 5117 "../parser.c"
    break;

  case 287: /* autopyname_arg: TK_REMOVELEADING '=' TK_STRING_VALUE  */
#line 2461 "parser.y"
                                                     {
            (yyval.autopyname).token = TK_REMOVELEADING;

            (yyval.autopyname).remove_leading = (yyvsp[0].text);
        }
#line 5127 "../parser.c"
    break;

  case 288: /* docstring: TK_DOCSTRING docstring_args codeblock  */
#line 2468 "parser.y"
                                                  {
            (yyval.docstr) = sipMalloc(sizeof(docstringDef));

            (yyval.docstr)->signature = (yyvsp[-1].docstring).signature;
            (yyval.docstr)->text = (yyvsp[0].codeb)->frag;
            free((yyvsp[0].codeb));

            /* Format the docstring. */
            if ((yyvsp[-1].docstring).format == deindented)
            {
                const char *cp;
                char *dp;
                int min_indent, indent, skipping;

                /* Find the common indent. */
                min_indent = -1;
                indent = 0;
                skipping = FALSE;

                for (cp = (yyval.docstr)->text; *cp != '\0'; ++cp)
                {
                    if (skipping)
                    {
                        /*
                         * We have handled the indent and are just looking for
                         * the end of the line.
                         */
                        if (*cp == '\n')
                            skipping = FALSE;
                    }
                    else
                    {
                        if (*cp == ' ')
                        {
                            ++indent;
                        }
                        else if (*cp != '\n')
                        {
                            if (min_indent < 0 || min_indent > indent)
                                min_indent = indent;

                            /* Ignore the remaining characters of the line. */
                            skipping = TRUE;
                        }
                    }
                }

                /* In case the last line doesn't have a trailing newline. */
                if (min_indent < 0 || min_indent > indent)
                    min_indent = indent;

                /*
                 * Go through the text again removing the common indentation.
                 */
                cp = dp = (yyval.docstr)->text;

                while (*cp != '\0')
                {
                    const char *start = cp;
                    int non_blank = FALSE;

                    /* Find the end of the line. */
                    while (*cp != '\n' && *cp != '\0')
                        if (*cp++ != ' ')
                            non_blank = TRUE;

                    /* Find where we are copying from. */
                    if (non_blank)
                    {
                        start += min_indent;

                        while (*start != '\n' && *start != '\0')
                            *dp++ = *start++;
                    }

                    if (*cp == '\n')
                        *dp++ = *cp++;
                }

                *dp = '\0';
            }
        }
#line 5214 "../parser.c"
    break;

  case 289: /* docstring_args: %empty  */
#line 2552 "parser.y"
                {
            (yyval.docstring).format = currentModule->defdocstringfmt;
            (yyval.docstring).signature = currentModule->defdocstringsig;
        }
#line 5223 "../parser.c"
    break;

  case 290: /* docstring_args: TK_STRING_VALUE  */
#line 2556 "parser.y"
                        {
            resetLexerState();

            (yyval.docstring).format = convertFormat((yyvsp[0].text));
            (yyval.docstring).signature = currentModule->defdocstringsig;
        }
#line 5234 "../parser.c"
    break;

  case 291: /* docstring_args: '(' docstring_arg_list ')'  */
#line 2562 "parser.y"
                                   {
            (yyval.docstring) = (yyvsp[-1].docstring);
        }
#line 5242 "../parser.c"
    break;

  case 293: /* docstring_arg_list: docstring_arg_list ',' docstring_arg  */
#line 2568 "parser.y"
                                             {
            (yyval.docstring) = (yyvsp[-2].docstring);

            switch ((yyvsp[0].docstring).token)
            {
            case TK_FORMAT: (yyval.docstring).format = (yyvsp[0].docstring).format; break;
            case TK_SIGNATURE: (yyval.docstring).signature = (yyvsp[0].docstring).signature; break;
            }
        }
#line 5256 "../parser.c"
    break;

  case 294: /* docstring_arg: TK_FORMAT '=' TK_STRING_VALUE  */
#line 2579 "parser.y"
                                              {
            (yyval.docstring).token = TK_FORMAT;

            (yyval.docstring).format = convertFormat((yyvsp[0].text));
            (yyval.docstring).signature = currentModule->defdocstringsig;
        }
#line 5267 "../parser.c"
    break;

  case 295: /* docstring_arg: TK_SIGNATURE '=' TK_STRING_VALUE  */
#line 2585 "parser.y"
                                         {
            (yyval.docstring).token = TK_SIGNATURE;

            (yyval.docstring).format = currentModule->defdocstringfmt;
            (yyval.docstring).signature = convertSignature((yyvsp[0].text));
        }
#line 5278 "../parser.c"
    break;

  case 296: /* optdocstring: %empty  */
#line 2593 "parser.y"
              {
            (yyval.docstr) = NULL;
        }
#line 5286 "../parser.c"
    break;

  case 298: /* extract: TK_EXTRACT extract_args codeblock  */
#line 2599 "parser.y"
                                              {
            if ((yyvsp[-1].extract).id == NULL)
                yyerror("%Extract must have an 'id' argument");

            if (notSkipping())
                addExtractPart(currentSpec, (yyvsp[-1].extract).id, (yyvsp[-1].extract).order, (yyvsp[0].codeb));
        }
#line 5298 "../parser.c"
    break;

  case 299: /* extract_args: TK_NAME_VALUE  */
#line 2608 "parser.y"
                              {
            resetLexerState();

            (yyval.extract).id = (yyvsp[0].text);
            (yyval.extract).order = -1;
        }
#line 5309 "../parser.c"
    break;

  case 300: /* extract_args: '(' extract_arg_list ')'  */
#line 2614 "parser.y"
                                 {
            (yyval.extract) = (yyvsp[-1].extract);
        }
#line 5317 "../parser.c"
    break;

  case 302: /* extract_arg_list: extract_arg_list ',' extract_arg  */
#line 2620 "parser.y"
                                         {
            (yyval.extract) = (yyvsp[-2].extract);

            switch ((yyvsp[0].extract).token)
            {
            case TK_ID: (yyval.extract).id = (yyvsp[0].extract).id; break;
            case TK_ORDER: (yyval.extract).order = (yyvsp[0].extract).order; break;
            }
        }
#line 5331 "../parser.c"
    break;

  case 303: /* extract_arg: TK_ID '=' TK_NAME_VALUE  */
#line 2631 "parser.y"
                                        {
            (yyval.extract).token = TK_ID;

            (yyval.extract).id = (yyvsp[0].text);
            (yyval.extract).order = -1;
        }
#line 5342 "../parser.c"
    break;

  case 304: /* extract_arg: TK_ORDER '=' TK_NUMBER_VALUE  */
#line 2637 "parser.y"
                                     {
            (yyval.extract).token = TK_ORDER;

            if ((yyvsp[0].number) < 0)
                yyerror("The 'order' of an %Extract directive must not be negative");

            (yyval.extract).id = NULL;
            (yyval.extract).order = (yyvsp[0].number);
        }
#line 5356 "../parser.c"
    break;

  case 305: /* makefile: TK_MAKEFILE TK_PATH_VALUE optfilename codeblock  */
#line 2648 "parser.y"
                                                            {
            /* Deprecated. */
        }
#line 5364 "../parser.c"
    break;

  case 308: /* codelines: codelines TK_CODELINE  */
#line 2657 "parser.y"
                              {
            (yyval.codeb) = (yyvsp[-1].codeb);

            append(&(yyval.codeb)->frag, (yyvsp[0].codeb)->frag);

            free((yyvsp[0].codeb)->frag);
            free((yyvsp[0].codeb));
        }
#line 5377 "../parser.c"
    break;

  case 309: /* $@9: %empty  */
#line 2667 "parser.y"
                                                {
            if (notSkipping())
            {
                const char *annos[] = {
                    "NoScope",
                    "NoTypeHint",
                    "PyName",
                    NULL
                };

                checkAnnos(&(yyvsp[0].optflags), annos);

                if (sectionFlags != 0 && (sectionFlags & ~(SECT_IS_PUBLIC | SECT_IS_PROT)) != 0)
                    yyerror("Class enums must be in the public or protected sections");

                if (currentSpec->genc && (yyvsp[-2].boolean))
                    yyerror("Scoped enums not allowed in a C module");

                currentEnum = newEnum(currentSpec, currentModule,
                        currentMappedType, (yyvsp[-1].text), &(yyvsp[0].optflags), sectionFlags, (yyvsp[-2].boolean));
            }
        }
#line 5404 "../parser.c"
    break;

  case 311: /* optenumkey: %empty  */
#line 2691 "parser.y"
            {
            (yyval.boolean) = FALSE;
        }
#line 5412 "../parser.c"
    break;

  case 312: /* optenumkey: TK_CLASS  */
#line 2694 "parser.y"
                 {
            (yyval.boolean) = TRUE;
        }
#line 5420 "../parser.c"
    break;

  case 313: /* optenumkey: TK_STRUCT  */
#line 2697 "parser.y"
                  {
            (yyval.boolean) = TRUE;
        }
#line 5428 "../parser.c"
    break;

  case 314: /* optfilename: %empty  */
#line 2702 "parser.y"
                {
            (yyval.text) = NULL;
        }
#line 5436 "../parser.c"
    break;

  case 315: /* optfilename: TK_PATH_VALUE  */
#line 2705 "parser.y"
                      {
            (yyval.text) = (yyvsp[0].text);
        }
#line 5444 "../parser.c"
    break;

  case 316: /* optname: %empty  */
#line 2710 "parser.y"
            {
            (yyval.text) = NULL;
        }
#line 5452 "../parser.c"
    break;

  case 317: /* optname: TK_NAME_VALUE  */
#line 2713 "parser.y"
                      {
            (yyval.text) = (yyvsp[0].text);
        }
#line 5460 "../parser.c"
    break;

  case 324: /* enumline: TK_NAME_VALUE optenumassign optflags optcomma  */
#line 2728 "parser.y"
                                                      {
            if (notSkipping())
            {
                const char *annos[] = {
                    "NoTypeHint",
                    "PyName",
                    NULL
                };

                enumMemberDef *emd, **tail;

                checkAnnos(&(yyvsp[-1].optflags), annos);

                /* Note that we don't use the assigned value. */
                emd = sipMalloc(sizeof (enumMemberDef));

                emd->pyname = cacheName(currentSpec,
                        getPythonName(currentModule, &(yyvsp[-1].optflags), (yyvsp[-3].text)));
                emd->cname = (yyvsp[-3].text);
                emd->no_typehint = getNoTypeHint(&(yyvsp[-1].optflags));
                emd->ed = currentEnum;
                emd->platforms = currentPlatforms;
                emd->next = NULL;

                /*
                 * Note that we don't check that members of scoped enums are
                 * unique.
                 */
                if (!isScopedEnum(currentEnum))
                    checkAttributes(currentSpec, currentModule, emd->ed->ecd,
                            emd->ed->emtd, emd->pyname->text, FALSE);

                /* Append to preserve the order. */
                for (tail = &currentEnum->members; *tail != NULL; tail = &(*tail)->next)
                    ;

                *tail = emd;

                if (inMainModule())
                    setIsUsedName(emd->pyname);
            }
        }
#line 5507 "../parser.c"
    break;

  case 329: /* optassign: %empty  */
#line 2780 "parser.y"
            {
            (yyval.valp) = NULL;
        }
#line 5515 "../parser.c"
    break;

  case 330: /* optassign: '=' expr  */
#line 2783 "parser.y"
                 {
            (yyval.valp) = (yyvsp[0].valp);
        }
#line 5523 "../parser.c"
    break;

  case 332: /* expr: expr binop value  */
#line 2789 "parser.y"
                         {
            valueDef *vd;
 
            if ((yyvsp[-2].valp) -> vtype == string_value || (yyvsp[0].valp) -> vtype == string_value)
                yyerror("Invalid binary operator for string");
 
            /* Find the last value in the existing expression. */
 
            for (vd = (yyvsp[-2].valp); vd -> next != NULL; vd = vd -> next)
                ;
 
            vd -> vbinop = (yyvsp[-1].qchar);
            vd -> next = (yyvsp[0].valp);

            (yyval.valp) = (yyvsp[-2].valp);
        }
#line 5544 "../parser.c"
    break;

  case 333: /* binop: '-'  */
#line 2807 "parser.y"
            {
            (yyval.qchar) = '-';
        }
#line 5552 "../parser.c"
    break;

  case 334: /* binop: '+'  */
#line 2810 "parser.y"
            {
            (yyval.qchar) = '+';
        }
#line 5560 "../parser.c"
    break;

  case 335: /* binop: '*'  */
#line 2813 "parser.y"
            {
            (yyval.qchar) = '*';
        }
#line 5568 "../parser.c"
    break;

  case 336: /* binop: '/'  */
#line 2816 "parser.y"
            {
            (yyval.qchar) = '/';
        }
#line 5576 "../parser.c"
    break;

  case 337: /* binop: '&'  */
#line 2819 "parser.y"
            {
            (yyval.qchar) = '&';
        }
#line 5584 "../parser.c"
    break;

  case 338: /* binop: '|'  */
#line 2822 "parser.y"
            {
            (yyval.qchar) = '|';
        }
#line 5592 "../parser.c"
    break;

  case 339: /* optunop: %empty  */
#line 2827 "parser.y"
            {
            (yyval.qchar) = '\0';
        }
#line 5600 "../parser.c"
    break;

  case 340: /* optunop: '!'  */
#line 2830 "parser.y"
            {
            (yyval.qchar) = '!';
        }
#line 5608 "../parser.c"
    break;

  case 341: /* optunop: '~'  */
#line 2833 "parser.y"
            {
            (yyval.qchar) = '~';
        }
#line 5616 "../parser.c"
    break;

  case 342: /* optunop: '-'  */
#line 2836 "parser.y"
            {
            (yyval.qchar) = '-';
        }
#line 5624 "../parser.c"
    break;

  case 343: /* optunop: '+'  */
#line 2839 "parser.y"
            {
            (yyval.qchar) = '+';
        }
#line 5632 "../parser.c"
    break;

  case 344: /* optunop: '*'  */
#line 2842 "parser.y"
            {
            (yyval.qchar) = '*';
        }
#line 5640 "../parser.c"
    break;

  case 345: /* optunop: '&'  */
#line 2845 "parser.y"
            {
            (yyval.qchar) = '&';
        }
#line 5648 "../parser.c"
    break;

  case 346: /* value: optcast optunop simplevalue  */
#line 2850 "parser.y"
                                        {
            if ((yyvsp[-1].qchar) != '\0' && (yyvsp[0].value).vtype == string_value)
                yyerror("Invalid unary operator for string");
 
            /* Convert the value to a simple expression on the heap. */
            (yyval.valp) = sipMalloc(sizeof (valueDef));
 
            *(yyval.valp) = (yyvsp[0].value);
            (yyval.valp)->vunop = (yyvsp[-1].qchar);
            (yyval.valp)->vbinop = '\0';
            (yyval.valp)->cast = (yyvsp[-2].scpvalp);
            (yyval.valp)->next = NULL;
        }
#line 5666 "../parser.c"
    break;

  case 347: /* optcast: %empty  */
#line 2865 "parser.y"
            {
            (yyval.scpvalp) = NULL;
        }
#line 5674 "../parser.c"
    break;

  case 348: /* optcast: '(' scopedname ')'  */
#line 2868 "parser.y"
                               {
            (yyval.scpvalp) = (yyvsp[-1].scpvalp);
        }
#line 5682 "../parser.c"
    break;

  case 349: /* scopedname: TK_SCOPE scopednamehead  */
#line 2873 "parser.y"
                                    {
            if (currentSpec->genc)
                yyerror("Scoped names are not allowed in a C module");

            (yyval.scpvalp) = scopeScopedName(NULL, (yyvsp[0].scpvalp));
        }
#line 5693 "../parser.c"
    break;

  case 352: /* scopednamehead: scopednamehead TK_SCOPE scopepart  */
#line 2883 "parser.y"
                                          {
            if (currentSpec->genc)
                yyerror("Scoped names are not allowed in a C module");

            appendScopedName(&(yyvsp[-2].scpvalp), (yyvsp[0].scpvalp));
        }
#line 5704 "../parser.c"
    break;

  case 353: /* scopepart: TK_NAME_VALUE  */
#line 2891 "parser.y"
                          {
            (yyval.scpvalp) = text2scopePart((yyvsp[0].text));
        }
#line 5712 "../parser.c"
    break;

  case 354: /* bool_value: TK_TRUE_VALUE  */
#line 2896 "parser.y"
                          {
            (yyval.boolean) = TRUE;
        }
#line 5720 "../parser.c"
    break;

  case 355: /* bool_value: TK_FALSE_VALUE  */
#line 2899 "parser.y"
                       {
            (yyval.boolean) = FALSE;
        }
#line 5728 "../parser.c"
    break;

  case 356: /* simplevalue: scopedname  */
#line 2904 "parser.y"
                           {
            /*
             * We let the C++ compiler decide if the value is a valid one - no
             * point in building a full C++ parser here.
             */

            (yyval.value).vtype = scoped_value;
            (yyval.value).u.vscp = (yyvsp[0].scpvalp);
        }
#line 5742 "../parser.c"
    break;

  case 357: /* simplevalue: basetype '(' exprlist ')'  */
#line 2913 "parser.y"
                                  {
            fcallDef *fcd;

            fcd = sipMalloc(sizeof (fcallDef));
            *fcd = (yyvsp[-1].fcall);
            fcd -> type = (yyvsp[-3].memArg);

            (yyval.value).vtype = fcall_value;
            (yyval.value).u.fcd = fcd;
        }
#line 5757 "../parser.c"
    break;

  case 358: /* simplevalue: '{' '}'  */
#line 2923 "parser.y"
                {
            (yyval.value).vtype = empty_value;
        }
#line 5765 "../parser.c"
    break;

  case 359: /* simplevalue: TK_REAL_VALUE  */
#line 2926 "parser.y"
                      {
            (yyval.value).vtype = real_value;
            (yyval.value).u.vreal = (yyvsp[0].real);
        }
#line 5774 "../parser.c"
    break;

  case 360: /* simplevalue: TK_NUMBER_VALUE  */
#line 2930 "parser.y"
                        {
            (yyval.value).vtype = numeric_value;
            (yyval.value).u.vnum = (yyvsp[0].number);
        }
#line 5783 "../parser.c"
    break;

  case 361: /* simplevalue: bool_value  */
#line 2934 "parser.y"
                   {
            (yyval.value).vtype = numeric_value;
            (yyval.value).u.vnum = (yyvsp[0].boolean);
        }
#line 5792 "../parser.c"
    break;

  case 362: /* simplevalue: TK_NULL_VALUE  */
#line 2938 "parser.y"
                      {
            (yyval.value).vtype = numeric_value;
            (yyval.value).u.vnum = 0;
        }
#line 5801 "../parser.c"
    break;

  case 363: /* simplevalue: TK_STRING_VALUE  */
#line 2942 "parser.y"
                        {
            (yyval.value).vtype = string_value;
            (yyval.value).u.vstr = (yyvsp[0].text);
        }
#line 5810 "../parser.c"
    break;

  case 364: /* simplevalue: TK_QCHAR_VALUE  */
#line 2946 "parser.y"
                       {
            (yyval.value).vtype = qchar_value;
            (yyval.value).u.vqchar = (yyvsp[0].qchar);
        }
#line 5819 "../parser.c"
    break;

  case 365: /* exprlist: %empty  */
#line 2952 "parser.y"
            {
            /* No values. */

            (yyval.fcall).nrArgs = 0;
        }
#line 5829 "../parser.c"
    break;

  case 366: /* exprlist: expr  */
#line 2957 "parser.y"
             {
            /* The single or first expression. */

            (yyval.fcall).args[0] = (yyvsp[0].valp);
            (yyval.fcall).nrArgs = 1;
        }
#line 5840 "../parser.c"
    break;

  case 367: /* exprlist: exprlist ',' expr  */
#line 2963 "parser.y"
                          {
            /* Check that it wasn't ...(,expression...). */

            if ((yyval.fcall).nrArgs == 0)
                yyerror("First argument to function call is missing");

            /* Check there is room. */

            if ((yyvsp[-2].fcall).nrArgs == MAX_NR_ARGS)
                yyerror("Internal error - increase the value of MAX_NR_ARGS");

            (yyval.fcall) = (yyvsp[-2].fcall);

            (yyval.fcall).args[(yyval.fcall).nrArgs] = (yyvsp[0].valp);
            (yyval.fcall).nrArgs++;
        }
#line 5861 "../parser.c"
    break;

  case 368: /* typedef: TK_TYPEDEF cpptype TK_NAME_VALUE optflags ';' optdocstring  */
#line 2981 "parser.y"
                                                                       {
            if (notSkipping())
            {
                const char *annos[] = {
                    "Capsule",
                    "DocType",
                    "Encoding",
                    "NoTypeName",
                    "PyInt",
                    "PyName",
                    "TypeHint",
                    "TypeHintIn",
                    "TypeHintOut",
                    NULL
                };

                checkAnnos(&(yyvsp[-2].optflags), annos);

                applyTypeFlags(currentModule, &(yyvsp[-4].memArg), &(yyvsp[-2].optflags));
                newTypedef(currentSpec, currentModule, (yyvsp[-3].text), &(yyvsp[-4].memArg), &(yyvsp[-2].optflags), (yyvsp[0].docstr));
            }
        }
#line 5888 "../parser.c"
    break;

  case 369: /* typedef: TK_TYPEDEF cpptype '(' '*' TK_NAME_VALUE ')' '(' cpptypelist ')' optflags ';' optdocstring  */
#line 3003 "parser.y"
                                                                                                   {
            if (notSkipping())
            {
                const char *annos[] = {
                    "DocType",
                    "Encoding",
                    "NoTypeName",
                    "PyInt",
                    "PyName",
                    "TypeHint",
                    "TypeHintIn",
                    "TypeHintOut",
                    NULL
                };

                signatureDef *sig;
                argDef ftype;

                checkAnnos(&(yyvsp[-2].optflags), annos);

                applyTypeFlags(currentModule, &(yyvsp[-10].memArg), &(yyvsp[-2].optflags));

                memset(&ftype, 0, sizeof (argDef));

                /* Create the full signature on the heap. */
                sig = sipMalloc(sizeof (signatureDef));
                *sig = (yyvsp[-4].signature);
                sig->result = (yyvsp[-10].memArg);

                /* Create the full type. */
                ftype.atype = function_type;
                ftype.nrderefs = 1;
                ftype.u.sa = sig;

                newTypedef(currentSpec, currentModule, (yyvsp[-7].text), &ftype, &(yyvsp[-2].optflags), (yyvsp[0].docstr));
            }
        }
#line 5930 "../parser.c"
    break;

  case 370: /* $@10: %empty  */
#line 3042 "parser.y"
                                 {
            if (currentSpec -> genc && (yyvsp[0].scpvalp)->next != NULL)
                yyerror("Namespaces not allowed in a C module");

            if (notSkipping())
                currentSupers = NULL;
        }
#line 5942 "../parser.c"
    break;

  case 371: /* $@11: %empty  */
#line 3048 "parser.y"
                                {
            if (notSkipping())
            {
                const char *annos[] = {
                    "Abstract",
                    "AllowNone",
                    "API",
                    "DelayDtor",
                    "Deprecated",
                    "ExportDerived",
                    "External",
                    "FileExtension",
                    "Metatype",
                    "Mixin",
                    "NoDefaultCtors",
                    "NoTypeHint",
                    "PyName",
                    "PyQtFlags",
                    "PyQtFlagsEnums",
                    "PyQtInterface",
                    "PyQtNoQMetaObject",
                    "Supertype",
                    "TypeHint",
                    "TypeHintIn",
                    "TypeHintOut",
                    "TypeHintValue",
                    "VirtualErrorHandler",
                    NULL
                };

                checkAnnos(&(yyvsp[0].optflags), annos);

                if (currentSpec->genc && currentSupers != NULL)
                    yyerror("Super-classes not allowed in a C module struct");

                defineClass((yyvsp[-3].scpvalp), currentSupers, &(yyvsp[0].optflags));
                sectionFlags = SECT_IS_PUBLIC;
            }
        }
#line 5986 "../parser.c"
    break;

  case 372: /* struct: TK_STRUCT scopedname $@10 superclasses optflags $@11 optclassbody ';'  */
#line 3086 "parser.y"
                           {
            if (notSkipping())
                completeClass((yyvsp[-6].scpvalp), &(yyvsp[-3].optflags), (yyvsp[-1].boolean));
        }
#line 5995 "../parser.c"
    break;

  case 373: /* $@12: %empty  */
#line 3092 "parser.y"
                     {currentIsTemplate = TRUE;}
#line 6001 "../parser.c"
    break;

  case 374: /* classtmpl: template $@12 class  */
#line 3092 "parser.y"
                                                       {
            if (currentSpec->genc)
                yyerror("Class templates not allowed in a C module");

            if (notSkipping())
            {
                classTmplDef *tcd;

                /*
                 * Make sure there is room for the extra class name argument.
                 */
                if ((yyvsp[-2].signature).nrArgs == MAX_NR_ARGS)
                    yyerror("Internal error - increase the value of MAX_NR_ARGS");

                tcd = sipMalloc(sizeof (classTmplDef));
                tcd->sig = (yyvsp[-2].signature);
                tcd->cd = (yyvsp[0].klass);
                tcd->next = currentSpec->classtemplates;

                currentSpec->classtemplates = tcd;
            }

            currentIsTemplate = FALSE;
        }
#line 6030 "../parser.c"
    break;

  case 375: /* template: TK_TEMPLATE '<' cpptypelist '>'  */
#line 3118 "parser.y"
                                            {
            (yyval.signature) = (yyvsp[-1].signature);
        }
#line 6038 "../parser.c"
    break;

  case 376: /* $@13: %empty  */
#line 3123 "parser.y"
                            {
            if (currentSpec->genc)
                yyerror("Class definition not allowed in a C module");

            if (notSkipping())
                currentSupers = NULL;
        }
#line 6050 "../parser.c"
    break;

  case 377: /* $@14: %empty  */
#line 3129 "parser.y"
                                {
            if (notSkipping())
            {
                const char *annos[] = {
                    "Abstract",
                    "AllowNone",
                    "API",
                    "DelayDtor",
                    "Deprecated",
                    "ExportDerived",
                    "External",
                    "FileExtension",
                    "Metatype",
                    "Mixin",
                    "NoDefaultCtors",
                    "PyName",
                    "PyQtFlags",
                    "PyQtFlagsEnums",
                    "PyQtInterface",
                    "PyQtNoQMetaObject",
                    "Supertype",
                    "TypeHint",
                    "TypeHintIn",
                    "TypeHintOut",
                    "TypeHintValue",
                    "VirtualErrorHandler",
                    NULL
                };

                checkAnnos(&(yyvsp[0].optflags), annos);

                defineClass((yyvsp[-3].scpvalp), currentSupers, &(yyvsp[0].optflags));
                sectionFlags = SECT_IS_PRIVATE;
            }
        }
#line 6090 "../parser.c"
    break;

  case 378: /* class: TK_CLASS scopedname $@13 superclasses optflags $@14 optclassbody ';'  */
#line 3163 "parser.y"
                           {
            if (notSkipping())
                (yyval.klass) = completeClass((yyvsp[-6].scpvalp), &(yyvsp[-3].optflags), (yyvsp[-1].boolean));
        }
#line 6099 "../parser.c"
    break;

  case 383: /* superclass: class_access scopedname  */
#line 3177 "parser.y"
                                    {
            if (notSkipping() && (yyvsp[-1].token) == TK_PUBLIC)
            {
                argDef ad;
                classDef *super;
                scopedNameDef *snd = (yyvsp[0].scpvalp);

                /*
                 * This is a hack to allow typedef'ed classes to be used before
                 * we have resolved the typedef definitions.  Unlike elsewhere,
                 * we require that the typedef is defined before being used.
                 */
                for (;;)
                {
                    ad.atype = no_type;
                    ad.argflags = 0;
                    ad.nrderefs = 0;
                    ad.original_type = NULL;

                    searchTypedefs(currentSpec, snd, &ad);

                    if (ad.atype != defined_type)
                        break;

                    if (ad.nrderefs != 0 || isConstArg(&ad) || isReference(&ad))
                        break;

                    snd = ad.u.snd;
                }

                if (ad.atype != no_type)
                    yyerror("Super-class list contains an invalid type");

                /*
                 * This is a bug because we should look in the local scope
                 * rather than assume it is in the global scope.
                 */
                if (snd->name[0] != '\0')
                    snd = scopeScopedName(NULL, snd);

                /*
                 * Note that passing NULL as the API is a bug.  Instead we
                 * should pass the API of the sub-class being defined,
                 * otherwise we cannot create sub-classes of versioned classes.
                 */
                super = findClass(currentSpec, class_iface, NULL, snd,
                        currentIsTemplate);
                appendToClassList(&currentSupers, super);
            }
        }
#line 6154 "../parser.c"
    break;

  case 384: /* class_access: %empty  */
#line 3229 "parser.y"
                {
        (yyval.token) = TK_PUBLIC;
        }
#line 6162 "../parser.c"
    break;

  case 385: /* class_access: TK_PUBLIC  */
#line 3232 "parser.y"
                  {
        (yyval.token) = TK_PUBLIC;
        }
#line 6170 "../parser.c"
    break;

  case 386: /* class_access: TK_PROTECTED  */
#line 3235 "parser.y"
                     {
        (yyval.token) = TK_PROTECTED;
        }
#line 6178 "../parser.c"
    break;

  case 387: /* class_access: TK_PRIVATE  */
#line 3238 "parser.y"
                   {
        (yyval.token) = TK_PRIVATE;
        }
#line 6186 "../parser.c"
    break;

  case 388: /* optclassbody: %empty  */
#line 3243 "parser.y"
                {
            (yyval.boolean) = FALSE;
        }
#line 6194 "../parser.c"
    break;

  case 389: /* optclassbody: '{' classbody '}'  */
#line 3246 "parser.y"
                          {
            (yyval.boolean) = TRUE;
        }
#line 6202 "../parser.c"
    break;

  case 403: /* classline: docstring  */
#line 3266 "parser.y"
                  {
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->docstring != NULL)
                    yyerror("%Docstring already given for class");

                scope->docstring = (yyvsp[0].docstr);
            }
        }
#line 6218 "../parser.c"
    break;

  case 404: /* classline: typecode  */
#line 3277 "parser.y"
                 {
            if (notSkipping())
                appendCodeBlock(&currentScope()->cppcode, (yyvsp[0].codeb));
        }
#line 6227 "../parser.c"
    break;

  case 405: /* classline: typehdrcode  */
#line 3281 "parser.y"
                    {
            if (notSkipping())
                appendCodeBlock(&currentScope()->iff->hdrcode, (yyvsp[0].codeb));
        }
#line 6236 "../parser.c"
    break;

  case 406: /* classline: travcode  */
#line 3285 "parser.y"
                 {
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->travcode != NULL)
                    yyerror("%GCTraverseCode already given for class");

                appendCodeBlock(&scope->travcode, (yyvsp[0].codeb));
            }
        }
#line 6252 "../parser.c"
    break;

  case 407: /* classline: clearcode  */
#line 3296 "parser.y"
                  {
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->clearcode != NULL)
                    yyerror("%GCClearCode already given for class");

                appendCodeBlock(&scope->clearcode, (yyvsp[0].codeb));
            }
        }
#line 6268 "../parser.c"
    break;

  case 408: /* classline: getbufcode  */
#line 3307 "parser.y"
                   {
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->getbufcode != NULL)
                    yyerror("%BIGetBufferCode already given for class");

                appendCodeBlock(&scope->getbufcode, (yyvsp[0].codeb));
            }
        }
#line 6284 "../parser.c"
    break;

  case 409: /* classline: releasebufcode  */
#line 3318 "parser.y"
                       {
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->releasebufcode != NULL)
                    yyerror("%BIReleaseBufferCode already given for class");

                appendCodeBlock(&scope->releasebufcode, (yyvsp[0].codeb));
            }
        }
#line 6300 "../parser.c"
    break;

  case 410: /* classline: readbufcode  */
#line 3329 "parser.y"
                    {
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->readbufcode != NULL)
                    yyerror("%BIGetReadBufferCode already given for class");

                appendCodeBlock(&scope->readbufcode, (yyvsp[0].codeb));
            }
        }
#line 6316 "../parser.c"
    break;

  case 411: /* classline: writebufcode  */
#line 3340 "parser.y"
                     {
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->writebufcode != NULL)
                    yyerror("%BIGetWriteBufferCode already given for class");

                appendCodeBlock(&scope->writebufcode, (yyvsp[0].codeb));
            }
        }
#line 6332 "../parser.c"
    break;

  case 412: /* classline: segcountcode  */
#line 3351 "parser.y"
                     {
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->segcountcode != NULL)
                    yyerror("%BIGetSegCountCode already given for class");

                appendCodeBlock(&scope->segcountcode, (yyvsp[0].codeb));
            }
        }
#line 6348 "../parser.c"
    break;

  case 413: /* classline: charbufcode  */
#line 3362 "parser.y"
                    {
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->charbufcode != NULL)
                    yyerror("%BIGetCharBufferCode already given for class");

                appendCodeBlock(&scope->charbufcode, (yyvsp[0].codeb));
            }
        }
#line 6364 "../parser.c"
    break;

  case 414: /* classline: instancecode  */
#line 3373 "parser.y"
                     {
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->instancecode != NULL)
                    yyerror("%InstanceCode already given for class");

                appendCodeBlock(&scope->instancecode, (yyvsp[0].codeb));
            }
        }
#line 6380 "../parser.c"
    break;

  case 415: /* classline: picklecode  */
#line 3384 "parser.y"
                   {
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->picklecode != NULL)
                    yyerror("%PickleCode already given for class");

                appendCodeBlock(&scope->picklecode, (yyvsp[0].codeb));
            }
        }
#line 6396 "../parser.c"
    break;

  case 416: /* classline: finalcode  */
#line 3395 "parser.y"
                  {
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->finalcode != NULL)
                    yyerror("%FinalisationCode already given for class");

                appendCodeBlock(&scope->finalcode, (yyvsp[0].codeb));
            }
        }
#line 6412 "../parser.c"
    break;

  case 417: /* classline: classtypehintcode  */
#line 3406 "parser.y"
                          {
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->typehintcode != NULL)
                    yyerror("%TypeHintCode already given for class");

                appendCodeBlock(&scope->typehintcode, (yyvsp[0].codeb));
            }
        }
#line 6428 "../parser.c"
    break;

  case 421: /* classline: TK_TOSUBCLASS codeblock  */
#line 3420 "parser.y"
                                {
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->convtosubcode != NULL)
                    yyerror("Class has more than one %ConvertToSubClassCode directive");

                appendCodeBlock(&scope->convtosubcode, (yyvsp[0].codeb));
            }
        }
#line 6444 "../parser.c"
    break;

  case 422: /* classline: TK_TOTYPE codeblock  */
#line 3431 "parser.y"
                            {
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->convtocode != NULL)
                    yyerror("Class has more than one %ConvertToTypeCode directive");

                appendCodeBlock(&scope->convtocode, (yyvsp[0].codeb));
            }
        }
#line 6460 "../parser.c"
    break;

  case 423: /* classline: TK_FROMTYPE codeblock  */
#line 3442 "parser.y"
                              {
            if (notSkipping())
            {
                classDef *scope = currentScope();

                if (scope->convfromcode != NULL)
                    yyerror("Class has more than one %ConvertFromTypeCode directive");

                appendCodeBlock(&scope->convfromcode, (yyvsp[0].codeb));
            }
        }
#line 6476 "../parser.c"
    break;

  case 424: /* classline: TK_PUBLIC optslot ':'  */
#line 3453 "parser.y"
                              {
            if (currentSpec -> genc)
                yyerror("public section not allowed in a C module");

            if (notSkipping())
                sectionFlags = SECT_IS_PUBLIC | (yyvsp[-1].number);
        }
#line 6488 "../parser.c"
    break;

  case 425: /* classline: TK_PROTECTED optslot ':'  */
#line 3460 "parser.y"
                                 {
            if (currentSpec -> genc)
                yyerror("protected section not allowed in a C module");

            if (notSkipping())
                sectionFlags = SECT_IS_PROT | (yyvsp[-1].number);
        }
#line 6500 "../parser.c"
    break;

  case 426: /* classline: TK_PRIVATE optslot ':'  */
#line 3467 "parser.y"
                               {
            if (currentSpec -> genc)
                yyerror("private section not allowed in a C module");

            if (notSkipping())
                sectionFlags = SECT_IS_PRIVATE | (yyvsp[-1].number);
        }
#line 6512 "../parser.c"
    break;

  case 427: /* classline: TK_SIGNALS ':'  */
#line 3474 "parser.y"
                       {
            if (currentSpec -> genc)
                yyerror("signals section not allowed in a C module");

            if (notSkipping())
                sectionFlags = SECT_IS_SIGNAL;
        }
#line 6524 "../parser.c"
    break;

  case 428: /* property: TK_PROPERTY property_args property_body  */
#line 3483 "parser.y"
                                                    {
            if ((yyvsp[-1].property).name == NULL)
                yyerror("A %Property directive must have a 'name' argument");

            if ((yyvsp[-1].property).get == NULL)
                yyerror("A %Property directive must have a 'get' argument");

            if (notSkipping())
                addProperty(currentSpec, currentModule, currentScope(),
                        (yyvsp[-1].property).name, (yyvsp[-1].property).get, (yyvsp[-1].property).set, (yyvsp[0].property).docstring);
        }
#line 6540 "../parser.c"
    break;

  case 429: /* property_args: '(' property_arg_list ')'  */
#line 3496 "parser.y"
                                          {
            (yyval.property) = (yyvsp[-1].property);
        }
#line 6548 "../parser.c"
    break;

  case 431: /* property_arg_list: property_arg_list ',' property_arg  */
#line 3502 "parser.y"
                                           {
            (yyval.property) = (yyvsp[-2].property);

            switch ((yyvsp[0].property).token)
            {
            case TK_GET: (yyval.property).get = (yyvsp[0].property).get; break;
            case TK_NAME: (yyval.property).name = (yyvsp[0].property).name; break;
            case TK_SET: (yyval.property).set = (yyvsp[0].property).set; break;
            }
        }
#line 6563 "../parser.c"
    break;

  case 432: /* property_arg: TK_GET '=' TK_NAME_VALUE  */
#line 3514 "parser.y"
                                         {
            (yyval.property).token = TK_GET;

            (yyval.property).get = (yyvsp[0].text);
            (yyval.property).name = NULL;
            (yyval.property).set = NULL;
        }
#line 6575 "../parser.c"
    break;

  case 433: /* property_arg: TK_NAME '=' name_or_string  */
#line 3521 "parser.y"
                                   {
            (yyval.property).token = TK_NAME;

            (yyval.property).get = NULL;
            (yyval.property).name = (yyvsp[0].text);
            (yyval.property).set = NULL;
        }
#line 6587 "../parser.c"
    break;

  case 434: /* property_arg: TK_SET '=' TK_NAME_VALUE  */
#line 3528 "parser.y"
                                 {
            (yyval.property).token = TK_SET;

            (yyval.property).get = NULL;
            (yyval.property).name = NULL;
            (yyval.property).set = (yyvsp[0].text);
        }
#line 6599 "../parser.c"
    break;

  case 435: /* property_body: %empty  */
#line 3537 "parser.y"
                {
            (yyval.property).token = 0;
            (yyval.property).docstring = NULL;
        }
#line 6608 "../parser.c"
    break;

  case 436: /* property_body: '{' property_body_directives '}' ';'  */
#line 3541 "parser.y"
                                             {
            (yyval.property) = (yyvsp[-2].property);
        }
#line 6616 "../parser.c"
    break;

  case 438: /* property_body_directives: property_body_directives property_body_directive  */
#line 3547 "parser.y"
                                                         {
            (yyval.property) = (yyvsp[-1].property);

            switch ((yyvsp[0].property).token)
            {
            case TK_DOCSTRING: (yyval.property).docstring = (yyvsp[0].property).docstring; break;
            }
        }
#line 6629 "../parser.c"
    break;

  case 439: /* property_body_directive: ifstart  */
#line 3557 "parser.y"
                                    {
            (yyval.property).token = TK_IF;
        }
#line 6637 "../parser.c"
    break;

  case 440: /* property_body_directive: ifend  */
#line 3560 "parser.y"
              {
            (yyval.property).token = TK_END;
        }
#line 6645 "../parser.c"
    break;

  case 441: /* property_body_directive: docstring  */
#line 3563 "parser.y"
                  {
            if (notSkipping())
            {
                (yyval.property).token = TK_DOCSTRING;
                (yyval.property).docstring = (yyvsp[0].docstr);
            }
            else
            {
                (yyval.property).token = 0;
                (yyval.property).docstring = NULL;
            }
        }
#line 6662 "../parser.c"
    break;

  case 444: /* optslot: %empty  */
#line 3581 "parser.y"
            {
            (yyval.number) = 0;
        }
#line 6670 "../parser.c"
    break;

  case 445: /* optslot: TK_SLOTS  */
#line 3584 "parser.y"
                 {
            (yyval.number) = SECT_IS_SLOT;
        }
#line 6678 "../parser.c"
    break;

  case 446: /* $@15: %empty  */
#line 3590 "parser.y"
                   {currentIsVirt = TRUE;}
#line 6684 "../parser.c"
    break;

  case 449: /* dtor_decl: '~' TK_NAME_VALUE '(' ')' optexceptions optabstract optflags ';' premethodcode methodcode virtualcatchercode  */
#line 3594 "parser.y"
                                                                                                                         {
            /* Note that we allow non-virtual dtors in C modules. */

            if (notSkipping())
            {
                const char *annos[] = {
                    "HoldGIL",
                    "ReleaseGIL",
                    NULL
                };

                classDef *cd = currentScope();

                checkAnnos(&(yyvsp[-4].optflags), annos);

                if (strcmp(classBaseName(cd),(yyvsp[-9].text)) != 0)
                    yyerror("Destructor doesn't have the same name as its class");

                if (isDtor(cd))
                    yyerror("Destructor has already been defined");

                if (currentSpec -> genc && (yyvsp[-2].codeb) == NULL)
                    yyerror("Destructor in C modules must include %MethodCode");


                appendCodeBlock(&cd->dealloccode, (yyvsp[-2].codeb));  /* premethodcode */
                appendCodeBlock(&cd->dealloccode, (yyvsp[-1].codeb)); /* methodcode */
                appendCodeBlock(&cd->dtorcode, (yyvsp[0].codeb));
                cd -> dtorexceptions = (yyvsp[-6].throwlist);

                /*
                 * Note that we don't apply the protected/public hack to dtors
                 * as it (I think) may change the behaviour of the wrapped API.
                 */
                cd->classflags |= sectionFlags;

                if ((yyvsp[-5].number))
                {
                    if (!currentIsVirt)
                        yyerror("Abstract destructor must be virtual");

                    setIsAbstractClass(cd);
                }

                /*
                 * The class has a shadow if we have a virtual dtor or some
                 * dtor code.
                 */
                if (currentIsVirt || (yyvsp[-1].codeb) != NULL)
                {
                    if (currentSpec -> genc)
                        yyerror("Virtual destructor or %VirtualCatcherCode not allowed in a C module");

                    setNeedsShadow(cd);
                }

                if (getReleaseGIL(&(yyvsp[-4].optflags)))
                    setIsReleaseGILDtor(cd);
                else if (getHoldGIL(&(yyvsp[-4].optflags)))
                    setIsHoldGILDtor(cd);
            }

            currentIsVirt = FALSE;
        }
#line 6753 "../parser.c"
    break;

  case 450: /* $@16: %empty  */
#line 3660 "parser.y"
                        {currentCtorIsExplicit = TRUE;}
#line 6759 "../parser.c"
    break;

  case 453: /* simplector: TK_NAME_VALUE '(' arglist ')' optexceptions optflags optctorsig ';' optdocstring premethodcode methodcode  */
#line 3664 "parser.y"
                                                                                                                      {
            /* Note that we allow ctors in C modules. */

            if (notSkipping())
            {
                const char *annos[] = {
                    "API",
                    "Default",
                    "Deprecated",
                    "HoldGIL",
                    "KeywordArgs",
                    "NoDerived",
                    "NoRaisesPyException",
                    "NoTypeHint",
                    "PostHook",
                    "PreHook",
                    "RaisesPyException",
                    "ReleaseGIL",
                    "Transfer",
                    NULL
                };

                checkAnnos(&(yyvsp[-5].optflags), annos);

                if (currentSpec -> genc)
                {
                    if ((yyvsp[-1].codeb) == NULL && (yyvsp[-8].signature).nrArgs != 0)
                        yyerror("Constructors with arguments in C modules must include %MethodCode");

                    if (currentCtorIsExplicit)
                        yyerror("Explicit constructors not allowed in a C module");
                }

                if ((sectionFlags & (SECT_IS_PUBLIC | SECT_IS_PROT | SECT_IS_PRIVATE)) == 0)
                    yyerror("Constructor must be in the public, private or protected sections");

                newCtor(currentModule, (yyvsp[-10].text), sectionFlags, &(yyvsp[-8].signature), &(yyvsp[-5].optflags), (yyvsp[0].codeb), (yyvsp[-6].throwlist), (yyvsp[-4].optsignature),
                        currentCtorIsExplicit, (yyvsp[-2].docstr), (yyvsp[-1].codeb));
            }

            free((yyvsp[-10].text));

            currentCtorIsExplicit = FALSE;
        }
#line 6808 "../parser.c"
    break;

  case 454: /* optctorsig: %empty  */
#line 3710 "parser.y"
            {
            (yyval.optsignature) = NULL;
        }
#line 6816 "../parser.c"
    break;

  case 455: /* $@17: %empty  */
#line 3713 "parser.y"
            {
            parsingCSignature = TRUE;
        }
#line 6824 "../parser.c"
    break;

  case 456: /* optctorsig: '[' $@17 '(' arglist ')' ']'  */
#line 3715 "parser.y"
                              {
            (yyval.optsignature) = sipMalloc(sizeof (signatureDef));

            *(yyval.optsignature) = (yyvsp[-2].signature);

            parsingCSignature = FALSE;
        }
#line 6836 "../parser.c"
    break;

  case 457: /* optsig: %empty  */
#line 3724 "parser.y"
        {
            (yyval.optsignature) = NULL;
        }
#line 6844 "../parser.c"
    break;

  case 458: /* $@18: %empty  */
#line 3727 "parser.y"
            {
            parsingCSignature = TRUE;
        }
#line 6852 "../parser.c"
    break;

  case 459: /* optsig: '[' $@18 cpptype '(' arglist ')' ']'  */
#line 3729 "parser.y"
                                      {
            (yyval.optsignature) = sipMalloc(sizeof (signatureDef));

            *(yyval.optsignature) = (yyvsp[-2].signature);
            (yyval.optsignature)->result = (yyvsp[-4].memArg);

            parsingCSignature = FALSE;
        }
#line 6865 "../parser.c"
    break;

  case 460: /* function: cpptype TK_NAME_VALUE '(' arglist ')' optconst optfinal optexceptions optabstract optflags optsig ';' optdocstring premethodcode methodcode virtualcatchercode virtualcallcode  */
#line 3739 "parser.y"
                                                                                                                                                                                           {
            if (notSkipping())
            {
                applyTypeFlags(currentModule, &(yyvsp[-16].memArg), &(yyvsp[-7].optflags));

                (yyvsp[-13].signature).result = (yyvsp[-16].memArg);

                newFunction(currentSpec, currentModule, currentScope(), NULL,
                        NULL, sectionFlags, currentIsStatic, currentIsSignal,
                        currentIsSlot, currentIsVirt, (yyvsp[-15].text), &(yyvsp[-13].signature), (yyvsp[-11].number), (yyvsp[-8].number), &(yyvsp[-7].optflags),
                        (yyvsp[-2].codeb), (yyvsp[-1].codeb), (yyvsp[0].codeb), (yyvsp[-9].throwlist), (yyvsp[-6].optsignature), (yyvsp[-4].docstr), (yyvsp[-10].number), (yyvsp[-3].codeb));
            }

            currentIsStatic = FALSE;
            currentIsSignal = FALSE;
            currentIsSlot = FALSE;
            currentIsVirt = FALSE;
        }
#line 6888 "../parser.c"
    break;

  case 461: /* function: cpptype TK_OPERATOR '=' '(' cpptype ')' ';'  */
#line 3757 "parser.y"
                                                    {
            /*
             * It looks like an assignment operator (though we don't bother to
             * check the types) so make sure it is private.
             */
            if (notSkipping())
            {
                classDef *cd = currentScope();

                if (cd == NULL || !(sectionFlags & SECT_IS_PRIVATE))
                    yyerror("Assignment operators may only be defined as private");

                setCannotAssign(cd);
            }

            currentIsStatic = FALSE;
            currentIsSignal = FALSE;
            currentIsSlot = FALSE;
            currentIsVirt = FALSE;
        }
#line 6913 "../parser.c"
    break;

  case 462: /* function: cpptype TK_OPERATOR operatorname '(' arglist ')' optconst optfinal optexceptions optabstract optflags optsig ';' premethodcode methodcode virtualcatchercode virtualcallcode  */
#line 3777 "parser.y"
                                                                                                                                                                                     {
            if (notSkipping())
            {
                classDef *cd = currentScope();
                ifaceFileDef *ns_scope;

                /*
                 * If the scope is a namespace then make sure the operator is
                 * handled as a global, but remember it's C++ scope..
                 */
                if (cd != NULL && cd->iff->type == namespace_iface)
                {
                    ns_scope = cd->iff;
                    cd = NULL;
                }
                else
                {
                    ns_scope = NULL;
                }

                applyTypeFlags(currentModule, &(yyvsp[-16].memArg), &(yyvsp[-6].optflags));

                /* Handle the unary '+' and '-' operators. */
                if ((cd != NULL && (yyvsp[-12].signature).nrArgs == 0) || (cd == NULL && (yyvsp[-12].signature).nrArgs == 1))
                {
                    if (strcmp((yyvsp[-14].text), "__add__") == 0)
                        (yyvsp[-14].text) = "__pos__";
                    else if (strcmp((yyvsp[-14].text), "__sub__") == 0)
                        (yyvsp[-14].text) = "__neg__";
                }

                (yyvsp[-12].signature).result = (yyvsp[-16].memArg);

                newFunction(currentSpec, currentModule, cd, ns_scope, NULL,
                        sectionFlags, currentIsStatic, currentIsSignal,
                        currentIsSlot, currentIsVirt, (yyvsp[-14].text), &(yyvsp[-12].signature), (yyvsp[-10].number), (yyvsp[-7].number), &(yyvsp[-6].optflags),
                        (yyvsp[-2].codeb), (yyvsp[-1].codeb), (yyvsp[0].codeb), (yyvsp[-8].throwlist), (yyvsp[-5].optsignature), NULL, (yyvsp[-9].number), (yyvsp[-3].codeb));
            }

            currentIsStatic = FALSE;
            currentIsSignal = FALSE;
            currentIsSlot = FALSE;
            currentIsVirt = FALSE;
        }
#line 6962 "../parser.c"
    break;

  case 463: /* function: TK_OPERATOR cpptype '(' arglist ')' optconst optfinal optexceptions optabstract optflags optsig ';' premethodcode methodcode virtualcatchercode virtualcallcode  */
#line 3821 "parser.y"
                                                                                                                                                                        {
            if (notSkipping())
            {
                char *sname;
                classDef *scope = currentScope();

                if (scope == NULL || (yyvsp[-12].signature).nrArgs != 0)
                    yyerror("Operator casts must be specified in a class and have no arguments");

                applyTypeFlags(currentModule, &(yyvsp[-14].memArg), &(yyvsp[-6].optflags));

                switch ((yyvsp[-14].memArg).atype)
                {
                case defined_type:
                    sname = NULL;
                    break;

                case bool_type:
                case cbool_type:
                case byte_type:
                case sbyte_type:
                case ubyte_type:
                case short_type:
                case ushort_type:
                case int_type:
                case cint_type:
                case uint_type:
                    sname = "__int__";
                    break;

                case long_type:
                case ulong_type:
                case longlong_type:
                case ulonglong_type:
                    sname = "__long__";
                    break;

                case float_type:
                case cfloat_type:
                case double_type:
                case cdouble_type:
                    sname = "__float__";
                    break;

                default:
                    yyerror("Unsupported operator cast");
                }

                if (sname != NULL)
                {
                    (yyvsp[-12].signature).result = (yyvsp[-14].memArg);

                    newFunction(currentSpec, currentModule, scope, NULL, NULL,
                            sectionFlags, currentIsStatic, currentIsSignal,
                            currentIsSlot, currentIsVirt, sname, &(yyvsp[-12].signature), (yyvsp[-10].number), (yyvsp[-7].number),
                            &(yyvsp[-6].optflags), (yyvsp[-2].codeb), (yyvsp[-1].codeb), (yyvsp[0].codeb), (yyvsp[-8].throwlist), (yyvsp[-5].optsignature), NULL, (yyvsp[-9].number), (yyvsp[-3].codeb));
                }
                else
                {
                    argList *al;

                    /* Check it doesn't already exist. */
                    for (al = scope->casts; al != NULL; al = al->next)
                        if (compareScopedNames((yyvsp[-14].memArg).u.snd, al->arg.u.snd) == 0)
                            yyerror("This operator cast has already been specified in this class");

                    al = sipMalloc(sizeof (argList));
                    al->arg = (yyvsp[-14].memArg);
                    al->next = scope->casts;

                    scope->casts = al;
                }
            }

            currentIsStatic = FALSE;
            currentIsSignal = FALSE;
            currentIsSlot = FALSE;
            currentIsVirt = FALSE;
        }
#line 7046 "../parser.c"
    break;

  case 464: /* operatorname: '+'  */
#line 3902 "parser.y"
                        {(yyval.text) = "__add__";}
#line 7052 "../parser.c"
    break;

  case 465: /* operatorname: '-'  */
#line 3903 "parser.y"
                {(yyval.text) = "__sub__";}
#line 7058 "../parser.c"
    break;

  case 466: /* operatorname: '*'  */
#line 3904 "parser.y"
                {(yyval.text) = "__mul__";}
#line 7064 "../parser.c"
    break;

  case 467: /* operatorname: '/'  */
#line 3905 "parser.y"
                {(yyval.text) = "__div__";}
#line 7070 "../parser.c"
    break;

  case 468: /* operatorname: '%'  */
#line 3906 "parser.y"
                {(yyval.text) = "__mod__";}
#line 7076 "../parser.c"
    break;

  case 469: /* operatorname: '&'  */
#line 3907 "parser.y"
                {(yyval.text) = "__and__";}
#line 7082 "../parser.c"
    break;

  case 470: /* operatorname: '|'  */
#line 3908 "parser.y"
                {(yyval.text) = "__or__";}
#line 7088 "../parser.c"
    break;

  case 471: /* operatorname: '^'  */
#line 3909 "parser.y"
                {(yyval.text) = "__xor__";}
#line 7094 "../parser.c"
    break;

  case 472: /* operatorname: '<' '<'  */
#line 3910 "parser.y"
                    {(yyval.text) = "__lshift__";}
#line 7100 "../parser.c"
    break;

  case 473: /* operatorname: '>' '>'  */
#line 3911 "parser.y"
                    {(yyval.text) = "__rshift__";}
#line 7106 "../parser.c"
    break;

  case 474: /* operatorname: '+' '='  */
#line 3912 "parser.y"
                    {(yyval.text) = "__iadd__";}
#line 7112 "../parser.c"
    break;

  case 475: /* operatorname: '-' '='  */
#line 3913 "parser.y"
                    {(yyval.text) = "__isub__";}
#line 7118 "../parser.c"
    break;

  case 476: /* operatorname: '*' '='  */
#line 3914 "parser.y"
                    {(yyval.text) = "__imul__";}
#line 7124 "../parser.c"
    break;

  case 477: /* operatorname: '/' '='  */
#line 3915 "parser.y"
                    {(yyval.text) = "__idiv__";}
#line 7130 "../parser.c"
    break;

  case 478: /* operatorname: '%' '='  */
#line 3916 "parser.y"
                    {(yyval.text) = "__imod__";}
#line 7136 "../parser.c"
    break;

  case 479: /* operatorname: '&' '='  */
#line 3917 "parser.y"
                    {(yyval.text) = "__iand__";}
#line 7142 "../parser.c"
    break;

  case 480: /* operatorname: '|' '='  */
#line 3918 "parser.y"
                    {(yyval.text) = "__ior__";}
#line 7148 "../parser.c"
    break;

  case 481: /* operatorname: '^' '='  */
#line 3919 "parser.y"
                    {(yyval.text) = "__ixor__";}
#line 7154 "../parser.c"
    break;

  case 482: /* operatorname: '<' '<' '='  */
#line 3920 "parser.y"
                    {(yyval.text) = "__ilshift__";}
#line 7160 "../parser.c"
    break;

  case 483: /* operatorname: '>' '>' '='  */
#line 3921 "parser.y"
                    {(yyval.text) = "__irshift__";}
#line 7166 "../parser.c"
    break;

  case 484: /* operatorname: '~'  */
#line 3922 "parser.y"
                {(yyval.text) = "__invert__";}
#line 7172 "../parser.c"
    break;

  case 485: /* operatorname: '(' ')'  */
#line 3923 "parser.y"
                    {(yyval.text) = "__call__";}
#line 7178 "../parser.c"
    break;

  case 486: /* operatorname: '[' ']'  */
#line 3924 "parser.y"
                    {(yyval.text) = "__getitem__";}
#line 7184 "../parser.c"
    break;

  case 487: /* operatorname: '<'  */
#line 3925 "parser.y"
                {(yyval.text) = "__lt__";}
#line 7190 "../parser.c"
    break;

  case 488: /* operatorname: '<' '='  */
#line 3926 "parser.y"
                    {(yyval.text) = "__le__";}
#line 7196 "../parser.c"
    break;

  case 489: /* operatorname: '=' '='  */
#line 3927 "parser.y"
                    {(yyval.text) = "__eq__";}
#line 7202 "../parser.c"
    break;

  case 490: /* operatorname: '!' '='  */
#line 3928 "parser.y"
                    {(yyval.text) = "__ne__";}
#line 7208 "../parser.c"
    break;

  case 491: /* operatorname: '>'  */
#line 3929 "parser.y"
                {(yyval.text) = "__gt__";}
#line 7214 "../parser.c"
    break;

  case 492: /* operatorname: '>' '='  */
#line 3930 "parser.y"
                    {(yyval.text) = "__ge__";}
#line 7220 "../parser.c"
    break;

  case 493: /* optconst: %empty  */
#line 3933 "parser.y"
            {
            (yyval.number) = FALSE;
        }
#line 7228 "../parser.c"
    break;

  case 494: /* optconst: TK_CONST  */
#line 3936 "parser.y"
                 {
            (yyval.number) = TRUE;
        }
#line 7236 "../parser.c"
    break;

  case 495: /* optfinal: %empty  */
#line 3941 "parser.y"
            {
            (yyval.number) = FALSE;
        }
#line 7244 "../parser.c"
    break;

  case 496: /* optfinal: TK_FINAL  */
#line 3944 "parser.y"
                 {
            (yyval.number) = TRUE;
        }
#line 7252 "../parser.c"
    break;

  case 497: /* optabstract: %empty  */
#line 3949 "parser.y"
                {
            (yyval.number) = 0;
        }
#line 7260 "../parser.c"
    break;

  case 498: /* optabstract: '=' TK_NUMBER_VALUE  */
#line 3952 "parser.y"
                            {
            if ((yyvsp[0].number) != 0)
                yyerror("Abstract virtual function '= 0' expected");

            (yyval.number) = TRUE;
        }
#line 7271 "../parser.c"
    break;

  case 499: /* optflags: %empty  */
#line 3960 "parser.y"
            {
            (yyval.optflags).nrFlags = 0;
        }
#line 7279 "../parser.c"
    break;

  case 500: /* optflags: '/' flaglist '/'  */
#line 3963 "parser.y"
                         {
            (yyval.optflags) = (yyvsp[-1].optflags);
        }
#line 7287 "../parser.c"
    break;

  case 501: /* flaglist: flag  */
#line 3969 "parser.y"
                 {
            (yyval.optflags).flags[0] = (yyvsp[0].flag);
            (yyval.optflags).nrFlags = 1;
        }
#line 7296 "../parser.c"
    break;

  case 502: /* flaglist: flaglist ',' flag  */
#line 3973 "parser.y"
                          {
            /* Check there is room. */

            if ((yyvsp[-2].optflags).nrFlags == MAX_NR_FLAGS)
                yyerror("Too many optional flags");

            (yyval.optflags) = (yyvsp[-2].optflags);

            (yyval.optflags).flags[(yyval.optflags).nrFlags++] = (yyvsp[0].flag);
        }
#line 7311 "../parser.c"
    break;

  case 503: /* flag: TK_NAME_VALUE  */
#line 3985 "parser.y"
                      {
            (yyval.flag).ftype = bool_flag;
            (yyval.flag).fname = (yyvsp[0].text);
        }
#line 7320 "../parser.c"
    break;

  case 504: /* flag: TK_NAME_VALUE '=' flagvalue  */
#line 3989 "parser.y"
                                    {
            (yyval.flag) = (yyvsp[0].flag);
            (yyval.flag).fname = (yyvsp[-2].text);
        }
#line 7329 "../parser.c"
    break;

  case 505: /* flagvalue: dottedname  */
#line 3995 "parser.y"
                       {
            (yyval.flag).ftype = (strchr((yyvsp[0].text), '.') != NULL) ? dotted_name_flag : name_flag;
            (yyval.flag).fvalue.sval = (yyvsp[0].text);
        }
#line 7338 "../parser.c"
    break;

  case 506: /* flagvalue: TK_NAME_VALUE ':' optnumber '-' optnumber  */
#line 3999 "parser.y"
                                                  {
            apiVersionRangeDef *avd;
            int from, to;

            (yyval.flag).ftype = api_range_flag;

            /* Check that the API is known. */
            if ((avd = findAPI(currentSpec, (yyvsp[-4].text))) == NULL)
                yyerror("unknown API name in API annotation");

            if (inMainModule())
                setIsUsedName(avd->api_name);

            /* Unbounded values are represented by 0. */
            if ((from = (yyvsp[-2].number)) < 0)
                from = 0;

            if ((to = (yyvsp[0].number)) < 0)
                to = 0;

            (yyval.flag).fvalue.aval = convertAPIRange(currentModule, avd->api_name,
                    from, to);
        }
#line 7366 "../parser.c"
    break;

  case 507: /* flagvalue: TK_STRING_VALUE  */
#line 4022 "parser.y"
                        {
            (yyval.flag).ftype = string_flag;
            (yyval.flag).fvalue.sval = convertFeaturedString((yyvsp[0].text));
        }
#line 7375 "../parser.c"
    break;

  case 508: /* flagvalue: TK_NUMBER_VALUE  */
#line 4026 "parser.y"
                        {
            (yyval.flag).ftype = integer_flag;
            (yyval.flag).fvalue.ival = (yyvsp[0].number);
        }
#line 7384 "../parser.c"
    break;

  case 509: /* virtualcallcode: %empty  */
#line 4032 "parser.y"
                 {
            (yyval.codeb) = NULL;
        }
#line 7392 "../parser.c"
    break;

  case 510: /* virtualcallcode: TK_VIRTUALCALLCODE codeblock  */
#line 4035 "parser.y"
                                     {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 7400 "../parser.c"
    break;

  case 511: /* methodcode: %empty  */
#line 4040 "parser.y"
            {
            (yyval.codeb) = NULL;
        }
#line 7408 "../parser.c"
    break;

  case 512: /* methodcode: TK_METHODCODE codeblock  */
#line 4043 "parser.y"
                                {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 7416 "../parser.c"
    break;

  case 513: /* premethodcode: %empty  */
#line 4048 "parser.y"
               {
            (yyval.codeb) = NULL;
        }
#line 7424 "../parser.c"
    break;

  case 514: /* premethodcode: TK_PREMETHODCODE codeblock  */
#line 4051 "parser.y"
                                   {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 7432 "../parser.c"
    break;

  case 515: /* virtualcatchercode: %empty  */
#line 4056 "parser.y"
                    {
            (yyval.codeb) = NULL;
        }
#line 7440 "../parser.c"
    break;

  case 516: /* virtualcatchercode: TK_VIRTUALCATCHERCODE codeblock  */
#line 4059 "parser.y"
                                        {
            (yyval.codeb) = (yyvsp[0].codeb);
        }
#line 7448 "../parser.c"
    break;

  case 517: /* arglist: rawarglist  */
#line 4064 "parser.y"
                       {
            int a, nrrxcon, nrrxdis, nrslotcon, nrslotdis, nrarray, nrarraysize;

            nrrxcon = nrrxdis = nrslotcon = nrslotdis = nrarray = nrarraysize = 0;

            for (a = 0; a < (yyvsp[0].signature).nrArgs; ++a)
            {
                argDef *ad = &(yyvsp[0].signature).args[a];

                switch (ad -> atype)
                {
                case rxcon_type:
                    ++nrrxcon;
                    break;

                case rxdis_type:
                    ++nrrxdis;
                    break;

                case slotcon_type:
                    ++nrslotcon;
                    break;

                case slotdis_type:
                    ++nrslotdis;
                    break;

                /* Suppress a compiler warning. */
                default:
                    ;
                }

                if (isArray(ad))
                    ++nrarray;

                if (isArraySize(ad))
                    ++nrarraysize;
            }

            if (nrrxcon != nrslotcon || nrrxcon > 1)
                yyerror("SIP_RXOBJ_CON and SIP_SLOT_CON must both be given and at most once");

            if (nrrxdis != nrslotdis || nrrxdis > 1)
                yyerror("SIP_RXOBJ_DIS and SIP_SLOT_DIS must both be given and at most once");

            if (nrarray != nrarraysize || nrarray > 1)
                yyerror("/Array/ and /ArraySize/ must both be given and at most once");

            (yyval.signature) = (yyvsp[0].signature);
        }
#line 7503 "../parser.c"
    break;

  case 518: /* rawarglist: %empty  */
#line 4116 "parser.y"
            {
            /* No arguments. */

            (yyval.signature).nrArgs = 0;
        }
#line 7513 "../parser.c"
    break;

  case 519: /* rawarglist: argvalue  */
#line 4121 "parser.y"
                 {
            /* The single or first argument. */

            (yyval.signature).args[0] = (yyvsp[0].memArg);
            (yyval.signature).nrArgs = 1;
        }
#line 7524 "../parser.c"
    break;

  case 520: /* rawarglist: rawarglist ',' argvalue  */
#line 4127 "parser.y"
                                {
            /* Check that it wasn't ...(,arg...). */
            if ((yyvsp[-2].signature).nrArgs == 0)
                yyerror("First argument of the list is missing");

            /*
             * If this argument has no default value, then the
             * previous one mustn't either.
             */
            if ((yyvsp[0].memArg).defval == NULL && (yyvsp[-2].signature).args[(yyvsp[-2].signature).nrArgs - 1].defval != NULL)
                yyerror("Compulsory argument given after optional argument");

            /* Check there is room. */
            if ((yyvsp[-2].signature).nrArgs == MAX_NR_ARGS)
                yyerror("Internal error - increase the value of MAX_NR_ARGS");

            (yyval.signature) = (yyvsp[-2].signature);

            (yyval.signature).args[(yyval.signature).nrArgs] = (yyvsp[0].memArg);
            (yyval.signature).nrArgs++;
        }
#line 7550 "../parser.c"
    break;

  case 521: /* argvalue: TK_SIPSIGNAL optname optflags optassign  */
#line 4150 "parser.y"
                                                    {
            deprecated("SIP_SIGNAL is deprecated\n");
            checkNoAnnos(&(yyvsp[-1].optflags), "SIP_SIGNAL has no annotations");

            (yyval.memArg).atype = signal_type;
            (yyval.memArg).argflags = ARG_IS_CONST;
            (yyval.memArg).nrderefs = 0;
            (yyval.memArg).name = cacheName(currentSpec, (yyvsp[-2].text));
            (yyval.memArg).defval = (yyvsp[0].valp);

            currentSpec -> sigslots = TRUE;
        }
#line 7567 "../parser.c"
    break;

  case 522: /* argvalue: TK_SIPSLOT optname optflags optassign  */
#line 4162 "parser.y"
                                              {
            deprecated("SIP_SLOT is deprecated\n");
            checkNoAnnos(&(yyvsp[-1].optflags), "SIP_SLOT has no annotations");

            (yyval.memArg).atype = slot_type;
            (yyval.memArg).argflags = ARG_IS_CONST;
            (yyval.memArg).nrderefs = 0;
            (yyval.memArg).name = cacheName(currentSpec, (yyvsp[-2].text));
            (yyval.memArg).defval = (yyvsp[0].valp);

            currentSpec -> sigslots = TRUE;
        }
#line 7584 "../parser.c"
    break;

  case 523: /* argvalue: TK_SIPANYSLOT optname optflags optassign  */
#line 4174 "parser.y"
                                                 {
            deprecated("SIP_ANYSLOT is deprecated\n");
            checkNoAnnos(&(yyvsp[-1].optflags), "SIP_ANYSLOT has no annotations");

            (yyval.memArg).atype = anyslot_type;
            (yyval.memArg).argflags = ARG_IS_CONST;
            (yyval.memArg).nrderefs = 0;
            (yyval.memArg).name = cacheName(currentSpec, (yyvsp[-2].text));
            (yyval.memArg).defval = (yyvsp[0].valp);

            currentSpec -> sigslots = TRUE;
        }
#line 7601 "../parser.c"
    break;

  case 524: /* argvalue: TK_SIPRXCON optname optflags  */
#line 4186 "parser.y"
                                     {
            const char *annos[] = {
                "SingleShot",
                NULL
            };

            deprecated("SIP_RXOBJ_CON is deprecated\n");
            checkAnnos(&(yyvsp[0].optflags), annos);

            (yyval.memArg).atype = rxcon_type;
            (yyval.memArg).argflags = 0;
            (yyval.memArg).nrderefs = 0;
            (yyval.memArg).name = cacheName(currentSpec, (yyvsp[-1].text));

            if (getOptFlag(&(yyvsp[0].optflags), "SingleShot", bool_flag) != NULL)
                (yyval.memArg).argflags |= ARG_SINGLE_SHOT;

            currentSpec -> sigslots = TRUE;
        }
#line 7625 "../parser.c"
    break;

  case 525: /* argvalue: TK_SIPRXDIS optname optflags  */
#line 4205 "parser.y"
                                     {
            deprecated("SIP_RXOBJ_DIS is deprecated\n");
            checkNoAnnos(&(yyvsp[0].optflags), "SIP_RXOBJ_DIS has no annotations");

            (yyval.memArg).atype = rxdis_type;
            (yyval.memArg).argflags = 0;
            (yyval.memArg).nrderefs = 0;
            (yyval.memArg).name = cacheName(currentSpec, (yyvsp[-1].text));

            currentSpec -> sigslots = TRUE;
        }
#line 7641 "../parser.c"
    break;

  case 526: /* argvalue: TK_SIPSLOTCON '(' arglist ')' optname optflags  */
#line 4216 "parser.y"
                                                       {
            deprecated("SIP_SLOT_CON is deprecated\n");
            checkNoAnnos(&(yyvsp[0].optflags), "SIP_SLOT_CON has no annotations");

            (yyval.memArg).atype = slotcon_type;
            (yyval.memArg).argflags = ARG_IS_CONST;
            (yyval.memArg).nrderefs = 0;
            (yyval.memArg).name = cacheName(currentSpec, (yyvsp[-1].text));

            memset(&(yyvsp[-3].signature).result, 0, sizeof (argDef));
            (yyvsp[-3].signature).result.atype = void_type;

            (yyval.memArg).u.sa = sipMalloc(sizeof (signatureDef));
            *(yyval.memArg).u.sa = (yyvsp[-3].signature);

            currentSpec -> sigslots = TRUE;
        }
#line 7663 "../parser.c"
    break;

  case 527: /* argvalue: TK_SIPSLOTDIS '(' arglist ')' optname optflags  */
#line 4233 "parser.y"
                                                       {
            deprecated("SIP_SLOT_DIS is deprecated\n");
            checkNoAnnos(&(yyvsp[0].optflags), "SIP_SLOT_DIS has no annotations");

            (yyval.memArg).atype = slotdis_type;
            (yyval.memArg).argflags = ARG_IS_CONST;
            (yyval.memArg).nrderefs = 0;
            (yyval.memArg).name = cacheName(currentSpec, (yyvsp[-1].text));

            memset(&(yyvsp[-3].signature).result, 0, sizeof (argDef));
            (yyvsp[-3].signature).result.atype = void_type;

            (yyval.memArg).u.sa = sipMalloc(sizeof (signatureDef));
            *(yyval.memArg).u.sa = (yyvsp[-3].signature);

            currentSpec -> sigslots = TRUE;
        }
#line 7685 "../parser.c"
    break;

  case 528: /* argvalue: TK_QOBJECT optname optflags  */
#line 4250 "parser.y"
                                    {
            deprecated("SIP_QOBJECT is deprecated\n");
            checkNoAnnos(&(yyvsp[0].optflags), "SIP_QOBJECT has no annotations");

            (yyval.memArg).atype = qobject_type;
            (yyval.memArg).argflags = 0;
            (yyval.memArg).nrderefs = 0;
            (yyval.memArg).name = cacheName(currentSpec, (yyvsp[-1].text));
        }
#line 7699 "../parser.c"
    break;

  case 529: /* argvalue: argtype optassign  */
#line 4259 "parser.y"
                          {
            (yyval.memArg) = (yyvsp[-1].memArg);
            (yyval.memArg).defval = (yyvsp[0].valp);
        }
#line 7708 "../parser.c"
    break;

  case 530: /* $@19: %empty  */
#line 4266 "parser.y"
                         {currentIsSignal = TRUE;}
#line 7714 "../parser.c"
    break;

  case 532: /* $@20: %empty  */
#line 4267 "parser.y"
                       {currentIsSlot = TRUE;}
#line 7720 "../parser.c"
    break;

  case 535: /* $@21: %empty  */
#line 4272 "parser.y"
                  {currentIsStatic = TRUE;}
#line 7726 "../parser.c"
    break;

  case 540: /* $@22: %empty  */
#line 4282 "parser.y"
                   {currentIsVirt = TRUE;}
#line 7732 "../parser.c"
    break;

  case 543: /* variable: cpptype TK_NAME_VALUE optflags variable_body ';' optaccesscode optgetcode optsetcode  */
#line 4286 "parser.y"
                                                                                                 {
            if (notSkipping())
            {
                const char *annos[] = {
                    "DocType",
                    "Encoding",
                    "NoSetter",
                    "NoTypeHint",
                    "PyInt",
                    "PyName",
                    "TypeHint",
                    NULL
                };

                checkAnnos(&(yyvsp[-5].optflags), annos);

                if ((yyvsp[-2].codeb) != NULL)
                {
                    if ((yyvsp[-4].variable).access_code != NULL)
                        yyerror("%AccessCode already defined");

                    (yyvsp[-4].variable).access_code = (yyvsp[-2].codeb);

                    deprecated("%AccessCode should be used as a sub-directive");
                }

                if ((yyvsp[-1].codeb) != NULL)
                {
                    if ((yyvsp[-4].variable).get_code != NULL)
                        yyerror("%GetCode already defined");

                    (yyvsp[-4].variable).get_code = (yyvsp[-1].codeb);

                    deprecated("%GetCode should be used as a sub-directive");
                }

                if ((yyvsp[0].codeb) != NULL)
                {
                    if ((yyvsp[-4].variable).set_code != NULL)
                        yyerror("%SetCode already defined");

                    (yyvsp[-4].variable).set_code = (yyvsp[0].codeb);

                    deprecated("%SetCode should be used as a sub-directive");
                }

                newVar(currentSpec, currentModule, (yyvsp[-6].text), currentIsStatic, &(yyvsp[-7].memArg),
                        &(yyvsp[-5].optflags), (yyvsp[-4].variable).access_code, (yyvsp[-4].variable).get_code, (yyvsp[-4].variable).set_code,
                        sectionFlags);
            }

            currentIsStatic = FALSE;
        }
#line 7790 "../parser.c"
    break;

  case 544: /* variable_body: %empty  */
#line 4341 "parser.y"
                {
            (yyval.variable).token = 0;
            (yyval.variable).access_code = NULL;
            (yyval.variable).get_code = NULL;
            (yyval.variable).set_code = NULL;
        }
#line 7801 "../parser.c"
    break;

  case 545: /* variable_body: '{' variable_body_directives '}'  */
#line 4347 "parser.y"
                                         {
            (yyval.variable) = (yyvsp[-1].variable);
        }
#line 7809 "../parser.c"
    break;

  case 547: /* variable_body_directives: variable_body_directives variable_body_directive  */
#line 4353 "parser.y"
                                                         {
            (yyval.variable) = (yyvsp[-1].variable);

            switch ((yyvsp[0].variable).token)
            {
            case TK_ACCESSCODE: (yyval.variable).access_code = (yyvsp[0].variable).access_code; break;
            case TK_GETCODE: (yyval.variable).get_code = (yyvsp[0].variable).get_code; break;
            case TK_SETCODE: (yyval.variable).set_code = (yyvsp[0].variable).set_code; break;
            }
        }
#line 7824 "../parser.c"
    break;

  case 548: /* variable_body_directive: ifstart  */
#line 4365 "parser.y"
                                    {
            (yyval.variable).token = TK_IF;
        }
#line 7832 "../parser.c"
    break;

  case 549: /* variable_body_directive: ifend  */
#line 4368 "parser.y"
              {
            (yyval.variable).token = TK_END;
        }
#line 7840 "../parser.c"
    break;

  case 550: /* variable_body_directive: TK_ACCESSCODE codeblock  */
#line 4371 "parser.y"
                                {
            if (notSkipping())
            {
                (yyval.variable).token = TK_ACCESSCODE;
                (yyval.variable).access_code = (yyvsp[0].codeb);
            }
            else
            {
                (yyval.variable).token = 0;
                (yyval.variable).access_code = NULL;
            }

            (yyval.variable).get_code = NULL;
            (yyval.variable).set_code = NULL;
        }
#line 7860 "../parser.c"
    break;

  case 551: /* variable_body_directive: TK_GETCODE codeblock  */
#line 4386 "parser.y"
                             {
            if (notSkipping())
            {
                (yyval.variable).token = TK_GETCODE;
                (yyval.variable).get_code = (yyvsp[0].codeb);
            }
            else
            {
                (yyval.variable).token = 0;
                (yyval.variable).get_code = NULL;
            }

            (yyval.variable).access_code = NULL;
            (yyval.variable).set_code = NULL;
        }
#line 7880 "../parser.c"
    break;

  case 552: /* variable_body_directive: TK_SETCODE codeblock  */
#line 4401 "parser.y"
                             {
            if (notSkipping())
            {
                (yyval.variable).token = TK_SETCODE;
                (yyval.variable).set_code = (yyvsp[0].codeb);
            }
            else
            {
                (yyval.variable).token = 0;
                (yyval.variable).set_code = NULL;
            }

            (yyval.variable).access_code = NULL;
            (yyval.variable).get_code = NULL;
        }
#line 7900 "../parser.c"
    break;

  case 553: /* cpptype: TK_CONST basetype deref optref  */
#line 4418 "parser.y"
                                           {
            (yyval.memArg) = (yyvsp[-2].memArg);
            add_derefs(&(yyval.memArg), &(yyvsp[-1].memArg));
            (yyval.memArg).argflags |= ARG_IS_CONST | (yyvsp[0].number);
        }
#line 7910 "../parser.c"
    break;

  case 554: /* cpptype: basetype deref optref  */
#line 4423 "parser.y"
                              {
            (yyval.memArg) = (yyvsp[-2].memArg);
            add_derefs(&(yyval.memArg), &(yyvsp[-1].memArg));
            (yyval.memArg).argflags |= (yyvsp[0].number);

            /* PyObject * is a synonym for SIP_PYOBJECT. */
            if ((yyvsp[-2].memArg).atype == defined_type && strcmp((yyvsp[-2].memArg).u.snd->name, "PyObject") == 0 && (yyvsp[-2].memArg).u.snd->next == NULL && (yyvsp[-1].memArg).nrderefs == 1 && (yyvsp[0].number) == 0)
            {
                (yyval.memArg).atype = pyobject_type;
                (yyval.memArg).nrderefs = 0;
            }
        }
#line 7927 "../parser.c"
    break;

  case 555: /* argtype: cpptype optname optflags  */
#line 4437 "parser.y"
                                     {
            const char *annos[] = {
                "AllowNone",
                "Array",
                "ArraySize",
                "Constrained",
                "DisallowNone",
                "DocType",
                "DocValue",
                "Encoding",
                "GetWrapper",
                "In",
                "KeepReference",
                "NoCopy",
                "Out",
                "PyInt",
                "ResultSize",
                "ScopesStripped",
                "Transfer",
                "TransferBack",
                "TransferThis",
                "TypeHint",
                "TypeHintIn",
                "TypeHintOut",
                "TypeHintValue",
                NULL
            };

            optFlag *of;

            checkAnnos(&(yyvsp[0].optflags), annos);

            (yyval.memArg) = (yyvsp[-2].memArg);
            (yyval.memArg).name = cacheName(currentSpec, (yyvsp[-1].text));

            handleKeepReference(&(yyvsp[0].optflags), &(yyval.memArg), currentModule);

            if ((of = getOptFlag(&(yyvsp[0].optflags), "ScopesStripped", opt_integer_flag)) != NULL)
                if (((yyval.memArg).scopes_stripped = of->fvalue.ival) <= 0)
                    yyerror("/ScopesStripped/ must be greater than 0");

            if (getAllowNone(&(yyvsp[0].optflags)))
                (yyval.memArg).argflags |= ARG_ALLOW_NONE;

            if (getDisallowNone(&(yyvsp[0].optflags)))
                (yyval.memArg).argflags |= ARG_DISALLOW_NONE;

            if (getOptFlag(&(yyvsp[0].optflags),"GetWrapper",bool_flag) != NULL)
                (yyval.memArg).argflags |= ARG_GET_WRAPPER;

            if (getOptFlag(&(yyvsp[0].optflags),"Array",bool_flag) != NULL)
                (yyval.memArg).argflags |= ARG_ARRAY;

            if (getOptFlag(&(yyvsp[0].optflags),"ArraySize",bool_flag) != NULL)
                (yyval.memArg).argflags |= ARG_ARRAY_SIZE;

            if (getTransfer(&(yyvsp[0].optflags)))
                (yyval.memArg).argflags |= ARG_XFERRED;

            if (getOptFlag(&(yyvsp[0].optflags),"TransferThis",bool_flag) != NULL)
                (yyval.memArg).argflags |= ARG_THIS_XFERRED;

            if (getOptFlag(&(yyvsp[0].optflags),"TransferBack",bool_flag) != NULL)
                (yyval.memArg).argflags |= ARG_XFERRED_BACK;

            if (getOptFlag(&(yyvsp[0].optflags),"In",bool_flag) != NULL)
                (yyval.memArg).argflags |= ARG_IN;

            if (getOptFlag(&(yyvsp[0].optflags),"Out",bool_flag) != NULL)
                (yyval.memArg).argflags |= ARG_OUT;

            if (getOptFlag(&(yyvsp[0].optflags), "ResultSize", bool_flag) != NULL)
                (yyval.memArg).argflags |= ARG_RESULT_SIZE;

            if (getOptFlag(&(yyvsp[0].optflags), "NoCopy", bool_flag) != NULL)
                (yyval.memArg).argflags |= ARG_NO_COPY;

            if (getOptFlag(&(yyvsp[0].optflags),"Constrained",bool_flag) != NULL)
            {
                (yyval.memArg).argflags |= ARG_CONSTRAINED;

                switch ((yyval.memArg).atype)
                {
                case bool_type:
                    (yyval.memArg).atype = cbool_type;
                    break;

                case int_type:
                    (yyval.memArg).atype = cint_type;
                    break;

                case float_type:
                    (yyval.memArg).atype = cfloat_type;
                    break;

                case double_type:
                    (yyval.memArg).atype = cdouble_type;
                    break;

                /* Suppress a compiler warning. */
                default:
                    ;
                }
            }

            applyTypeFlags(currentModule, &(yyval.memArg), &(yyvsp[0].optflags));
            (yyval.memArg).typehint_value = getTypeHintValue(&(yyvsp[0].optflags));
        }
#line 8040 "../parser.c"
    break;

  case 556: /* optref: %empty  */
#line 4547 "parser.y"
        {
            (yyval.number) = 0;
        }
#line 8048 "../parser.c"
    break;

  case 557: /* optref: '&'  */
#line 4550 "parser.y"
            {
            if (currentSpec -> genc)
                yyerror("References not allowed in a C module");

            (yyval.number) = ARG_IS_REF;
        }
#line 8059 "../parser.c"
    break;

  case 558: /* deref: %empty  */
#line 4558 "parser.y"
        {
            (yyval.memArg).nrderefs = 0;
        }
#line 8067 "../parser.c"
    break;

  case 559: /* deref: deref '*' TK_CONST  */
#line 4561 "parser.y"
                           {
            add_new_deref(&(yyval.memArg), &(yyvsp[-2].memArg), TRUE);
        }
#line 8075 "../parser.c"
    break;

  case 560: /* deref: deref '*'  */
#line 4564 "parser.y"
                  {
            add_new_deref(&(yyval.memArg), &(yyvsp[-1].memArg), FALSE);
        }
#line 8083 "../parser.c"
    break;

  case 561: /* basetype: scopedname  */
#line 4569 "parser.y"
                       {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = defined_type;
            (yyval.memArg).u.snd = (yyvsp[0].scpvalp);

            /* Try and resolve typedefs as early as possible. */
            resolveAnyTypedef(currentSpec, &(yyval.memArg));
        }
#line 8096 "../parser.c"
    break;

  case 562: /* basetype: scopedname '<' cpptypelist '>'  */
#line 4577 "parser.y"
                                       {
            templateDef *td;

            td = sipMalloc(sizeof(templateDef));
            td->fqname = (yyvsp[-3].scpvalp);
            td->types = (yyvsp[-1].signature);

            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = template_type;
            (yyval.memArg).u.td = td;
        }
#line 8112 "../parser.c"
    break;

  case 563: /* basetype: TK_STRUCT scopedname  */
#line 4588 "parser.y"
                             {
            memset(&(yyval.memArg), 0, sizeof (argDef));

            /* In a C module all structures must be defined. */
            if (currentSpec -> genc)
            {
                (yyval.memArg).atype = defined_type;
                (yyval.memArg).u.snd = (yyvsp[0].scpvalp);
            }
            else
            {
                (yyval.memArg).atype = struct_type;
                (yyval.memArg).u.sname = (yyvsp[0].scpvalp);
            }
        }
#line 8132 "../parser.c"
    break;

  case 564: /* basetype: TK_UNSIGNED TK_SHORT  */
#line 4603 "parser.y"
                             {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = ushort_type;
        }
#line 8141 "../parser.c"
    break;

  case 565: /* basetype: TK_SHORT  */
#line 4607 "parser.y"
                 {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = short_type;
        }
#line 8150 "../parser.c"
    break;

  case 566: /* basetype: TK_UNSIGNED  */
#line 4611 "parser.y"
                    {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = uint_type;
        }
#line 8159 "../parser.c"
    break;

  case 567: /* basetype: TK_UNSIGNED TK_INT  */
#line 4615 "parser.y"
                           {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = uint_type;
        }
#line 8168 "../parser.c"
    break;

  case 568: /* basetype: TK_INT  */
#line 4619 "parser.y"
               {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = int_type;
        }
#line 8177 "../parser.c"
    break;

  case 569: /* basetype: TK_LONG  */
#line 4623 "parser.y"
                {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = long_type;
        }
#line 8186 "../parser.c"
    break;

  case 570: /* basetype: TK_UNSIGNED TK_LONG  */
#line 4627 "parser.y"
                            {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = ulong_type;
        }
#line 8195 "../parser.c"
    break;

  case 571: /* basetype: TK_LONG TK_LONG  */
#line 4631 "parser.y"
                        {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = longlong_type;
        }
#line 8204 "../parser.c"
    break;

  case 572: /* basetype: TK_UNSIGNED TK_LONG TK_LONG  */
#line 4635 "parser.y"
                                    {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = ulonglong_type;
        }
#line 8213 "../parser.c"
    break;

  case 573: /* basetype: TK_FLOAT  */
#line 4639 "parser.y"
                 {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = float_type;
        }
#line 8222 "../parser.c"
    break;

  case 574: /* basetype: TK_DOUBLE  */
#line 4643 "parser.y"
                  {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = double_type;
        }
#line 8231 "../parser.c"
    break;

  case 575: /* basetype: TK_BOOL  */
#line 4647 "parser.y"
                {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = bool_type;
        }
#line 8240 "../parser.c"
    break;

  case 576: /* basetype: TK_SIGNED TK_CHAR  */
#line 4651 "parser.y"
                          {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = sstring_type;
        }
#line 8249 "../parser.c"
    break;

  case 577: /* basetype: TK_UNSIGNED TK_CHAR  */
#line 4655 "parser.y"
                            {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = ustring_type;
        }
#line 8258 "../parser.c"
    break;

  case 578: /* basetype: TK_CHAR  */
#line 4659 "parser.y"
                {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = string_type;
        }
#line 8267 "../parser.c"
    break;

  case 579: /* basetype: TK_WCHAR_T  */
#line 4663 "parser.y"
                   {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = wstring_type;
        }
#line 8276 "../parser.c"
    break;

  case 580: /* basetype: TK_VOID  */
#line 4667 "parser.y"
                {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = void_type;
        }
#line 8285 "../parser.c"
    break;

  case 581: /* basetype: TK_PYOBJECT  */
#line 4671 "parser.y"
                    {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = pyobject_type;
        }
#line 8294 "../parser.c"
    break;

  case 582: /* basetype: TK_PYTUPLE  */
#line 4675 "parser.y"
                   {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = pytuple_type;
        }
#line 8303 "../parser.c"
    break;

  case 583: /* basetype: TK_PYLIST  */
#line 4679 "parser.y"
                  {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = pylist_type;
        }
#line 8312 "../parser.c"
    break;

  case 584: /* basetype: TK_PYDICT  */
#line 4683 "parser.y"
                  {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = pydict_type;
        }
#line 8321 "../parser.c"
    break;

  case 585: /* basetype: TK_PYCALLABLE  */
#line 4687 "parser.y"
                      {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = pycallable_type;
        }
#line 8330 "../parser.c"
    break;

  case 586: /* basetype: TK_PYSLICE  */
#line 4691 "parser.y"
                   {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = pyslice_type;
        }
#line 8339 "../parser.c"
    break;

  case 587: /* basetype: TK_PYTYPE  */
#line 4695 "parser.y"
                  {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = pytype_type;
        }
#line 8348 "../parser.c"
    break;

  case 588: /* basetype: TK_PYBUFFER  */
#line 4699 "parser.y"
                    {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = pybuffer_type;
        }
#line 8357 "../parser.c"
    break;

  case 589: /* basetype: TK_SIPSSIZET  */
#line 4703 "parser.y"
                     {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = ssize_type;
        }
#line 8366 "../parser.c"
    break;

  case 590: /* basetype: TK_SIZET  */
#line 4707 "parser.y"
                 {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = size_type;
        }
#line 8375 "../parser.c"
    break;

  case 591: /* basetype: TK_ELLIPSIS  */
#line 4711 "parser.y"
                    {
            memset(&(yyval.memArg), 0, sizeof (argDef));
            (yyval.memArg).atype = ellipsis_type;
        }
#line 8384 "../parser.c"
    break;

  case 592: /* cpptypelist: cpptype  */
#line 4717 "parser.y"
                        {
            /* The single or first type. */

            (yyval.signature).args[0] = (yyvsp[0].memArg);
            (yyval.signature).nrArgs = 1;
        }
#line 8395 "../parser.c"
    break;

  case 593: /* cpptypelist: cpptypelist ',' cpptype  */
#line 4723 "parser.y"
                                {
            /* Check there is nothing after an ellipsis. */
            if ((yyvsp[-2].signature).args[(yyvsp[-2].signature).nrArgs - 1].atype == ellipsis_type)
                yyerror("An ellipsis must be at the end of the argument list");

            /* Check there is room. */
            if ((yyvsp[-2].signature).nrArgs == MAX_NR_ARGS)
                yyerror("Internal error - increase the value of MAX_NR_ARGS");

            (yyval.signature) = (yyvsp[-2].signature);

            (yyval.signature).args[(yyval.signature).nrArgs] = (yyvsp[0].memArg);
            (yyval.signature).nrArgs++;
        }
#line 8414 "../parser.c"
    break;

  case 594: /* optexceptions: %empty  */
#line 4739 "parser.y"
                {
            (yyval.throwlist) = NULL;
        }
#line 8422 "../parser.c"
    break;

  case 595: /* optexceptions: TK_THROW '(' exceptionlist ')'  */
#line 4742 "parser.y"
                                       {
            if (currentSpec->genc)
                yyerror("Exceptions not allowed in a C module");

            (yyval.throwlist) = (yyvsp[-1].throwlist);
        }
#line 8433 "../parser.c"
    break;

  case 596: /* exceptionlist: %empty  */
#line 4750 "parser.y"
                {
            /* Empty list so use a blank. */

            (yyval.throwlist) = sipMalloc(sizeof (throwArgs));
            (yyval.throwlist) -> nrArgs = 0;
        }
#line 8444 "../parser.c"
    break;

  case 597: /* exceptionlist: scopedname  */
#line 4756 "parser.y"
                   {
            /* The only or first exception. */

            (yyval.throwlist) = sipMalloc(sizeof (throwArgs));
            (yyval.throwlist) -> nrArgs = 1;
            (yyval.throwlist) -> args[0] = findException(currentSpec, (yyvsp[0].scpvalp), FALSE);
        }
#line 8456 "../parser.c"
    break;

  case 598: /* exceptionlist: exceptionlist ',' scopedname  */
#line 4763 "parser.y"
                                     {
            /* Check that it wasn't ...(,arg...). */

            if ((yyvsp[-2].throwlist) -> nrArgs == 0)
                yyerror("First exception of throw specifier is missing");

            /* Check there is room. */

            if ((yyvsp[-2].throwlist) -> nrArgs == MAX_NR_ARGS)
                yyerror("Internal error - increase the value of MAX_NR_ARGS");

            (yyval.throwlist) = (yyvsp[-2].throwlist);
            (yyval.throwlist) -> args[(yyval.throwlist) -> nrArgs++] = findException(currentSpec, (yyvsp[0].scpvalp), FALSE);
        }
#line 8475 "../parser.c"
    break;


#line 8479 "../parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 4779 "parser.y"



/*
 * Parse the specification.
 */
void parse(sipSpec *spec, FILE *fp, char *filename, int strict,
        stringList *tsl, stringList *bsl, stringList *xfl, KwArgs kwArgs,
        int protHack)
{
    classTmplDef *tcd;

    /* Initialise the spec. */
 
    memset(spec, 0, sizeof (sipSpec));
    spec->genc = -1;

    currentSpec = spec;
    strictParse = strict;
    backstops = bsl;
    neededQualifiers = tsl;
    excludedQualifiers = xfl;
    currentModule = NULL;
    currentMappedType = NULL;
    currentIsVirt = FALSE;
    currentCtorIsExplicit = FALSE;
    currentIsStatic = FALSE;
    currentIsSignal = FALSE;
    currentIsSlot = FALSE;
    currentIsTemplate = FALSE;
    previousFile = NULL;
    stackPtr = 0;
    currentPlatforms = NULL;
    currentScopeIdx = 0;
    sectionFlags = 0;
    defaultKwArgs = kwArgs;
    makeProtPublic = protHack;

    newModule(fp, filename);
    spec->module = currentModule;

    yyparse();

    handleEOF();
    handleEOM();

    /*
     * Go through each template class and remove it from the list of classes.
     */
    for (tcd = spec->classtemplates; tcd != NULL; tcd = tcd->next)
    {
        classDef **cdp;

        for (cdp = &spec->classes; *cdp != NULL; cdp = &(*cdp)->next)
            if (*cdp == tcd->cd)
            {
                ifaceFileDef **ifdp;

                /* Remove the interface file as well. */
                for (ifdp = &spec->ifacefiles; *ifdp != NULL; ifdp = &(*ifdp)->next)
                    if (*ifdp == tcd->cd->iff)
                    {
                        *ifdp = (*ifdp)->next;
                        break;
                    }

                *cdp = (*cdp)->next;
                break;
            }
    }
}


/*
 * Tell the parser that a complete file has now been read.
 */
void parserEOF(const char *name, parserContext *pc)
{
    previousFile = sipStrdup(name);
    currentContext = *pc;
}


/*
 * Append a class definition to a class list if it doesn't already appear.
 * Append is needed specifically for the list of super-classes because the
 * order is important to Python.
 */
void appendToClassList(classList **clp,classDef *cd)
{
    classList *new;

    /* Find the end of the list. */

    while (*clp != NULL)
    {
        if ((*clp) -> cd == cd)
            return;

        clp = &(*clp) -> next;
    }

    new = sipMalloc(sizeof (classList));

    new -> cd = cd;
    new -> next = NULL;

    *clp = new;
}


/*
 * Create a new module for the current specification and make it current.
 */
static void newModule(FILE *fp, const char *filename)
{
    moduleDef *mod;

    parseFile(fp, filename, currentModule, FALSE);

    mod = allocModule();
    mod->file = filename;

    if (currentModule != NULL)
        mod->defexception = currentModule->defexception;

    currentModule = mod;
}


/*
 * Allocate and initialise the memory for a new module.
 */
static moduleDef *allocModule()
{
    moduleDef *newmod, **tailp;

    newmod = sipMalloc(sizeof (moduleDef));

    newmod->defdocstringfmt = raw;
    newmod->encoding = no_type;
    newmod->next_key = -1;

    /*
     * The consolidated module support needs these to be in order that they
     * appeared.
     */
    for (tailp = &currentSpec->modules; *tailp != NULL; tailp = &(*tailp)->next)
        ;

    *tailp = newmod;

    return newmod;
}


/*
 * Switch to parsing a new file.
 */
static void parseFile(FILE *fp, const char *name, moduleDef *prevmod,
        int optional)
{
    parserContext pc;

    pc.filename = name;
    pc.ifdepth = stackPtr;
    pc.prevmod = prevmod;

    if (setInputFile(fp, &pc, optional))
        currentContext = pc;
}


/*
 * Find an interface file, or create a new one.
 */
ifaceFileDef *findIfaceFile(sipSpec *pt, moduleDef *mod, scopedNameDef *fqname,
        ifaceFileType iftype, apiVersionRangeDef *api_range, argDef *ad)
{
    ifaceFileDef *iff, *first_alt = NULL;

    /* See if the name is already used. */

    for (iff = pt->ifacefiles; iff != NULL; iff = iff->next)
    {
        if (compareScopedNames(iff->fqcname, fqname) != 0)
            continue;

        /*
         * If they are both versioned then assume the user knows what they are
         * doing.
         */
        if (iff->api_range != NULL && api_range != NULL && iff->module == mod)
        {
            /* Remember the first of the alternate APIs. */
            if ((first_alt = iff->first_alt) == NULL)
                first_alt = iff;

            break;
        }

        /*
         * They must be the same type except that we allow a class if we want
         * an exception.  This is because we allow classes to be used before
         * they are defined.
         */
        if (iff->type != iftype)
            if (iftype != exception_iface || iff->type != class_iface)
                yyerror("A class, exception, namespace or mapped type has already been defined with the same name");

        /* Ignore an external class declared in another module. */
        if (iftype == class_iface && iff->module != mod)
        {
            classDef *cd;

            for (cd = pt->classes; cd != NULL; cd = cd->next)
                if (cd->iff == iff)
                    break;

            if (cd != NULL && iff->module != NULL && isExternal(cd))
                continue;
        }

        /*
         * If this is a mapped type with the same name defined in a different
         * module, then check that this type isn't the same as any of the
         * mapped types defined in that module.
         */
        if (iftype == mappedtype_iface && iff->module != mod)
        {
            mappedTypeDef *mtd;

            /*
             * This is a bit of a cheat.  With consolidated modules it's
             * possible to have two implementations of a mapped type in
             * different branches of the module hierarchy.  We assume that, if
             * there really are multiple implementations in the same branch,
             * then it will be picked up in a non-consolidated build.
             */
            if (isConsolidated(pt->module))
                continue;

            for (mtd = pt->mappedtypes; mtd != NULL; mtd = mtd->next)
            {
                if (mtd->iff != iff)
                    continue;

                if (ad->atype != template_type ||
                    mtd->type.atype != template_type ||
                    sameBaseType(ad, &mtd->type))
                    yyerror("Mapped type has already been defined in another module");
            }

            /*
             * If we got here then we have a mapped type based on an existing
             * template, but with unique parameters.  We don't want to use
             * interface files from other modules, so skip this one.
             */

            continue;
        }

        /* Ignore a namespace defined in another module. */
        if (iftype == namespace_iface && iff->module != mod)
            continue;

        return iff;
    }

    iff = sipMalloc(sizeof (ifaceFileDef));

    iff->name = cacheName(pt, scopedNameToString(fqname));
    iff->api_range = api_range;

    if (first_alt != NULL)
    {
        iff->first_alt = first_alt;
        iff->next_alt = first_alt->next_alt;

        first_alt->next_alt = iff;
    }
    else
    {
        /* This is the first alternate so point to itself. */
        iff->first_alt = iff;
    }

    /*
     * Note that we assume that the type (ie. class vs. mapped type vs.
     * exception) will be the same across all platforms.
     */
    iff->platforms = currentPlatforms;

    iff->type = iftype;
    iff->ifacenr = -1;
    iff->fqcname = fqname;
    iff->module = NULL;
    iff->hdrcode = NULL;
    iff->used = NULL;
    iff->file_extension = NULL;
    iff->next = pt->ifacefiles;

    pt->ifacefiles = iff;

    return iff;
}


/*
 * Find a class definition in a parse tree.
 */
static classDef *findClass(sipSpec *pt, ifaceFileType iftype,
        apiVersionRangeDef *api_range, scopedNameDef *fqname, int tmpl_arg)
{
    return findClassWithInterface(pt,
            findIfaceFile(pt, currentModule, fqname, iftype, api_range, NULL),
            tmpl_arg);
}


/*
 * Find a class definition given an existing interface file.
 */
static classDef *findClassWithInterface(sipSpec *pt, ifaceFileDef *iff,
        int tmpl_arg)
{
    classDef *cd;

    for (cd = pt->classes; cd != NULL; cd = cd->next)
        if (cd->iff == iff)
        {
            if (isTemplateArg(cd) && !tmpl_arg)
                resetTemplateArg(cd);

            return cd;
        }

    /* Create a new one. */
    cd = sipMalloc(sizeof (classDef));

    if (tmpl_arg)
        setTemplateArg(cd);

    cd->iff = iff;
    cd->pyname = cacheName(pt, classBaseName(cd));
    cd->next = pt->classes;

    pt->classes = cd;

    return cd;
}


/*
 * Add an interface file to an interface file list if it isn't already there.
 */
void appendToIfaceFileList(ifaceFileList **ifflp, ifaceFileDef *iff)
{
    /* Make sure we don't try to add an interface file to its own list. */
    if (&iff->used != ifflp)
    {
        ifaceFileList *iffl;

        while ((iffl = *ifflp) != NULL)
        {
            /* Don't bother if it is already there. */
            if (iffl->iff == iff)
                return;

            ifflp = &iffl -> next;
        }

        iffl = sipMalloc(sizeof (ifaceFileList));

        iffl->iff = iff;
        iffl->next = NULL;

        *ifflp = iffl;
    }
}


/*
 * Find an undefined (or create a new) exception definition in a parse tree.
 */
static exceptionDef *findException(sipSpec *pt, scopedNameDef *fqname, int new)
{
    exceptionDef *xd, **tail;
    ifaceFileDef *iff;
    classDef *cd;

    iff = findIfaceFile(pt, currentModule, fqname, exception_iface, NULL, NULL);

    /* See if it is an existing one. */
    for (xd = pt->exceptions; xd != NULL; xd = xd->next)
        if (xd->iff == iff)
            return xd;

    /*
     * If it is an exception interface file then we have never seen this name
     * before.  We require that exceptions are defined before being used, but
     * don't make the same requirement of classes (for reasons of backwards
     * compatibility).  Therefore the name must be reinterpreted as a (as yet
     * undefined) class.
     */
    if (new)
    {
        if (iff->type == exception_iface)
            cd = NULL;
        else
            yyerror("There is already a class with the same name or the exception has been used before being defined");
    }
    else
    {
        if (iff->type == exception_iface)
            iff->type = class_iface;

        cd = findClassWithInterface(pt, iff, FALSE);
    }

    /* Create a new one. */
    xd = sipMalloc(sizeof (exceptionDef));

    xd->exceptionnr = -1;
    xd->needed = FALSE;
    xd->iff = iff;
    xd->pyname = NULL;
    xd->cd = cd;
    xd->bibase = NULL;
    xd->base = NULL;
    xd->raisecode = NULL;
    xd->next = NULL;

    /* Append it to the list. */
    for (tail = &pt->exceptions; *tail != NULL; tail = &(*tail)->next)
        ;

    *tail = xd;

    return xd;
}


/*
 * Find an undefined (or create a new) class definition in a parse tree.
 */
static classDef *newClass(sipSpec *pt, ifaceFileType iftype,
        apiVersionRangeDef *api_range, scopedNameDef *fqname,
        const char *virt_error_handler, typeHintDef *typehint_in,
        typeHintDef *typehint_out, const char *typehint_value)
{
    int flags;
    classDef *cd, *scope;
    codeBlockList *hdrcode;

    if (sectionFlags & SECT_IS_PRIVATE)
        yyerror("Classes, structs and namespaces must be in the public or protected sections");

    flags = 0;

    if ((scope = currentScope()) != NULL)
    {
        if (sectionFlags & SECT_IS_PROT && !makeProtPublic)
        {
            flags = CLASS_IS_PROTECTED;

            if (scope->iff->type == class_iface)
                setNeedsShadow(scope);
        }

        /* Header code from outer scopes is also included. */
        hdrcode = scope->iff->hdrcode;
    }
    else
        hdrcode = NULL;

    if (pt -> genc)
    {
        /* C structs are always global types. */
        while (fqname -> next != NULL)
            fqname = fqname -> next;

        scope = NULL;
    }

    cd = findClass(pt, iftype, api_range, fqname, FALSE);

    /* Check it hasn't already been defined. */
    if (iftype != namespace_iface && cd->iff->module != NULL)
        yyerror("The struct/class has already been defined");

    /* Complete the initialisation. */
    cd->classflags |= flags;
    cd->ecd = scope;
    cd->iff->module = currentModule;
    cd->virt_error_handler = virt_error_handler;
    cd->typehint_in = typehint_in;
    cd->typehint_out = typehint_out;
    cd->typehint_value = typehint_value;

    if (currentIsTemplate)
        setIsTemplateClass(cd);

    appendCodeBlockList(&cd->iff->hdrcode, hdrcode);

    /* See if it is a namespace extender. */
    if (iftype == namespace_iface)
    {
        classDef *ns;

        for (ns = pt->classes; ns != NULL; ns = ns->next)
        {
            if (ns == cd)
                continue;

            if (ns->iff->type != namespace_iface)
                continue;

            if (compareScopedNames(ns->iff->fqcname, fqname) != 0)
                continue;

            cd->real = ns;

            if (inMainModule())
                ns->iff->first_alt->needed = TRUE;

            break;
        }
    }

    return cd;
}


/*
 * Tidy up after finishing a class definition.
 */
static void finishClass(sipSpec *pt, moduleDef *mod, classDef *cd,
        optFlags *of)
{
    const char *pyname;
    optFlag *flg;

    /* Get the Python name and see if it is different to the C++ name. */
    pyname = getPythonName(mod, of, classBaseName(cd));

    cd->pyname = NULL;
    checkAttributes(pt, mod, cd->ecd, NULL, pyname, FALSE);
    cd->pyname = cacheName(pt, pyname);
    cd->no_typehint = getNoTypeHint(of);

    if ((flg = getOptFlag(of, "Metatype", dotted_name_flag)) != NULL)
        cd->metatype = cacheName(pt, flg->fvalue.sval);

    if ((flg = getOptFlag(of, "Supertype", dotted_name_flag)) != NULL)
        cd->supertype = cacheName(pt, flg->fvalue.sval);

    if (getOptFlag(of, "ExportDerived", bool_flag) != NULL)
        setExportDerived(cd);

    if (getOptFlag(of, "Mixin", bool_flag) != NULL)
        setMixin(cd);

    if ((flg = getOptFlag(of, "FileExtension", string_flag)) != NULL)
        cd->iff->file_extension = flg->fvalue.sval;

    if ((flg = getOptFlag(of, "PyQtFlagsEnums", string_list_flag)) != NULL)
    {
        cd->pyqt_flags_enums = flg->fvalue.slval;
        cd->pyqt_flags = 1;
    }

    /* This is deprecated and only used by versions before v5.12. */
    if ((flg = getOptFlag(of, "PyQtFlags", integer_flag)) != NULL)
        cd->pyqt_flags = flg->fvalue.ival;

    if (getOptFlag(of, "PyQtNoQMetaObject", bool_flag) != NULL)
        setPyQtNoQMetaObject(cd);

    if ((flg = getOptFlag(of, "PyQtInterface", string_flag)) != NULL)
        cd->pyqt_interface = flg->fvalue.sval;

    if (isOpaque(cd))
    {
        if (getOptFlag(of, "External", bool_flag) != NULL)
            setIsExternal(cd);
    }
    else
    {
        int seq_might, seq_not, default_to_sequence;
        memberDef *md;

        if (getOptFlag(of, "NoDefaultCtors", bool_flag) != NULL)
            setNoDefaultCtors(cd);

        if (cd -> ctors == NULL)
        {
            if (!noDefaultCtors(cd))
            {
                /* Provide a default ctor. */

                cd->ctors = sipMalloc(sizeof (ctorDef));
 
                cd->ctors->ctorflags = SECT_IS_PUBLIC;
                cd->ctors->pysig.result.atype = void_type;
                cd->ctors->cppsig = &cd->ctors->pysig;

                cd->defctor = cd->ctors;

                setCanCreate(cd);
            }
        }
        else if (cd -> defctor == NULL)
        {
            ctorDef *ct, *last = NULL;

            for (ct = cd -> ctors; ct != NULL; ct = ct -> next)
            {
                if (!isPublicCtor(ct))
                    continue;

                if (ct -> pysig.nrArgs == 0 || ct -> pysig.args[0].defval != NULL)
                {
                    cd -> defctor = ct;
                    break;
                }

                if (last == NULL)
                    last = ct;
            }

            /* The last resort is the first public ctor. */
            if (cd->defctor == NULL)
                cd->defctor = last;
        }

        if (getDeprecated(of))
            setIsDeprecatedClass(cd);

        if (cd->convtocode != NULL && getAllowNone(of))
            setClassHandlesNone(cd);

        if (getOptFlag(of,"Abstract",bool_flag) != NULL)
        {
            setIsAbstractClass(cd);
            setIsIncomplete(cd);
            resetCanCreate(cd);
        }

        /* We assume a public dtor if nothing specific was provided. */
        if (!isDtor(cd))
            setIsPublicDtor(cd);

        if (getOptFlag(of, "DelayDtor", bool_flag) != NULL)
        {
            setIsDelayedDtor(cd);
            setHasDelayedDtors(mod);
        }

        /*
         * There are subtle differences between the add and concat methods and
         * the multiply and repeat methods.  The number versions can have their
         * operands swapped and may return NotImplemented.  If the user has
         * used the /Numeric/ annotation or there are other numeric operators
         * then we use add/multiply.  Otherwise, if the user has used the
         * /Sequence/ annotation or there are indexing operators then we use
         * concat/repeat.
         */
        seq_might = seq_not = FALSE;

        for (md = cd->members; md != NULL; md = md->next)
            switch (md->slot)
            {
            case getitem_slot:
            case setitem_slot:
            case delitem_slot:
                /* This might be a sequence. */
                seq_might = TRUE;
                break;

            case sub_slot:
            case isub_slot:
            case div_slot:
            case idiv_slot:
            case mod_slot:
            case imod_slot:
            case floordiv_slot:
            case ifloordiv_slot:
            case truediv_slot:
            case itruediv_slot:
            case pos_slot:
            case neg_slot:
                /* This is definately not a sequence. */
                seq_not = TRUE;
                break;

            /* Suppress a compiler warning. */
            default:
                ;
            }

        default_to_sequence = (!seq_not && seq_might);

        for (md = cd->members; md != NULL; md = md->next)
        {
            /* Ignore if it is explicitly numeric. */
            if (isNumeric(md))
                continue;

            if (isSequence(md) || default_to_sequence)
                switch (md->slot)
                {
                case add_slot:
                    md->slot = concat_slot;
                    break;

                case iadd_slot:
                    md->slot = iconcat_slot;
                    break;

                case mul_slot:
                    md->slot = repeat_slot;
                    break;

                case imul_slot:
                    md->slot = irepeat_slot;
                    break;

                /* Suppress a compiler warning. */
                default:
                    ;
                }
        }
    }

    if (inMainModule())
    {
        setIsUsedName(cd->iff->name);
        setIsUsedName(cd->pyname);
    }
}


/*
 * Return the encoded name of a template (ie. including its argument types) as
 * a scoped name.
 */
scopedNameDef *encodedTemplateName(templateDef *td)
{
    int a;
    scopedNameDef *snd;

    snd = copyScopedName(td->fqname);

    for (a = 0; a < td->types.nrArgs; ++a)
    {
        char buf[50];
        int flgs;
        scopedNameDef *arg_snd;
        argDef *ad = &td->types.args[a];

        flgs = 0;

        if (isConstArg(ad))
            flgs += 1;

        if (isReference(ad))
            flgs += 2;

        /* We use numbers so they don't conflict with names. */
        sprintf(buf, "%02d%d%d", ad->atype, flgs, ad->nrderefs);

        switch (ad->atype)
        {
        case defined_type:
            arg_snd = copyScopedName(ad->u.snd);
            break;

        case template_type:
            arg_snd = encodedTemplateName(ad->u.td);
            break;

        case struct_type:
            arg_snd = copyScopedName(ad->u.sname);
            break;

        default:
            arg_snd = NULL;
        }

        /*
         * Replace the first element of the argument name with a copy with the
         * encoding prepended.
         */
        if (arg_snd != NULL)
            arg_snd->name = concat(buf, arg_snd->name, NULL);
        else
            arg_snd = text2scopePart(sipStrdup(buf));

        appendScopedName(&snd, arg_snd);
    }

    return snd;
}


/*
 * Create a new mapped type.
 */
static mappedTypeDef *newMappedType(sipSpec *pt, argDef *ad, optFlags *of)
{
    mappedTypeDef *mtd;
    scopedNameDef *snd;
    ifaceFileDef *iff;
    const char *cname;

    /* Check that the type is one we want to map. */
    switch (ad->atype)
    {
    case defined_type:
        snd = ad->u.snd = fullyQualifiedName(ad->u.snd);
        cname = scopedNameTail(snd);
        break;

    case template_type:
        ad->u.td->fqname = fullyQualifiedName(ad->u.td->fqname);
        snd = encodedTemplateName(ad->u.td);
        cname = NULL;
        break;

    case struct_type:
        snd = ad->u.sname = fullyQualifiedName(ad->u.sname);
        cname = scopedNameTail(snd);
        break;

    default:
        yyerror("Invalid type for %MappedType");
    }

    iff = findIfaceFile(pt, currentModule, snd, mappedtype_iface,
            getAPIRange(of), ad);

    /* Check it hasn't already been defined. */
    for (mtd = pt->mappedtypes; mtd != NULL; mtd = mtd->next)
        if (mtd->iff == iff)
        {
            /*
             * We allow types based on the same template but with different
             * arguments.
             */
            if (ad->atype != template_type || sameBaseType(ad, &mtd->type))
                yyerror("Mapped type has already been defined in this module");
        }

    /* The module may not have been set yet. */
    iff->module = currentModule;

    /* Create a new mapped type. */
    mtd = allocMappedType(pt, ad);

    if (cname != NULL)
        mtd->pyname = cacheName(pt, getPythonName(currentModule, of, cname));

    mappedTypeAnnos(mtd, of);

    mtd->iff = iff;
    mtd->next = pt->mappedtypes;

    pt->mappedtypes = mtd;

    if (inMainModule())
    {
        setIsUsedName(mtd->cname);

        if (mtd->pyname)
            setIsUsedName(mtd->pyname);
    }

    return mtd;
}


/*
 * Allocate, initialise and return a mapped type structure.
 */
mappedTypeDef *allocMappedType(sipSpec *pt, argDef *type)
{
    mappedTypeDef *mtd;

    mtd = sipMalloc(sizeof (mappedTypeDef));

    mtd->type = *type;
    mtd->type.argflags = 0;
    mtd->type.nrderefs = 0;

    mtd->cname = cacheName(pt, type2string(&mtd->type));

    /* Keep track of the original definition as it gets copied. */
    mtd->real = mtd;

    return mtd;
}


/*
 * Create a new enum.
 */
static enumDef *newEnum(sipSpec *pt, moduleDef *mod, mappedTypeDef *mt_scope,
        char *name, optFlags *of, int flags, int isscoped)
{
    enumDef *ed, *first_alt, *next_alt;
    classDef *c_scope;
    ifaceFileDef *scope;

    if (mt_scope != NULL)
    {
        scope = mt_scope->iff;
        c_scope = NULL;
    }
    else
    {
        if ((c_scope = currentScope()) != NULL)
            scope = c_scope->iff;
        else
            scope = NULL;
    }

    ed = sipMalloc(sizeof (enumDef));

    /* Assume the enum isn't versioned. */
    first_alt = ed;
    next_alt = NULL;

    if (name != NULL)
    {
        ed->pyname = cacheName(pt, getPythonName(mod, of, name));
        checkAttributes(pt, mod, c_scope, mt_scope, ed->pyname->text, FALSE);

        ed->fqcname = text2scopedName(scope, name);
        ed->cname = cacheName(pt, scopedNameToString(ed->fqcname));

        if (inMainModule())
        {
            setIsUsedName(ed->pyname);
            setIsUsedName(ed->cname);
        }

        /* If the scope is versioned then look for any alternate. */
        if (scope != NULL && scope->api_range != NULL)
        {
            enumDef *alt;

            for (alt = pt->enums; alt != NULL; alt = alt->next)
            {
                if (alt->module != mod || alt->fqcname == NULL)
                    continue;

                if (compareScopedNames(alt->fqcname, ed->fqcname) == 0)
                {
                    first_alt = alt->first_alt;
                    next_alt = first_alt->next_alt;
                    first_alt->next_alt = ed;

                    break;
                }
            }
        }
    }
    else
    {
        ed->pyname = NULL;
        ed->fqcname = NULL;
        ed->cname = NULL;
    }

    if (flags & SECT_IS_PROT)
    {
        if (makeProtPublic)
        {
            flags &= ~SECT_IS_PROT;
            flags |= SECT_IS_PUBLIC;
        }
        else if (c_scope != NULL)
        {
            setNeedsShadow(c_scope);
        }
    }

    ed->enumflags = flags;
    ed->no_typehint = getNoTypeHint(of);
    ed->enumnr = -1;
    ed->ecd = c_scope;
    ed->emtd = mt_scope;
    ed->first_alt = first_alt;
    ed->next_alt = next_alt;
    ed->module = mod;
    ed->members = NULL;
    ed->slots = NULL;
    ed->overs = NULL;
    ed->platforms = currentPlatforms;
    ed->next = pt -> enums;

    pt->enums = ed;

    if (getOptFlag(of, "NoScope", bool_flag) != NULL)
        setIsNoScope(ed);

    if (isscoped)
        setIsScopedEnum(ed);

    return ed;
}


/*
 * Get the type values and (optionally) the type names for substitution in
 * handwritten code.
 */
void appendTypeStrings(scopedNameDef *ename, signatureDef *patt, signatureDef *src, signatureDef *known, scopedNameDef **names, scopedNameDef **values)
{
    int a;

    for (a = 0; a < patt->nrArgs; ++a)
    {
        argDef *pad = &patt->args[a];

        if (pad->atype == defined_type)
        {
            char *nam = NULL, *val;
            argDef *sad;

            /*
             * If the type names are already known then check that this is one
             * of them.
             */
            if (known == NULL)
                nam = scopedNameTail(pad->u.snd);
            else if (pad->u.snd->next == NULL)
            {
                int k;

                for (k = 0; k < known->nrArgs; ++k)
                {
                    /* Skip base types. */
                    if (known->args[k].atype != defined_type)
                        continue;

                    if (strcmp(pad->u.snd->name, known->args[k].u.snd->name) == 0)
                    {
                        nam = pad->u.snd->name;
                        break;
                    }
                }
            }

            if (nam == NULL)
                continue;

            /* Add the name. */
            appendScopedName(names, text2scopePart(nam));

            /*
             * Add the corresponding value.  For defined types we don't want 
             * any indirection or references.
             */
            sad = &src->args[a];

            if (sad->atype == defined_type)
                val = scopedNameToString(sad->u.snd);
            else
                val = type2string(sad);

            /* We do want const. */
            if (isConstArg(sad))
            {
                char *const_val = sipStrdup("const ");

                append(&const_val, val);
                free(val);

                val = const_val;
            }

            appendScopedName(values, text2scopePart(val));
        }
        else if (pad->atype == template_type)
        {
            argDef *sad = &src->args[a];

            /* These checks shouldn't be necessary, but... */
            if (sad->atype == template_type && pad->u.td->types.nrArgs == sad->u.td->types.nrArgs)
                appendTypeStrings(ename, &pad->u.td->types, &sad->u.td->types, known, names, values);
        }
    }
}


/*
 * Convert a type to a string on the heap.  The string will use the minimum
 * whitespace while still remaining valid C++.
 */
static char *type2string(argDef *ad)
{
    int i, on_heap = FALSE;
    int nr_derefs = ad->nrderefs;
    int is_reference = isReference(ad);
    char *s;

    /* Use the original type if possible. */
    if (ad->original_type != NULL && !noTypeName(ad->original_type))
    {
        s = scopedNameToString(ad->original_type->fqname);
        on_heap = TRUE;

        nr_derefs -= ad->original_type->type.nrderefs;

        if (isReference(&ad->original_type->type))
            is_reference = FALSE;
    }
    else
        switch (ad->atype)
        {
        case template_type:
            {
                templateDef *td = ad->u.td;

                s = scopedNameToString(td->fqname);
                append(&s, "<");

                for (i = 0; i < td->types.nrArgs; ++i)
                {
                    char *sub_type = type2string(&td->types.args[i]);

                    if (i > 0)
                        append(&s, ",");

                    append(&s, sub_type);
                    free(sub_type);
                }

                if (s[strlen(s) - 1] == '>')
                    append(&s, " >");
                else
                    append(&s, ">");

                on_heap = TRUE;
                break;
            }

        case struct_type:
            s = scopedNameToString(ad->u.sname);
            on_heap = TRUE;
            break;

        case defined_type:
            s = scopedNameToString(ad->u.snd);
            on_heap = TRUE;
            break;

        case ubyte_type:
        case ustring_type:
            s = "unsigned char";
            break;

        case byte_type:
        case ascii_string_type:
        case latin1_string_type:
        case utf8_string_type:
        case string_type:
            s = "char";
            break;

        case sbyte_type:
        case sstring_type:
            s = "signed char";
            break;

        case wstring_type:
            s = "wchar_t";
            break;

        case ushort_type:
            s = "unsigned short";
            break;

        case short_type:
            s = "short";
            break;

        case uint_type:
            s = "uint";
            break;

        case int_type:
        case cint_type:
            s = "int";
            break;

        case ulong_type:
            s = "unsigned long";
            break;

        case long_type:
            s = "long";
            break;

        case ulonglong_type:
            s = "unsigned long long";
            break;

        case longlong_type:
            s = "long long";
            break;

        case float_type:
        case cfloat_type:
            s = "float";
            break;

        case double_type:
        case cdouble_type:
            s = "double";
            break;

        case bool_type:
        case cbool_type:
            s = "bool";
            break;

        case void_type:
            s = "void";
            break;

        case capsule_type:
            s = "void *";
            break;

        case size_type:
            s = "size_t";
            break;

        default:
            fatal("Unsupported type argument to type2string(): %d\n", ad->atype);
        }

    /* Make sure the string is on the heap. */
    if (!on_heap)
        s = sipStrdup(s);

    while (nr_derefs-- > 0)
        append(&s, "*");

    if (is_reference)
        append(&s, "&");

    return s;
}


/*
 * Remove any explicit global scope.
 */
scopedNameDef *removeGlobalScope(scopedNameDef *snd)
{
    return ((snd != NULL && snd->name[0] == '\0') ? snd->next : snd);
}


/*
 * Convert a scoped name to a string on the heap.
 */
static char *scopedNameToString(scopedNameDef *name)
{
    static const char scope_string[] = "::";
    size_t len;
    scopedNameDef *snd;
    char *s, *dp;

    /*
     * We don't want the global scope (which probably should always be there,
     * but we check anyway).
     */
    name = removeGlobalScope(name);

    /* Work out the length of buffer needed. */
    len = 0;

    for (snd = name; snd != NULL; snd = snd->next)
    {
        len += strlen(snd->name);

        if (snd->next != NULL)
        {
            /* Ignore the encoded part of template names. */
            if (isdigit(snd->next->name[0]))
                break;

            len += strlen(scope_string);
        }
    }

    /* Allocate and populate the buffer. */
    dp = s = sipMalloc(len + 1);

    for (snd = name; snd != NULL; snd = snd->next)
    {
        strcpy(dp, snd->name);
        dp += strlen(snd->name);

        if (snd->next != NULL)
        {
            /* Ignore the encoded part of template names. */
            if (isdigit(snd->next->name[0]))
                break;

            strcpy(dp, scope_string);
            dp += strlen(scope_string);
        }
    }

    return s;
}


/*
 * Instantiate a class template.
 */
static void instantiateClassTemplate(sipSpec *pt, moduleDef *mod,
        classDef *scope, scopedNameDef *fqname, classTmplDef *tcd,
        templateDef *td, const char *pyname, int use_template_name,
        docstringDef *docstring)
{
    scopedNameDef *type_names, *type_values;
    classDef *cd;
    ctorDef *oct, **cttail;
    argDef *ad;
    ifaceFileList *iffl, **used;
    classList *cl;
    stringList *sl;

    type_names = type_values = NULL;
    appendTypeStrings(classFQCName(tcd->cd), &tcd->sig, &td->types, NULL, &type_names, &type_values);

    /*
     * Add a mapping from the template name to the instantiated name.  If we
     * have got this far we know there is room for it.
     */
    ad = &tcd->sig.args[tcd->sig.nrArgs++];
    memset(ad, 0, sizeof (argDef));
    ad->atype = defined_type;
    ad->u.snd = classFQCName(tcd->cd);

    appendScopedName(&type_names, text2scopePart(scopedNameTail(classFQCName(tcd->cd))));
    appendScopedName(&type_values, text2scopePart(scopedNameToString(fqname)));

    /* Create the new class. */
    cd = sipMalloc(sizeof (classDef));

    /* Start with a shallow copy. */
    *cd = *tcd->cd;

    if (docstring != NULL)
        cd->docstring = docstring;

    resetIsTemplateClass(cd);
    cd->pyname = cacheName(pt, pyname);
    cd->td = td;

    if (use_template_name)
        setUseTemplateName(cd);

    /* Handle the interface file. */
    cd->iff = findIfaceFile(pt, mod, fqname, class_iface,
            (scope != NULL ? scope->iff->api_range : NULL), NULL);
    cd->iff->module = mod;

    appendCodeBlockList(&cd->iff->hdrcode, tcd->cd->iff->hdrcode);

    /* Make a copy of the used list and add the enclosing scope. */
    used = &cd->iff->used;

    for (iffl = tcd->cd->iff->used; iffl != NULL; iffl = iffl->next)
        appendToIfaceFileList(used, iffl->iff);

    /* Include any scope header code. */
    if (scope != NULL)
        appendCodeBlockList(&cd->iff->hdrcode, scope->iff->hdrcode);

    if (inMainModule())
    {
        setIsUsedName(cd->iff->name);
        setIsUsedName(cd->pyname);
    }

    cd->ecd = currentScope();

    /* Handle any type hints. */
    if (cd->typehint_in != NULL)
        cd->typehint_in = newTypeHint(
                templateString(cd->typehint_in->raw_hint, type_names,
                        type_values));

    if (cd->typehint_out != NULL)
        cd->typehint_out = newTypeHint(
                templateString(cd->typehint_out->raw_hint, type_names,
                        type_values));

    /* Handle any flagged enums. */
    if ((sl = cd->pyqt_flags_enums) != NULL)
    {
        cd->pyqt_flags_enums = NULL;

        do
        {
            appendString(&cd->pyqt_flags_enums,
                    templateString(sl->s, type_names, type_values));
            sl = sl->next;
        }
        while (sl != NULL);
    }

    /* Handle the super-classes. */
    for (cl = cd->supers; cl != NULL; cl = cl->next)
    {
        int a;
        scopedNameDef *unscoped;

        unscoped = removeGlobalScope(cl->cd->iff->fqcname);

        /* Ignore defined or scoped classes. */
        if (cl->cd->iff->module != NULL || unscoped->next != NULL)
            continue;

        for (a = 0; a < tcd->sig.nrArgs - 1; ++a)
            if (strcmp(unscoped->name, scopedNameTail(tcd->sig.args[a].u.snd)) == 0)
            {
                argDef *tad = &td->types.args[a];
                classDef *icd;

                if (tad->atype == defined_type)
                    icd = findClass(pt, class_iface, NULL, tad->u.snd, FALSE);
                else if (tad->atype == class_type)
                    icd = tad->u.cd;
                else
                    fatal("Template argument %s must expand to a class\n",
                            unscoped->name);

                cl->cd = icd;
            }
    }

    /* Handle the enums. */
    instantiateTemplateEnums(pt, tcd, td, cd, used, type_names, type_values);

    /* Handle the variables. */
    instantiateTemplateVars(pt, tcd, td, cd, used, type_names, type_values);

    /* Handle the typedefs. */
    instantiateTemplateTypedefs(pt, tcd, td, cd, type_names, type_values);

    /* Handle the ctors. */
    cd->ctors = NULL;
    cttail = &cd->ctors;

    for (oct = tcd->cd->ctors; oct != NULL; oct = oct->next)
    {
        ctorDef *nct = sipMalloc(sizeof (ctorDef));

        /* Start with a shallow copy. */
        *nct = *oct;

        templateSignature(&nct->pysig, oct->kwargs, FALSE, tcd, td, cd,
                type_names, type_values);

        if (oct->cppsig == NULL)
            nct->cppsig = NULL;
        else if (oct->cppsig == &oct->pysig)
            nct->cppsig = &nct->pysig;
        else
        {
            nct->cppsig = sipMalloc(sizeof (signatureDef));

            *nct->cppsig = *oct->cppsig;

            templateSignature(nct->cppsig, NoKwArgs, FALSE, tcd, td, cd,
                    type_names, type_values);
        }

        nct->methodcode = templateCode(pt, used, nct->methodcode, type_names, type_values);
        nct->premethodcode = templateCode(pt, used, nct->premethodcode, type_names, type_values);

        nct->next = NULL;
        *cttail = nct;
        cttail = &nct->next;

        /* Handle the default ctor. */
        if (tcd->cd->defctor == oct)
            cd->defctor = nct;
    }

    cd->dealloccode = templateCode(pt, used, cd->dealloccode, type_names, type_values);
    cd->dtorcode = templateCode(pt, used, cd->dtorcode, type_names, type_values);

    /* Handle the methods. */
    cd->members = instantiateTemplateMethods(tcd->cd->members, mod);
    cd->overs = instantiateTemplateOverloads(pt, tcd->cd->overs,
            tcd->cd->members, cd->members, tcd, td, cd, used, type_names,
            type_values);

    cd->cppcode = templateCode(pt, used, cd->cppcode, type_names, type_values);
    cd->iff->hdrcode = templateCode(pt, used, cd->iff->hdrcode, type_names, type_values);
    cd->convtosubcode = templateCode(pt, used, cd->convtosubcode, type_names, type_values);
    cd->convtocode = templateCode(pt, used, cd->convtocode, type_names, type_values);
    cd->travcode = templateCode(pt, used, cd->travcode, type_names, type_values);
    cd->clearcode = templateCode(pt, used, cd->clearcode, type_names, type_values);
    cd->getbufcode = templateCode(pt, used, cd->getbufcode, type_names, type_values);
    cd->releasebufcode = templateCode(pt, used, cd->releasebufcode, type_names, type_values);
    cd->readbufcode = templateCode(pt, used, cd->readbufcode, type_names, type_values);
    cd->writebufcode = templateCode(pt, used, cd->writebufcode, type_names, type_values);
    cd->segcountcode = templateCode(pt, used, cd->segcountcode, type_names, type_values);
    cd->charbufcode = templateCode(pt, used, cd->charbufcode, type_names, type_values);
    cd->instancecode = templateCode(pt, used, cd->instancecode, type_names, type_values);
    cd->picklecode = templateCode(pt, used, cd->picklecode, type_names, type_values);
    cd->finalcode = templateCode(pt, used, cd->finalcode, type_names, type_values);
    cd->typehintcode = templateCode(pt, used, cd->typehintcode, type_names, type_values);
    cd->next = pt->classes;

    pt->classes = cd;

    tcd->sig.nrArgs--;

    freeScopedName(type_names);
    freeScopedName(type_values);
}


/*
 * Instantiate the methods of a template class.
 */
static memberDef *instantiateTemplateMethods(memberDef *tmd, moduleDef *mod)
{
    memberDef *md, *methods, **mdtail;

    methods = NULL;
    mdtail = &methods;

    for (md = tmd; md != NULL; md = md->next)
    {
        memberDef *nmd = sipMalloc(sizeof (memberDef));

        /* Start with a shallow copy. */
        *nmd = *md;

        nmd->module = mod;

        if (inMainModule())
            setIsUsedName(nmd->pyname);

        nmd->next = NULL;
        *mdtail = nmd;
        mdtail = &nmd->next;
    }

    return methods;
}


/*
 * Instantiate the overloads of a template class.
 */
static overDef *instantiateTemplateOverloads(sipSpec *pt, overDef *tod,
        memberDef *tmethods, memberDef *methods, classTmplDef *tcd,
        templateDef *td, classDef *cd, ifaceFileList **used,
        scopedNameDef *type_names, scopedNameDef *type_values)
{
    overDef *od, *overloads, **odtail;

    overloads = NULL;
    odtail = &overloads;

    for (od = tod; od != NULL; od = od->next)
    {
        overDef *nod = sipMalloc(sizeof (overDef));
        memberDef *nmd, *omd;

        /* Start with a shallow copy. */
        *nod = *od;

        for (nmd = methods, omd = tmethods; omd != NULL; omd = omd->next, nmd = nmd->next)
            if (omd == od->common)
            {
                nod->common = nmd;
                break;
            }

        templateSignature(&nod->pysig, od->kwargs, TRUE, tcd, td, cd,
                type_names, type_values);

        if (od->cppsig == &od->pysig)
            nod->cppsig = &nod->pysig;
        else
        {
            nod->cppsig = sipMalloc(sizeof (signatureDef));

            *nod->cppsig = *od->cppsig;

            templateSignature(nod->cppsig, NoKwArgs, TRUE, tcd, td, cd,
                    type_names, type_values);
        }

        nod->methodcode = templateCode(pt, used, nod->methodcode, type_names, type_values);
        nod->premethodcode = templateCode(pt, used, nod->premethodcode, type_names, type_values);
        nod->virtcallcode = templateCode(pt, used, nod->virtcallcode, type_names, type_values);
        nod->virtcode = templateCode(pt, used, nod->virtcode, type_names, type_values);

        nod->next = NULL;
        *odtail = nod;
        odtail = &nod->next;
    }

    return overloads;
}


/*
 * Instantiate the enums of a template class.
 */
static void instantiateTemplateEnums(sipSpec *pt, classTmplDef *tcd,
        templateDef *td, classDef *cd, ifaceFileList **used,
        scopedNameDef *type_names, scopedNameDef *type_values)
{
    enumDef *ted;
    moduleDef *mod = cd->iff->module;

    for (ted = pt->enums; ted != NULL; ted = ted->next)
        if (ted->ecd == tcd->cd)
        {
            enumDef *ed;
            enumMemberDef *temd;

            ed = sipMalloc(sizeof (enumDef));

            /* Start with a shallow copy. */
            *ed = *ted;

            if (ed->fqcname != NULL)
            {
                ed->fqcname = text2scopedName(cd->iff,
                        scopedNameTail(ed->fqcname));
                ed->cname = cacheName(pt, scopedNameToString(ed->fqcname));
            }

            if (inMainModule())
            {
                if (ed->pyname != NULL)
                    setIsUsedName(ed->pyname);

                if (ed->cname != NULL)
                    setIsUsedName(ed->cname);
            }

            ed->ecd = cd;
            ed->first_alt = ed;
            ed->module = mod;
            ed->members = NULL;

            for (temd = ted->members; temd != NULL; temd = temd->next)
            {
                enumMemberDef *emd;

                emd = sipMalloc(sizeof (enumMemberDef));

                /* Start with a shallow copy. */
                *emd = *temd;
                emd->ed = ed;

                emd->next = ed->members;
                ed->members = emd;
            }

            ed->slots = instantiateTemplateMethods(ted->slots, mod);
            ed->overs = instantiateTemplateOverloads(pt, ted->overs,
                    ted->slots, ed->slots, tcd, td, cd, used, type_names,
                    type_values);

            ed->next = pt->enums;
            pt->enums = ed;
        }
}


/*
 * Instantiate the variables of a template class.
 */
static void instantiateTemplateVars(sipSpec *pt, classTmplDef *tcd,
        templateDef *td, classDef *cd, ifaceFileList **used,
        scopedNameDef *type_names, scopedNameDef *type_values)
{
    varDef *tvd;

    for (tvd = pt->vars; tvd != NULL; tvd = tvd->next)
        if (tvd->ecd == tcd->cd)
        {
            varDef *vd;

            vd = sipMalloc(sizeof (varDef));

            /* Start with a shallow copy. */
            *vd = *tvd;

            if (inMainModule())
                setIsUsedName(vd->pyname);

            vd->fqcname = text2scopedName(cd->iff,
                    scopedNameTail(vd->fqcname));
            vd->ecd = cd;
            vd->module = cd->iff->module;

            templateType(&vd->type, tcd, td, cd, type_names, type_values);

            vd->accessfunc = templateCode(pt, used, vd->accessfunc, type_names, type_values);
            vd->getcode = templateCode(pt, used, vd->getcode, type_names, type_values);
            vd->setcode = templateCode(pt, used, vd->setcode, type_names, type_values);

            addVariable(pt, vd);
        }
}


/*
 * Instantiate the typedefs of a template class.
 */
static void instantiateTemplateTypedefs(sipSpec *pt, classTmplDef *tcd,
        templateDef *td, classDef *cd, scopedNameDef *type_names,
        scopedNameDef *type_values)
{
    typedefDef *tdd;

    for (tdd = pt->typedefs; tdd != NULL; tdd = tdd->next)
    {
        typedefDef *new_tdd;

        if (tdd->ecd != tcd->cd)
            continue;

        new_tdd = sipMalloc(sizeof (typedefDef));

        /* Start with a shallow copy. */
        *new_tdd = *tdd;

        new_tdd->fqname = text2scopedName(cd->iff,
                scopedNameTail(new_tdd->fqname));
        new_tdd->ecd = cd;
        new_tdd->module = cd->iff->module;

        templateType(&new_tdd->type, tcd, td, cd, type_names, type_values);

        addTypedef(pt, new_tdd);
    }
}


/*
 * Replace any template arguments in a signature.
 */
static void templateSignature(signatureDef *sd, KwArgs kwargs, int result,
        classTmplDef *tcd, templateDef *td, classDef *ncd,
        scopedNameDef *type_names, scopedNameDef *type_values)
{
    int a;

    if (result)
        templateType(&sd->result, tcd, td, ncd, type_names, type_values);

    for (a = 0; a < sd->nrArgs; ++a)
    {
        argDef *ad = &sd->args[a];

        templateType(ad, tcd, td, ncd, type_names, type_values);

        /* Make sure we have the name of any keyword argument. */
        if (inMainModule() && ad->name != NULL)
        {
            if (kwargs == AllKwArgs || (kwargs == OptionalKwArgs && ad->defval != NULL))
                setIsUsedName(ad->name);
        }
    }
}


/*
 * Replace any template arguments in a type.
 */
static void templateType(argDef *ad, classTmplDef *tcd, templateDef *td,
        classDef *ncd, scopedNameDef *type_names, scopedNameDef *type_values)
{
    int a;
    char *name;

    /* Descend into any sub-templates. */
    if (ad->atype == template_type)
    {
        templateDef *new_td = sipMalloc(sizeof (templateDef));

        /* Make a deep copy of the template definition. */
        *new_td = *ad->u.td;
        ad->u.td = new_td;

        templateSignature(&ad->u.td->types, NoKwArgs, FALSE, tcd, td, ncd,
                type_names, type_values);

        return;
    }

    /* Handle any default value. */
    if (ad->defval != NULL && ad->defval->vtype == fcall_value)
    {
        /*
         * We only handle the subset where the value is an function call, ie. a
         * template ctor.
         */
        valueDef *vd = ad->defval;

        if (vd->vtype == fcall_value && vd->u.fcd->type.atype == defined_type)
        {
            valueDef *new_vd;
            fcallDef *fcd;
            scopedNameDef *snd, **tailp;

            fcd = sipMalloc(sizeof (fcallDef));
            *fcd = *vd->u.fcd;

            tailp = &fcd->type.u.snd;
            for (snd = vd->u.fcd->type.u.snd; snd != NULL; snd = snd->next)
            {
                *tailp = text2scopePart(
                        templateString(snd->name, type_names, type_values));
                tailp = &(*tailp)->next;
            }

            new_vd = sipMalloc(sizeof (valueDef));
            new_vd->vtype = fcall_value;
            new_vd->u.fcd = fcd;

            ad->defval = new_vd;
        }
    }

    /* Handle any type hints. */
    if (ad->typehint_in != NULL)
        ad->typehint_in = newTypeHint(
                templateString(ad->typehint_in->raw_hint, type_names,
                        type_values));

    if (ad->typehint_out != NULL)
        ad->typehint_out = newTypeHint(
                templateString(ad->typehint_out->raw_hint, type_names,
                        type_values));

    /* Ignore if it isn't an unscoped name. */
    if (ad->atype != defined_type || ad->u.snd->next != NULL)
        return;

    name = ad->u.snd->name;

    for (a = 0; a < tcd->sig.nrArgs - 1; ++a)
        if (strcmp(name, scopedNameTail(tcd->sig.args[a].u.snd)) == 0)
        {
            argDef *tad = &td->types.args[a];

            ad->atype = tad->atype;

            /* We take the constrained flag from the real type. */
            resetIsConstrained(ad);

            if (isConstrained(tad))
                setIsConstrained(ad);

            ad->u = tad->u;

            return;
        }

    /* Handle the class name itself. */
    if (strcmp(name, scopedNameTail(classFQCName(tcd->cd))) == 0)
    {
        ad->atype = class_type;
        ad->u.cd = ncd;
        ad->original_type = NULL;
    }
}


/*
 * Replace any template arguments in a literal code block.
 */
codeBlockList *templateCode(sipSpec *pt, ifaceFileList **used,
        codeBlockList *ocbl, scopedNameDef *names, scopedNameDef *values)
{
    codeBlockList *ncbl = NULL;

    while (ocbl != NULL)
    {
        char *at = ocbl->block->frag;
        int start_of_line = TRUE;

        do
        {
            char *from = at, *first = NULL;
            codeBlock *cb;
            scopedNameDef *nam, *val, *nam_first, *val_first;

            /* Suppress a compiler warning. */
            val_first = NULL;

            /*
             * Don't do any substitution in lines that appear to be
             * preprocessor directives.  This prevents #include'd file names
             * being broken.
             */
            if (start_of_line)
            {
                /* Strip leading whitespace. */
                while (isspace(*from))
                    ++from;

                if (*from == '#')
                {
                    /* Skip to the end of the line. */
                    do
                        ++from;
                    while (*from != '\n' && *from != '\0');
                }
                else
                {
                    start_of_line = FALSE;
                }
            }

            /*
             * Go through the rest of this fragment looking for each of the
             * types and the name of the class itself.
             */
            nam = names;
            val = values;

            while (nam != NULL && val != NULL)
            {
                char *cp;

                if ((cp = strstr(from, nam->name)) != NULL)
                    if (first == NULL || first > cp)
                    {
                        nam_first = nam;
                        val_first = val;
                        first = cp;
                    }

                nam = nam->next;
                val = val->next;
            }

            /* Create the new fragment. */
            cb = sipMalloc(sizeof (codeBlock));

            if (at == ocbl->block->frag)
            {
                cb->filename = ocbl->block->filename;
                cb->linenr = ocbl->block->linenr;
            }
            else
                cb->filename = NULL;

            appendCodeBlock(&ncbl, cb);

            /* See if anything was found. */
            if (first == NULL)
            {
                /* We can just point to this. */
                cb->frag = at;

                /* All done with this one. */
                at = NULL;
            }
            else
            {
                static char *gen_names[] = {
                    "sipType_",
                    "sipClass_",
                    "sipEnum_",
                    "sipException_",
                    NULL
                };

                char *dp, *sp, **gn;
                int genname = FALSE;

                /*
                 * If the context in which the text is used is in the name of a
                 * SIP generated object then translate any "::" scoping to "_"
                 * and remove any const.
                 */
                for (gn = gen_names; *gn != NULL; ++gn)
                    if (search_back(first, at, *gn))
                    {
                        addUsedFromCode(pt, used, val_first->name);
                        genname = TRUE;
                        break;
                    }

                /* Fragment the fragment. */
                cb->frag = sipMalloc(first - at + strlen(val_first->name) + 1);

                strncpy(cb->frag, at, first - at);

                dp = &cb->frag[first - at];
                sp = val_first->name;

                if (genname)
                {
                    char gch;

                    if (strlen(sp) > 6 && strncmp(sp, "const ", 6) == 0)
                        sp += 6;

                    while ((gch = *sp++) != '\0')
                        if (gch == ':' && *sp == ':')
                        {
                            *dp++ = '_';
                            ++sp;
                        }
                        else
                            *dp++ = gch;

                    *dp = '\0';
                }
                else
                    strcpy(dp, sp);

                /* Move past the replaced text. */
                at = first + strlen(nam_first->name);

                if (*at == '\n')
                    start_of_line = TRUE;
            }
        }
        while (at != NULL && *at != '\0');

        ocbl = ocbl->next;
    }

    return ncbl;
}


/*
 * Return TRUE if the text at the end of a string matches the target string.
 */
static int search_back(const char *end, const char *start, const char *target)
{
    size_t tlen = strlen(target);

    if (start + tlen >= end)
        return FALSE;

    return (strncmp(end - tlen, target, tlen) == 0);
}


/*
 * Add any needed interface files based on handwritten code.
 */
static void addUsedFromCode(sipSpec *pt, ifaceFileList **used, const char *sname)
{
    ifaceFileDef *iff;
    enumDef *ed;

    for (iff = pt->ifacefiles; iff != NULL; iff = iff->next)
    {
        if (iff->type != class_iface && iff->type != exception_iface)
            continue;

        if (sameName(iff->fqcname, sname))
        {
            appendToIfaceFileList(used, iff);
            return;
        }
    }

    for (ed = pt->enums; ed != NULL; ed = ed->next)
    {
        if (ed->ecd == NULL)
            continue;

        if (sameName(ed->fqcname, sname))
        {
            appendToIfaceFileList(used, ed->ecd->iff);
            return;
        }
    }
}


/*
 * Compare a scoped name with its string equivalent.
 */
static int sameName(scopedNameDef *snd, const char *sname)
{
    /* Handle any explicit scopes. */
    if (sname[0] == ':' && sname[1] == ':')
    {
        if (snd->name[0] != '\0')
            return FALSE;

        sname += 2;
    }

    snd = removeGlobalScope(snd);

    while (snd != NULL && *sname != '\0')
    {
        const char *sp = snd->name;

        while (*sp != '\0' && *sname != ':' && *sname != '\0')
            if (*sp++ != *sname++)
                return FALSE;

        if (*sp != '\0' || (*sname != ':' && *sname != '\0'))
            return FALSE;

        snd = snd->next;

        if (*sname == ':')
            sname += 2;
    }

    return (snd == NULL && *sname == '\0');
}


/*
 * Compare a (possibly) relative scoped name with a fully qualified scoped name
 * while taking the current scope into account.
 */
static int foundInScope(scopedNameDef *fq_name, scopedNameDef *rel_name)
{
    classDef *scope;

    for (scope = currentScope(); scope != NULL; scope = scope->ecd)
    {
        scopedNameDef *snd;
        int found;

        snd = copyScopedName(classFQCName(scope));
        appendScopedName(&snd, copyScopedName(rel_name));

        found = (compareScopedNames(fq_name, snd) == 0);

        freeScopedName(snd);

        if (found)
            return TRUE;
    }

    return compareScopedNames(fq_name, rel_name) == 0;
}


/*
 * Create a new typedef.
 */
static void newTypedef(sipSpec *pt, moduleDef *mod, char *name, argDef *type,
        optFlags *optflgs, docstringDef *docstring)
{
    int no_type_name;
    typedefDef *td;
    scopedNameDef *fqname;
    classDef *scope;

    scope = currentScope();
    fqname = text2scopedName((scope != NULL ? scope->iff : NULL), name);
    no_type_name = (getOptFlag(optflgs, "NoTypeName", bool_flag) != NULL);

    /* See if we are instantiating a template class. */
    if (type->atype == template_type)
    {
        classTmplDef *tcd;
        templateDef *td = type->u.td;

        for (tcd = pt->classtemplates; tcd != NULL; tcd = tcd->next)
            if (foundInScope(tcd->cd->iff->fqcname, td->fqname) &&
                sameTemplateSignature(&tcd->sig, &td->types, FALSE))
            {
                instantiateClassTemplate(pt, mod, scope, fqname, tcd, td,
                        getPythonName(mod, optflgs, name), no_type_name,
                        docstring);

                /* All done. */
                return;
            }
    }

    td = sipMalloc(sizeof (typedefDef));

    td->tdflags = 0;
    td->fqname = fqname;
    td->ecd = scope;
    td->module = mod;
    td->platforms = currentPlatforms;
    td->type = *type;

    if (getOptFlag(optflgs, "Capsule", bool_flag) != NULL)
    {
        /* Make sure the type is void *. */
        if (type->atype != void_type || type->nrderefs != 1 || isConstArg(type) || isReference(type))
        {
            fatalScopedName(fqname);
            fatal(" must be a void* if /Capsule/ is specified\n");
        }

        td->type.atype = capsule_type;
        td->type.nrderefs = 0;
        td->type.u.cap = fqname;
    }

    if (no_type_name)
        setNoTypeName(td);

    addTypedef(pt, td);
}


/*
 * Add a typedef to the list so that the list remains sorted.
 */
static void addTypedef(sipSpec *pt, typedefDef *tdd)
{
    typedefDef **tdp;

    /*
     * Check it doesn't already exist (with a strict parse) and find the
     * position in the sorted list where it should be put.
     */
    for (tdp = &pt->typedefs; *tdp != NULL; tdp = &(*tdp)->next)
    {
        int res = compareScopedNames((*tdp)->fqname, tdd->fqname);

        if (res == 0 && strictParse)
        {
            fatalScopedName(tdd->fqname);
            fatal(" already defined\n");
        }

        if (res >= 0)
            break;
    }

    tdd->next = *tdp;
    *tdp = tdd;

    tdd->module->nrtypedefs++;
}


/*
 * Speculatively try and resolve any typedefs.  In some cases (eg. when
 * comparing template signatures) it helps to use the real type if it is known.
 * Note that this wouldn't be necessary if we required that all types be known
 * before they are used.
 */
static void resolveAnyTypedef(sipSpec *pt, argDef *ad)
{
    argDef orig = *ad;

    while (ad->atype == defined_type)
    {
        ad->atype = no_type;
        searchTypedefs(pt, ad->u.snd, ad);

        /*
         * Don't resolve to a template type as it may be superceded later on
         * by a more specific mapped type.
         */
        if (ad->atype == no_type || ad->atype == template_type)
        {
            *ad = orig;
            break;
        }
    }
}


/*
 * Return TRUE if the template signatures are the same.  A deep comparison is
 * used for mapped type templates where we want to recurse into any nested
 * templates.
 */
int sameTemplateSignature(signatureDef *tmpl_sd, signatureDef *args_sd,
        int deep)
{
    int a;

    if (tmpl_sd->nrArgs != args_sd->nrArgs)
        return FALSE;

    for (a = 0; a < tmpl_sd->nrArgs; ++a)
    {
        argDef *tmpl_ad = &tmpl_sd->args[a];
        argDef *args_ad = &args_sd->args[a];

        /*
         * If we are doing a shallow comparision (ie. for class templates) then
         * a type name in the template signature matches anything in the
         * argument signature.
         */
        if (tmpl_ad->atype == defined_type && !deep)
            continue;

        /*
         * For type names only compare the references and pointers, and do the
         * same for any nested templates.
         */
        if (tmpl_ad->atype == defined_type && args_ad->atype == defined_type)
        {
            if (isReference(tmpl_ad) != isReference(args_ad) || tmpl_ad->nrderefs != args_ad->nrderefs)
                return FALSE;
        }
        else if (tmpl_ad->atype == template_type && args_ad->atype == template_type)
        {
            if (!sameTemplateSignature(&tmpl_ad->u.td->types, &args_ad->u.td->types, deep))
                return FALSE;
        }
        else if (!sameBaseType(tmpl_ad, args_ad))
            return FALSE;
    }

    return TRUE;
}


/*
 * Create a new variable.
 */
static void newVar(sipSpec *pt, moduleDef *mod, char *name, int isstatic,
        argDef *type, optFlags *of, codeBlock *acode, codeBlock *gcode,
        codeBlock *scode, int section)
{
    varDef *var;
    classDef *escope = currentScope();
    nameDef *nd;

    /*
     * For the moment we don't support capsule variables because it needs the
     * API major version increasing.
     */
    if (type->atype == capsule_type)
        yyerror("Capsule variables not yet supported");

    /* Check the section. */
    if (section != 0)
    {
        if ((section & SECT_IS_PUBLIC) == 0)
            yyerror("Class variables must be in the public section");

        if (!isstatic && acode != NULL)
            yyerror("%AccessCode cannot be specified for non-static class variables");
    }

    if (isstatic && pt->genc)
        yyerror("Cannot have static members in a C structure");

    if (gcode != NULL || scode != NULL)
    {
        if (acode != NULL)
            yyerror("Cannot mix %AccessCode and %GetCode or %SetCode");

        if (escope == NULL)
            yyerror("Cannot specify %GetCode or %SetCode for global variables");
    }

    applyTypeFlags(mod, type, of);

    nd = cacheName(pt, getPythonName(mod, of, name));

    if (inMainModule())
        setIsUsedName(nd);

    checkAttributes(pt, mod, escope, NULL, nd->text, FALSE);

    var = sipMalloc(sizeof (varDef));

    var->pyname = nd;
    var->fqcname = text2scopedName((escope != NULL ? escope->iff : NULL),
            name);
    var->ecd = escope;
    var->module = mod;
    var->varflags = 0;
    var->no_typehint = getNoTypeHint(of);
    var->platforms = currentPlatforms;
    var->type = *type;
    appendCodeBlock(&var->accessfunc, acode);
    appendCodeBlock(&var->getcode, gcode);
    appendCodeBlock(&var->setcode, scode);

    if (isstatic || (escope != NULL && escope->iff->type == namespace_iface))
        setIsStaticVar(var);

    if (getOptFlag(of, "NoSetter", bool_flag) != NULL)
        setNoSetter(var);

    addVariable(pt, var);
}


/*
 * Create a new ctor.
 */
static void newCtor(moduleDef *mod, char *name, int sectFlags,
        signatureDef *args, optFlags *optflgs, codeBlock *methodcode,
        throwArgs *exceptions, signatureDef *cppsig, int explicit,
        docstringDef *docstring, codeBlock *premethodcode)
{
    int a;
    ctorDef *ct, **ctp;
    classDef *cd = currentScope();

    /* Check the name of the constructor. */
    if (strcmp(classBaseName(cd), name) != 0)
        yyerror("Constructor doesn't have the same name as its class");

    /* Add to the list of constructors. */
    ct = sipMalloc(sizeof (ctorDef));

    if (sectFlags & SECT_IS_PROT && makeProtPublic)
    {
        sectFlags &= ~SECT_IS_PROT;
        sectFlags |= SECT_IS_PUBLIC;
    }

    /* Allow the signature to be used like an function signature. */
    memset(&args->result, 0, sizeof (argDef));
    args->result.atype = void_type;

    ct->docstring = docstring;
    ct->ctorflags = sectFlags;
    ct->no_typehint = getNoTypeHint(optflgs);
    ct->api_range = getAPIRange(optflgs);
    ct->pysig = *args;
    ct->cppsig = (cppsig != NULL ? cppsig : &ct->pysig);
    ct->exceptions = exceptions;
    ct->platforms = currentPlatforms;
    appendCodeBlock(&ct->methodcode, methodcode);
    appendCodeBlock(&ct->premethodcode, premethodcode);

    if (!isPrivateCtor(ct))
        setCanCreate(cd);

    if (isProtectedCtor(ct))
        setNeedsShadow(cd);

    if (explicit)
        setIsExplicitCtor(ct);

    getHooks(optflgs, &ct->prehook, &ct->posthook);

    if (getReleaseGIL(optflgs))
        setIsReleaseGILCtor(ct);
    else if (getHoldGIL(optflgs))
        setIsHoldGILCtor(ct);

    if (getTransfer(optflgs))
        setIsResultTransferredCtor(ct);

    if (getDeprecated(optflgs))
        setIsDeprecatedCtor(ct);

    if (!isPrivateCtor(ct))
        ct->kwargs = keywordArgs(mod, optflgs, &ct->pysig, FALSE);

    if (methodcode == NULL && getOptFlag(optflgs, "NoRaisesPyException", bool_flag) == NULL)
    {
        if (allRaisePyException(mod) || getOptFlag(optflgs, "RaisesPyException", bool_flag) != NULL)
            setRaisesPyExceptionCtor(ct);
    }

    if (getOptFlag(optflgs, "NoDerived", bool_flag) != NULL)
    {
        if (cppsig != NULL)
            yyerror("The /NoDerived/ annotation cannot be used with a C++ signature");

        if (methodcode == NULL)
            yyerror("The /NoDerived/ annotation must be used with %MethodCode");

        ct->cppsig = NULL;
    }

    if (getOptFlag(optflgs, "Default", bool_flag) != NULL)
    {
        if (cd->defctor != NULL)
            yyerror("A constructor with the /Default/ annotation has already been defined");

        cd->defctor = ct;
    }

    /* /Transfer/ arguments need the wrapper. */
    for (a = 0; a < ct->pysig.nrArgs; ++a)
    {
        argDef *ad = &ct->pysig.args[a];

        if (isTransferred(ad))
            setGetWrapper(ad);
    }

    /* Append to the list. */
    for (ctp = &cd->ctors; *ctp != NULL; ctp = &(*ctp)->next)
        ;

    *ctp = ct;
}


/*
 * Create a new function.
 */
static void newFunction(sipSpec *pt, moduleDef *mod, classDef *c_scope,
        ifaceFileDef *ns_scope, mappedTypeDef *mt_scope, int sflags,
        int isstatic, int issignal, int isslot, int isvirt, char *name,
        signatureDef *sig, int isconst, int isabstract, optFlags *optflgs,
        codeBlock *methodcode, codeBlock *vcode, codeBlock *virtcallcode,
        throwArgs *exceptions, signatureDef *cppsig, docstringDef *docstring,
        int isfinal, codeBlock *premethodcode)
{
    static const char *annos[] = {
        "__len__",
        "__imatmul__",
        "__matmul__",
        "AbortOnException",
        "AllowNone",
        "API",
        "AutoGen",
        "Deprecated",
        "DisallowNone",
        "DocType",
        "Encoding",
        "Factory",
        "HoldGIL",
        "KeywordArgs",
        "KeepReference",
        "NewThread",
        "NoArgParser",
        "NoCopy",
        "NoRaisesPyException",
        "NoTypeHint",
        "NoVirtualErrorHandler",
        "Numeric",
        "PostHook",
        "PreHook",
        "PyInt",
        "PyName",
        "PyQtSignalHack",
        "RaisesPyException",
        "ReleaseGIL",
        "Sequence",
        "VirtualErrorHandler",
        "Transfer",
        "TransferBack",
        "TransferThis",
        "TypeHint",
        NULL
    };

    const char *pyname, *virt_error_handler;
    int factory, xferback, no_arg_parser, no_virt_error_handler;
    overDef *od, **odp, **headp;
    optFlag *of;

    checkAnnos(optflgs, annos);

    /* Extra checks for a C module. */
    if (pt->genc)
    {
        if (c_scope != NULL)
            yyerror("Function declaration not allowed in a struct in a C module");

        if (isstatic)
            yyerror("Static functions not allowed in a C module");

        if (exceptions != NULL)
            yyerror("Exceptions not allowed in a C module");

        /* Handle C void prototypes. */
        if (sig->nrArgs == 1)
        {
            argDef *vad = &sig->args[0];

            if (vad->atype == void_type && vad->nrderefs == 0)
                sig->nrArgs = 0;
        }
    }

    if (mt_scope != NULL)
        headp = &mt_scope->overs;
    else if (c_scope != NULL)
        headp = &c_scope->overs;
    else
        headp = &mod->overs;

    /*
     * See if the function has a non-lazy method.  These are methods that
     * Python expects to see defined in the type before any instance of the
     * type is created.
     */
    if (c_scope != NULL)
    {
        static const char *lazy[] = {
            "__getattribute__",
            "__getattr__",
            "__enter__",
            "__exit__",
            "__aenter__",
            "__aexit__",
            NULL
        };

        const char **l;

        for (l = lazy; *l != NULL; ++l)
            if (strcmp(name, *l) == 0)
            {
                setHasNonlazyMethod(c_scope);
                break;
            }
    }

    /* See if it is a factory method. */
    if (getOptFlag(optflgs, "Factory", bool_flag) != NULL)
        factory = TRUE;
    else
    {
        int a;

        factory = FALSE;

        /* Check /TransferThis/ wasn't specified. */
        if (c_scope == NULL || isstatic)
            for (a = 0; a < sig->nrArgs; ++a)
                if (isThisTransferred(&sig->args[a]))
                    yyerror("/TransferThis/ may only be specified in constructors and class methods");
    }

    /* See if the result is to be returned to Python ownership. */
    xferback = (getOptFlag(optflgs, "TransferBack", bool_flag) != NULL);

    if (factory && xferback)
        yyerror("/TransferBack/ and /Factory/ cannot both be specified");

    /* Create a new overload definition. */

    od = sipMalloc(sizeof (overDef));

    getSourceLocation(&od->sloc);

    /* Set the overload flags. */

    if ((sflags & SECT_IS_PROT) && makeProtPublic)
    {
        sflags &= ~SECT_IS_PROT;
        sflags |= SECT_IS_PUBLIC | OVER_REALLY_PROT;
    }

    od->overflags = sflags;

    if (issignal)
    {
        resetIsSlot(od);
        setIsSignal(od);
    }
    else if (isslot)
    {
        resetIsSignal(od);
        setIsSlot(od);
    }

    od->no_typehint = getNoTypeHint(optflgs);

    if (isSignal(od))
        if ((of = getOptFlag(optflgs, "PyQtSignalHack", integer_flag)) != NULL)
            od->pyqt_signal_hack = of->fvalue.ival;

    if (factory)
        setIsFactory(od);

    if (xferback)
        setIsResultTransferredBack(od);

    if (getTransfer(optflgs))
        setIsResultTransferred(od);

    if (getOptFlag(optflgs, "TransferThis", bool_flag) != NULL)
        setIsThisTransferredMeth(od);

    if (methodcode == NULL && getOptFlag(optflgs, "NoRaisesPyException", bool_flag) == NULL)
    {
        if (allRaisePyException(mod) || getOptFlag(optflgs, "RaisesPyException", bool_flag) != NULL)
            setRaisesPyException(od);
    }

    if (isProtected(od))
        setNeedsShadow(c_scope);

    if ((isSlot(od) || isSignal(od)) && !isPrivate(od))
    {
        if (isSignal(od))
            setNeedsShadow(c_scope);

        pt->sigslots = TRUE;
    }

    if (isSignal(od) && (methodcode != NULL || vcode != NULL || virtcallcode != NULL))
        yyerror("Cannot provide code for signals");

    if (isstatic)
    {
        if (isSignal(od))
            yyerror("Static functions cannot be signals");

        if (isvirt)
            yyerror("Static functions cannot be virtual");

        setIsStatic(od);
    }

    if (isconst)
        setIsConst(od);

    if (isfinal)
        setIsFinal(od);

    if (isabstract)
    {
        if (sflags == 0)
            yyerror("Non-class function specified as abstract");

        setIsAbstract(od);
    }

    if ((of = getOptFlag(optflgs, "AutoGen", opt_name_flag)) != NULL)
    {
        if (of->fvalue.sval == NULL || isEnabledFeature(of->fvalue.sval))
            setIsAutoGen(od);
    }

    virt_error_handler = getVirtErrorHandler(optflgs);
    no_virt_error_handler = (getOptFlag(optflgs, "NoVirtualErrorHandler", bool_flag) != NULL);

    if (isvirt)
    {
        if (!isfinal)
        {
            setIsVirtual(od);
            setNeedsShadow(c_scope);
        }

        if (getOptFlag(optflgs, "AbortOnException", bool_flag) != NULL)
            setAbortOnException(od);

        if (no_virt_error_handler)
        {
            if (virt_error_handler != NULL)
                yyerror("/VirtualErrorHandler/ and /NoVirtualErrorHandler/ provided");

            setNoErrorHandler(od);
        }
        else
        {
            od->virt_error_handler = virt_error_handler;
        }
    }
    else
    {
        if (vcode != NULL)
            yyerror("%VirtualCatcherCode provided for non-virtual function");

        if (virt_error_handler != NULL)
            yyerror("/VirtualErrorHandler/ provided for non-virtual function");

        if (no_virt_error_handler)
            yyerror("/NoVirtualErrorHandler/ provided for non-virtual function");
    }

    od->cppname = name;
    od->pysig = *sig;
    od->cppsig = (cppsig != NULL ? cppsig : &od->pysig);
    od->exceptions = exceptions;
    od->platforms = currentPlatforms;
    appendCodeBlock(&od->methodcode, methodcode);
    appendCodeBlock(&od->premethodcode, premethodcode);
    appendCodeBlock(&od->virtcallcode, virtcallcode);
    appendCodeBlock(&od->virtcode, vcode);

    no_arg_parser = (getOptFlag(optflgs, "NoArgParser", bool_flag) != NULL);

    if (no_arg_parser)
    {
        if (methodcode == NULL)
            yyerror("%MethodCode must be supplied if /NoArgParser/ is specified");
    }
    else
    {
        /*
         * The argument parser requires that there is nothing after an
         * ellipsis.
         */
        checkEllipsis(sig);
    }

    if (cppsig != NULL)
        checkEllipsis(cppsig);

    if (getOptFlag(optflgs, "NoCopy", bool_flag) != NULL)
        setNoCopy(&od->pysig.result);

    if (getAllowNone(optflgs))
        setAllowNone(&od->pysig.result);

    if (getDisallowNone(optflgs))
        setDisallowNone(&od->pysig.result);

    handleKeepReference(optflgs, &od->pysig.result, mod);

    pyname = getPythonName(mod, optflgs, name);

    od->common = findFunction(pt, mod, c_scope, ns_scope, mt_scope, pyname,
            (methodcode != NULL), sig->nrArgs, no_arg_parser);

    if (isProtected(od))
        setHasProtected(od->common);

    if (strcmp(pyname, "__delattr__") == 0)
        setIsDelattr(od);

    od->docstring = docstring;

    od->api_range = getAPIRange(optflgs);

    if (od->api_range == NULL)
        setNotVersioned(od->common);

    if (getOptFlag(optflgs, "Numeric", bool_flag) != NULL)
    {
        if (isSequence(od->common))
            yyerror("/Sequence/ has already been specified");

        setIsNumeric(od->common);
    }

    if (getOptFlag(optflgs, "Sequence", bool_flag) != NULL)
    {
        if (isNumeric(od->common))
            yyerror("/Numeric/ has already been specified");

        setIsSequence(od->common);
    }

    /* Methods that run in new threads must be virtual. */
    if (getOptFlag(optflgs, "NewThread", bool_flag) != NULL)
    {
        argDef *res;

        if (!isvirt)
            yyerror("/NewThread/ may only be specified for virtual functions");

        /*
         * This is an arbitary limitation to make the code generator slightly
         * easier - laziness on my part.
         */
        res = &od->cppsig->result;

        if (res->atype != void_type || res->nrderefs != 0)
            yyerror("/NewThread/ may only be specified for void functions");

        setIsNewThread(od);
    }

    getHooks(optflgs, &od->prehook, &od->posthook);

    if (getReleaseGIL(optflgs))
        setIsReleaseGIL(od);
    else if (getHoldGIL(optflgs))
        setIsHoldGIL(od);

    if (getDeprecated(optflgs))
        setIsDeprecated(od);

    if (!isPrivate(od) && (od->common->slot == no_slot || od->common->slot == call_slot))
    {
        od->kwargs = keywordArgs(mod, optflgs, &od->pysig, hasProtected(od->common));

        if (od->kwargs != NoKwArgs)
            setUseKeywordArgs(od->common);

        /*
         * If the overload is protected and defined in an imported module then
         * we need to make sure that any other overloads' keyword argument
         * names are marked as used.
         */
        if (!isSignal(od) && isProtected(od) && !inMainModule())
        {
            overDef *kwod;

            for (kwod = c_scope->overs; kwod != NULL; kwod = kwod->next)
                if (kwod->common == od->common && kwod->kwargs != NoKwArgs)
                {
                    int a;

                    for (a = 0; a < kwod->pysig.nrArgs; ++a)
                    {
                        argDef *ad = &kwod->pysig.args[a];

                        if (kwod->kwargs == OptionalKwArgs && ad->defval == NULL)
                            continue;

                        if (ad->name != NULL)
                            setIsUsedName(ad->name);
                    }
                }
        }
    }

    od->next = NULL;

    /* See if we want to auto-generate some methods. */
    if (getOptFlag(optflgs, "__len__", bool_flag) != NULL)
    {
        overDef *len;

        len = sipMalloc(sizeof (overDef));

        len->cppname = "__len__";
        len->overflags = SECT_IS_PUBLIC;
        len->pysig.result.atype = ssize_type;
        len->pysig.nrArgs = 0;
        len->cppsig = &len->pysig;

        if ((len->methodcode = od->methodcode) == NULL)
        {
            char *buf = sipStrdup("            sipRes = (SIP_SSIZE_T)sipCpp->");
            codeBlock *code;

            append(&buf, od->cppname);
            append(&buf, "();\n");

            code = sipMalloc(sizeof (codeBlock));

            code->frag = buf;
            code->filename = "Auto-generated";
            code->linenr = 1;

            appendCodeBlock(&len->methodcode, code);
        }

        len->common = findFunction(pt, mod, c_scope, ns_scope, mt_scope,
                len->cppname, TRUE, 0, FALSE);

        len->platforms = od->platforms;
        len->next = od->next;
        od->next = len;
    }

    if (getOptFlag(optflgs, "__matmul__", bool_flag) != NULL)
    {
        overDef *matmul;

        matmul = sipMalloc(sizeof (overDef));

        matmul->cppname = "__matmul__";
        matmul->overflags = SECT_IS_PUBLIC;
        matmul->pysig = od->pysig;
        matmul->cppsig = (cppsig != NULL ? cppsig : &matmul->pysig);

        matmul->methodcode = od->methodcode;

        matmul->common = findFunction(pt, mod, c_scope, ns_scope, mt_scope,
                matmul->cppname, (matmul->methodcode != NULL),
                matmul->pysig.nrArgs, FALSE);

        matmul->platforms = od->platforms;
        matmul->next = od->next;
        od->next = matmul;
    }

    if (getOptFlag(optflgs, "__imatmul__", bool_flag) != NULL)
    {
        overDef *imatmul;

        imatmul = sipMalloc(sizeof (overDef));

        imatmul->cppname = "__imatmul__";
        imatmul->overflags = SECT_IS_PUBLIC;
        imatmul->pysig = od->pysig;
        imatmul->cppsig = (cppsig != NULL ? cppsig : &imatmul->pysig);

        imatmul->methodcode = od->methodcode;

        imatmul->common = findFunction(pt, mod, c_scope, ns_scope, mt_scope,
                imatmul->cppname, (imatmul->methodcode != NULL),
                imatmul->pysig.nrArgs, FALSE);

        imatmul->platforms = od->platforms;
        imatmul->next = od->next;
        od->next = imatmul;
    }

    /* Append to the list. */
    for (odp = headp; *odp != NULL; odp = &(*odp)->next)
        ;

    *odp = od;
}


/*
 * Return the Python name based on the C/C++ name and any /PyName/ annotation.
 */
static const char *getPythonName(moduleDef *mod, optFlags *optflgs,
        const char *cname)
{
    const char *pname;
    optFlag *of;
    autoPyNameDef *apnd;

    /* Use the explicit name if given. */
    if ((of = getOptFlag(optflgs, "PyName", name_flag)) != NULL)
        return of->fvalue.sval;

    /* Apply any automatic naming rules. */
    pname = cname;

    for (apnd = mod->autopyname; apnd != NULL; apnd = apnd->next)
    {
        size_t len = strlen(apnd->remove_leading);

        if (strncmp(pname, apnd->remove_leading, len) == 0)
            pname += len;
    }

    return pname;
}


/*
 * Cache a name in a module.  Entries in the cache are stored in order of
 * decreasing length.
 */
nameDef *cacheName(sipSpec *pt, const char *name)
{
    nameDef *nd, **ndp;
    size_t len;

    /* Allow callers to be lazy about checking if there is really a name. */
    if (name == NULL)
        return NULL;

    /* Skip entries that are too large. */
    ndp = &pt->namecache;
    len = strlen(name);

    while (*ndp != NULL && (*ndp)->len > len)
        ndp = &(*ndp)->next;

    /* Check entries that are the right length. */
    for (nd = *ndp; nd != NULL && nd->len == len; nd = nd->next)
        if (memcmp(nd->text, name, len) == 0)
            return nd;

    /* Create a new one. */
    nd = sipMalloc(sizeof (nameDef));

    nd->nameflags = 0;
    nd->text = name;
    nd->len = len;
    nd->next = *ndp;

    *ndp = nd;

    return nd;
}


/*
 * Find (or create) an overloaded function name.
 */
static memberDef *findFunction(sipSpec *pt, moduleDef *mod, classDef *c_scope,
        ifaceFileDef *ns_scope, mappedTypeDef *mt_scope, const char *pname,
        int hwcode, int nrargs, int no_arg_parser)
{
    static struct slot_map {
        const char *name;   /* The slot name. */
        slotType type;      /* The corresponding type. */
        int needs_hwcode;   /* Set if handwritten code is required. */
        int nrargs;         /* Nr. of arguments. */
    } slot_table[] = {
        {"__str__", str_slot, TRUE, 0},
        {"__int__", int_slot, FALSE, 0},
        {"__long__", long_slot, FALSE, 0},
        {"__float__", float_slot, FALSE, 0},
        {"__len__", len_slot, TRUE, 0},
        {"__contains__", contains_slot, TRUE, 1},
        {"__add__", add_slot, FALSE, 1},
        {"__sub__", sub_slot, FALSE, 1},
        {"__mul__", mul_slot, FALSE, 1},
        {"__div__", div_slot, FALSE, 1},
        {"__mod__", mod_slot, FALSE, 1},
        {"__floordiv__", floordiv_slot, TRUE, 1},
        {"__truediv__", truediv_slot, FALSE, 1},
        {"__and__", and_slot, FALSE, 1},
        {"__or__", or_slot, FALSE, 1},
        {"__xor__", xor_slot, FALSE, 1},
        {"__lshift__", lshift_slot, FALSE, 1},
        {"__rshift__", rshift_slot, FALSE, 1},
        {"__iadd__", iadd_slot, FALSE, 1},
        {"__isub__", isub_slot, FALSE, 1},
        {"__imul__", imul_slot, FALSE, 1},
        {"__idiv__", idiv_slot, FALSE, 1},
        {"__imod__", imod_slot, FALSE, 1},
        {"__ifloordiv__", ifloordiv_slot, TRUE, 1},
        {"__itruediv__", itruediv_slot, FALSE, 1},
        {"__iand__", iand_slot, FALSE, 1},
        {"__ior__", ior_slot, FALSE, 1},
        {"__ixor__", ixor_slot, FALSE, 1},
        {"__ilshift__", ilshift_slot, FALSE, 1},
        {"__irshift__", irshift_slot, FALSE, 1},
        {"__invert__", invert_slot, FALSE, 0},
        {"__call__", call_slot, FALSE, -1},
        {"__getitem__", getitem_slot, FALSE, 1},
        {"__setitem__", setitem_slot, TRUE, 2},
        {"__delitem__", delitem_slot, TRUE, 1},
        {"__lt__", lt_slot, FALSE, 1},
        {"__le__", le_slot, FALSE, 1},
        {"__eq__", eq_slot, FALSE, 1},
        {"__ne__", ne_slot, FALSE, 1},
        {"__gt__", gt_slot, FALSE, 1},
        {"__ge__", ge_slot, FALSE, 1},
        {"__cmp__", cmp_slot, FALSE, 1},
        {"__bool__", bool_slot, TRUE, 0},
        {"__nonzero__", bool_slot, TRUE, 0},
        {"__neg__", neg_slot, FALSE, 0},
        {"__pos__", pos_slot, FALSE, 0},
        {"__abs__", abs_slot, TRUE, 0},
        {"__repr__", repr_slot, TRUE, 0},
        {"__hash__", hash_slot, TRUE, 0},
        {"__index__", index_slot, TRUE, 0},
        {"__iter__", iter_slot, TRUE, 0},
        {"__next__", next_slot, TRUE, 0},
        {"__setattr__", setattr_slot, TRUE, 2},
        {"__delattr__", delattr_slot, TRUE, 1},
        {"__matmul__", matmul_slot, FALSE, 1},
        {"__imatmul__", imatmul_slot, FALSE, 1},
        {"__await__", await_slot, TRUE, 0},
        {"__aiter__", aiter_slot, TRUE, 0},
        {"__anext__", anext_slot, TRUE, 0},
        {NULL, no_slot, FALSE, 0}
    };

    memberDef *md, **flist;
    struct slot_map *sm;
    slotType st;

    /* Get the slot type. */
    st = no_slot;

    for (sm = slot_table; sm->name != NULL; ++sm)
        if (strcmp(sm->name, pname) == 0)
        {
            if (sm->needs_hwcode && !hwcode)
                yyerror("This Python slot requires %MethodCode");

            if (sm->nrargs >= 0)
            {
                if (mt_scope == NULL && c_scope == NULL)
                {
                    /* Global operators need one extra argument. */
                    if (sm -> nrargs + 1 != nrargs)
                        yyerror("Incorrect number of arguments to global operator");
                }
                else if (sm->nrargs != nrargs)
                    yyerror("Incorrect number of arguments to Python slot");
            }

            st = sm->type;

            break;
        }

    /* Check there is no name clash. */
    checkAttributes(pt, mod, c_scope, mt_scope, pname, TRUE);

    /* See if it already exists. */
    if (mt_scope != NULL)
        flist = &mt_scope->members;
    else if (c_scope != NULL)
        flist = &c_scope->members;
    else
        flist = &mod->othfuncs;

    /* __delattr__ is implemented as __setattr__. */
    if (st == delattr_slot)
    {
        if (inMainModule())
            setIsUsedName(cacheName(pt, pname));

        st = setattr_slot;
        pname = "__setattr__";
    }

    for (md = *flist; md != NULL; md = md->next)
        if (strcmp(md->pyname->text, pname) == 0 && md->module == mod)
            break;

    if (md == NULL)
    {
        /* Create a new one. */
        md = sipMalloc(sizeof (memberDef));

        md->pyname = cacheName(pt, pname);
        md->memberflags = 0;
        md->slot = st;
        md->module = mod;
        md->ns_scope = ns_scope;
        md->next = *flist;

        *flist = md;

        if (inMainModule())
            setIsUsedName(md->pyname);

        if (no_arg_parser)
            setNoArgParser(md);
    }
    else if (noArgParser(md))
        yyerror("Another overload has already been defined that is annotated as /NoArgParser/");

    /* Global operators are a subset. */
    if (mt_scope == NULL && c_scope == NULL && st != no_slot && st != neg_slot && st != pos_slot && !isNumberSlot(md) && !isInplaceNumberSlot(md) && !isRichCompareSlot(md))
        yyerror("Global operators must be either numeric or comparison operators");

    return md;
}


/*
 * Search a set of flags for a particular one.
 */
static optFlag *findOptFlag(optFlags *flgs, const char *name)
{
    int f;

    for (f = 0; f < flgs->nrFlags; ++f)
    {
        optFlag *of = &flgs->flags[f];

        if (strcmp(of->fname, name) == 0)
            return of;
    }

    return NULL;
}


/*
 * Search a set of flags for a particular one and check its type.
 */
static optFlag *getOptFlag(optFlags *flgs, const char *name, flagType ft)
{
    optFlag *of = findOptFlag(flgs, name);

    if (of != NULL)
    {
        /* An optional name can look like a boolean or a name. */
        if (ft == opt_name_flag)
        {
            if (of->ftype == bool_flag)
            {
                of->ftype = opt_name_flag;
                of->fvalue.sval = NULL;
            }
            else if (of->ftype == name_flag)
            {
                of->ftype = opt_name_flag;
            }
        }

        /* An optional integer can look like a boolean or an integer. */
        if (ft == opt_integer_flag)
        {
            if (of->ftype == bool_flag)
            {
                of->ftype = opt_integer_flag;
                of->fvalue.ival = -1;
            }
            else if (of->ftype == integer_flag)
            {
                of->ftype = opt_integer_flag;
            }
        }

        /* A string list will look like a string. */
        if (ft == string_list_flag && of->ftype == string_flag)
        {
            char *s;

            s = of->fvalue.sval;
            of->fvalue.slval = NULL;

            while (*s != '\0')
            {
                char *start;

                while (*s == ' ')
                    ++s;

                start = s;

                if (*start != '\0')
                {
                    char saved, *end;

                    for (end = start + 1; *end != ' ' && *end != '\0'; ++end)
                        ;

                    saved = *end;
                    *end = '\0';

                    appendString(&of->fvalue.slval, start);

                    *end = saved;
                    s = end;
                }
            }

            of->ftype = string_list_flag;
        }

        if (ft != of->ftype)
            yyerror("Annotation has a value of the wrong type");
    }

    return of;
}


/*
 * A name is going to be used as a Python attribute name within a Python scope
 * (ie. a Python dictionary), so check against what we already know is going in
 * the same scope in case there is a clash.
 */
static void checkAttributes(sipSpec *pt, moduleDef *mod, classDef *py_c_scope,
        mappedTypeDef *py_mt_scope, const char *attr, int isfunc)
{
    enumDef *ed;
    varDef *vd;
    classDef *cd;

    /* We don't do any check for a non-strict parse. */
    if (!strictParse)
        return;

    /* Check the enums. */
    for (ed = pt->enums; ed != NULL; ed = ed->next)
    {
        if (ed->pyname == NULL)
            continue;

        if (py_c_scope != NULL)
        {
            if (ed->ecd != py_c_scope)
                continue;
        }
        else if (py_mt_scope != NULL)
        {
            if (ed->emtd != py_mt_scope)
                continue;
        }
        else if (ed->ecd != NULL || ed->emtd != NULL)
        {
            continue;
        }

        if (strcmp(ed->pyname->text, attr) == 0)
            yyerror("There is already an enum in scope with the same Python name");

        if (!isScopedEnum(ed))
        {
            enumMemberDef *emd;

            for (emd = ed->members; emd != NULL; emd = emd->next)
                if (strcmp(emd->pyname->text, attr) == 0)
                    yyerror("There is already an enum member in scope with the same Python name");
        }
    }

    /*
     * Only check the members if this attribute isn't a member because we can
     * handle members with the same name in the same scope.
     */
    if (!isfunc)
    {
        memberDef *md, *membs;
        overDef *overs;

        if (py_mt_scope != NULL)
        {
            membs = py_mt_scope->members;
            overs = py_mt_scope->overs;
        }
        else if (py_c_scope != NULL)
        {
            membs = py_c_scope->members;
            overs = py_c_scope->overs;
        }
        else
        {
            membs = mod->othfuncs;
            overs = mod->overs;
        }

        for (md = membs; md != NULL; md = md->next)
        {
            overDef *od;

            if (strcmp(md->pyname->text, attr) != 0)
                continue;

            /* Check for a conflict with all overloads. */
            for (od = overs; od != NULL; od = od->next)
            {
                if (od->common != md)
                    continue;

                yyerror("There is already a function in scope with the same Python name");
            }
        }
    }

    /* If the scope was a mapped type then that's all we have to check. */
    if (py_mt_scope != NULL)
        return;

    /* Check the variables. */
    for (vd = pt->vars; vd != NULL; vd = vd->next)
    {
        if (vd->ecd != py_c_scope)
            continue;

        if (strcmp(vd->pyname->text,attr) == 0)
            yyerror("There is already a variable in scope with the same Python name");
    }

    /* Check the classes. */
    for (cd = pt->classes; cd != NULL; cd = cd->next)
    {
        if (cd->ecd != py_c_scope || cd->pyname == NULL)
            continue;

        if (strcmp(cd->pyname->text, attr) == 0 && !isExternal(cd))
            yyerror("There is already a class or namespace in scope with the same Python name");
    }

    /* Check the exceptions. */
    if (py_c_scope == NULL)
    {
        exceptionDef *xd;

        for (xd = pt->exceptions; xd != NULL; xd = xd->next)
            if (xd->pyname != NULL && strcmp(xd->pyname, attr) == 0)
                yyerror("There is already an exception with the same Python name");
    }

    /* Check the properties. */
    if (py_c_scope != NULL)
    {
        propertyDef *pd;

        for (pd = py_c_scope->properties; pd != NULL; pd = pd->next)
            if (strcmp(pd->name->text, attr) == 0)
                yyerror("There is already a property with the same name");
    }
}


/*
 * Append a code block to a list of them.
 */
static void appendCodeBlock(codeBlockList **headp, codeBlock *cb)
{
    codeBlockList *cbl;

    /* Handle the trivial case. */
    if (cb == NULL)
        return;

    /* Find the end of the list. */
    while (*headp != NULL)
    {
        /* Ignore if the block is already in the list. */
        if ((*headp)->block == cb)
            return;

        headp = &(*headp)->next;
    }

    cbl = sipMalloc(sizeof (codeBlockList));
    cbl->block = cb;

    *headp = cbl;
}


/*
 * Append a code block list to an existing list.
 */
void appendCodeBlockList(codeBlockList **headp, codeBlockList *cbl)
{
    while (cbl != NULL)
    {
        appendCodeBlock(headp, cbl->block);
        cbl = cbl->next;
    }
}


/*
 * Handle the end of a fully parsed a file.
 */
static void handleEOF()
{
    /*
     * Check that the number of nested if's is the same as when we started
     * the file.
     */

    if (stackPtr > currentContext.ifdepth)
        fatal("Too many %%If statements in %s\n", previousFile);

    if (stackPtr < currentContext.ifdepth)
        fatal("Too many %%End statements in %s\n", previousFile);
}


/*
 * Handle the end of a fully parsed a module.
 */
static void handleEOM()
{
    moduleDef *from;

    /* Check it has been named. */
    if (currentModule->name == NULL)
        fatal("No %%Module has been specified for module defined in %s\n",
                previousFile);

    from = currentContext.prevmod;

    if (from != NULL)
    {
        if (from->encoding == no_type)
            from->encoding = currentModule->encoding;

        if (isCallSuperInitUndefined(from))
        {
            if (isCallSuperInitYes(currentModule))
                setCallSuperInitYes(from);
            else
                setCallSuperInitNo(from);
        }
    }

    /* The previous module is now current. */
    currentModule = from;
}


/*
 * Find an existing qualifier.
 */
static qualDef *findQualifier(const char *name)
{
    moduleDef *mod;

    for (mod = currentSpec->modules; mod != NULL; mod = mod->next)
    {
        qualDef *qd;

        for (qd = mod->qualifiers; qd != NULL; qd = qd->next)
            if (strcmp(qd->name, name) == 0)
                return qd;
    }

    /* Qualifiers corresponding to the SIP version are created on the fly. */
    if (name[0] == 'S' && name[1] == 'I' && name[2] == 'P' && name[3] == '_')
    {
        const char *cp = &name[3];
        int major, minor, patch;

        cp = getInt(cp, &major);
        cp = getInt(cp, &minor);
        cp = getInt(cp, &patch);

        if (*cp != '\0')
            yyerror("Unexpected character after SIP version number");

        return allocQualifier(currentModule, -1,
                (major << 16) | (minor << 8) | patch, TRUE, name,
                time_qualifier);
    }

    return NULL;
}


/*
 * Get an integer from string.
 */
static const char *getInt(const char *cp, int *ip)
{
    /* Handle the default value. */
    *ip = 0;

    if (*cp == '\0')
        return cp;

    /* There must be a leading underscore. */
    if (*cp++ != '_')
        yyerror("An underscore must separate the parts of a SIP version number");

    while (isdigit(*cp))
    {
        *ip *= 10;
        *ip += *cp - '0';
        ++cp;
    }

    return cp;
}


/*
 * Find an existing API.
 */
apiVersionRangeDef *findAPI(sipSpec *pt, const char *name)
{
    moduleDef *mod;

    for (mod = pt->modules; mod != NULL; mod = mod->next)
    {
        apiVersionRangeDef *avd;

        for (avd = mod->api_versions; avd != NULL; avd = avd->next)
            if (strcmp(avd->api_name->text, name) == 0)
                return avd;
    }

    return NULL;
}


/*
 * Return a copy of a scoped name.
 */
scopedNameDef *copyScopedName(scopedNameDef *snd)
{
    scopedNameDef *head;

    head = NULL;

    while (snd != NULL)
    {
        appendScopedName(&head,text2scopePart(snd -> name));
        snd = snd -> next;
    }

    return head;
}


/*
 * Append a name to a list of scopes.
 */
void appendScopedName(scopedNameDef **headp,scopedNameDef *newsnd)
{
    while (*headp != NULL)
        headp = &(*headp) -> next;

    *headp = newsnd;
}


/*
 * Free a scoped name - but not the text itself.
 */
void freeScopedName(scopedNameDef *snd)
{
    while (snd != NULL)
    {
        scopedNameDef *next = snd -> next;

        free(snd);

        snd = next;
    }
}


/*
 * Convert a text string to a scope part structure.
 */
scopedNameDef *text2scopePart(char *text)
{
    scopedNameDef *snd;

    snd = sipMalloc(sizeof (scopedNameDef));

    snd->name = text;
    snd->next = NULL;

    return snd;
}


/*
 * Convert a text string to a fully scoped name.
 */
static scopedNameDef *text2scopedName(ifaceFileDef *scope, char *text)
{
    return scopeScopedName(scope, text2scopePart(text));
}


/*
 * Prepend any current scope to a scoped name.
 */
static scopedNameDef *scopeScopedName(ifaceFileDef *scope, scopedNameDef *name)
{
    scopedNameDef *snd;

    snd = (scope != NULL ? copyScopedName(scope->fqcname) : text2scopePart(""));

    appendScopedName(&snd, name);

    return snd;
}


/*
 * Return a pointer to the tail part of a scoped name.
 */
char *scopedNameTail(scopedNameDef *snd)
{
    if (snd == NULL)
        return NULL;

    while (snd->next != NULL)
        snd = snd->next;

    return snd->name;
}


/*
 * Push the given scope onto the scope stack.
 */
static void pushScope(classDef *scope)
{
    if (currentScopeIdx >= MAX_NESTED_SCOPE)
        fatal("Internal error: increase the value of MAX_NESTED_SCOPE\n");

    scopeStack[currentScopeIdx] = scope;
    sectFlagsStack[currentScopeIdx] = sectionFlags;

    ++currentScopeIdx;
}


/*
 * Pop the scope stack.
 */
static void popScope(void)
{
    if (currentScopeIdx > 0)
        sectionFlags = sectFlagsStack[--currentScopeIdx];
}


/*
 * Return non-zero if the current input should be parsed rather than be
 * skipped.
 */
static int notSkipping()
{
    return (stackPtr == 0 ? TRUE : skipStack[stackPtr - 1]);
}


/*
 * Return the value of an expression involving a time period.
 */
static int timePeriod(const char *lname, const char *uname)
{
    int line;
    qualDef *qd, *lower, *upper;
    moduleDef *mod;

    if (lname == NULL)
        lower = NULL;
    else if ((lower = findQualifier(lname)) == NULL || lower->qtype != time_qualifier)
        yyerror("Lower bound is not a time version");

    if (uname == NULL)
        upper = NULL;
    else if ((upper = findQualifier(uname)) == NULL || upper->qtype != time_qualifier)
        yyerror("Upper bound is not a time version");

    /* Sanity checks on the bounds. */
    if (lower == NULL && upper == NULL)
        yyerror("Lower and upper bounds cannot both be omitted");

    if (lower != NULL && upper != NULL)
    {
        if (lower->module != upper->module || lower->line != upper->line)
            yyerror("Lower and upper bounds are from different timelines");

        if (lower == upper)
            yyerror("Lower and upper bounds must be different");

        if (lower->order > upper->order)
            yyerror("Later version specified as lower bound");
    }

    /* Go through each slot in the relevant timeline. */
    if (lower != NULL)
    {
        mod = lower->module;
        line = lower->line;
    }
    else
    {
        mod = upper->module;
        line = upper->line;
    }

    /* Handle the SIP version number pseudo-timeline. */
    if (line < 0)
    {
        if (lower != NULL && SIP_VERSION < lower->order)
            return FALSE;

        if (upper != NULL && SIP_VERSION >= upper->order)
            return FALSE;

        return TRUE;
    }

    for (qd = mod->qualifiers; qd != NULL; qd = qd->next)
    {
        if (qd->qtype != time_qualifier || qd->line != line)
            continue;

        if (selectedQualifier(neededQualifiers, qd))
        {
            if (lower != NULL && qd->order < lower->order)
                return FALSE;

            if (upper != NULL && qd->order >= upper->order)
                return FALSE;

            return TRUE;
        }
    }

    /*
     * If there is no upper bound then assume the expression is true unless
     * the lower bound is a backstop.
     */
    if (upper == NULL)
        return !isBackstop(lower);

    /*
     * If the upper limit corresponds to a backstop then assume the expression
     * is true.
     */
    return isBackstop(upper);
}


/*
 * See if a qualifier is a backstop.
 */
static int isBackstop(qualDef *qd)
{
    stringList *sl;

    for (sl = backstops; sl != NULL; sl = sl->next)
        if (strcmp(qd->name, sl->s) == 0)
            return TRUE;

    return FALSE;
}


/*
 * Return the value of an expression involving a single platform or feature.
 */
static int platOrFeature(char *name, int optnot)
{
    int this;
    qualDef *qd;

    if ((qd = findQualifier(name)) == NULL || qd->qtype == time_qualifier)
        yyerror("No such platform or feature");

    /* Assume this sub-expression is false. */

    this = FALSE;

    if (qd->qtype == feature_qualifier)
    {
        if (!excludedFeature(excludedQualifiers, qd))
            this = TRUE;
    }
    else
    {
        if (!strictParse)
        {
            if (optnot)
            {
                moduleDef *mod;

                /* Add every platform except the one we have. */
                for (mod = currentSpec->modules; mod != NULL; mod = mod->next)
                {
                    qualDef *not_qd;

                    for (not_qd = mod->qualifiers; not_qd != NULL; not_qd = not_qd->next)
                        if (not_qd->qtype == platform_qualifier && strcmp(not_qd->name, qd->name) != 0)
                            addPlatform(not_qd);
                }
            }
            else
            {
                addPlatform(qd);
            }

            /*
             * If it is a non-strict parse then this is always TRUE, ie. we
             * never skip because of the platform.
             */
            return TRUE;
        }

        if (selectedQualifier(neededQualifiers, qd))
            this = TRUE;
    }

    if (optnot)
        this = !this;

    return this;
}


/*
 * Add a platform to the current list of platforms if it is not already there.
 */
static void addPlatform(qualDef *qd)
{
    platformDef *pd;

    for (pd = currentPlatforms; pd != NULL; pd = pd->next)
        if (pd->qualifier == qd)
            return;

    pd = sipMalloc(sizeof (platformDef));
    pd->qualifier = qd;
    pd->next = currentPlatforms;
    currentPlatforms = pd;
}


/*
 * Return TRUE if the given qualifier is excluded.
 */
int excludedFeature(stringList *xsl, qualDef *qd)
{
    while (xsl != NULL)
    {
        if (strcmp(qd->name, xsl->s) == 0)
            return TRUE;

        xsl = xsl->next;
    }

    return !qd->default_enabled;
}


/*
 * Return TRUE if the given qualifier is needed.
 */
int selectedQualifier(stringList *needed_qualifiers, qualDef *qd)
{
    stringList *sl;

    for (sl = needed_qualifiers; sl != NULL; sl = sl->next)
        if (strcmp(qd->name, sl->s) == 0)
            return qd->default_enabled;

    return FALSE;
}


/*
 * Return the current scope.  currentScope() is only valid if notSkipping()
 * returns non-zero.
 */
static classDef *currentScope(void)
{
    return (currentScopeIdx > 0 ? scopeStack[currentScopeIdx - 1] : NULL);
}


/*
 * Create a new qualifier.
 */
static void newQualifier(moduleDef *mod, int line, int order,
        int default_enabled, const char *name, qualType qt)
{
    qualDef *qd;

    /* See if it already exists. */
    if ((qd = findQualifier(name)) != NULL)
    {
        /*
         * We allow versions to be defined more than once so long as they are
         * in different timelines.  It is sometimes necessary to define the
         * same timeline in multiple modules if a module that others depend on
         * is added during the timeline (eg. QtWebEngineCore).
         */
        if (qd->qtype != time_qualifier || qt != time_qualifier || (qd->module == mod && qd->line == line))
            yyerror("Version is already defined");
    }

    allocQualifier(mod, line, order, default_enabled, name, qt);
}


/*
 * Allocate a new qualifier.
 */
static qualDef *allocQualifier(moduleDef *mod, int line, int order,
        int default_enabled, const char *name, qualType qt)
{
    qualDef *qd;

    qd = sipMalloc(sizeof (qualDef));

    qd->name = name;
    qd->qtype = qt;
    qd->module = mod;
    qd->line = line;
    qd->order = order;
    qd->default_enabled = default_enabled;
    qd->next = mod->qualifiers;

    mod->qualifiers = qd;

    return qd;
}


/*
 * Create a new imported module.
 */
static void newImport(const char *filename)
{
    moduleDef *from, *mod;
    moduleListDef *mld;

    /* Create a new module if it has not already been defined. */
    for (mod = currentSpec->modules; mod != NULL; mod = mod->next)
        if (strcmp(mod->file, filename) == 0)
            break;

    from = currentModule;

    if (mod == NULL)
    {
        newModule(NULL, filename);
        mod = currentModule;
    }
    else if (from->encoding == no_type)
    {
        /* Import any defaults from the already parsed module. */
        from->encoding = mod->encoding;
    }

    /* Add the new import unless it has already been imported. */
    for (mld = from->imports; mld != NULL; mld = mld->next)
        if (mld->module == mod)
            return;

    mld = sipMalloc(sizeof (moduleListDef));
    mld->module = mod;
    mld->next = from->imports;

    from->imports = mld;
}


/*
 * Set up pointers to hook names.
 */
static void getHooks(optFlags *optflgs,char **pre,char **post)
{
    optFlag *of;

    if ((of = getOptFlag(optflgs,"PreHook",name_flag)) != NULL)
        *pre = of -> fvalue.sval;
    else
        *pre = NULL;

    if ((of = getOptFlag(optflgs,"PostHook",name_flag)) != NULL)
        *post = of -> fvalue.sval;
    else
        *post = NULL;
}


/*
 * Get the /Transfer/ option flag.
 */
static int getTransfer(optFlags *optflgs)
{
    return (getOptFlag(optflgs, "Transfer", bool_flag) != NULL);
}


/*
 * Get the /ReleaseGIL/ option flag.
 */
static int getReleaseGIL(optFlags *optflgs)
{
    return (getOptFlag(optflgs, "ReleaseGIL", bool_flag) != NULL);
}


/*
 * Get the /HoldGIL/ option flag.
 */
static int getHoldGIL(optFlags *optflgs)
{
    return (getOptFlag(optflgs, "HoldGIL", bool_flag) != NULL);
}


/*
 * Get the /Deprecated/ option flag.
 */
static int getDeprecated(optFlags *optflgs)
{
    return (getOptFlag(optflgs, "Deprecated", bool_flag) != NULL);
}


/*
 * Get the /AllowNone/ option flag.
 */
static int getAllowNone(optFlags *optflgs)
{
    return (getOptFlag(optflgs, "AllowNone", bool_flag) != NULL);
}


/*
 * Get the /DisallowNone/ option flag.
 */
static int getDisallowNone(optFlags *optflgs)
{
    return (getOptFlag(optflgs, "DisallowNone", bool_flag) != NULL);
}


/*
 * Get the /VirtualErrorHandler/ option flag.
 */
static const char *getVirtErrorHandler(optFlags *optflgs)
{
    optFlag *of = getOptFlag(optflgs, "VirtualErrorHandler", name_flag);

    if (of == NULL)
        return NULL;

    return of->fvalue.sval;
}


/*
 * Get the /DocType/ option flag.
 */
static const char *getDocType(optFlags *optflgs)
{
    optFlag *of = getOptFlag(optflgs, "DocType", string_flag);

    if (of == NULL)
        return NULL;

    deprecated("/DocType/ is deprecated\n");

    return of->fvalue.sval;
}


/*
 * Get the /TypeHintValue/ option flag.
 */
static const char *getTypeHintValue(optFlags *optflgs)
{
    optFlag *of = getOptFlag(optflgs, "TypeHintValue", string_flag);

    if (of != NULL)
        return of->fvalue.sval;

    if ((of = getOptFlag(optflgs, "DocValue", string_flag)) != NULL)
    {
        deprecated("/DocValue/ is deprecated\n");

        return of->fvalue.sval;
    }

    return NULL;
}


/*
 * Get the /TypeHint/, /TypeHintIn/ and /TypeHintOut/ option flags.
 */
static void getTypeHints(optFlags *optflgs, typeHintDef **in,
        typeHintDef **out)
{
    optFlag *of;
    typeHintDef *thd;

    if ((of = getOptFlag(optflgs, "TypeHint", string_flag)) != NULL)
        thd = newTypeHint(of->fvalue.sval);
    else
        thd = NULL;

    if ((of = getOptFlag(optflgs, "TypeHintIn", string_flag)) != NULL)
    {
        if (thd != NULL)
            yywarning("/TypeHintIn/ overrides /TypeHint/");

        *in = newTypeHint(of->fvalue.sval);
    }
    else
    {
        *in = thd;
    }

    if ((of = getOptFlag(optflgs, "TypeHintOut", string_flag)) != NULL)
    {
        if (thd != NULL)
            yywarning("/TypeHintOut/ overrides /TypeHint/");

        *out = newTypeHint(of->fvalue.sval);
    }
    else
    {
        *out = thd;
    }
}


/*
 * Get the /NoTypeHint/ option flag.
 */
static int getNoTypeHint(optFlags *optflgs)
{
    return (getOptFlag(optflgs, "NoTypeHint", bool_flag) != NULL);
}


/*
 * Return TRUE if the PyQt4 plugin was specified.
 */
int pluginPyQt4(sipSpec *pt)
{
    return stringFind(pt->plugins, "PyQt4");
}


/*
 * Return TRUE if the PyQt5 plugin was specified.
 */
int pluginPyQt5(sipSpec *pt)
{
    return stringFind(pt->plugins, "PyQt5");
}


/*
 * Return TRUE if a list of strings contains a given entry.
 */
static int stringFind(stringList *sl, const char *s)
{
    while (sl != NULL)
    {
        if (strcmp(sl->s, s) == 0)
            return TRUE;

        sl = sl->next;
    }

    return FALSE;
}


/*
 * Set the name of a module.
 */
static void setModuleName(sipSpec *pt, moduleDef *mod, const char *fullname)
{
    mod->fullname = cacheName(pt, fullname);

    if (inMainModule())
        setIsUsedName(mod->fullname);

    if ((mod->name = strrchr(fullname, '.')) != NULL)
        mod->name++;
    else
        mod->name = fullname;
}


/*
 * Define a new class and set its name.
 */
static void defineClass(scopedNameDef *snd, classList *supers, optFlags *of)
{
    classDef *cd;
    typeHintDef *in, *out;

    getTypeHints(of, &in, &out);

    cd = newClass(currentSpec, class_iface, getAPIRange(of),
            fullyQualifiedName(snd), getVirtErrorHandler(of), in, out,
            getTypeHintValue(of));
    cd->supers = supers;

    pushScope(cd);
}


/*
 * Return a fully qualified scoped name.
 */
static scopedNameDef *fullyQualifiedName(scopedNameDef *snd)
{
    classDef *scope = currentScope();

    return scopeScopedName((scope != NULL ? scope->iff : NULL), snd);
}


/*
 * Complete the definition of a class.
 */
static classDef *completeClass(scopedNameDef *snd, optFlags *of, int has_def)
{
    classDef *cd = currentScope();

    /* See if the class was defined or just declared. */
    if (has_def)
    {
        if (snd->next != NULL)
            yyerror("A scoped name cannot be given in a class/struct definition");

    }
    else if (cd->supers != NULL)
        yyerror("Class/struct has super-classes but no definition");
    else
        setIsOpaque(cd);

    finishClass(currentSpec, currentModule, cd, of);
    popScope();

    /*
     * Check that external classes have only been declared at the global scope.
     */
    if (isExternal(cd) && currentScope() != NULL)
        yyerror("External classes/structs can only be declared in the global scope");

    return cd;
}


/*
 * Add a variable to the list so that the list remains sorted.
 */
static void addVariable(sipSpec *pt, varDef *vd)
{
    varDef **at = &pt->vars;

    while (*at != NULL)
    {
        if (strcmp(vd->pyname->text, (*at)->pyname->text) < 0)
            break;

        at = &(*at)->next;
    }

    vd->next = *at;
    *at = vd;
}


/*
 * Update a type according to optional flags.
 */
static void applyTypeFlags(moduleDef *mod, argDef *ad, optFlags *flags)
{
    ad->doctype = getDocType(flags);
    getTypeHints(flags, &ad->typehint_in, &ad->typehint_out);

    if (getOptFlag(flags, "PyInt", bool_flag) != NULL)
    {
        if (ad->atype == string_type)
            ad->atype = byte_type;
        else if (ad->atype == sstring_type)
            ad->atype = sbyte_type;
        else if (ad->atype == ustring_type)
            ad->atype = ubyte_type;
    }

    if (ad->atype == string_type && !isArray(ad) && !isReference(ad))
    {
        optFlag *of;

        if ((of = getOptFlag(flags, "Encoding", string_flag)) == NULL)
        {
            if (mod->encoding != no_type)
                ad->atype = mod->encoding;
            else
                ad->atype = string_type;
        }
        else if ((ad->atype = convertEncoding(of->fvalue.sval)) == no_type)
            yyerror("The value of the /Encoding/ annotation must be one of \"ASCII\", \"Latin-1\", \"UTF-8\" or \"None\"");
    }
}


/*
 * Return the keyword argument support converted from a string.
 */
static KwArgs convertKwArgs(const char *kwargs)
{
    if (strcmp(kwargs, "None") == 0)
        return NoKwArgs;

    if (strcmp(kwargs, "All") == 0)
        return AllKwArgs;

    if (strcmp(kwargs, "Optional") == 0)
        return OptionalKwArgs;

    yyerror("The style of keyword argument support must be one of \"All\", \"Optional\" or \"None\"");
}


/*
 * Return the Format for a string.
 */
static Format convertFormat(const char *format)
{
    if (strcmp(format, "raw") == 0)
        return raw;

    if (strcmp(format, "deindented") == 0)
        return deindented;

    yyerror("The docstring format must be either \"raw\" or \"deindented\"");
}


/*
 * Return the Signature for a string.
 */
static Signature convertSignature(const char *signature)
{
    if (strcmp(signature, "discarded") == 0)
        return discarded;

    if (strcmp(signature, "prepended") == 0)
        return prepended;

    if (strcmp(signature, "appended") == 0)
        return appended;

    yyerror("The docstring signature must be either \"discarded\", \"prepended\" or \"appended\"");
}


/*
 * Return the argument type for a string with the given encoding or no_type if
 * the encoding was invalid.
 */
static argType convertEncoding(const char *encoding)
{
    if (strcmp(encoding, "ASCII") == 0)
        return ascii_string_type;

    if (strcmp(encoding, "Latin-1") == 0)
        return latin1_string_type;

    if (strcmp(encoding, "UTF-8") == 0)
        return utf8_string_type;

    if (strcmp(encoding, "None") == 0)
        return string_type;

    return no_type;
}


/*
 * Get the /API/ option flag.
 */
static apiVersionRangeDef *getAPIRange(optFlags *optflgs)
{
    optFlag *of;

    if ((of = getOptFlag(optflgs, "API", api_range_flag)) == NULL)
        return NULL;

    return of->fvalue.aval;
}


/*
 * Return the API range structure and version number corresponding to the
 * given API range.
 */
static apiVersionRangeDef *convertAPIRange(moduleDef *mod, nameDef *name,
        int from, int to)
{
    int index;
    apiVersionRangeDef *avd, **avdp;

    /* Handle the trivial case. */
    if (from == 0 && to == 0)
        return NULL;

    for (index = 0, avdp = &mod->api_ranges; (*avdp) != NULL; avdp = &(*avdp)->next, ++index)
    {
        avd = *avdp;

        if (avd->api_name == name && avd->from == from && avd->to == to)
            return avd;
    }

    /* The new one must be appended so that version numbers remain valid. */
    avd = sipMalloc(sizeof (apiVersionRangeDef));

    avd->api_name = name;
    avd->from = from;
    avd->to = to;
    avd->index = index;

    avd->next = NULL;
    *avdp = avd;

    return avd;
}


/*
 * Return the style of keyword argument support for a signature.
 */
static KwArgs keywordArgs(moduleDef *mod, optFlags *optflgs, signatureDef *sd,
        int need_name)
{
    KwArgs kwargs;
    optFlag *ka_anno, *no_ka_anno;

    /* Get the default. */
    kwargs = mod->kwargs;

    /*
     * Get the possible annotations allowing /KeywordArgs/ to have different
     * types of values.
     */
    ka_anno = findOptFlag(optflgs, "KeywordArgs");
    no_ka_anno = getOptFlag(optflgs, "NoKeywordArgs", bool_flag);

    if (no_ka_anno != NULL)
    {
        if (ka_anno != NULL)
            yyerror("/KeywordArgs/ and /NoKeywordArgs/ cannot both be specified");

        deprecated("/NoKeywordArgs/ is deprecated, use /KeywordArgs=\"None\" instead");

        kwargs = NoKwArgs;
    }
    else if (ka_anno != NULL)
    {
        /* A string value is the non-deprecated type. */
        if (ka_anno->ftype == string_flag)
        {
            kwargs = convertKwArgs(ka_anno->fvalue.sval);
        }
        else
        {
            deprecated("/KeywordArgs/ is deprecated, use /KeywordArgs=\"All\" instead");

            /* Get it again to check the type. */
            ka_anno = getOptFlag(optflgs, "KeywordArgs", bool_flag);
        }
    }

    /* An ellipsis cannot be used with keyword arguments. */
    if (sd->nrArgs > 0 && sd->args[sd->nrArgs - 1].atype == ellipsis_type)
        kwargs = NoKwArgs;

    if (kwargs != NoKwArgs)
    {
        int a, is_name = FALSE;

        /*
         * Mark argument names as being used and check there is at least one.
         */
        for (a = 0; a < sd->nrArgs; ++a)
        {
            argDef *ad = &sd->args[a];

            if (kwargs == OptionalKwArgs && ad->defval == NULL)
                continue;

            if (ad->name != NULL)
            {
                if (need_name || inMainModule())
                    setIsUsedName(ad->name);

                is_name = TRUE;
            }
        }

        if (!is_name)
            kwargs = NoKwArgs;
    }

    return kwargs;
}


/*
 * Extract the version of a string value optionally associated with a
 * particular feature.
 */
static char *convertFeaturedString(char *fs)
{
    while (fs != NULL)
    {
        char *next, *value;

        /* Individual values are ';' separated. */
        if ((next = strchr(fs, ';')) != NULL)
            *next++ = '\0';

        /* Features and values are ':' separated. */
        if ((value = strchr(fs, ':')) == NULL)
        {
            /* This is an unconditional value so just return it. */
            return strip(fs);
        }

        *value++ = '\0';

        if (isEnabledFeature(strip(fs)))
            return strip(value);

        fs = next;
    }

    /* No value was enabled. */
    return NULL;
}


/*
 * Return the stripped version of a string.
 */
static char *strip(char *s)
{
    while (*s == ' ')
        ++s;

    if (*s != '\0')
    {
        char *cp = &s[strlen(s) - 1];

        while (*cp == ' ')
            *cp-- = '\0';
    }

    return s;
}


/*
 * Return TRUE if the given feature is enabled.
 */
static int isEnabledFeature(const char *name)
{
    qualDef *qd;

    if ((qd = findQualifier(name)) == NULL || qd->qtype != feature_qualifier)
        yyerror("No such feature");

    return !excludedFeature(excludedQualifiers, qd);
}


/*
 * Add a property definition to a class.
 */
static void addProperty(sipSpec *pt, moduleDef *mod, classDef *cd,
        const char *name, const char *get, const char *set,
        docstringDef *docstring)
{
    propertyDef *pd;

    checkAttributes(pt, mod, cd, NULL, name, FALSE);

    pd = sipMalloc(sizeof (propertyDef));

    pd->name = cacheName(pt, name);
    pd->get = get;
    pd->set = set;
    pd->docstring = docstring;
    pd->platforms = currentPlatforms;
    pd->next = cd->properties;

    cd->properties = pd;

    if (inMainModule())
        setIsUsedName(pd->name);
}


/*
 * Configure a module and return the (possibly new) current module.
 */
static moduleDef *configureModule(sipSpec *pt, moduleDef *module,
        const char *filename, const char *name, int c_module, KwArgs kwargs,
        int use_arg_names, int py_ssize_t_clean, int use_limited_api,
        int call_super_init, int all_raise_py_exc,
        const char *def_error_handler, docstringDef *docstring)
{
    moduleDef *mod;

    /* Check the module hasn't already been defined. */
    for (mod = pt->modules; mod != NULL; mod = mod->next)
        if (mod->fullname != NULL && strcmp(mod->fullname->text, name) == 0)
            yyerror("Module is already defined");

    /*
     * If we are in a container module then create a component module and make
     * it current.
     */
    if (isContainer(module) || module->container != NULL)
    {
        mod = allocModule();

        mod->file = filename;
        mod->container = (isContainer(module) ? module : module->container);

        module = mod;
    }

    setModuleName(pt, module, name);
    module->kwargs = kwargs;
    module->virt_error_handler = def_error_handler;
    module->docstring = docstring;

    if (all_raise_py_exc)
        setAllRaisePyException(module);

    if (use_arg_names)
        setUseArgNames(module);

    if (py_ssize_t_clean)
        setPY_SSIZE_T_CLEAN(module);

    if (use_limited_api)
        setUseLimitedAPI(module);

    if (call_super_init == 0)
        setCallSuperInitNo(module);
    else if (call_super_init > 0)
        setCallSuperInitYes(module);

    if (pt->genc < 0)
        pt->genc = c_module;
    else if (pt->genc != c_module)
        yyerror("Cannot mix C and C++ modules");

    return module;
}


/*
 * Add a Python naming rule to a module.
 */
static void addAutoPyName(moduleDef *mod, const char *remove_leading)
{
    autoPyNameDef *apnd, **apndp;

    for (apndp = &mod->autopyname; *apndp != NULL; apndp = &(*apndp)->next)
        ;

    apnd = sipMalloc(sizeof (autoPyNameDef));
    apnd->remove_leading = remove_leading;
    apnd->next = *apndp;

    *apndp = apnd;
}


/*
 * Check that no invalid or unknown annotations are given.
 */
static void checkAnnos(optFlags *annos, const char *valid[])
{
    if (parsingCSignature && annos->nrFlags != 0)
    {
        deprecated("Annotations should not be used in explicit C/C++ signatures");
    }
    else
    {
        int i;

        for (i = 0; i < annos->nrFlags; i++)
        {
            const char **name;

            for (name = valid; *name != NULL; ++name)
                if (strcmp(*name, annos->flags[i].fname) == 0)
                    break;

            if (*name == NULL)
                yywarning("Annotation is unknown");
        }
    }
}


/*
 * Check that no annotations were given.
 */
static void checkNoAnnos(optFlags *annos, const char *msg)
{
    if (annos->nrFlags != 0)
        deprecated(msg);
}


/*
 * Handle any /KeepReference/ annotation for a type.
 */
static void handleKeepReference(optFlags *optflgs, argDef *ad, moduleDef *mod)
{
    optFlag *of;

    if ((of = getOptFlag(optflgs, "KeepReference", opt_integer_flag)) != NULL)
    {
        setKeepReference(ad);

        if ((ad->key = of->fvalue.ival) < -1)
            yyerror("/KeepReference/ key cannot be negative");

        /* If there was no explicit key then auto-allocate one. */
        if (ad->key == -1)
            ad->key = mod->next_key--;
    }
}


/*
 * Configure the mapped type annotations that are also valid with mapped type
 * templates.
 */
static void mappedTypeAnnos(mappedTypeDef *mtd, optFlags *optflgs)
{
    if (getOptFlag(optflgs, "NoRelease", bool_flag) != NULL)
        setNoRelease(mtd);

    if (getAllowNone(optflgs))
        setHandlesNone(mtd);

    mtd->doctype = getDocType(optflgs);
    getTypeHints(optflgs, &mtd->typehint_in, &mtd->typehint_out);
    mtd->typehint_value = getTypeHintValue(optflgs);
}


/*
 * Initialise an argument with the derefences of another, plus a new one.
 */
static void add_new_deref(argDef *new, argDef *orig, int isconst)
{
    if ((new->nrderefs = orig->nrderefs + 1) >= MAX_NR_DEREFS)
        yyerror("Internal error - increase the value of MAX_NR_DEREFS");

    memcpy(&new->derefs[0], &orig->derefs[0], sizeof (new->derefs));
    new->derefs[orig->nrderefs] = isconst;
}


/*
 * Add the dereferences from one type to another.
 */
static void add_derefs(argDef *dst, argDef *src)
{
    int i;

    for (i = 0; i < src->nrderefs; ++i)
    {
        if (dst->nrderefs >= MAX_NR_DEREFS - 1)
            fatal("Internal error - increase the value of MAX_NR_DEREFS\n");

        dst->derefs[dst->nrderefs++] = src->derefs[i];
    }
}


/*
 * Check if a word is a Python keyword (or has been at any time).
 */
int isPyKeyword(const char *word)
{
    static const char *kwds[] = {
        "False", "None", "True", "and", "as", "assert", "break", "class",
        "continue", "def", "del", "elif", "else", "except", "finally", "for",
        "from", "global", "if", "import", "in", "is", "lambda", "nonlocal",
        "not", "or", "pass", "raise", "return", "try", "while", "with'"
        "yield",
        /* Historical keywords. */
        "exec", "print",
        NULL
    };

    const char **kwd;

    for (kwd = kwds; *kwd != NULL; ++kwd)
        if (strcmp(*kwd, word) == 0)
            return TRUE;

    return FALSE;
}


/*
 * Check there is nothing after an ellipsis.
 */
static void checkEllipsis(signatureDef *sd)
{
    int a;

    for (a = 0; a < sd->nrArgs; ++a)
        if (sd->args[a].atype == ellipsis_type && a < sd->nrArgs - 1)
            yyerror("An ellipsis must be at the end of the argument list if /NoArgParser/ is not specified");
}
